/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001,2002 by Information-technology Promotion Agency, JAPAN
 *  Copyright (C) 2001,2002 by TRON Association, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2000-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2005-2010 by Monami Software Limited Partnership, JAPAN
 *  Copyright (C) 2005-2006 by Japan Aerospace Exploration Agency.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ץå¸⥸塼MIPS32ѡ
 */

#include "hrp_kernel.h"
#include "check.h"
#include "task.h"
#include "memory.h"

/*
 *  ߡ㳰ͥȥ
 */
UW nontask_nest;

/*
 *  㳰ϥɥεơ֥
 */
FP exc_table[ TNUM_ALL_EXCNO ];

/*
 *  ץå¸ν
 */
void
cpu_initialize(void)
{
	int i;

	/* 㳰٥εơ֥ */
	for( i = 0; i < TNUM_ALL_EXCNO; i++ ) {
		x_define_exc( i, (FP) &default_exc_handler );
	}
}

/*
 *  ץå¸νλ
 */
void
cpu_terminate(void)
{
}

/*
 *  ͭ饤֥ȤѰդ٤ؿ
 */
extern void	call_ret_tex(void);

/*
 *  桼Ф륿㳰롼εư
 */
BOOL
prepare_texrtn_umode(EXCSTACK *ssp, SIZE size)
{
	EXCSTACK		*usp;

	usp = (EXCSTACK *)((char *)p_runtsk->tskctxb.usp - size);
	if (!PROBE_STACK(usp, size)) {
		p_runtsk->enatex = FALSE;
		return(TRUE);
	}
	usp->at = ssp->at;
	usp->v0 = ssp->v0;
	usp->v1 = ssp->v1;
	usp->a0 = ssp->a0;
	usp->a1 = ssp->a1;
	usp->a2 = ssp->a2;
	usp->a3 = ssp->a3;
	usp->a4 = ssp->a4;
	usp->a5 = ssp->a5;
	usp->a6 = ssp->a6;
	usp->a7 = ssp->a7;
	usp->t4 = ssp->t4;
	usp->t5 = ssp->t5;
	usp->t6 = ssp->t6;
	usp->t7 = ssp->t7;
	usp->t8 = ssp->t8;
	usp->t9 = ssp->t9;
	usp->gp = ssp->gp;
	usp->ra = ssp->ra;
	usp->hi = ssp->hi;
	usp->lo = ssp->lo;
	usp->CP0_EPC = ssp->CP0_EPC;

#if ABI_FPR == 0
#else /* ABI_FPR == 8 */
	usp->f0 = ssp->f0;
	usp->f1 = ssp->f1;
	usp->f2 = ssp->f2;
	usp->f3 = ssp->f3;
	usp->f4 = ssp->f4;
	usp->f5 = ssp->f5;
	usp->f6 = ssp->f6;
	usp->f7 = ssp->f7;
	usp->f8 = ssp->f8;
	usp->f9 = ssp->f9;
	usp->f10 = ssp->f10;
	usp->f11 = ssp->f11;
	usp->f12 = ssp->f12;
	usp->f13 = ssp->f13;
	usp->f14 = ssp->f14;
	usp->f15 = ssp->f15;
	usp->f16 = ssp->f16;
	usp->f17 = ssp->f17;
	usp->f18 = ssp->f18;
	usp->f19 = ssp->f19;
	usp->f21 = ssp->f21;
	usp->f23 = ssp->f23;
	usp->f25 = ssp->f25;
	usp->f27 = ssp->f27;
	usp->f29 = ssp->f29;
	usp->f31 = ssp->f31;
#endif

	ssp->a0 = (int)(p_runtsk->texptn); /* TEXPTN (UINT) */
	ssp->a1 = (long)(p_runtsk->p_tinib->exinf); /* VP_INT */
	ssp->ra = (long)call_ret_tex; /* FP */
	ssp->CP0_EPC = (long)(p_runtsk->p_tinib->texrtn); /* FP */
	p_runtsk->enatex = FALSE;
	p_runtsk->texptn = 0u;
	p_runtsk->tskctxb.usp = usp;
	return(FALSE);
}

/*
 *  桼Ф륿㳰롼󤫤Υ꥿
 */
BOOL
prepare_ret_tex_umode(EXCSTACK *ssp, SIZE size)
{
	EXCSTACK		*usp;

	usp = (EXCSTACK *)p_runtsk->tskctxb.usp;
	if (p_runtsk->texptn != 0u) {
		/*
		 *  㳰롼κƵư
		 */
		if (!PROBE_STACK(usp, size)) {
			p_runtsk->enatex = FALSE;
			return(TRUE);
		}
		ssp->a0 = (int)(p_runtsk->texptn); /* TEXPTN (UINT) */
		ssp->a1 = (long)(p_runtsk->p_tinib->exinf); /* VP_INT */
		ssp->ra = (long)call_ret_tex; /* FP */
		ssp->CP0_EPC = (long)(p_runtsk->p_tinib->texrtn); /* FP */
		p_runtsk->enatex = FALSE;
		p_runtsk->texptn = 0u;
	}
	else {
		/*
		 *  㳰롼󤫤Υ꥿
		 */
		if (!PROBE_STACK(usp, size)) {
			p_runtsk->enatex = FALSE;
			return(TRUE);
		}
		ssp->at = usp->at;
		ssp->v0 = usp->v0;
		ssp->v1 = usp->v1;
		ssp->a0 = usp->a0;
		ssp->a1 = usp->a1;
		ssp->a2 = usp->a2;
		ssp->a3 = usp->a3;
		ssp->a4 = usp->a4;
		ssp->a5 = usp->a5;
		ssp->a6 = usp->a6;
		ssp->a7 = usp->a7;
		ssp->t4 = usp->t4;
		ssp->t5 = usp->t5;
		ssp->t6 = usp->t6;
		ssp->t7 = usp->t7;
		ssp->t8 = usp->t8;
		ssp->t9 = usp->t9;
		ssp->gp = usp->gp;
		ssp->ra = usp->ra;
		ssp->hi = usp->hi;
		ssp->lo = usp->lo;
		ssp->CP0_EPC = usp->CP0_EPC;

#if ABI_FPR == 0
#else /* ABI_FPR == 8 */
		ssp->f0 = usp->f0;
		ssp->f1 = usp->f1;
		ssp->f2 = usp->f2;
		ssp->f3 = usp->f3;
		ssp->f4 = usp->f4;
		ssp->f5 = usp->f5;
		ssp->f6 = usp->f6;
		ssp->f7 = usp->f7;
		ssp->f8 = usp->f8;
		ssp->f9 = usp->f9;
		ssp->f10 = usp->f10;
		ssp->f11 = usp->f11;
		ssp->f12 = usp->f12;
		ssp->f13 = usp->f13;
		ssp->f14 = usp->f14;
		ssp->f15 = usp->f15;
		ssp->f16 = usp->f16;
		ssp->f17 = usp->f17;
		ssp->f18 = usp->f18;
		ssp->f19 = usp->f19;
		ssp->f21 = usp->f21;
		ssp->f23 = usp->f23;
		ssp->f25 = usp->f25;
		ssp->f27 = usp->f27;
		ssp->f29 = usp->f29;
		ssp->f31 = usp->f31;
#endif

		p_runtsk->enatex = TRUE;
		p_runtsk->tskctxb.usp = (char *)usp + size;
	}
	return(FALSE);
}
