/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001,2002 by Information-technology Promotion Agency, JAPAN
 *  Copyright (C) 2001,2002 by TRON Association, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2000-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2005-2010 by Monami Software Limited Partnership, JAPAN
 *  Copyright (C) 2005-2006 by Japan Aerospace Exploration Agency.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ץå¸⥸塼MIPS32ѡ
 *
 *  Υ󥯥롼ɥեϡt_config.hΤߤ饤󥯥롼ɤ롥
 *  ¾Υե뤫ľܥ󥯥롼ɤƤϤʤʤ
 */

#ifndef _CPU_CONFIG_H_
#define _CPU_CONFIG_H_

/*
 *  ͥ̾Υ͡
 */
#include <cpu_rename.h>

/*  ΤCPU㳰ܿ  */
#define TNUM_KERNEL_EXCNO 2
#define TNUM_ALL_EXCNO	(TNUM_CORE_EXCNO + TNUM_KERNEL_EXCNO)

/*
 *  ץåü̿Υ饤ؿ
 */
#include <cpu_insn.h>

#ifndef _MACRO_ONLY
/*
 *  ƥȥ֥å
 */
typedef struct task_context_block {
        VP	sp;             /* åݥ */
        FP	pc;             /* ץ५ */
	VP usp; /* user stack pointer */
} CTXB;

/*
 *  ݸɥᥤ󥳥ƥȥ֥å
 */
#define DOMCTXB VW /* unused */

/*
 *  ͥݸɥᥤ󥳥ƥȥ֥å
 */
#define DOMCTXB_KERNEL 0 /* unused */

#endif /* _MACRO_ONLY */

/*
 *  ǥեȤΥƥॹåΥ
 */
#define DEFAULT_SSTKSZ	2048

#ifndef _MACRO_ONLY

/*
 *  TOPPERSɸ߽ǥμ¸
 *
 *    CPUå֤ȽǤϡơ쥸IEӥåȤѤȽǤƤ롣
 */

/*
 *  ߡ㳰ͥȥ
 */

extern UW nontask_nest;

/*
 *  ƥȤλ
 *
 *    ߥͥȥ󥿤ɤ߽Фľ˳ߤȯƤ⡢äȤˤ
 *    ƥȤ⸵äƤ롣
 */
Inline BOOL
sense_context(void)
{
	return(nontask_nest > 0);
}

#endif /* _MACRO_ONLY */

#ifndef _MACRO_ONLY
/*
 *  CPUå֤ؤΰܹ
 */
Inline void
x_lock_cpu(void)
{
	disint();		/* cpu_insn.h */
}

#define t_lock_cpu()	x_lock_cpu()
#define i_lock_cpu()	x_lock_cpu()

/*
 *  CPUå֤β
 */
Inline void
x_unlock_cpu(void)
{
	enaint();		/* cpu_insn.h */
}

#define t_unlock_cpu()	x_unlock_cpu()
#define i_unlock_cpu()	x_unlock_cpu()

/*
 *  CPUå֤λ
 */
Inline BOOL
x_sense_lock(void)
{
	return(!(current_sr() & SR_IE));
}

#define t_sense_lock()	x_sense_lock()
#define i_sense_lock()	x_sense_lock()

/*
 *  ǥѥå
 */

/*
 *  ǹ̥ͥؤΥǥѥåcpu_support.S
 *
 *  dispatchϡƥȤƤӽФ줿ӥ
 *  ƤӽФ٤ΤǡƥȡCPUå֡ǥѥ
 *  ľ֡ͥ٥ޥTIPM_ENAALLξ֤ǸƤӽФʤ
 *  Фʤʤ
 */
extern void	dispatch(void);

/*
 *  ߤΥƥȤΤƤƥǥѥåcpu_support.S
 *
 *  exit_and_dispatchϡext_tskƤӽФ٤Τǡƥ
 *  ȡCPUå֡ǥѥåľ֡ͥ٥ޥ
 *  TIPM_ENAALLξ֤ǸƤӽФʤФʤʤ
 */
extern void	exit_and_dispatch(void) NoReturn;

/*
 *  ǥѥåưϡcpu_support.S
 *
 *  start_dispatchϡͥ뵯ư˸ƤӽФ٤Τǡ٤Ƥγ
 *  ߤػߤ֡ʳߥå֤Ʊξ֡ˤǸƤӽФʤ
 *  ʤʤ
 */
extern void	start_dispatch(void) NoReturn;

/*
 *  ͥνλθƽФcpu_support.S
 *
 *  call_exit_kernelϡͥνλ˸ƤӽФ٤Τǡ󥿥
 *  ƥȤڤ괹ơͥνλexit_kernelˤƤӽ
 *  
 */
extern void call_exit_kernel(void) NoReturn;

/*
 *  ƥȤν
 *
 *  ٻ߾֤¹ԤǤ֤˰ܹԤ˸ƤФ롥λ
 *  ǥåΰȤäƤϤʤʤ
 *
 *  activate_context򡤥饤ؿǤϤʤޥȤƤΤϡ
 *  λǤTCBƤʤǤ롥
 */
extern void activate_r(void);

#define activate_context(p_tcb) \
		{ \
			(p_tcb)->tskctxb.pc = activate_r; \
			(p_tcb)->tskctxb.sp = (char *)(p_tcb)->p_tinib->sstk + (p_tcb)->p_tinib->sstksz; \
			(p_tcb)->tskctxb.usp = (char *)(p_tcb)->p_tinib->stk + (p_tcb)->p_tinib->stkpsz * PAGE_SIZE; \
		}

/*
 *  calltexϻѤʤ
 */
#define OMIT_CALLTEX

/*
 *  initialize_memoryϻѤʤ
 */
#ifndef GENERATE_MEMINIB
#else /* GENERATE_MEMINIB */
#define OMIT_GENERATE_MEMINIB
#endif /* GENERATE_MEMINIB */

/*
 *  CPU㳰ϥɥ
 */

/*  㳰ϥɥ鵼ơ֥  */
extern FP	 exc_table[ TNUM_ALL_EXCNO ];

/*
 *  CPU㳰ϥɥ
 *
 *  ٥ȥֹexcnoCPU㳰ϥɥεưϤexchdrꤹ롥
 */
Inline void
x_define_exc(EXCNO excno, FP exchdr)
{
	exc_table[excno] = exchdr;
}

/*
 *  CPU㳰ϥɥν
 */

/*
 *  CPU㳰ϥɥޥ
 */

#define	EXC_ENTRY(exchdr)     exchdr

#define	EXCHDR_ENTRY(exchdr)  extern void exchdr(VP sp)

/*
 *  Ѥδؿ
 */

/* ϿƤʤ㳰ȯΥ */
extern void     default_exc_handler( VP p_excinf );

/*
 *  CPU㳰ȯΥƥ֤λ
 */

/*
 *  CPU㳰ȯΥƥȤλ
 *
 *  CPU㳰ȯΥƥȤƥȤλFALSE
 *  ǤʤTRUE֤
 */
Inline BOOL
exc_sense_context(VP p_excinf)
{
	return( nontask_nest > 1 );
		/* 1ӤΤϡ߼¹CPU㳰ʬߥͥ
		   󥿤󥯥ȤƤ뤿 */
}

/*
 *  CPU㳰ȯΥƥȤȳߤΥޥ֤λ
 *
 *  CPU㳰ȯΥƥ֤ͥ¹Ǥʤ
 *  ƥȤǤꡤߥå֤ǤʤCPUå֤Ǥʤʥ
 *  ǥΡ˳ͥ٥ޥTIPM_ENAALLǤTRUEǤʤ
 *  FALSE֤CPU㳰ͥδγ߽ȯ
 *  ˤFALSE֤ˡ
 */
Inline BOOL
exc_sense_intmask(VP p_excinf)
{
	return !exc_sense_context(p_excinf) && ((EXCSTACK *)p_excinf)->CP0_Status & SR_IE && x_get_ipm() == TIPM_ENAALL;
}

/*
 *  CPU㳰ȯΥƥȤȳߡCPUå֤λ
 *
 *  CPU㳰ȯΥƥ֤ͥ¹Ǥʤ
 *  ƥȤǤꡤߥå֤ǤʤCPUå֤Ǥʤ
 *  TRUEǤʤFALSE֤CPU㳰ͥδγ
 *  ȯˤFALSE֤ˡ
 */
Inline BOOL
exc_sense_unlock(VP p_excinf)
{
	return !exc_sense_context(p_excinf) && ((EXCSTACK *)p_excinf)->CP0_Status & SR_IE;
}

/*
 *  ץå¸ν
 */
extern void	cpu_initialize(void);

/*
 *  ץå¸νλ
 */
extern void	cpu_terminate(void);

/*
 *  桼Ф륿㳰롼εư
 */
extern BOOL	prepare_texrtn_umode(EXCSTACK *ssp, SIZE size);

/*
 *  桼Ф륿㳰롼󤫤Υ꥿
 */
extern BOOL	prepare_ret_tex_umode(EXCSTACK *ssp, SIZE size);

#endif /* _MACRO_ONLY */

/* ͥ뵯ưΥå */
#define COPYRIGHT_CPU \
"Copyright (C) 2001-2003 by Industrial Technology Institute,\n" \
"                            Miyagi Prefectural Government, JAPAN\n" \
"Copyright (C) 2005-2010 by Monami Software Limited Partnership, JAPAN\n" \
"Copyright (C) 2005-2006 by Japan Aerospace Exploration Agency.\n"

#endif /* _CPU_CONFIG_H_ */
