/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2000-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2005-2010 by Monami Software Limited Partnership, JAPAN
 *  Copyright (C) 2005-2006 by Japan Aerospace Exploration Agency.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ץå˰¸MIPS32ѡ
 *
 *  Υ󥯥롼ɥեϡkernel.hsil.hǥ󥯥롼ɤ롥
 *  ¾Υե뤫ľܥ󥯥롼ɤ뤳ȤϤʤΥե򥤥
 *  롼ɤˡt_stddef.hitron.h󥯥롼ɤΤǡ
 *  ˰¸Ƥ褤
 */

#ifndef _CPU_DEFS_H_
#define _CPU_DEFS_H_

#define MIPS32						/* ץåά */

/*
 *  CPU㳰ϥɥֹ
 */
#define EXCNO_CALTEX_ILLSTK		32 /* TNUM_CORE_EXCNO + 0 */
#define EXCNO_RETTEX_ILLSTK		33 /* TNUM_CORE_EXCNO + 1 */

#ifndef _MACRO_ONLY

/*
 *  ߥå֤
 */
#define SIL_PRE_LOC		UW _sr_
#define SIL_LOC_INT()	(_sr_ = current_sr(), set_sr(_sr_ & ~SR_IE))
#define SIL_UNL_INT()	set_sr(current_sr() | (_sr_ & SR_IE))

#endif /* _MACRO_ONLY */

/*
 *  եȥߤˤ륵ӥ륤󥿥ե
 */
#ifdef CALSVC_TRAP

#define CAL_SVC_0(TYPE, FNCD) \
   register INT r2 asm("$2") = (INT)FNCD; \
   Asm("syscall" : "=r"(r2) : "0"(r2)); \
   return ((TYPE)r2)

#define CAL_SVC_0M(TYPE, FNCD) \
   register INT r2 asm("$2") = (INT)FNCD; \
   Asm("syscall" : "=r"(r2) : "0"(r2) : "memory"); \
   return ((TYPE)r2)

#define CAL_SVC_1(TYPE, FNCD, TYPE1, PAR1) \
   register INT r2 asm("$2") = (INT)FNCD; \
   register TYPE1 r4 asm("$4") = (TYPE1)PAR1; \
   Asm("syscall" : "=r"(r2) : "0"(r2), "r"(r4)); \
   return ((TYPE)r2)

#define CAL_SVC_1M(TYPE, FNCD, TYPE1, PAR1) \
   register INT r2 asm("$2") = (INT)FNCD; \
   register TYPE1 r4 asm("$4") = (TYPE1)PAR1; \
   Asm("syscall" : "=r"(r2) : "0"(r2), "r"(r4) : "memory"); \
   return ((TYPE)r2)

#define CAL_SVC_2(TYPE, FNCD, TYPE1, PAR1, TYPE2, PAR2) \
   register INT r2 asm("$2") = (INT)FNCD; \
   register TYPE1 r4 asm("$4") = (TYPE1)PAR1; \
   register TYPE2 r5 asm("$5") = (TYPE2)PAR2; \
   Asm("syscall" : "=r"(r2) : "0"(r2), "r"(r4), "r"(r5)); \
   return ((TYPE)r2)

#define CAL_SVC_2M(TYPE, FNCD, TYPE1, PAR1, TYPE2, PAR2) \
   register INT r2 asm("$2") = (INT)FNCD; \
   register TYPE1 r4 asm("$4") = (TYPE1)PAR1; \
   register TYPE2 r5 asm("$5") = (TYPE2)PAR2; \
   Asm("syscall" : "=r"(r2) : "0"(r2), "r"(r4), "r"(r5) : "memory"); \
   return ((TYPE)r2)

#define CAL_SVC_3(TYPE, FNCD, TYPE1, PAR1, TYPE2, PAR2, TYPE3, PAR3) \
   register INT r2 asm("$2") = (INT)FNCD; \
   register TYPE1 r4 asm("$4") = (TYPE1)PAR1; \
   register TYPE2 r5 asm("$5") = (TYPE2)PAR2; \
   register TYPE3 r6 asm("$6") = (TYPE3)PAR3; \
   Asm("syscall" : "=r"(r2) : "0"(r2), "r"(r4), "r"(r5), "r"(r6)); \
   return ((TYPE)r2)

#define CAL_SVC_3M(TYPE, FNCD, TYPE1, PAR1, TYPE2, PAR2, TYPE3, PAR3) \
   register INT r2 asm("$2") = (INT)FNCD; \
   register TYPE1 r4 asm("$4") = (TYPE1)PAR1; \
   register TYPE2 r5 asm("$5") = (TYPE2)PAR2; \
   register TYPE3 r6 asm("$6") = (TYPE3)PAR3; \
   Asm("syscall" : "=r"(r2) : "0"(r2), "r"(r4), "r"(r5), "r"(r6) : "memory"); \
   return ((TYPE)r2)

#define CAL_SVC_4(TYPE, FNCD, TYPE1, PAR1, TYPE2, PAR2, TYPE3, PAR3, TYPE4, PAR4) \
   register INT r2 asm("$2") = (INT)FNCD; \
   register TYPE1 r4 asm("$4") = (TYPE1)PAR1; \
   register TYPE2 r5 asm("$5") = (TYPE2)PAR2; \
   register TYPE3 r6 asm("$6") = (TYPE3)PAR3; \
   register TYPE4 r7 asm("$7") = (TYPE4)PAR4; \
   Asm("syscall" : "=r"(r2) : "0"(r2), "r"(r4), "r"(r5), "r"(r6), "r"(r7)); \
   return ((TYPE)r2)

#define CAL_SVC_4M(TYPE, FNCD, TYPE1, PAR1, TYPE2, PAR2, TYPE3, PAR3, TYPE4, PAR4) \
   register INT r2 asm("$2") = (INT)FNCD; \
   register TYPE1 r4 asm("$4") = (TYPE1)PAR1; \
   register TYPE2 r5 asm("$5") = (TYPE2)PAR2; \
   register TYPE3 r6 asm("$6") = (TYPE3)PAR3; \
   register TYPE4 r7 asm("$7") = (TYPE4)PAR4; \
   Asm("syscall" : "=r"(r2) : "0"(r2), "r"(r4), "r"(r5), "r"(r6), "r"(r7) : "memory"); \
   return ((TYPE)r2)

#define CAL_SVC_5(TYPE, FNCD, TYPE1, PAR1, TYPE2, PAR2, TYPE3, PAR3, TYPE4, PAR4, TYPE5, PAR5) \
   register INT r2 asm("$2") = (INT)FNCD; \
   register TYPE1 r4 asm("$4") = (TYPE1)PAR1; \
   register TYPE2 r5 asm("$5") = (TYPE2)PAR2; \
   register TYPE3 r6 asm("$6") = (TYPE3)PAR3; \
   register TYPE4 r7 asm("$7") = (TYPE4)PAR4; \
   register TYPE5 r8 asm("$8") = (TYPE5)PAR5; \
   Asm("syscall" : "=r"(r2) : "0"(r2), "r"(r4), "r"(r5), "r"(r6), "r"(r7), "r"(r8)); \
   return ((TYPE)r2)

#define CAL_SVC_5M(TYPE, FNCD, TYPE1, PAR1, TYPE2, PAR2, TYPE3, PAR3, TYPE4, PAR4, TYPE5, PAR5) \
   register INT r2 asm("$2") = (INT)FNCD; \
   register TYPE1 r4 asm("$4") = (TYPE1)PAR1; \
   register TYPE2 r5 asm("$5") = (TYPE2)PAR2; \
   register TYPE3 r6 asm("$6") = (TYPE3)PAR3; \
   register TYPE4 r7 asm("$7") = (TYPE4)PAR4; \
   register TYPE5 r8 asm("$8") = (TYPE5)PAR5; \
   Asm("syscall" : "=r"(r2) : "0"(r2), "r"(r4), "r"(r5), "r"(r6), "r"(r7), "r"(r8) : "memory"); \
   return ((TYPE)r2)

#endif /* CALSVC_TRAP */
#endif /* _CPU_DEFS_H_ */
