/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001,2002 by Information-technology Promotion Agency, JAPAN
 *  Copyright (C) 2001,2002 by TRON Association, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2005-2006 by Japan Aerospace Exploration Agency.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ꥪ֥ȴ⥸塼
 */

#include "hrp_kernel.h"
#include "memory.h"

#ifndef GENERATE_MEMINIB
#else /* GENERATE_MEMINIB */

#define cpu_assert(a)

/*
 *  ꥪ֥Ƚ֥åθ
 */
/*
 *  CAUTION: .bss and .data are not initialized.
 *  CAUTION: useg is not available.
 */
Inline INT
cpu_search_meminib(VP addr)
{
	INT		left, right, i;

	left = 0;
	right = tnum_meminib - 1;
	while (left < right) {
		i = (left + right + 1) / 2;
		if (addr < memtop_table[i]) {
			right = i - 1;
		}
		else {
			left = i;
		}
	}
	return(left);
}

/*
 *  ꥪ֥ȴ⥸塼ν
 */
/*
 *  CAUTION: .bss and .data are not initialized.
 *  CAUTION: useg is not available.
 */
void
cpu_initialize_memory(void)
{
	const MEMINFO	*p_meminfo;
	VP				nexttop;
	INT				meminib;
	INT				i, j;

	/*
	 *  ꥪ֥Ƚ֥å
	 *
	 *  ΰ褬1Ĥζΰˤʤ褦롥
	 */
	tnum_meminib = 1;
	memtop_table[0] = (void *) 0;
	meminib_table[0].mematr = TA_UNUSED;
	meminib_table[0].acptn4 = 0u;
	meminib_table[0].acptn1 = 0u;
	meminib_table[0].acptn2 = 0u;

	for (p_meminfo = meminfo_table, i = 0; i < tnum_meminfo;
												p_meminfo++, i++) {
		/*
		 *  ƥꥪ֥ȽФơꥪ֥
		 *  ֥å롥ޤꥪ֥Ƚ
		 *  󤬼ΰޤꥪ֥Ȥõ줬
		 *  ΰǤʤΤϡꥪ֥Ƚ󤬼
		 *  ΰ˽Ťʤ꤬Ǥ롥
		 */
		meminib = cpu_search_meminib(p_meminfo->top);
		cpu_assert(meminib_table[meminib].mematr == TA_UNUSED);

		if (meminib + 1 < tnum_meminib) {
			nexttop = memtop_table[meminib + 1];
			cpu_assert(p_meminfo->limit <= nexttop);
		}
		else {
			nexttop = (void *) 0;
		}

		if (p_meminfo->top == memtop_table[meminib]) {
			if (p_meminfo->limit != nexttop) {
				for (j = tnum_meminib - 1; j >= meminib; j--) {
					memtop_table[j + 1] = memtop_table[j];
					meminib_table[j + 1] = meminib_table[j];
				}
				tnum_meminib += 1;
				memtop_table[meminib + 1] = p_meminfo->limit;
			}
		}
		else {
			if (p_meminfo->limit != nexttop) {
				for (j = tnum_meminib - 1; j >= meminib; j--) {
					memtop_table[j + 2] = memtop_table[j];
					meminib_table[j + 2] = meminib_table[j];
				}
				tnum_meminib += 2;
				memtop_table[meminib + 2] = p_meminfo->limit;
			}
			else {
				for (j = tnum_meminib - 1; j >= meminib; j--) {
					memtop_table[j + 1] = memtop_table[j];
					meminib_table[j + 1] = meminib_table[j];
				}
				tnum_meminib += 1;
			}
			meminib += 1;
			memtop_table[meminib] = p_meminfo->top;
		}
		meminib_table[meminib].mematr = p_meminfo->mematr;
		meminib_table[meminib].acptn4 = p_meminfo->acptn4;
		meminib_table[meminib].acptn1 = p_meminfo->acptn1;
		meminib_table[meminib].acptn2 = p_meminfo->acptn2;
	}
}

#endif /* GENERATE_MEMINIB */

/*
 *  bss򥯥ꥢ
 */
/*
 *  CAUTION: .bss and .data are not initialized.
 */
extern const UINT tnum_bss_section;
extern const struct { VP sbss; VP ebss; } bss_section_table[];
void cpu_initialize_bss(void) {
	int i;
	for (i = 0; i < tnum_bss_section; ++i) {
		char *c = bss_section_table[i].sbss;
		while (c < (char *)bss_section_table[i].ebss) {
			*c++ = 0;
		}
	}
}

/*
 *  data (ROMб)
 */
/*
 *  CAUTION: .bss and .data are not initialized.
 */
extern const UINT tnum_data_section;
extern const struct { VP sdata; VP sidata; VP eidata; } data_section_table[];
void cpu_initialize_data(void) {
	int i;
	for (i = 0; i < tnum_data_section; ++i) {
		char *d = data_section_table[i].sdata;
		char *s = data_section_table[i].sidata;
		while (s < (char *)data_section_table[i].eidata) {
			*d++ = *s++;
		}
	}
}
