/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2000-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2005-     by Monami Software Limited Partnership, JAPAN
 *  Copyright (C) 2005-2006 by Japan Aerospace Exploration Agency.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

#define _MACRO_ONLY

#include "hrp_kernel.h"

	.set at
	.set reorder

/*
 *  㳰٥ɥ쥹Ǥʬ (BEV=1)
 */

/*
 *  ɥꥻåȡեȥꥻåȡNMI(Non Maskable Interrupt)
 *     ơ쥸BEVӥåȤ
 *         ¸ʤ0xbfc00000  (kseg1ΰ表åʤ)
 */
	.section .vector_reset, "ax"
	.align 2

	.global start	/* ȥ꡼ݥ */

start:
reset_and_NMI:
	mfc0	kt0, Status
	li	kt1, SR_NMI
	and	kt1, kt0, kt1
	bne	kt1, zero, NMI_exception

	/* ɥꥻåȡեȥꥻåȻ */
	ABI_PLA	kt1, reset
	jr	kt1

	/* NMI  */
NMI_exception: /* infinite loop */
	b NMI_exception

/*
 *  TLB԰㳰
 *      ơ쥸BEVӥåȤ
 *          1ΤȤ0xbfc00200  (kseg1ΰ表åʤ)
 *          0ΤȤ0x80000000  (kseg0ΰ表å夢)
 */
	.section .vector_tlb, "ax"
	.align 2

TLB_miscompare_exception:
	.set noat
	ABI_PLA kt1, tlb_refill
	jr kt1
	.set at

/*
 *  XTLB԰㳰
 *      ơ쥸BEVӥåȤ
 *          1ΤȤ0xbfc00280  (kseg1ΰ表åʤ)
 *          0ΤȤ0x80000080  (kseg0ΰ表å夢)
 */
	.section .vector_xtlb, "ax"
	.align 2

XTLB_miscompare_exception:
	.set noat
	ABI_PLA kt1, tlb_refill
	jr kt1
	.set at

/*
 *  ¾㳰㳰/߽롼
 *  (MIPSƥϳߥ٥ơ֥ߤ㳰
 *   Ȥʬ)
 *      ơ쥸BEVӥåȤ
 *          1ΤȤ0xbfc00380  (kseg1ΰ表åʤ)
 *          0ΤȤ0x80000180  (kseg0ΰ表å夢)
 */
	.section .vector_other, "ax"
	.align 2

other_exception:
	.set noat
	ABI_PLA	kt1, general_exception
	jr	kt1
	.set at
