/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2000-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2005-2006 by Japan Aerospace Exploration Agency.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

#include "hrp_kernel.h"
#include "task.h"
#include "memory.h"

#define OFFSET_DEF(TYPE, FIELD)							\
	Asm("OFFSET_DEF " #TYPE "_" #FIELD " = %0"			\
	  : /* no output */									\
	  : "g"(offsetof(TYPE, FIELD)))

#define OFFSET_DEF2(TYPE, FIELD, FIELDNAME)				\
	Asm("OFFSET_DEF " #TYPE "_" #FIELDNAME " = %0"		\
	  : /* no output */									\
	  : "g"(offsetof(TYPE, FIELD)))

void
makeoffset(void)
{
	OFFSET_DEF(DOMINIB, domptn);

	OFFSET_DEF(TCB, p_tinib);
	OFFSET_DEF(TCB, p_dominib);
	OFFSET_DEF(TCB, svclevel);
	OFFSET_DEF(TCB, texptn);
	OFFSET_DEF2(TCB, tskctxb.sp, sp);
	OFFSET_DEF2(TCB, tskctxb.pc, pc);

	OFFSET_DEF(TINIB, exinf);
	OFFSET_DEF(TINIB, task);

#ifndef GENERATE_MEMINIB
#else /* GENERATE_MEMINIB */
	OFFSET_DEF(MEMINFO, mematr);
	OFFSET_DEF(MEMINFO, top);
#endif /* GENERATE_MEMINIB */
	OFFSET_DEF(MEMINIB, acptn1);
	OFFSET_DEF(MEMINIB, acptn2);
	OFFSET_DEF(MEMINIB, mematr);
	OFFSET_DEF2(TCB, tskctxb.usp, usp);
	OFFSET_DEF(TINIB, sstk);
	OFFSET_DEF(TINIB, sstksz);
}

UW	BIT_REF_4 = 0x12345678;
UH	BIT_REF_2 = 0x1234;
UB	BIT_REF_1 = 0x12;

#if SIL_ENDIAN == SIL_ENDIAN_BIG	/* ӥåǥץå */
TCB	BIT_BB_TCB_enatex = {
	/* BIT_BBӥåǥ
	           Хñ̤ǥӥåȥѥϤ */
#else /* SIL_ENDIAN == SIL_ENDIAN_BIG *//* ȥ륨ǥץå */
TCB	BIT_LB_TCB_enatex = {
	/* BIT_LBȥ륨ǥ
	           Хñ̤ǥӥåȥѥϤ */
#endif /* SIL_ENDIAN == SIL_ENDIAN_BIG */
	{ NULL, NULL }, NULL, NULL,
	0u, 0u, 0u, 0u,
	FALSE, FALSE, TRUE, FALSE,
	0u, NULL, { NULL, NULL },
	0u, { NULL, NULL, NULL }
};

#if SIL_ENDIAN == SIL_ENDIAN_BIG
TCB	BIT_BB_TCB_waifbd = {
#else
TCB	BIT_LB_TCB_waifbd = {
#endif
	{ NULL, NULL }, NULL, NULL,
	0u, 0u, 0u, 0u,
	FALSE, FALSE, FALSE, TRUE,
	0u, NULL, { NULL, NULL },
	0u, { NULL, NULL, NULL }
};
