/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2000-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2005-2010 by Monami Software Limited Partnership, JAPAN
 *  Copyright (C) 2005-2006 by Japan Aerospace Exploration Agency.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

#ifndef _MIPS32_H_
#define _MIPS32_H_

#include <util.h>

/*
 *  MIPS32 
 */

/* CPU쥸̾ */
#define zero    $0      /*  */
#define v0      $2      /* ؿ */
#define v1      $3
#define a0      $4      /* ؿΰ */
#define a1      $5
#define a2      $6
#define a3      $7
#define a4      $8
#define a5      $9
#define a6      $10
#define a7      $11
#define t4      $12     /* ƥݥ쥸 tx (x=4-7)ؿƤӽФ˲ */
#define t5      $13
#define t6      $14
#define t7      $15
#define s0      $16     /* sx (x=0-7) : ؿƤӽФѤʥ쥸 */
#define s1      $17
#define s2      $18
#define s3      $19
#define s4      $20
#define s5      $21
#define s6      $22
#define s7      $23
#define t8      $24     /* ƥݥ쥸 tx (x=8-9)ؿƤӽФ˲ */
#define t9      $25
#define kt0     $26     /* OSѤͽѤ */
#define kt1     $27
#define gp      $28     /* ѿΰΥ١ɥ쥹 */
#define sp      $29     /* åݥ */
#define s8      $30     /* s8 : ؿƤӽФѤʥ쥸 */
#define ra      $31     /* ؿꥢɥ쥹 */

/* CP0쥸̾ */
#define Index           $0
#define Random          $1
#define EntryLo0        $2
#define EntryLo1        $3
#define Context         $4
#define PageMask        $5
#define Wired           $6
#define Error           $7
#define BadVAddr        $8
#define Count           $9
#define EntryHi         $10
#define Compare         $11
#define Status          $12
#define Cause           $13
#define EPC             $14
#define PRId            $15
#define Config          $16
#define LLAddr          $17
#define WatchLo         $18
#define WatchHi         $19
#define XContext        $20
/* $21-$24 - ͽ */
#define Performance     $25
#define ParityErr       $26
#define CacheErr        $27
#define TagLo           $28
#define TagHi           $29
#define ErrorEPC        $30
/* $31 - ͽ */

/*  饤󥢥֥ǻȤ  */
#define str_Status	"$12"

/*  ơ쥸ط  */
#define SR_IE		BIT0			/*  IEӥå  */
#define SR_EXL		BIT1			/*  EXLӥå  */
#define SR_ERL		BIT2			/*  ERLӥå  */

#define SR_IM		0xff00			/*  IMӥåȤФޥ  */

#define SR_KSU 0x18
#define SR_KSU_Kernel 0x00
#define SR_KSU_User 0x10
#define SR_UX		BIT5			/*  UXӥå  */
#define SR_SX		BIT6			/*  SXӥå  */
#define SR_KX		BIT7			/*  SXӥå  */
#define SR_NMI BIT19
#define SR_SR		BIT20			/*  SRӥå  */
#define SR_TS BIT21
#define SR_BEV		BIT22			/*  BEVӥå  */
#define SR_RE		BIT25			/*  REӥå  */
#define SR_FR BIT26
#define SR_CU0		BIT28			/*  CU0ӥå  */
#define SR_CU1		BIT29			/*  CU1ӥå  */
#define SR_CU2		BIT30			/*  CU2ӥå  */
#define SR_XX		BIT31			/*  XXӥå  */

/*  쥸ط  */
#define Cause_IP0       BIT8    /*  IP0ӥå  */
#define Cause_IP1       BIT9    /*  IP1ӥå  */
#define Cause_IP2       BIT10   /*  IP2ӥå  */
#define Cause_IP3       BIT11   /*  IP3ӥå  */
#define Cause_IP4       BIT12   /*  IP4ӥå  */
#define Cause_IP5       BIT13   /*  IP5ӥå  */
#define Cause_IP6       BIT14   /*  IP6ӥå  */
#define Cause_IP7       BIT15   /*  IP7ӥå  */
#define Cause_WP BIT22
#define Cause_IV BIT23

/*  ߤФIPӥåȤ̾  */
#define Cause_Int0	Cause_IP2  /*  Int0׵ӥå  */
#define Cause_Int1	Cause_IP3  /*  Int1׵ӥå  */
#define Cause_Int2	Cause_IP4  /*  Int2׵ӥå  */
#define Cause_Int3	Cause_IP5  /*  Int3׵ӥå  */
#define Cause_Int4	Cause_IP6  /*  Int4׵ӥå  */

/*  쥸鸶ɤФޥ  */
#define ExcCode_mask    0x7c

/* 㳰 */
#define Int     0       /* 㳰 */
#define Mod     1       /* TLBѹ㳰 */
#define TLBL    2       /* TLB԰㳰 (ɤޤ̿եå) */
#define TLBS    3       /* TLB԰㳰 (ȥ) */
#define AdEL    4       /* ɥ쥹顼㳰 (ɤޤ̿եå) */
#define AdES    5       /* ɥ쥹顼㳰 (ȥ) */
#define IBE     6       /* Х顼㳰 (̿եå) */
#define DBE     7       /* Х顼㳰 (ǡΥɤޤϥȥ) */
#define Sys     8       /* ƥॳ㳰 */
#define Bp      9       /* ֥쥤ݥ㳰 */
#define RI      10      /* ͽ̿㳰 */
#define CpU     11      /* ץåԲ㳰 */
#define Ov      12      /* 黻Сե㳰 */
#define Tr      13      /* ȥå㳰 */
/* 14 - ͽ */
#define FPE     15      /* ư㳰 */
/* 16-22 - ͽ */
#define WATCH   23      /* å㳰 */
/* 24-31 - ͽ */

/* Cache Coherency Attributes */
#define CCA_Uncached 2
#define CCA_Cacheable 3

/* EntryLo0, EntryLo1 (CP0 Registers 2 and 3, Select 0) */
#define EntryLo_V BIT1
#define EntryLo_D BIT2

/* Configuration Register (CP0 Register 16, Select 0) */
#define Config_K0 0x7
#define Config_K0_Uncached CCA_Uncached
#define Config_K0_Cacheable CCA_Cacheable

/* Configuration Register 1 (CP0 Register 16, Select 1) */
#define Config1_WR BIT3

/* WatchLo Register (CP0 Register 18) */
#define WatchLo_W BIT0
#define WatchLo_R BIT1
#define WatchLo_I BIT2

/* WatchHi Register (CP0 Register 19) */
#define WatchHi_M BIT31

/*  װֹ  */
#define INTNO_IP0               0
#define INTNO_IP1               1
#define INTNO_IP2               2
#define INTNO_IP3               3
#define INTNO_IP4               4
#define INTNO_IP5               5
#define INTNO_IP6               6
#define INTNO_IP7               7

/*  γߤܿʥեȥߤޤ */
#define TNUM_CORE_INTNO		8

/*
 *  MIPS32Υơ쥸ǽʺǹߵĥӥåȥѥ
 */
#define MAX_IPM  0xff

/*
 *  CPU㳰μ
 */
#define TNUM_CORE_EXCNO	32u

/*
 *  ϻΥå¤
 *    default_exc_handlerؿcpu_support.S򻲾ȤΤȡ
 */
#ifndef _MACRO_ONLY

typedef struct exc_stack {

	/*  쥸  */
	UW	at;
	UW	v0;
	UW	v1;
	UW	a0;
	UW	a1;
	UW	a2;
	UW	a3;
	UW	a4;
	UW	a5;
	UW	a6;
	UW	a7;
	UW	t4;
	UW	t5;
	UW	t6;
	UW	t7;
	UW	t8;
	UW	t9;
	UW	gp;
	UW	ra;

	UW	hi;
	UW	lo;
	UW	CP0_EPC;

#if ABI_FPR == 0
#else /* ABI_FPR == 8 */
	UD f0;
	UD f1;
	UD f2;
	UD f3;
	UD f4;
	UD f5;
	UD f6;
	UD f7;
	UD f8;
	UD f9;
	UD f10;
	UD f11;
	UD f12;
	UD f13;
	UD f14;
	UD f15;
	UD f16;
	UD f17;
	UD f18;
	UD f19;
	UD f21;
	UD f23;
	UD f25;
	UD f27;
	UD f29;
	UD f31;
#endif

	UW	CP0_Status;
	UW CP0_Cause;

} EXCSTACK;

#endif /* _MACRO_ONLY */

#endif /* _MIPS32_H_ */
