/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2000-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2005-2010 by Monami Software Limited Partnership, JAPAN
 *  Copyright (C) 2005-2006 by Japan Aerospace Exploration Agency.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		Х󥿥ޥɥ饤СJAXA_MIPS_TENGINEѡ
 */

#ifndef _HW_OVRTIMER_H_
#define _HW_OVRTIMER_H_

#include <sil.h>
#include <t_config.h>

/*
 *  Х󥿥޳ߥϥɥϿΤ
 */
#define INHNO_OVRTIMER	INTNO_TMR1		/* ߥϥɥֹ */
#define INTNO_OVRTIMER	INTNO_TMR1		/* ֹ */
#define INTPRI_OVRTIMER	EXT_IPM(ICU_IPM_TMR1)		/* ͥ */
#define INTATR_OVRTIMER	TA_LOWLEVEL			/* ° */

#ifndef _MACRO_ONLY

/*
 *  ͤɽȥץå֤ȤѴ
 *
 *  JAXA_MIPS_TENGINEǤϡޤTIMER_CLOCK[kHz]˥ȥåפ롥
 */
#define TO_OVRCLOCK(ovrtim)		((UW)((UD)(ovrtim) * TIMER_CLOCK / 1000))
#define TO_OVRTIM(clk)			((OVRTIM)((UD)(clk) * 1000 / TIMER_CLOCK))

/*
 *  ¥ץå֤ȤƥХ󥿥ޤǤ
 */
#define TMAX_OVRTIM		TO_OVRTIM(0xffffffffu)

/*
 *  ޳׵Υꥢ
 */
Inline void hw_ovrtimer_int_clear() {
}

/*
 *  Х󥿥ޤν
 *
 *  Х󥿥ޤνԤޤưϤϹԤʤ
 *  ߥϥɥϿϡhw_ovrtimer.cfg򥳥ե졼˽
 *  뤳ȤǹԤ
 */
Inline void
hw_ovrtimer_initialize(void)
{
}

/*
 *  Х󥿥ޤư
 *
 *  Х󥿥ޤˡĤovrtimꤷưϤ롥ovrtim
 *  ñ̤ϦäȤ롥
 */
Inline void
hw_ovrtimer_start(OVRTIM ovrtim)
{
}

/*
 *  Х󥿥ޤ
 *
 *  Х󥿥ޤߤޤλĤ֤ɤ߽Ф⤷Ĥ
 *  0ʤޤϤ̤ˤˤʤäƤˤϡ1֤ޤХ
 *  󥿥ޤγߤ򥯥ꥢ롥
 */
Inline OVRTIM
hw_ovrtimer_stop(void)
{
	return 1;
}

/*
 *  Х󥿥ޤλĤ֤μ
 *
 *  Х󥿥ޤλĤ֤ɤ߽Ф
 */
Inline OVRTIM
hw_ovrtimer_get_current(void)
{
	return 0;
}

/*
 *  Х󥿥޳ߥϥɥ
 */
extern void	hw_ovrtimer_handler(void);

#endif /* _MACRO_ONLY */
#endif /* _HW_OVRTIMER_H_ */
