/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2000-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2005-2010 by Monami Software Limited Partnership, JAPAN
 *  Copyright (C) 2005-2006 by Japan Aerospace Exploration Agency.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ޥɥ饤СJAXA_MIPS_TENGINEѡ
 */

#ifndef _HW_TIMER_H_
#define _HW_TIMER_H_

#include <sil.h>
#include <t_config.h>

/*
 *  ޳ߥϥɥϿΤ
 */
#define INHNO_TIMER		INTNO_TMR0		/* ߥϥɥֹ */
#define INTNO_TIMER		INTNO_TMR0		/* ֹ */
#define INTPRI_TIMER	EXT_IPM(ICU_IPM_TMR0)		/* ͥ */
#define INTATR_TIMER	TA_LOWLEVEL			/* ° */

#ifndef _MACRO_ONLY

/*
 *  ͤɽη
 */
typedef UW		CLOCK;

/*
 *  ͤɽȥߥáñ̤ȤѴ
 *
 *  JAXA_MIPS_TENGINEǤϡޤTIMER_CLOCK[kHz]˥ȥåפ롥
 */
#define TO_CLOCK(nume, deno)	(TIMER_CLOCK * (nume) / (deno))
#define TO_USEC(clock)			((clock) * 1000u / TIMER_CLOCK)

/*
 *  ޼ñ̤ɽѴ
 */
#define CLOCK_PER_TICK		((CLOCK) TO_CLOCK(TIC_NUME, TIC_DENO))

/*
 *  ǤΥ޼ñ̤ɽ
 */
#define MAX_CLOCK		((CLOCK) 0xffffffff)	/* Х */

/*
 *  ޤθͤȯͤȤߤʤȽ
 */
#define GET_TOLERANCE	(TO_CLOCK(TIC_NUME, TIC_DENO) / 100)	/* ٤θѤ͡ñ̤ɽ*/
#define BEFORE_IREQ(clock) \
			((clock) >= TO_CLOCK(TIC_NUME, TIC_DENO) - GET_TOLERANCE)

/*
 *  ޳׵Υꥢ
 */
Inline void hw_timer_int_clear() {
	Asm(
			"mfc0 $2, $9; li $3, %0; addu $2, $2, $3; li $3, %1; and $2, $2, $3; mtc0 $2, $11"
			:
			: "i"((1 << TIMER_CLOCK_SHIFT) + TIMER_CLOCK_MARGIN), "i"((-1 << TIMER_CLOCK_SHIFT))
			: "$2", "$3"
	);
}

/*
 *  ޤεư
 *
 *  ޤŪʥ޳׵ȯ롥
 */
extern void	hw_timer_initialize(VP_INT exinf);

/*
 *  ޤ߽
 *
 *  ޤưߤ롥
 */
extern void	hw_timer_terminate(VP_INT exinf);

/*
 *  ޤθͤɽФ
 */
Inline CLOCK
hw_timer_get_current(void)
{
	UW count;
	Asm(
			"mfc0 %0, $9"
			: "=r"(count)
	);
	return count & ((1 << TIMER_CLOCK_SHIFT) - 1);
}

/*
 *  ޳׵Υå
 */
Inline BOOL
hw_timer_fetch_interrupt(void)
{
	UW cause;
	Asm(
			"mfc0 %0, $13"
			: "=r"(cause)
	);
	return cause & Cause_IP7;
}

/*
 *  ޳ߥϥɥ
 */
extern void	hw_timer_handler(void);

#endif /* _MACRO_ONLY */
#endif /* _HW_TIMER_H_ */
