/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2000-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2005-2010 by Monami Software Limited Partnership, JAPAN
 *  Copyright (C) 2005-2007 by Japan Aerospace Exploration Agency.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		åȥƥ¸⥸塼JAXA_MIPS_TENGINEѡ
 *
 *  Υ󥯥롼ɥեϡt_config.hΤߤ饤󥯥롼ɤ롥
 *  ¾Υե뤫ľܥ󥯥롼ɤƤϤʤʤ
 */

#ifndef _SYS_CONFIG_H_
#define _SYS_CONFIG_H_

/*
 *  ͥ̾Υ͡
 */
#include <sys_rename.h>
#ifndef _MACRO_ONLY
extern PRI dummy_ipm;
#endif

/*  Τγߤܿ  */
#define TMIN_ICU_INTNO 0
#define TNUM_ALL_INTNO	(TMIN_ICU_INTNO + TNUM_ICU_INTNO)

#ifndef _MACRO_ONLY

/*  ߥϥɥ顿ߥޥơ֥Ѥη  */
typedef struct {
	FP inthdr; /* DEF_INHͿ줿inthdr */
	UH intatr; /* CFG_INTͿ줿intatrβ16ӥå */
	UH intpri; /* CFG_INTͿ줿intpriȿž */
} INT_TABLE;

#endif /* _MACRO_ONLY */

/*
 *  åȥƥΥϡɥ񸻤
 */
#include <board.h>
#define INTNO_TMR0 7
#define INTNO_TMR1 8 /* unused */
#define MAX_ICU_ILV 1
#define TNUM_ICU_INTNO 32
#define INTNO_SIO0 4
#include <mips.h>

/*
 *  ֹϰϤȽ
 */
#define	VALID_INTNO(intno) (0 <= (intno) && (intno) < TNUM_ALL_INTNO)

/*
 *  ưåΥåȥƥ̾
 */
#define TARGET_NAME	"HR5000/T-Engine"

/* ͥ뵯ưΥå */
#define COPYRIGHT_SYS \
"Copyright (C) 2005-2007 by Japan Aerospace Exploration Agency.\n"

#ifndef _MACRO_ONLY
/*
 *  ׵Υޥ
 *
 *  ׵ޥ뵡ǽ򥵥ݡȤƤʤˤϡFALSE֤
 */
Inline BOOL
x_disable_int(INTNO intno)
{
	return TRUE;
}

#define t_disable_int(intno)	x_disable_int(intno)
#define i_disable_int(intno)	x_disable_int(intno)

/*
 *  ׵Υޥ
 *
 *  ׵ޥ뵡ǽ򥵥ݡȤƤʤˤϡFALSE֤
 */
Inline BOOL
x_enable_int(INTNO intno)
{
	return TRUE;
}

#define t_enable_int(intno)	x_enable_int(intno)
#define i_enable_int(intno)	x_enable_int(intno)

/*
 *  ׵Υꥢ
 */
Inline void
x_clear_int(INTNO intno)
{
}

#define t_clear_int(intno)	x_clear_int(intno)
#define i_clear_int(intno)	x_clear_int(intno)

/*
 *  ׵饤°
 *
 */
Inline void
x_config_int(INTNO intno, ATR intatr, PRI intpri)
{
}

/*
 *  ߥϥɥɬפIRC
 *
 *  åȥꥬξˤϡ׵򥯥ꥢ롥åȥꥬ
 *  ȥꥬǤ⡤ߤͤ򸫤˥ꥢƤ롥
 */
Inline void
i_begin_int(INTNO intno)
{
	i_clear_int(intno);
}

/*
 *  ߥϥɥνиɬפIRC
 *
 *  JAXA_MIPS_TENGINEǤɬפIRCϤʤ
 */
Inline void
i_end_int(INTNO intno)
{
}

#endif /* _MACRO_ONLY */

/*
 *  Хϥɥ򥵥ݡȤ뤫ɤ
 */
#define SUPPORT_OVR

/*
 *  get_utm򥵥ݡȤ뤫ɤ
 */
#define SUPPORT_GET_UTM

/*
 *  ԤΤ
 */
#define	SIL_DLY_TIM1	2865	/* ؿsil_dly_nseפѤˤϡѹ뤳 */
#define	SIL_DLY_TIM2	398	/* ؿsil_dly_nseפѤˤϡѹ뤳 */

#ifndef _MACRO_ONLY

/*
 *  åȥƥ¸ν
 */
extern void	sys_initialize(void);

/*
 *  åȥƥνλ
 *
 *  ƥλ˻ȤROM˥GDB STUBƽФǼ¸롥
 */
extern void	sys_exit(void) NoReturn;

/*
 *  åȥƥʸ
 *
 *  ƥ٥ʸϥ롼ROM˥GDB STUBƽФǼ
 *  롥
 */
extern void	sys_putc(char c);

#endif /* _MACRO_ONLY */

/*
 *  MMUΥڡ
 */
#define PAGE_SIZE		8192

/*
 *  ͥ٥ޥ饤֥
 */

/*
 *  ͥ٥ޥγɽɽѴ
 */
#define EXT_IPM(iipm)	(-(iipm))	/* ɽɽѴ */
#define INT_IPM(ipm)	(-(ipm))	/* ɽɽѴ */

#ifndef _MACRO_ONLY

/*
 *  ͥ٥ޥ
 */
Inline void
x_set_ipm(PRI intpri)
{
	dummy_ipm = intpri;
}

#define t_set_ipm(intpri)	x_set_ipm(intpri)
#define i_set_ipm(intpri)	x_set_ipm(intpri)

/*
 *  ͥ٥ޥλ
 */
Inline PRI
x_get_ipm(void)
{
	return dummy_ipm;
}

#define t_get_ipm()	x_get_ipm()
#define i_get_ipm()	x_get_ipm()

/*
 *  ߥϥɥ
 */

/*  ߥϥɥ顿ߥޥơ֥  */
extern const INT_TABLE int_table[ TNUM_ALL_INTNO ];

/*
 *  ߥϥɥ
 *
 *  ٥ȥֹinhnoγߥϥɥεưϤinthdrꤹ롥
 */
Inline void
x_define_inh(INHNO inhno, FP inthdr)
{
}

/*
 *  ߥϥɥν
 */

/*
 *  ߥϥɥޥ
 */

#define INT_ENTRY(inthdr) inthdr

#define	INTHDR_ENTRY(inthdr)  extern void inthdr(void)

/*
 *  Ѥδؿ
 */

/* ϿƤʤȯΥ */
extern void default_int_handler(void);

#endif /* _MACRO_ONLY */

/*============================================================================*/
/* ʲϡ̥ɥȤ̵ȼ */

/*  MIPS32δط */
/*  ¼ŪʳϡߥȥǹԤᡢMIPS32˴ؤƤ
    ǽʬĤ롣*/
#define INIT_CORE_IPM	(Cause_IP7 | Cause_IP4)

/*
 *  ơ쥸ν
 */
#define INIT_STATUS_AND (SR_SR | SR_NMI)
#if STATUS_BEV == 0
#define INIT_STATUS_OR (SR_CU1 | SR_FR | SR_KX | SR_SX | SR_UX | INIT_CORE_IPM)
#else /* STATUS_BEV == 1 */
#define INIT_STATUS_OR (SR_CU1 | SR_FR | SR_BEV | SR_KX | SR_SX | SR_UX | INIT_CORE_IPM)
#endif

/*
 *  쥸ν
 */
#define INIT_CAUSE_AND ~(Cause_IV | Cause_WP | Cause_IP1 | Cause_IP0)
#define INIT_CAUSE_OR 0

/*
 *  ե쥸ν
 */
#define INIT_CONFIG_AND ~(Config_K23 | Config_KU | Config_K0)
#define INIT_CONFIG_OR (Config_K23_Uncached | Config_KU_Uncached | Config_K0_Uncached)

/*
 *  FCSR macro
 */
#if ABI_FPR == 0
#else /* ABI_FPR == 8 */
#define INIT_FCSR 0
#endif

/*
 *  hardware_init_hook constant
 */
#ifndef _MACRO_ONLY
extern const UB mematr_cache_config[];
#endif /* _MACRO_ONLY */

/*
 *  memory object macro
 */
#define MEMATR_CACHE_C(c) ((c) & TA_UNCACHE ? CCA_Uncached : (c) & TA_WTHROUGH ? CCA_Cacheable_writethrough_writeallocate : CCA_Cacheable_writeback)
#define MEMATR_CACHE_CDVG(c, d, v, g) (MEMATR_CACHE_C(c) << 3 | ((d) ? 1 : 0) << 2 | ((v) ? 1 : 0) << 1 | ((g) ? 1 : 0))
#define MEMATR_CACHE_MASK (0x3 << MEMATR_CACHE_SHIFT)
#define MEMATR_CACHE_SHIFT 1

/*
 *  tlb_refill constant
 */
#ifndef _MACRO_ONLY
extern const UB mematr_cache_entrylo[];
#endif /* _MACRO_ONLY */

/*
 *  tlb_refill variable
 */
#ifndef _MACRO_ONLY
extern UW tlb_refill_register[];
#endif /* _MACRO_ONLY */

/*
 *  tlb_umode macro
 */
#define UNUSED_ASID 0xff
#define UNUSED_CDVG (CCA_Uncached << 3)

/*
 *  tlb_umode variable
 */
#ifndef _MACRO_ONLY
extern VP tlb_umode_task;
#endif /* _MACRO_ONLY */

#endif /* _SYS_CONFIG_H_ */
