/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2000-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2005-2010 by Monami Software Limited Partnership, JAPAN
 *  Copyright (C) 2005-2006 by Japan Aerospace Exploration Agency.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		åȥƥ¸⥸塼 ֥JAXA_MIPS_TENGINEѡ
 */

#define	_MACRO_ONLY
#include "hrp_kernel.h"
#include "offset.h"
#include "memory.h"
#define dmfc0 mfc0
#define dmtc0 mtc0
#define dsrl srl
#define ld lw
#define sd sw

	.set at
	.set reorder

/*
 *  åȥϡɥ¸
 */
	.section .text_reset, "ax"
	.align 2
	.global	hardware_init_hook

hardware_init_hook:

	/*
	 * åν
	 */
	mtc0	zero, TagLo
	mtc0	zero, TagHi

	mfc0 t4, Config, 1
	srl t5, t4, 19
	andi t5, t5, 7 /* t5 = Config1.IL */
	beq t5, zero, hardware_init_hook_2 /* branch if Config1.IL == 0 */
	li t8, 2
	sllv t5, t8, t5 /* t5 = 2 << Config1.IL */
	srl t6, t4, 22
	andi t6, t6, 7 /* t6 = Config1.IS */
	li t8, 64
	sllv t6, t8, t6 /* t6 = 64 << Config1.IS */
	srl t7, t4, 16
	andi t7, t7, 7 /* t7 = Config1.IA */
	li t8, 0xffffffff80000000
hardware_init_hook_0:
	move t9, t6
hardware_init_hook_1:
	cache Index_Store_Tag_I, (t8)
	addu t8, t8, t5
	addiu t9, t9, -1
	bne t9, zero, hardware_init_hook_1
	addiu t7, t7, -1
	bgez t7, hardware_init_hook_0
hardware_init_hook_2:

	srl t5, t4, 10
	andi t5, t5, 7 /* t5 = Config1.DL */
	beq t5, zero, hardware_init_hook_5 /* branch if Config1.DL == 0 */
	li t8, 2
	sllv t5, t8, t5 /* t5 = 2 << Config1.DL */
	srl t6, t4, 13
	andi t6, t6, 7 /* t6 = Config1.DS */
	li t8, 64
	sllv t6, t8, t6 /* t6 = 64 << Config1.DS */
	srl t7, t4, 7
	andi t7, t7, 7 /* t7 = Config1.DA */
	li t8, 0xffffffff80000000
hardware_init_hook_3:
	move t9, t6
hardware_init_hook_4:
	cache Index_Store_Tag_D, (t8)
	addu t8, t8, t5
	addiu t9, t9, -1
	bne t9, zero, hardware_init_hook_4
	addiu t7, t7, -1
	bgez t7, hardware_init_hook_3
hardware_init_hook_5:

#ifndef GENERATE_MEMINIB
	ABI_PLA t4, tnum_meminib
	lw t4, (t4)
	ABI_PLA t5, meminib_table
	ABI_PLA t6, memtop_table
	li t7, 0xffffffffe0000000
	li t8, 0xffffffff80000000
hardware_init_hook_6:
	beq t4, zero, hardware_init_hook_9
	lw t9, MEMINIB_mematr(t5) /* t9 = meminib_table[].mematr */
	beq t9, zero, hardware_init_hook_7 /* branch if meminib_table[].mematr == 0 */
	ABI_PL t9, (t6) /* t9 = memtop_table[] */
	and t9, t9, t7
	beq t9, t8, hardware_init_hook_8 /* branch if memtop_table[] & 0xffffffffe0000000 == 0xffffffff80000000 */
hardware_init_hook_7:
	addiu t4, t4, -1
	ABI_PADDIU t5, t5, 16 /* t5 += sizeof(MEMINIB) */
	ABI_PADDIU t6, t6, 4 /* t6 += sizeof(VP) */
	b hardware_init_hook_6
hardware_init_hook_8:
	ABI_PLA t4, mematr_cache_config
	lw t5, MEMINIB_mematr(t5) /* t5 = meminib_table[].mematr */
	andi t5, t5, MEMATR_CACHE_MASK
	srl t5, t5, MEMATR_CACHE_SHIFT
	ABI_PADDU t4, t4, t5
	lb t4, (t4) /* t4 = mematr_cache_config[] */
	mfc0 t5, Config
	ori t5, t5, Config_K0
	xori t5, t5, Config_K0
	or t5, t5, t4
	mtc0 t5, Config /* K0 = mematr_cache_config[] */
hardware_init_hook_9:
#else /* GENERATE_MEMINIB */
	ABI_PLA t4, tnum_meminfo
	lw t4, (t4)
	ABI_PLA t5, meminfo_table
	li t6, 0xffffffffe0000000
	li t7, 0xffffffff80000000
hardware_init_hook_6:
	beq t4, zero, hardware_init_hook_8
	ABI_PL t8, MEMINFO_top(t5) /* t8 = meminfo_table[].top */
	and t8, t8, t6
	beq t8, t7, hardware_init_hook_7 /* branch if meminfo_table[].top & 0xffffffffe0000000 == 0xffffffff80000000 */
	addiu t4, t4, -1
	ABI_PADDIU t5, t5, 24 /* t5 += sizeof(MEMINFO) */
	b hardware_init_hook_6
hardware_init_hook_7:
	ABI_PLA t4, mematr_cache_config
	lw t5, MEMINFO_mematr(t5) /* t5 = meminfo_table[].mematr */
	andi t5, t5, MEMATR_CACHE_MASK
	srl t5, t5, MEMATR_CACHE_SHIFT
	ABI_PADDU t4, t4, t5
	lb t4, (t4) /* t4 = mematr_cache_config[] */
	mfc0 t5, Config
	ori t5, t5, Config_K0
	xori t5, t5, Config_K0
	or t5, t5, t4
	mtc0 t5, Config /* K0 = mematr_cache_config[] */
hardware_init_hook_8:
#endif /* GENERATE_MEMINIB */

	/*
	 * TLBν
	 */
	mtc0 zero, Index /* Index = 0 */
	mtc0 zero, PageMask /* Mask = 4Kbyte */
	li t4, 2
	mtc0 t4, Wired /* Wired = 2 */
	dmtc0 zero, EntryHi /* ASID = 0 */

	/*
	 * ܡɤν
	 */

	/* ɬפʤС˥ꥳȥνΥɤ */

	/* ɬפʤСߥȥ */

	/* ɬפʤС˳߸Х⡼ɥ쥸Υɤ */


	/*----------*/

	j	ra		/*  ƤӽФإ꥿  */

/*============================================================================*/

/* ߽˴ؤ롢װȽʬΥƥ¸ */

	/*  ƤӽФ줿Ȥ       */
	/*    t4˥ơ쥸 */
	/*    t5˸쥸       */
	/*  ͤäƤ         */

	.section .text_unmapped, "ax"
	.align 2
	.global proc_interrupt_sys
proc_interrupt_sys:
/*  ߥȥICUIPM򥹥å¸  */

	and     a6, t5, t4          /*  ׵ӥåȤ˥ޥ򤫤  */
	sll t7, a6, 16
	clz t7, t7 /* t7 = (a6 & Cause_IP7) ? 0 : (a6 & Cause_IP6) ? 1 : (a6 & Cause_IP5) ? 2 : ... */
	li a4, 7
	subu a4, a4, t7

	/* ʤ餫θʬǤʤ */
	bltz a4,       proc_interrupt_sys_2

/*  MIPS32٥ʬ٥Ǥν	*/
/*    װֹa4		*/
/*    ϡɥߤξˤϡset_ICU_IPM				*/

/*  ߥȥ¸Υޥ  */

/*  ơ쥸ΥޥC롼ƤӽФ  */
/*    a4˳װֹ椬ꤵ줿֤Ǥ  */
	ABI_PLA      a7, int_table   /* ٥ɥ쥹 */
.if ABI_POINTER == 4
	sll     t6, a4, 3       /* װֹ8
				      INT_TABLEϡ8Хȡ */
.else /* ABI_POINTER == 8 */
	sll t6, a4, 4
.endif
	ABI_PADDU     t5, a7, t6      /* ٥ɥ쥹򻻽 */
	ABI_PL      t7, (t5)        /* C롼Ƭɥ쥹ɤ߽Ф */

	ori t6, t4, (INIT_CORE_IPM | SR_KSU | SR_EXL)
	xori t6, t6, (INIT_CORE_IPM | SR_KSU | SR_EXL)
	mtc0    t6, Status      /* ߵġơ쥸Υޥ*/
	jalr    ra, t7          /* C롼ƤӽФ  */

	mfc0    a4, Status
	ori a4, a4, (INIT_CORE_IPM | SR_IE)
	xori     a4, a4, SR_IE  /* ߶ػ*/
	mtc0    a4, Status
	CLEAR_HAZARD_STATUS_INTERRUPT_DISABLE

proc_interrupt_sys_2:
/*  ߥȥICUIPM򥹥å  */

	ABI_PLA v1, join_interrupt_and_exception
	jr v1

/*
 *  TLB and XTLB Refill Exceptions (if Status.EXL == 0 at the time of exception)
 */
	.section .text_unmapped, "ax"
	.align 2
	.global tlb_refill
tlb_refill:
	.set noat
	ABI_PLA kt1, tlb_refill_register
	sd t4, 0*ABI_GPR(kt1)
	sd t5, 1*ABI_GPR(kt1)
	sd t6, 2*ABI_GPR(kt1)
	sd t7, 3*ABI_GPR(kt1)
	sd t8, 4*ABI_GPR(kt1)
	sd t9, 5*ABI_GPR(kt1)

	dmfc0 t4, BadVAddr
	move t5, zero /* left = 0 */
	ABI_PLA t6, tnum_meminib
	lw t6, (t6)
	addiu t6, t6, -1 /* right = tnum_meminib - 1 */
	ABI_PLA t7, memtop_table
tlb_refill_0:
	sltu t8, t5, t6
	beq t8, zero, tlb_refill_2 /* branch if left >= right */
	addu t8, t5, t6
	addiu t8, t8, 1
	srl t8, t8, 1 /* i = (left + right + 1) / 2 */
	sll t9, t8, 2 /* t9 = i * sizeof(VP) */
	ABI_PADDU t9, t7, t9 /* t9 = &memtop_table[i] */
	ABI_PL t9, (t9)
	sltu t9, t4, t9
	beq t9, zero, tlb_refill_1 /* branch if BadVAddr >= memtop_table[i] */
	addiu t6, t8, -1 /* right = i - 1 */
	b tlb_refill_0
tlb_refill_1:
	move t5, t8 /* left = i */
	b tlb_refill_0
tlb_refill_2:
	ABI_PLA t6, meminib_table
	sll t5, t5, 4 /* t5 = left * sizeof(MEMINIB) */
	ABI_PADDU t5, t6, t5 /* t5 = &meminib_table[left] */

	ABI_PLA t6, mematr_cache_entrylo
	lw t7, MEMINIB_mematr(t5) /* t7 = meminib_table[].mematr */
	andi t8, t7, MEMATR_CACHE_MASK
	srl t8, t8, MEMATR_CACHE_SHIFT
	ABI_PADDU t6, t6, t8
	lb t6, (t6) /* t6 = mematr_cache_entrylo[] */
	andi t7, t7, TA_USTACK
	beq t7, zero, tlb_refill_3 /* branch if meminib_table[].mematr & TA_USTACK == 0 */
	mfc0 t7, Status
	andi t7, t7, SR_KSU
	bne t7, zero, tlb_refill_8 /* branch if Status.KSU != 0 */
	ori t6, t6, (EntryLo_D | EntryLo_V)
	b tlb_refill_7

tlb_refill_3:
	mfc0 t7, Status
	andi t7, t7, SR_KSU
	bne t7, zero, tlb_refill_4 /* branch if Status.KSU != 0 */
	li t7, 0x80000000
	b tlb_refill_5
tlb_refill_4:
	ABI_PLA t7, rundom
	lw t7, (t7)
tlb_refill_5:
	lw t8, MEMINIB_acptn1(t5) /* t8 = meminib_table[].acptn1 */
	and t8, t8, t7
	beq t8, zero, tlb_refill_6
	ori t6, t6, (EntryLo_D | EntryLo_V)
	b tlb_refill_7
tlb_refill_6:
	lw t8, MEMINIB_acptn2(t5) /* t8 = meminib_table[].acptn2 */
	and t8, t8, t7
	beq t8, zero, tlb_refill_7
	ori t6, t6, EntryLo_V
tlb_refill_7:
	dsrl t4, t4, 6
	li t7, 0x3fffff80
	and t4, t4, t7 /* t4 = (BadVAddr & 0xfffffe000) >> 6 */
	or t4, t4, t6
	mtc0 t4, EntryLo0 /* PFN = (BadVAddr & 0xfffffe000) >> 12 */
	ori t4, t4, 0x40
	mtc0 t4, EntryLo1 /* PFN = ((BadVAddr & 0xfffffe000) + 0x1000) >> 12 */
	ssnop
	tlbwr /* hazard 6 - (4..7 + 1) */

	ld t9, 5*ABI_GPR(kt1)
	ld t8, 4*ABI_GPR(kt1)
	ld t7, 3*ABI_GPR(kt1)
	ld t6, 2*ABI_GPR(kt1)
	ld t5, 1*ABI_GPR(kt1)
	ld t4, 0*ABI_GPR(kt1)
	eret

tlb_refill_8:
	ABI_PL t7, MEMINIB_acptn1(t5) /* t7 = meminib_table[].acptn1 */
	ABI_PLA t8, p_runtsk
	ABI_PL t8, (t8)
	bne t7, t8, tlb_refill_9 /* branch if meminib_table[].acptn1 != p_runtsk */
	ori t6, t6, (EntryLo_D | EntryLo_V)
tlb_refill_9:
	dsrl t4, t4, 6
	li t7, 0x3fffff80
	and t4, t4, t7 /* t4 = (BadVAddr & 0xfffffe000) >> 6 */
	or t4, t4, t6
	mtc0 t4, EntryLo0 /* PFN = (BadVAddr & 0xfffffe000) >> 12 */
	ori t4, t4, 0x40
	mtc0 t4, EntryLo1 /* PFN = ((BadVAddr & 0xfffffe000) + 0x1000) >> 12 */
	ssnop
	tlbwi /* hazard 6 - (4..7 + 1) */
	mfc0 t7, Index
	xori t7, t7, 1
	mtc0 t7, Index

	ld t9, 5*ABI_GPR(kt1)
	ld t8, 4*ABI_GPR(kt1)
	ld t7, 3*ABI_GPR(kt1)
	ld t6, 2*ABI_GPR(kt1)
	ld t5, 1*ABI_GPR(kt1)
	ld t4, 0*ABI_GPR(kt1)
	eret
	.set at

/*
 *  TLB for user mode
 */
	.section .text_unmapped, "ax"
	.align 2
	.global tlb_umode
tlb_umode:
	ABI_PLA t4, tlb_umode_task
	ABI_PL t5, (t4)
	ABI_PLA t6, p_runtsk
	ABI_PL t6, (t6)
	beq t5, t6, tlb_umode_0 /* branch if tlb_umode_task == p_runtsk */
	ABI_PS t6, (t4)
	dmfc0 t4, EntryHi
	mtc0 zero, Index /* Index = 0 */
	li t5, UNUSED_CDVG
	mtc0 t5, EntryLo0
	mtc0 t5, EntryLo1
	li t5, (0x0000 | UNUSED_ASID)
	dmtc0 t5, EntryHi /* VPN2 = 0 */
	ssnop
	tlbwi /* hazard 6 - (4..7 + 1) */
	li t5, 1
	mtc0 t5, Index /* Index = 1 */
	li t5, (0x2000 | UNUSED_ASID)
	dmtc0 t5, EntryHi /* VPN2 = 1 */
	ssnop
	tlbwi /* hazard 6 - (4..7 + 1) */
	dmtc0 t4, EntryHi
tlb_umode_0:
	jr ra
