/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2005-2006 by Japan Aerospace Exploration Agency.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ȯĶ¸⥸塼
 *
 *  Υ󥯥롼ɥեϡt_config.hΤߤ饤󥯥롼ɤ롥
 *  ¾Υե뤫ľܥ󥯥롼ɤƤϤʤʤ
 */

#ifndef _TOOL_CONFIG_H_
#define _TOOL_CONFIG_H_

/*
 *  ȯĶ¸νϻѤʤ
 */
#define tool_initialize()

/*
 *  atexit νȥǥȥ饯μ¹
 */
#ifndef _MACRO_ONLY

Inline void
call_atexit(void)
{
	extern void	software_term_hook(void);
	volatile FP	fp = software_term_hook;

	/*
	 *  software_term_hookؤΥݥ󥿤򡤰övolatile FPfp
	 *  ƤȤΤϡ0ȤӤŬǺʤ褦
	 *  ˤ뤿Ǥ롥
	 */
	if (fp != 0) {
		(*fp)();
	}
}

#endif /* _MACRO_ONLY */

/*
 *  ȥ졼
 */

#define LOG_KER_ENTER()
#define LOG_KER_LEAVE()

#define LOG_INH_ENTER(inhno)			/* åȰ¸ */
#define LOG_INH_LEAVE(inhno)			/* åȰ¸ */

#define LOG_ISR_ENTER(intno)			/* åȰ¸ */
#define LOG_ISR_LEAVE(intno)			/* åȰ¸ */

#define LOG_CYC_ENTER(p_cyccb)
#define LOG_CYC_LEAVE(p_cyccb)

#define LOG_ALM_ENTER(p_almcb)
#define LOG_ALM_LEAVE(p_almcb)

#define LOG_EXC_ENTER(excno)			/* åȰ¸ */
#define LOG_EXC_LEAVE(excno)			/* åȰ¸ */

#define LOG_TEX_ENTER(texptn)
#define LOG_TEX_LEAVE(texptn)

#define LOG_TSKSTAT(p_tcb)

#define LOG_DSP_ENTER(p_tcb)			/* åȰ¸ */
#define LOG_DSP_LEAVE(p_tcb)			/* åȰ¸ */

#define LOG_ACT_TSK_ENTER(tskid)
#define LOG_ACT_TSK_LEAVE(ercd)
#define LOG_IACT_TSK_ENTER(tskid)
#define LOG_IACT_TSK_LEAVE(ercd)
#define LOG_CAN_ACT_ENTER(tskid)
#define LOG_CAN_ACT_LEAVE(ercd)
#define LOG_EXT_TSK_ENTER()
#define LOG_EXT_TSK_LEAVE(ercd)
#define LOG_TER_TSK_ENTER(tskid)
#define LOG_TER_TSK_LEAVE(ercd)
#define LOG_CHG_PRI_ENTER(tskid, tskpri)
#define LOG_CHG_PRI_LEAVE(ercd)
#define LOG_GET_PRI_ENTER(tskid, p_tskpri)
#define LOG_GET_PRI_LEAVE(ercd, tskpri)
#define LOG_REF_TSK_ENTER(tskid, pk_rtsk)
#define LOG_REF_TSK_LEAVE(ercd, pk_rtsk)

#define LOG_SLP_TSK_ENTER()
#define LOG_SLP_TSK_LEAVE(ercd)
#define LOG_TSLP_TSK_ENTER(tmout)
#define LOG_TSLP_TSK_LEAVE(ercd)
#define LOG_WUP_TSK_ENTER(tskid)
#define LOG_WUP_TSK_LEAVE(ercd)
#define LOG_IWUP_TSK_ENTER(tskid)
#define LOG_IWUP_TSK_LEAVE(ercd)
#define LOG_CAN_WUP_ENTER(tskid)
#define LOG_CAN_WUP_LEAVE(ercd)
#define LOG_REL_WAI_ENTER(tskid)
#define LOG_REL_WAI_LEAVE(ercd)
#define LOG_IREL_WAI_ENTER(tskid)
#define LOG_IREL_WAI_LEAVE(ercd)
#define LOG_SUS_TSK_ENTER(tskid)
#define LOG_SUS_TSK_LEAVE(ercd)
#define LOG_RSM_TSK_ENTER(tskid)
#define LOG_RSM_TSK_LEAVE(ercd)
#define LOG_FRSM_TSK_ENTER(tskid)
#define LOG_FRSM_TSK_LEAVE(ercd)
#define LOG_DLY_TSK_ENTER(dlytim)
#define LOG_DLY_TSK_LEAVE(ercd)

#define LOG_RAS_TEX_ENTER(tskid, rasptn)
#define LOG_RAS_TEX_LEAVE(ercd)
#define LOG_IRAS_TEX_ENTER(tskid, rasptn)
#define LOG_IRAS_TEX_LEAVE(ercd)
#define LOG_DIS_TEX_ENTER()
#define LOG_DIS_TEX_LEAVE(ercd)
#define LOG_ENA_TEX_ENTER()
#define LOG_ENA_TEX_LEAVE(ercd)
#define LOG_SNS_TEX_ENTER()
#define LOG_SNS_TEX_LEAVE(state)
#define LOG_REF_TEX_ENTER(tskid, pk_rtex)
#define LOG_REF_TEX_LEAVE(ercd, pk_rtex)

#define LOG_SIG_SEM_ENTER(semid)
#define LOG_SIG_SEM_LEAVE(ercd)
#define LOG_ISIG_SEM_ENTER(semid)
#define LOG_ISIG_SEM_LEAVE(ercd)
#define LOG_WAI_SEM_ENTER(semid)
#define LOG_WAI_SEM_LEAVE(ercd)
#define LOG_POL_SEM_ENTER(semid)
#define LOG_POL_SEM_LEAVE(ercd)
#define LOG_TWAI_SEM_ENTER(semid, tmout)
#define LOG_TWAI_SEM_LEAVE(ercd)
#define LOG_INI_SEM_ENTER(semid)
#define LOG_INI_SEM_LEAVE(ercd)
#define LOG_REF_SEM_ENTER(semid, pk_rsem)
#define LOG_REF_SEM_LEAVE(ercd, pk_rsem)

#define LOG_SET_FLG_ENTER(flgid, setptn)
#define LOG_SET_FLG_LEAVE(ercd)
#define LOG_ISET_FLG_ENTER(flgid, setptn)
#define LOG_ISET_FLG_LEAVE(ercd)
#define LOG_CLR_FLG_ENTER(flgid, clrptn)
#define LOG_CLR_FLG_LEAVE(ercd)
#define LOG_WAI_FLG_ENTER(flgid, waiptn, wfmode, p_flgptn)
#define LOG_WAI_FLG_LEAVE(ercd, flgptn)
#define LOG_POL_FLG_ENTER(flgid, waiptn, wfmode, p_flgptn)
#define LOG_POL_FLG_LEAVE(ercd, flgptn)
#define LOG_TWAI_FLG_ENTER(flgid, waiptn, wfmode, p_flgptn, tmout)
#define LOG_TWAI_FLG_LEAVE(ercd, flgptn)
#define LOG_INI_FLG_ENTER(flgid)
#define LOG_INI_FLG_LEAVE(ercd)
#define LOG_REF_FLG_ENTER(flgid, pk_rflg)
#define LOG_REF_FLG_LEAVE(ercd, pk_rflg)

#define LOG_SND_DTQ_ENTER(dtqid, data)
#define LOG_SND_DTQ_LEAVE(ercd)
#define LOG_PSND_DTQ_ENTER(dtqid, data)
#define LOG_PSND_DTQ_LEAVE(ercd)
#define LOG_IPSND_DTQ_ENTER(dtqid, data)
#define LOG_IPSND_DTQ_LEAVE(ercd)
#define LOG_TSND_DTQ_ENTER(dtqid, data, tmout)
#define LOG_TSND_DTQ_LEAVE(ercd)
#define LOG_FSND_DTQ_ENTER(dtqid, data)
#define LOG_FSND_DTQ_LEAVE(ercd)
#define LOG_IFSND_DTQ_ENTER(dtqid, data)
#define LOG_IFSND_DTQ_LEAVE(ercd)
#define LOG_RCV_DTQ_ENTER(dtqid, p_data)
#define LOG_RCV_DTQ_LEAVE(ercd, data)
#define LOG_PRCV_DTQ_ENTER(dtqid, p_data)
#define LOG_PRCV_DTQ_LEAVE(ercd, data)
#define LOG_TRCV_DTQ_ENTER(dtqid, p_data, tmout)
#define LOG_TRCV_DTQ_LEAVE(ercd, data)
#define LOG_INI_DTQ_ENTER(dtqid)
#define LOG_INI_DTQ_LEAVE(ercd)
#define LOG_REF_DTQ_ENTER(dtqid, pk_rdtq)
#define LOG_REF_DTQ_LEAVE(ercd, pk_rdtq)

#define LOG_SND_MBX_ENTER(mbxid, pk_msg)
#define LOG_SND_MBX_LEAVE(ercd)
#define LOG_RCV_MBX_ENTER(mbxid, ppk_msg)
#define LOG_RCV_MBX_LEAVE(ercd, pk_msg)
#define LOG_PRCV_MBX_ENTER(mbxid, ppk_msg)
#define LOG_PRCV_MBX_LEAVE(ercd, pk_msg)
#define LOG_TRCV_MBX_ENTER(mbxid, ppk_msg, tmout)
#define LOG_TRCV_MBX_LEAVE(ercd, pk_msg)
#define LOG_INI_MBX_ENTER(mbxid)
#define LOG_INI_MBX_LEAVE(ercd)
#define LOG_REF_MBX_ENTER(mbxid, pk_rmbx)
#define LOG_REF_MBX_LEAVE(ercd, pk_rmbx)

#define LOG_LOC_MTX_ENTER(mtxid)
#define LOG_LOC_MTX_LEAVE(ercd)
#define LOG_PLOC_MTX_ENTER(mtxid)
#define LOG_PLOC_MTX_LEAVE(ercd)
#define LOG_TLOC_MTX_ENTER(mtxid, tmout)
#define LOG_TLOC_MTX_LEAVE(ercd)
#define LOG_UNL_MTX_ENTER(mtxid)
#define LOG_UNL_MTX_LEAVE(ercd)
#define LOG_INI_MTX_ENTER(mtxid)
#define LOG_INI_MTX_LEAVE(ercd)
#define LOG_REF_MTX_ENTER(mtxid, pk_rmtx)
#define LOG_REF_MTX_LEAVE(ercd, pk_rmtx)

#define LOG_GET_MPF_ENTER(mpfid, p_blk)
#define LOG_GET_MPF_LEAVE(ercd, blk)
#define LOG_PGET_MPF_ENTER(mpfid, p_blk)
#define LOG_PGET_MPF_LEAVE(ercd, blk)
#define LOG_TGET_MPF_ENTER(mpfid, p_blk, tmout)
#define LOG_TGET_MPF_LEAVE(ercd, blk)
#define LOG_REL_MPF_ENTER(mpfid, blk)
#define LOG_REL_MPF_LEAVE(ercd)
#define LOG_INI_MPF_ENTER(mpfid)
#define LOG_INI_MPF_LEAVE(ercd)
#define LOG_REF_MPF_ENTER(mpfid, pk_rmpf)
#define LOG_REF_MPF_LEAVE(ercd, pk_rmpf)

#define LOG_SET_TIM_ENTER(p_systim)
#define LOG_SET_TIM_LEAVE(ercd)
#define LOG_GET_TIM_ENTER(p_systim)
#define LOG_GET_TIM_LEAVE(ercd, systim)
#define LOG_ISIG_TIM_ENTER()
#define LOG_ISIG_TIM_LEAVE(ercd)

#define LOG_STA_CYC_ENTER(cycid)
#define LOG_STA_CYC_LEAVE(ercd)
#define LOG_STP_CYC_ENTER(cycid)
#define LOG_STP_CYC_LEAVE(ercd)
#define LOG_REF_CYC_ENTER(cycid, pk_rcyc)
#define LOG_REF_CYC_LEAVE(ercd, pk_rcyc)

#define LOG_STA_ALM_ENTER(almid, almtim)
#define LOG_STA_ALM_LEAVE(ercd)
#define LOG_ISTA_ALM_ENTER(almid, almtim)
#define LOG_ISTA_ALM_LEAVE(ercd)
#define LOG_STP_ALM_ENTER(almid)
#define LOG_STP_ALM_LEAVE(ercd)
#define LOG_ISTP_ALM_ENTER(almid)
#define LOG_ISTP_ALM_LEAVE(ercd)
#define LOG_REF_ALM_ENTER(almid, pk_ralm)
#define LOG_REF_ALM_LEAVE(ercd, pk_ralm)

#define LOG_GET_UTM_ENTER(p_sysutim)
#define LOG_GET_UTM_LEAVE(ercd, sysutim)

#define LOG_ROT_RDQ_ENTER(tskpri)
#define LOG_ROT_RDQ_LEAVE(ercd)
#define LOG_IROT_RDQ_ENTER(tskpri)
#define LOG_IROT_RDQ_LEAVE(ercd)
#define LOG_GET_DID_ENTER(p_domid)
#define LOG_GET_DID_LEAVE(ercd, domid)
#define LOG_GET_TID_ENTER(p_tskid)
#define LOG_GET_TID_LEAVE(ercd, tskid)
#define LOG_IGET_TID_ENTER(p_tskid)
#define LOG_IGET_TID_LEAVE(ercd, tskid)
#define LOG_LOC_CPU_ENTER()
#define LOG_LOC_CPU_LEAVE(ercd)
#define LOG_ILOC_CPU_ENTER()
#define LOG_ILOC_CPU_LEAVE(ercd)
#define LOG_UNL_CPU_ENTER()
#define LOG_UNL_CPU_LEAVE(ercd)
#define LOG_IUNL_CPU_ENTER()
#define LOG_IUNL_CPU_LEAVE(ercd)
#define LOG_DIS_DSP_ENTER()
#define LOG_DIS_DSP_LEAVE(ercd)
#define LOG_ENA_DSP_ENTER()
#define LOG_ENA_DSP_LEAVE(ercd)
#define LOG_SNS_CTX_ENTER()
#define LOG_SNS_CTX_LEAVE(state)
#define LOG_SNS_LOC_ENTER()
#define LOG_SNS_LOC_LEAVE(state)
#define LOG_SNS_DSP_ENTER()
#define LOG_SNS_DSP_LEAVE(state)
#define LOG_SNS_DPN_ENTER()
#define LOG_SNS_DPN_LEAVE(state)
#define LOG_SNS_KER_ENTER()
#define LOG_SNS_KER_LEAVE(state)

#define LOG_XSNS_DPN_ENTER(p_excinf)
#define LOG_XSNS_DPN_LEAVE(state)
#define LOG_XSNS_XPN_ENTER(p_excinf)
#define LOG_XSNS_XPN_LEAVE(state)

#define LOG_DIS_INT_ENTER(intno)
#define LOG_DIS_INT_LEAVE(ercd)
#define LOG_ENA_INT_ENTER(intno)
#define LOG_ENA_INT_LEAVE(ercd)
#define LOG_CHG_IPM_ENTER(intpri)
#define LOG_CHG_IPM_LEAVE(ercd)
#define LOG_GET_IPM_ENTER(p_intpri)
#define LOG_GET_IPM_LEAVE(ercd, intpri)

#define LOG_PRB_MEM_ENTER(base, size, domid, tskid, pmmode)
#define LOG_PRB_MEM_LEAVE(ercd)

#define LOG_EXT_KER_ENTER()
#define LOG_EXT_KER_LEAVE(ercd)

#define LOG_REF_OVR_ENTER(tskid, pk_rovr)
#define LOG_REF_OVR_LEAVE(ercd, pk_rovr)
#define LOG_STA_OVR_ENTER(tskid, ovrtim)
#define LOG_STA_OVR_LEAVE(ercd)
#define LOG_STP_OVR_ENTER(tskid)
#define LOG_STP_OVR_LEAVE(ercd);

#endif /* _TOOL_CONFIG_H_ */
