/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2005 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2005-2010 by Monami Software Limited Partnership, JAPAN
 *  Copyright (C) 2005-2006 by Japan Aerospace Exploration Agency.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ȯĶ˰¸
 *
 *  Υ󥯥롼ɥեϡt_stddef.hitron.hƬǥ󥯥롼
 *  ɤ롥¾Υե뤫ľܥ󥯥롼ɤ뤳ȤϤʤ¾Υ
 *  󥯥롼ɥեΩäƽ뤿ᡤ¾Υ󥯥롼ɥե
 *  ˰¸ƤϤʤʤ
 */

#ifndef _TOOL_DEFS_H_
#define _TOOL_DEFS_H_

/*
 *  ѥ¸Υǡ
 */
#define _int8_		char			/* 8ӥåȤ */
#define _int16_		short			/* 16ӥåȤ */
#define _int32_		int				/* 32ӥåȤ */
#define _int64_		long long		/* 64ӥåȤ */

/* typedef VP __MPF_UNIT; */
#define __STK_UNIT long long
/* #define _bool_ int */
/* #define _intptr_ long */
/* #define _size_t_ size_t */
/* #define _vp_int_ void * */
#define ABI_FPR 0
#define ABI_GPR 4
#define ABI_POINTER 4
#define ABI_STACK(a) (((a) + 7) & ~7)
#if ABI_POINTER == 4
#define ABI_PADDIU addiu
#define ABI_PADDU addu
#define ABI_PL lw
#define ABI_PLA la
#define ABI_PS sw
#else /* ABI_POINTER == 8 */
#define ABI_PADDIU daddiu
#define ABI_PADDU daddu
#define ABI_PL ld
#define ABI_PLA dla
#define ABI_PS sd
#endif

/*
 *  ѥγĥǽΤΥޥ
 */
#ifndef __cplusplus					/* C++ ˤ inline  */
#if __STDC_VERSION__ < 199901L		/* C99 ˤ inline  */
#define inline	__inline__			/* 饤ؿ */
#endif /* __STDC_VERSION__ < 199901L */
#endif /* __cplusplus */

#define Inline	static inline

#ifndef __cplusplus					/* C++ ˤ asm  */
#define asm		__asm__				/* 饤󥢥֥ */
#endif /* __cplusplus */

#define Asm		__asm__ volatile	/* 饤󥢥֥ʺŬ޻ߡ*/

#define NoReturn	__attribute__((__noreturn__))
									/* ꥿󤷤ʤؿ */

#endif /* _TOOL_DEFS_H_ */
