/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ITRONͶ̵Υǡޥ
 *
 *  Υեˤϡɥץեˤɬפʤޤ
 *  롥ǡϡɥץե礦ɤ
 *  ĹˤϤƤʤ
 *
 *  ֥Υե䥷ƥॳե졼ե
 *  뤫餳Υե򥤥󥯥롼ɤϡ_MACRO_ONLY
 *  ȤǡޥʳεҤȤǤ롥
 *
 *  Υ󥯥롼ɥեϡkernel.hsil.hǥ󥯥롼ɤ롥
 *  ޤITRONͶ̵˽򤹤륽եȥʤΥ󥯥롼ɥե
 *  ϡΥեľܥ󥯥롼ɤƤ褤㳰ơ
 *  ¾Υե뤫ľܥ󥯥롼ɤ뤳ȤϤʤ
 *
 *  Υե򥤥󥯥롼ɤˡt_stddef.h򥤥󥯥롼ɤƤ
 *  ȤɬפǤ롥
 */

#ifndef _ITRON_H_
#define _ITRON_H_

#ifdef __cplusplus
extern "C" {
#endif

/*
 *  ȯĶ˰¸
 */
#include <tool_defs.h>

/*
 *  ȯĶɸ।󥯥롼ɥեNULLsize_tɬס
 *
 *  C++/EC++Ǥϡɸ;stddef.hݡȤƤȤϸ¤ʤ
 *  ۤȤɤνϤǥݡȤƤ롥
 */
#ifndef _MACRO_ONLY
#include <stddef.h>
#endif /* _MACRO_ONLY */

/*
 *  ȯĶ¸ΥǡΥǥե
 */
#ifndef _bool_
#define _bool_			int			/* ֡뷿 */
#endif /* _bool_ */

#ifndef _size_t_
#define _size_t_		size_t		/*  */
#endif /* _size_t_ */

#ifndef _vp_int_
#define _vp_int_		void *		/* ݥ󥿷ޤint */
#endif /* _vp_int_ */

/*
 *  ITRONͶ̥ǡ
 */
#ifndef _MACRO_ONLY

#ifdef _int8_
typedef	signed _int8_		B;		/* դ8ӥå */
typedef	unsigned _int8_		UB;		/* ̵8ӥå */
typedef	_int8_				VB;		/* ޤʤ8ӥåȤ */
#endif /* _int8_ */

typedef	signed _int16_		H;		/* դ16ӥå */
typedef	unsigned _int16_ 	UH;		/* ̵16ӥå */
typedef	_int16_				VH;		/* ޤʤ16ӥåȤ */

typedef	signed _int32_		W;		/* դ32ӥå */
typedef	unsigned _int32_	UW;		/* ̵32ӥå */
typedef	_int32_				VW;		/* ޤʤ32ӥåȤ */

#ifdef _int64_
typedef	signed _int64_		D;		/* դ64ӥå */
typedef	unsigned _int64_	UD;		/* ̵64ӥå */
typedef	_int64_				VD;		/* ޤʤ64ӥåȤ */
#endif /* _int64_ */

typedef	void			*VP;		/* ޤʤΤؤΥݥ */
typedef	void			(*FP)();	/* ץεưϡʥݥ󥿡 */

typedef signed int		INT;		/* ʥդ */
typedef unsigned int	UINT;		/* ʥ̵ */

typedef _bool_			BOOL;		/*  */

typedef INT				FN;			/* ǽ */
typedef	INT				ER;			/* 顼 */
typedef	INT				ID;			/* ֥ȤIDֹ */
typedef	UINT			ATR;		/* ֥Ȥ° */
typedef	UINT			STAT;		/* ֥Ȥξ */
typedef	UINT			MODE;		/* ӥư⡼ */
typedef	INT				PRI;		/* ͥ */
typedef	_size_t_		SIZE;		/* ΰΥ */

typedef	INT				TMO;		/* ॢȻ */
typedef	UINT			RELTIM;		/* л */
typedef	UW				SYSTIM;		/* ƥ */
typedef	UW				SYSUTIM;	/* ǽɾѥƥ */

typedef	_vp_int_		VP_INT;		/* VPޤINT */

typedef	INT				ER_BOOL;	/* ERޤBOOL */
typedef	INT				ER_ID;		/* ERޤID */
typedef	INT				ER_UINT;	/* ERޤUINT */

#endif /* _MACRO_ONLY */

/*
 *  ITRONͶ
 */

/*
 *  
 *
 *  _MACRO_ONLYλˤϡNULLʤϡ_MACRO_ONLYλ
 *  stddef.h򥤥󥯥롼ɤʤᡤǤʤNULL
 *  ǽ뤿Ǥ롥ޤƥॳե졼ե
 *  ˤNULLƤϤʤʤᡤ
 *  ʤԹ礬褤
 */
#ifndef _MACRO_ONLY
#ifndef NULL					/* stddef.h˴ޤޤƤϤ */
#define NULL		0			/* ̵ݥ */
#endif /* NULL */
#endif /* _MACRO_ONLY */

#define TRUE		1			/*  */
#define FALSE		0			/*  */
#define E_OK		0			/* ｪλ */

/*
 *  ᥤ󥨥顼
 */
#define E_SYS		(-5)		/* ƥ२顼 */
#define E_NOSPT		(-9)		/* ̤ݡȵǽ */
#define E_RSFN		(-10)		/* ͽǽ */
#define E_RSATR		(-11)		/* ͽ° */
#define E_PAR		(-17)		/* ѥ᡼顼 */
#define E_ID		(-18)		/* IDֹ */
#define E_CTX		(-25)		/* ƥȥ顼 */
#define E_MACV		(-26)		/* ꥢȿ */
#define E_OACV		(-27)		/* ֥ȥȿ */
#define E_ILUSE		(-28)		/* ӥ */
#define E_NOMEM		(-33)		/* ­ */
#define E_NOID		(-34)		/* IDֹ­ */
#define E_OBJ		(-41)		/* ֥Ⱦ֥顼 */
#define E_NOEXS		(-42)		/* ֥̤ */
#define E_QOVR		(-43)		/* 塼󥰥Сե */
#define E_RLWAI		(-49)		/* Ԥ֤ζ */
#define E_TMOUT		(-50)		/* ݡ󥰼Ԥޤϥॢ */
#define E_DLT		(-51)		/* Ԥ֥Ȥκ */
#define E_CLS		(-52)		/* Ԥ֥ȤξѲ */
#define E_WBLK		(-57)		/* Υ֥å󥰼դ */
#define E_BOVR		(-58)		/* ХåեСե */

/*
 *  ֥°
 */
#define TA_NULL		0u			/* ֥°ꤷʤ */

/*
 *  ॢȻ
 */
#define TMO_POL		0			/* ݡ */
#define TMO_FEVR	(-1)		/* ʵԤ */
#define TMO_NBLK	(-2)		/* Υ֥å */

/*
 *  ITRONͶ̥ޥ
 */

/*
 *  顼ʬޥ
 *
 *  ʲΥޥϡդ2ɽƤꡤե
 *  黻ҡ>>ˤѥեȤ뤳ȤꤷƤ롥Ǥʤȯ
 *  Ǥϡtool_defs.hǤ񤭤ʤФʤʤ
 *
 *  MERCDޥϡᥤ󥨥顼ɤǤ뤳ȤꤷƤ롥
 *  Ǥʤ硤2Ĥפʤʤ롥
 */
#ifndef ERCD
#define ERCD(mercd, sercd) \
				((ER)((((UINT) sercd) << 8) | (((UINT) mercd) & 0xffu)))
#endif /* ERCD */

#ifndef MERCD
#ifdef _int8_
#define MERCD(ercd)		((ER)((B)(ercd)))
#else /* _int8_ */
#define MERCD(ercd)		((ER)(((UINT) ercd) | ~0xffu))
#endif /* _int8_ */
#endif /* MERCD */

#ifndef SERCD
#define SERCD(ercd)		((ER)((ercd) >> 8))
#endif /* SERCD */

/*
 *  饤ȥåޥ
 */
#ifndef ALIGN_TYPE
#define ALIGN_TYPE(addr, type)	((((SIZE)(addr)) & (alignof(type) - 1u)) == 0u)
#endif /* ALIGN_TYPE */

#ifdef __cplusplus
}
#endif

#endif /* _ITRON_H_ */
