/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001,2002 by Information-technology Promotion Agency, JAPAN
 *  Copyright (C) 2001,2002 by TRON Association, JAPAN
 *  Copyright (C) 2004-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		TOPPERS/HRPͥ ɸ।󥯥롼ɥե
 *
 *  Υ󥯥롼ɥեϡͥ뤬ݡȤ륵ӥ
 *  ȡɬפʥǡޥޤࡥ
 *
 *  ֥Υե䥷ƥॳե졼ե
 *  뤫餳Υե򥤥󥯥롼ɤϡ_MACRO_ONLY
 *  ȤǡޥʳεҤȤǤ롥
 *
 *  ǥ󥯥롼ɤƤեơ¾Υ󥯥롼ɥե
 *  ˰¸Ƥʤ
 */

#ifndef _KERNEL_H_
#define _KERNEL_H_

#ifdef __cplusplus
extern "C" {
#endif

/*
 *  ͥ롦ץꥱ ̥󥯥롼ɥե
 */
#include <t_stddef.h>

/*
 *  ITRONͶ̵Υǡޥ
 */
#include <itron.h>

/*
 *  ƥץå˰¸
 */
#include <sys_defs.h>
#include <cpu_defs.h>

/*
 *  ƥӥΤ
 */
#include <t_syslog.h>

#ifndef _MACRO_ONLY

/*
 *  ǡ
 */
typedef	UINT		TEXPTN;		/* 㳰װΥӥåȥѥ */
typedef	UINT		FLGPTN;		/* ٥ȥե饰Υӥåȥѥ */
typedef UW			ACPTN;		/* ĥѥ */
typedef UW			OVRTIM;		/* ץå */
typedef	UINT		INHNO;		/* ߥϥɥֹ */
typedef	UINT		INTNO;		/* ֹ */
typedef	UINT		EXCNO;		/* CPU㳰ϥɥֹ */

typedef struct acvct {			/* ĥ٥ */
	ACPTN			acptn1;		/* ̾1Υĥѥ */
	ACPTN			acptn2;		/* ̾2Υĥѥ */
	ACPTN			acptn3;		/* Υĥѥ */
	ACPTN			acptn4;		/* Υĥѥ */
} ACVCT;

typedef	struct t_msg {			/* ᡼ܥåΥåإå */
	struct t_msg	*pk_next;
} T_MSG;

typedef	struct t_msg_pri {		/* ͥդåإå */
	T_MSG	msgque;				/* åإå */
	PRI		msgpri;				/* åͥ */
} T_MSG_PRI;

/*
 *  ѥåȷ
 */
typedef struct t_rtsk {
	STAT	tskstat;	/*  */
	PRI		tskpri;		/* θͥ */
	PRI		tskbpri;	/* Υ١ͥ */
	STAT	tskwait;	/* Ԥװ */
	ID		wobjid;		/* ԤоݤΥ֥ȤID */
	TMO		lefttmo;	/* ॢȤޤǤλ */
	UINT	actcnt;		/* ư׵ᥭ塼󥰿 */
	UINT	wupcnt;		/* ׵ᥭ塼󥰿 */
	UINT	suscnt;		/* Ԥ׵ͥȿ */
} T_RTSK;

typedef struct t_rtex {
	STAT	texstat;	/* 㳰ξ */
	TEXPTN	pndptn;		/* α㳰װ */
} T_RTEX;

typedef struct t_rsem {
	ID		wtskid;		/* ޥեԤƬΥID */
	UINT	semcnt;		/* ޥեθߤλ񸻿 */
} T_RSEM;

typedef struct t_rflg {
	ID		wtskid;		/* ٥ȥե饰ԤƬΥID */
	FLGPTN	flgptn;		/* ٥ȥե饰θߤΥӥåȥѥ */
} T_RFLG;

typedef struct t_rdtq {
	ID		stskid;		/* ǡ塼ԤƬΥID */
	ID		rtskid;		/* ǡ塼μԤƬΥID */
	UINT	sdtqcnt;	/* ǡ塼äƤǡο */
} T_RDTQ;

typedef struct t_rmbx {
	ID		wtskid;		/* ᡼ܥåԤƬΥID */
	T_MSG	*pk_msg;	/* å塼ƬΥåѥå */
} T_RMBX;

typedef struct t_rmtx {
	ID		htskid;		/* ߥ塼ƥååƤ륿ID */
	ID		wtskid;		/* ߥ塼ƥåԤƬΥID */
} T_RMTX;

typedef struct t_rmpf {
	ID		wtskid;		/* ĹסԤƬΥID */
	UINT	fblkcnt;	/* Ĺסζ֥å */
} T_RMPF;

typedef struct t_rcyc {
	STAT	cycstat;	/* ϥɥư */
	RELTIM	lefttim;	/* ϥɥ򼡤˵ư٤ޤǤλ */
} T_RCYC;

typedef struct t_ralm {
	STAT	almstat;	/* 顼ϥɥư */
	RELTIM	lefttim;	/* 顼ϥɥεưޤǤλ */
} T_RALM;

typedef struct t_rovr {
	STAT	ovrstat;	/* Хϥɥư */
	OVRTIM	leftotm;	/* ĤΥץå */
} T_ROVR;

#endif /* _MACRO_ONLY */

/*
 *  ӥƽФΤ
 */
#include "kernel_fncode.h"
#include "kernel_svc.h"

/*
 *  ݸɥᥤID
 */
#define	TDOM_SELF		0			/* °ݸɥᥤ */
#define	TDOM_KERNEL		(-1u)		/* ͥɥᥤ */
#define	TDOM_NONE		(-2u)		/* ݸɥᥤ˽°ʤ */

/*
 *  ֥°
 *
 *  TA_DOMޥϡATR32ӥåȤǤ뤳ȤꤷƤ롥
 *  ǤʤˤϡåȰ¸Ǥ񤭤ʤФʤ
 *  
 */
#ifndef TA_DOM
#define TA_DOM(domid)	((domid) << 16)		/* °ݸɥᥤIDλ */
#endif /* TA_DOM */

#define TA_HLNG			0x00u		/* ѥ󥿥ե */
#define TA_ASM			0x01u		/* ֥ѥ󥿥ե */

#define TA_TFIFO		0x00u		/* ԤFIFO */
#define TA_TPRI			0x01u		/* Ԥͥٽ */

#define TA_MFIFO		0x00u		/* å塼FIFO */
#define TA_MPRI			0x02u		/* å塼ͥٽ */

#define TA_ACT			0x02u		/* ư줿֤ */

#define TA_WSGL			0x00u		/* ٥ȥե饰Ԥ1ĤΤ */
#define TA_WMUL			0x02u		/* ٥ȥե饰ʣԤ */
#define TA_CLR			0x04u		/* ٥ȥե饰Υꥢ */

#define TA_INHERIT		0x02u		/* ͥٷѾץȥΥߥ塼ƥå */
#define TA_CEILING		0x03u		/* ͥپ¥ץȥΥߥ塼ƥå */

#define TA_STA			0x02u		/* ϥɥư֤ */

#define	TA_RW			0x00u		/* ꡼ɡ饤Ȳǽ */
#define	TA_RO			0x01u		/* ꡼ɥ꡼ */
#define	TA_CACHE		0x00u		/* åǽ */
#define	TA_UNCACHE		0x02u		/* åԲ */
#define	TA_WBACK		0x00u		/* 饤ȥХåå */
#define	TA_WTHROUGH		0x04u		/* 饤ȥ롼å */

#define	TA_ENAINT		0x00u		/* ׵ػߥե饰򥯥ꥢ */
#define	TA_DISINT		0x01u		/* ׵ػߥե饰򥻥å*/
#define	TA_LEVEL		0x00u		/* ٥ȥꥬ */
#define	TA_EDGE			0x02u		/* åȥꥬ */
/* ʲϥåǻѤ */
#define	TA_POSEDGE		0x02u		/* ݥƥ֥åȥꥬ */
#define	TA_NEGEDGE		0x04u		/* ͥƥ֥åȥꥬ */
#define	TA_BOTHEDGE		0x06u		/* ξåȥꥬ */
#define	TA_LOWLEVEL		0x00u		/* ٥ȥꥬ */
#define	TA_HIGHLEVEL	0x08u		/* ϥ٥ȥꥬ */

/*
 *  ĥѥ
 */
#define TACP(domid)		(1u << ((domid) - 1))	/* domidΤߤ饢 */
#define TACP_SHARED		(~0u)			/* ٤ƤΥɥᥤ󤫤饢 */
#define TACP_KERNEL		(0u)			/* ͥɥᥤΤߥ */

/*
 *  ӥư⡼ɤ
 */
#define TWF_ANDW		0x00u		/* ٥ȥե饰ANDԤ */
#define TWF_ORW			0x01u		/* ٥ȥե饰ORԤ */

#define	TPM_READ		0x01		/* ɽФΥå */
#define	TPM_WRITE		0x02		/* ߥΥå */

/*
 *  ֥Ȥξ֤
 */
#define TTS_RUN			0x01u		/* ¹Ծ */
#define TTS_RDY			0x02u		/* ¹Բǽ */
#define TTS_WAI			0x04u		/* Ԥ */
#define TTS_SUS			0x08u		/* Ԥ */
#define TTS_WAS			0x0cu		/* Ԥ */
#define TTS_DMT			0x10u		/* ٻ߾ */

#define TTW_SLP			0x0001u		/* Ԥ */
#define TTW_DLY			0x0002u		/* ַвԤ */
#define TTW_SEM			0x0004u		/* ޥե񸻤γԤ */
#define TTW_FLG			0x0008u		/* ٥ȥե饰Ԥ */
#define TTW_SDTQ		0x0010u		/* ǡ塼ؤԤ */
#define TTW_RDTQ		0x0020u		/* ǡ塼μԤ */
#define TTW_MBX			0x0040u		/* ᡼ܥåμԤ */
#define TTW_MTX			0x0080u		/* ߥ塼ƥåΥåԤ */
#define TTW_MPF			0x2000u		/* Ĺ֥åγԤ */

#define TTEX_ENA		0x00u		/* 㳰ľ */
#define TTEX_DIS		0x01u		/* 㳰ػ߾ */

#define TCYC_STP		0x00u		/* ϥɥ餬ưƤʤ */
#define TCYC_STA		0x01u		/* ϥɥ餬ưƤ */

#define TALM_STP		0x00u		/* 顼ϥɥ餬ưƤʤ */
#define TALM_STA		0x01u		/* 顼ϥɥ餬ưƤ */

#define TOVR_STP		0x00u		/* Хϥɥ餬ưƤʤ */
#define TOVR_STA		0x01u		/* Хϥɥ餬ưƤ */

/*
 *  ¾
 */
#define TSK_SELF		0			/*  */
#define TSK_NONE		0			/* 륿ʤ */

#define TPRI_SELF		0			/* Υ١ͥ٤λ */
#define TPRI_INI		0			/* εưͥ٤λ */

#define TIPM_ENAALL		0			/* ٤Ƥγߤ */

/*
 *  ȥޥ
 */

/*
 *  ͥ٤ϰ
 */
#define TMIN_TPRI		1			/* ͥ٤κǾ */
#define TMAX_TPRI		16			/* ͥ٤κ */
#define TMIN_MPRI		1			/* åͥ٤κǾ */
#define TMAX_MPRI		16			/* åͥ٤κ */

/*
 *  С
 */
#define TKERNEL_MAKER	0x0118u		/* ͥΥ᡼ */
#define TKERNEL_PRID	0x0006u		/* ͥμֹ */
#define TKERNEL_SPVER	0xf5a0u		/* ITRONͤΥСֹ */
#define TKERNEL_PRVER	0x1000u		/* ͥΥСֹ */

/*
 *  塼󥰡ͥȲκ
 */
#define TMAX_ACTCNT		1u			/* ư׵ᥭ塼󥰿κ */
#define TMAX_WUPCNT		1u			/* ׵ᥭ塼󥰿κ */
#define TMAX_SUSCNT		1u			/* Ԥ׵ͥȿκ */

/*
 *  ӥåȥѥΥӥåȿ
 */
#ifndef TBIT_TEXPTN					/* 㳰װΥӥåȿ */
#define TBIT_TEXPTN		(sizeof(TEXPTN) * CHAR_BIT)
#endif /* TBIT_TEXPTN */

#ifndef TBIT_FLGPTN					/* ٥ȥե饰Υӥåȿ */
#define TBIT_FLGPTN		(sizeof(FLGPTN) * CHAR_BIT)
#endif /* TBIT_FLGPTN */

#ifdef __cplusplus
}
#endif

#endif /* _KERNEL_H_ */
