/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ꥢ륤󥿥եɥ饤
 */

#ifndef _SERIAL_H_
#define _SERIAL_H_

/*
 *  ꥢ륤󥿥եɥ饤ФѤѥå
 */
typedef struct {
	UINT	reacnt;		/* Хåեʸ */
	UINT	wricnt;		/* Хåեʸ */
} T_SERIAL_RPOR;

/*
 *  ꥢ륤󥿥եɥ饤Фν롼
 */
extern void	serial_initialize(VP_INT exinf) throw();

/*
 *  ꥢ륤󥿥եɥ饤ФΥӥ
 */

#ifndef CALSVC_TRAP

#define serial_opn_por _serial_opn_por
#define serial_cls_por _serial_cls_por
#define serial_rea_dat _serial_rea_dat
#define serial_wri_dat _serial_wri_dat
#define serial_ctl_por _serial_ctl_por
#define serial_ref_por _serial_ref_por

extern ER		serial_opn_por(ID portid) throw();
extern ER		serial_cls_por(ID portid) throw();
extern ER_UINT	serial_rea_dat(ID portid, char *buf, UINT len) throw();
extern ER_UINT	serial_wri_dat(ID portid, char *buf, UINT len) throw();
extern ER		serial_ctl_por(ID portid, UINT ioctl) throw();
extern ER		serial_ref_por(ID portid, T_SERIAL_RPOR *pk_rpor) throw();

#else /* CALSVC_TRAP */

#define TFN_SERIAL_OPN_POR		(4)
#define TFN_SERIAL_CLS_POR		(5)
#define TFN_SERIAL_REA_DAT		(6)
#define TFN_SERIAL_WRI_DAT		(7)
#define TFN_SERIAL_CTL_POR		(8)
#define TFN_SERIAL_REF_POR		(9)

Inline ER
serial_opn_por(ID portid)
{
#if defined(__GNUC__)
	CAL_SVC_1(ER, TFN_SERIAL_OPN_POR, ID, portid);
#elif defined(__ghs__)
	return (ER)CAL_SVC_1(TFN_SERIAL_OPN_POR, portid);
#else
#error Compiler not supported
#endif
}

Inline ER
serial_cls_por(ID portid)
{
#if defined(__GNUC__) && !defined(__ghs__)
	CAL_SVC_1(ER, TFN_SERIAL_CLS_POR, ID, portid);
#elif defined(__ghs__)
	return (ER)CAL_SVC_1(ER, TFN_SERIAL_CLS_POR, portid);
#else
#error Compiler not supported
#endif
}

Inline ER_UINT
serial_rea_dat(ID portid, char *buf, UINT len)
{
#if defined(__GNUC__) && !defined(__ghs__)
	CAL_SVC_3M(ER, TFN_SERIAL_REA_DAT, ID, portid, char *, buf, UINT, len);
#elif defined(__ghs__)
	return (ER_UINT)CAL_SVC_3M(TFN_SERIAL_REA_DAT, portid, buf, len);
#else
#error Compiler not supported
#endif
}

Inline ER_UINT
serial_wri_dat(ID portid, char *buf, UINT len)
{
#if defined(__GNUC__) && !defined(__ghs__)
	CAL_SVC_3(ER, TFN_SERIAL_WRI_DAT, ID, portid, char *, buf, UINT, len);
#elif defined(__ghs__)
	return (ER_UINT)CAL_SVC_3(TFN_SERIAL_WRI_DAT, portid, buf, len);
#else
#error Compiler not supported
#endif
}

Inline ER
serial_ctl_por(ID portid, UINT ioctl)
{
#if defined(__GNUC__) && !defined(__ghs__)
	CAL_SVC_2(ER, TFN_SERIAL_CTL_POR, ID, portid, UINT, ioctl);
#elif defined(__ghs__)
	return (ER)CAL_SVC_2(TFN_SERIAL_CTL_POR, portid, ioctl);
#else
#error Compiler not supported
#endif
}

Inline ER
serial_ref_por(ID portid, T_SERIAL_RPOR *pk_rpor)
{
#if defined(__GNUC__) && !defined(__ghs__)
	CAL_SVC_2M(ER, TFN_SERIAL_CTL_POR, ID, portid, T_SERIAL_RPOR *, pk_rpor);
#elif defined(__ghs__)
	return (ER)CAL_SVC_2M(TFN_SERIAL_CTL_POR, portid, pk_rpor);
#else
#error Compiler not supported
#endif
}

#endif /* CALSVC_TRAP */

/*
 *  ꥢ륤󥿥եɥ饤ФưѤΤ
 *
 *  ʲϡӥå¤ȤäѤ롥
 */
#define	IOCTL_NULL	0u			/* ʤ */
#define	IOCTL_ECHO	0x0001u		/* ʸ򥨥Хå */
#define	IOCTL_CRLF	0x0010u		/* LF  CR ղ */
#define	IOCTL_FCSND	0x0100u		/* ФƥեԤ */
#define	IOCTL_FCANY	0x0200u		/* ɤΤ褦ʸǤƳ */
#define	IOCTL_FCRCV	0x0400u		/* ФƥեԤ */

#endif /* _SERIAL_H_ */
