/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ƥ।󥿥ե쥤ʥå¸
 *
 *  ֥Υե䥷ƥॳե졼ե
 *  뤫餳Υե򥤥󥯥롼ɤϡ_MACRO_ONLY
 *  ȤǡޥʳεҤȤǤ롥
 *
 *  ǥ󥯥롼ɤƤեơ¾Υ󥯥롼ɥե
 *  ˰¸Ƥʤ
 */

#ifndef _SIL_H_
#define _SIL_H_

#ifdef __cplusplus
extern "C" {
#endif

/*
 *  ͥ롦ץꥱ ̥󥯥롼ɥե
 */
#include <t_stddef.h>

/*
 *  ITRONͶ̵Υǡޥ
 */
#include <itron.h>

/*
 *  ƥץå˰¸
 */
#include <sys_defs.h>
#include <cpu_defs.h>

/*
 *  ƥӥΤ
 */
#include <t_syslog.h>

/*
 *  ǥ
 */
#define	SIL_ENDIAN_LITTLE	0		/* ȥ륨ǥ */
#define	SIL_ENDIAN_BIG		1		/* ӥåǥ */

/*
 *  ǥޥ
 */
#if SIL_ENDIAN == SIL_ENDIAN_BIG
#define SIL_BIG_ENDIAN
#else /* SIL_ENDIAN == SIL_ENDIAN_BIG */
#define SIL_LITTLE_ENDIAN
#endif /* SIL_ENDIAN == SIL_ENDIAN_BIG */

#ifndef _MACRO_ONLY

/*
 *  ߥå֤
 *
 *  SIL_PRE_LOCSIL_LOC_INT()SIL_UNL_INT()ϡåȰ¸
 *  դ롥ǥեȤѰդƤʤ
 */

/*
 *  Ԥ
 */
extern void	sil_dly_nse(UINT dlytim) throw();

/*
 *  ǥȿž
 */
#ifndef SIL_REV_ENDIAN_H
#define	SIL_REV_ENDIAN_H(data) \
				((((data) & 0xff) << 8) | (((data) >> 8) & 0xff))
#endif /* SIL_REV_ENDIAN_H */

#ifndef SIL_REV_ENDIAN_W
#define	SIL_REV_ENDIAN_W(data) \
				((((data) & 0xff) << 24) | (((data) & 0xff00) << 8) \
					| (((data) >> 8) & 0xff00) | (((data) >> 24) & 0xff))
#endif /* SIL_REV_ENDIAN_H */

/*
 *  ֥ؿ
 */
#ifndef OMIT_SIL_ACCESS

/*
 *  8ӥåñ̤ɽФ
 */
#ifdef _int8_

Inline UB
sil_reb_mem(VP mem)
{
	UB	data;

	data = *((volatile UB *) mem);
	return(data);
}

Inline void
sil_wrb_mem(VP mem, UB data)
{
	*((volatile UB *) mem) = data;
}

#endif /* _int8_ */

/*
 *  16ӥåñ̤ɽФ
 */

Inline UH
sil_reh_mem(VP mem)
{
	UH	data;

	data = *((volatile UH *) mem);
	return(data);
}

Inline void
sil_wrh_mem(VP mem, UH data)
{
	*((volatile UH *) mem) = data;
}

#ifdef SIL_BIG_ENDIAN			/* ӥåǥץå */

#define	sil_reh_bem(mem)		sil_reh_mem(mem)
#define	sil_wrh_bem(mem, data)	sil_wrh_mem(mem, data)

#ifndef OMIT_SIL_REH_LEM

Inline UH
sil_reh_lem(VP mem)
{
	UH	data;

	data = *((volatile UH *) mem);
	return(SIL_REV_ENDIAN_H(data));
}

#endif /* OMIT_SIL_REH_LEM */
#ifndef OMIT_SIL_WRH_LEM

Inline void
sil_wrh_lem(VP mem, UH data)
{
	*((volatile UH *) mem) = SIL_REV_ENDIAN_H(data);
}

#endif /* OMIT_SIL_WRH_LEM */
#else /* SIL_BIG_ENDIAN */		/* ȥ륨ǥץå */

#define	sil_reh_lem(mem)		sil_reh_mem(mem)
#define	sil_wrh_lem(mem, data)	sil_wrh_mem(mem, data)

#ifndef OMIT_SIL_REH_BEM

Inline UH
sil_reh_bem(VP mem)
{
	UH	data;

	data = *((volatile UH *) mem);
	return(SIL_REV_ENDIAN_H(data));
}

#endif /* OMIT_SIL_REH_BEM */
#ifndef OMIT_SIL_WRH_BEM

Inline void
sil_wrh_bem(VP mem, UH data)
{
	*((volatile UH *) mem) = SIL_REV_ENDIAN_H(data);
}

#endif /* OMIT_SIL_WRH_BEM */
#endif /* SIL_BIG_ENDIAN */

/*
 *  32ӥåñ̤ɽФ
 */

Inline UW
sil_rew_mem(VP mem)
{
	UW	data;

	data = *((volatile UW *) mem);
	return(data);
}

Inline void
sil_wrw_mem(VP mem, UW data)
{
	*((volatile UW *) mem) = data;
}

#ifdef SIL_BIG_ENDIAN			/* ӥåǥץå */

#define	sil_rew_bem(mem)		sil_rew_mem(mem)
#define	sil_wrw_bem(mem, data)	sil_wrw_mem(mem, data)

#ifndef OMIT_SIL_REW_LEM

Inline UW
sil_rew_lem(VP mem)
{
	UW	data;

	data = *((volatile UW *) mem);
	return(SIL_REV_ENDIAN_W(data));
}

#endif /* OMIT_SIL_REW_LEM */
#ifndef OMIT_SIL_WRW_LEM

Inline void
sil_wrw_lem(VP mem, UW data)
{
	*((volatile UW *) mem) = SIL_REV_ENDIAN_W(data);
}

#endif /* OMIT_SIL_WRW_LEM */
#else /* SIL_BIG_ENDIAN */		/* ȥ륨ǥץå */

#define	sil_rew_lem(mem)		sil_rew_mem(mem)
#define	sil_wrw_lem(mem, data)	sil_wrw_mem(mem, data)

#ifndef OMIT_SIL_REW_BEM

Inline UW
sil_rew_bem(VP mem)
{
	UW	data;

	data = *((volatile UW *) mem);
	return(SIL_REV_ENDIAN_W(data));
}

#endif /* OMIT_SIL_REW_BEM */
#ifndef OMIT_SIL_WRW_BEM

Inline void
sil_wrw_bem(VP mem, UW data)
{
	*((volatile UW *) mem) = SIL_REV_ENDIAN_W(data);
}

#endif /* OMIT_SIL_WRW_BEM */
#endif /* SIL_BIG_ENDIAN */
#endif /* OMIT_SIL_ACCESS */

#endif /* _MACRO_ONLY */

#ifdef __cplusplus
}
#endif

#endif /* _SIL_H_ */
