/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ͥ롦ץꥱ ̥󥯥롼ɥե
 *
 *  Υ󥯥롼ɥեϡkernel.hsil.hƬǥ󥯥롼ɤ
 *  롥¾Υե뤫ľܥ󥯥롼ɤ뤳ȤϤʤ
 *
 *  ǥ󥯥롼ɤƤեơ¾Υ󥯥롼ɥե
 *  ˰¸Ƥʤ
 */

#ifndef _T_STDDEF_H_
#define _T_STDDEF_H_

/*
 *  ȯĶ˰¸
 */
#include <tool_defs.h>

/*
 *  ȯĶɸ।󥯥롼ɥեCHAR_BITɬס
 *
 *  C++/EC++Ǥϡɸ;limits.hݡȤƤȤϸ¤ʤ
 *  ۤȤɤνϤǥݡȤƤ뤿ᡤѤ롥
 */
#ifndef _MACRO_ONLY
#include <limits.h>
#endif /* _MACRO_ONLY */

/*
 *  ѥγĥǽΤΥޥΥǥե
 */
#ifndef Inline
#define Inline		static inline
#endif /* Inline */

/*
 *  ˴ؤФΥޥ
 */
#if defined(__GNUC__) && !defined(__ghs__)
#ifndef offsetof
#define	offsetof(structure, field)	((size_t) &(((structure *) 0)->field))
#endif /* offsetof */
#elif defined(__ghs__)
/* defined in <stddef.h> */
#else /* !defined(__GNUC__) && !defined(__ghs__) */
#error Compiler not supported
#endif /* defined(__GNUC__) && !defined(__ghs__) */

#ifndef alignof
#define alignof(type)	offsetof(struct { char field1; type field2; }, field2)
#endif /* alignof */

/*
 *  C/EC++throw()н
 */
#if !defined(__cplusplus) || defined(__embedded_cplusplus)
#define throw()
#endif

/*
 *  assertޥ
 */
#undef assert
#ifndef NDEBUG
#define assert(exp)		((void)((exp) ? 0 : (_assert_fail(#exp, \
									__FILE__, __LINE__), _assert_abort(), 0)))
#else /* NDEBUG */
#define assert(exp)		((void) 0)
#endif /* NDEBUG */

#endif /* _T_STDDEF_H_ */
