/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ƥǽ
 *
 *  ƥӥϡƥΥϤ뤿Υӥ
 *  Ǥ롥ͥ뤫ΥνϤˤѤ뤿ᡤԤ
 *  ˤϤ뤳ȤϤʤ
 *
 *  ϡͥΥХåե˽񤭹फ٥ʸ
 *  ϴؿѤƽϤ롥ɤȤϡĥӥڤ
 *  뤳ȤǤ롥
 *
 *  Хåեΰ褬ХեˤϡŤäƾ
 *  񤭤롥
 *
 *  ֥Υե䥷ƥॳե졼ե
 *  뤫餳Υե򥤥󥯥롼ɤϡ_MACRO_ONLY 
 *  ȤǡޥʳεҤȤǤ롥
 *
 *  Υե򥤥󥯥롼ɤˡt_stddef.hitron.h򥤥󥯥
 *  ɤƤȤɬפǤ롥
 */

#ifndef _T_SYSLOG_H_
#define _T_SYSLOG_H_

/*
 *  μ̤
 *
 *  LOG_TYPE_CYCLOG_TYPE_ASSERTʳϡǥХå󥰥󥿥ե
 *  ͤȹפƤ롥
 */
#define LOG_TYPE_INH		0x01u	/* ߥϥɥ */
#define LOG_TYPE_ISR		0x02u	/* ߥӥ롼 */
#define LOG_TYPE_CYC		0x03u	/* ϥɥ */
#define LOG_TYPE_EXC		0x04u	/* CPU㳰ϥɥ */
#define LOG_TYPE_TEX		0x05u	/* 㳰롼 */
#define LOG_TYPE_TSKSTAT	0x06u	/* Ѳ */
#define LOG_TYPE_DSP		0x07u	/* ǥѥå */
#define LOG_TYPE_SVC		0x08u	/* ӥ */
#define LOG_TYPE_COMMENT	0x09u	/*  */
#define LOG_TYPE_ASSERT		0x0au	/* μ */

#define LOG_ENTER			0x00u	/*  */
#define LOG_LEAVE			0x80u	/* иλ */

/*
 *  ν٤
 */
#define LOG_EMERG		0u		/* åȥͤ륨顼 */
#define LOG_ALERT		1u
#define LOG_CRIT		2u
#define LOG_ERROR		3u		/* ƥ२顼 */
#define LOG_WARNING		4u		/* ٹå */
#define LOG_NOTICE		5u
#define LOG_INFO		6u
#define LOG_DEBUG		7u		/* ǥХåѥå */

#ifndef _MACRO_ONLY

/*
 *  Υǡ¤
 */

#define TMAX_LOGINFO	6u

typedef struct {
	UINT	logtype;				/* μ */
	SYSTIM	logtim;					/*  */
	VP_INT	loginfo[TMAX_LOGINFO];	/* ¾Υ */
} SYSLOG;

/*
 *  ν٤Υӥåȥޥåפ뤿Υޥ
 */
#define LOG_MASK(prio)	(1u << (prio))
#define LOG_UPTO(prio)	((1u << ((prio) + 1u)) - 1u)

#ifndef OMIT_SYSLOG

/*
 *  ƥǽθƽФ󥿥ե
 */

#ifndef CALSVC_TRAP

#define wri_log _kernel_wri_log
#define rea_log _kernel_rea_log
#define msk_log _kernel_msk_log

/*
 *  ν
 */
extern ER	wri_log(UINT prio, SYSLOG *p_syslog) throw();

/*
 *  ХåեΥɽФ
 */
extern ER_UINT	rea_log(SYSLOG *p_syslog) throw();

/* 
 *  Ϥ٤ν٤
 */
extern ER	msk_log(UINT logmask, UINT lowmask) throw();

#else /* CALSVC_TRAP */

#define TFN_WRI_LOG		(1)
#define TFN_REA_LOG		(2)
#define TFN_MSK_LOG		(3)

/*
 *  ν
 */
Inline ER
wri_log(UINT prio, SYSLOG *p_syslog)
{
#if defined(__GNUC__) && !defined(__ghs__)
	CAL_SVC_2(ER, TFN_WRI_LOG, UINT, prio, SYSLOG *, p_syslog);
#elif defined(__ghs__)
	return (ER)CAL_SVC_2(TFN_WRI_LOG, prio, p_syslog);
#else
#error Compiler not supported
#endif
}

/*
 *  ХåեΥɽФ
 */
Inline ER_UINT
rea_log(SYSLOG *p_syslog)
{
#if defined(__GNUC__) && !defined(__ghs__)
	CAL_SVC_1M(ER_UINT, TFN_REA_LOG, SYSLOG *, p_syslog);
#elif defined(__ghs__)
	return (ER_UINT)CAL_SVC_1M(TFN_REA_LOG, p_syslog);
#else
#error Compiler not supported
#endif
}

/* 
 *  Ϥ٤ν٤
 */
Inline ER
msk_log(UINT logmask, UINT lowmask)
{
#if defined(__GNUC__) && !defined(__ghs__)
	CAL_SVC_2(ER, TFN_MSK_LOG, UINT, logmask, UINT, lowmask);
#elif defined(__ghs__)
	return (ER)CAL_SVC_2(TFN_MSK_LOG, logmask, lowmask);
#else
#error Compiler not supported
#endif
}

#endif /* CALSVC_TRAP */

/*
 *  Ϥ뤿Υ饤֥ؿ
 */

Inline void
_syslog_0(UINT prio, UINT type)
{
	SYSLOG	syslog;

	syslog.logtype = type;
	(void) wri_log(prio, &syslog);
}

Inline void
_syslog_1(UINT prio, UINT type, VP_INT arg1)
{
	SYSLOG	syslog;

	syslog.logtype = type;
	syslog.loginfo[0] = arg1;
	(void) wri_log(prio, &syslog);
}

Inline void
_syslog_2(UINT prio, UINT type, VP_INT arg1, VP_INT arg2)
{
	SYSLOG	syslog;

	syslog.logtype = type;
	syslog.loginfo[0] = arg1;
	syslog.loginfo[1] = arg2;
	(void) wri_log(prio, &syslog);
}

Inline void
_syslog_3(UINT prio, UINT type, VP_INT arg1, VP_INT arg2, VP_INT arg3)
{
	SYSLOG	syslog;

	syslog.logtype = type;
	syslog.loginfo[0] = arg1;
	syslog.loginfo[1] = arg2;
	syslog.loginfo[2] = arg3;
	(void) wri_log(prio, &syslog);
}

Inline void
_syslog_4(UINT prio, UINT type, VP_INT arg1, VP_INT arg2,
								VP_INT arg3, VP_INT arg4)
{
	SYSLOG	syslog;

	syslog.logtype = type;
	syslog.loginfo[0] = arg1;
	syslog.loginfo[1] = arg2;
	syslog.loginfo[2] = arg3;
	syslog.loginfo[3] = arg4;
	(void) wri_log(prio, &syslog);
}

Inline void
_syslog_5(UINT prio, UINT type, VP_INT arg1, VP_INT arg2,
								VP_INT arg3, VP_INT arg4, VP_INT arg5)
{
	SYSLOG	syslog;

	syslog.logtype = type;
	syslog.loginfo[0] = arg1;
	syslog.loginfo[1] = arg2;
	syslog.loginfo[2] = arg3;
	syslog.loginfo[3] = arg4;
	syslog.loginfo[4] = arg5;
	(void) wri_log(prio, &syslog);
}

Inline void
_syslog_6(UINT prio, UINT type, VP_INT arg1, VP_INT arg2, VP_INT arg3,
								VP_INT arg4, VP_INT arg5, VP_INT arg6)
{
	SYSLOG	syslog;

	syslog.logtype = type;
	syslog.loginfo[0] = arg1;
	syslog.loginfo[1] = arg2;
	syslog.loginfo[2] = arg3;
	syslog.loginfo[3] = arg4;
	syslog.loginfo[4] = arg5;
	syslog.loginfo[5] = arg6;
	(void) wri_log(prio, &syslog);
}

/*
 *  ʥȡˤϤ뤿Υ饤֥ؿvasyslog.c
 */
extern void	syslog(UINT prio, const char *format, ...) throw();

#else /* OMIT_SYSLOG */
/*
 *  ƥǽѤʤ
 */

Inline ER
wri_log(UINT prio, SYSLOG *p_syslog)
{
	return(E_NOSPT);
}

Inline ER_UINT
rea_log(SYSLOG *p_syslog)
{
	return(E_NOSPT);
}

Inline ER
msk_log(UINT logmask, UINT lowmask)
{
	return(E_NOSPT);
}

Inline void
_syslog_0(UINT prio, UINT type)
{
}

Inline void
_syslog_1(UINT prio, UINT type, VP_INT arg1)
{
}

Inline void
_syslog_2(UINT prio, UINT type, VP_INT arg1, VP_INT arg2)
{
}

Inline void
_syslog_3(UINT prio, UINT type, VP_INT arg1, VP_INT arg2, VP_INT arg3)
{
}

Inline void
_syslog_4(UINT prio, UINT type, VP_INT arg1, VP_INT arg2,
								VP_INT arg3, VP_INT arg4)
{
}

Inline void
_syslog_5(UINT prio, UINT type, VP_INT arg1, VP_INT arg2,
								VP_INT arg3, VP_INT arg4, VP_INT arg5)
{
}

Inline void
_syslog_6(UINT prio, UINT type, VP_INT arg1, VP_INT arg2, VP_INT arg3,
								VP_INT arg4, VP_INT arg5, VP_INT arg6)
{
}

#if defined(__GNUC__) && !defined(__ghs__)
Inline void
syslog(UINT prio, const char *format, ...)
{
}
#else
void		syslog(UINT prio, const char *format, ...);
#endif

#endif /* OMIT_SYSLOG */

/*
 *  ʥȡˤϤ뤿Υޥ
 *
 *  formatӸ³ΰå򡤽prioǥ
 *  ȤƽϤ뤿Υޥarg1argnVP_INT˥㥹Ȥ뤿
 *  ᡤVP_INT˷ѴǤǤդηǤ褤
 */

#define syslog_0(prio, format) \
				_syslog_1(prio, LOG_TYPE_COMMENT, (VP_INT) format)

#define syslog_1(prio, format, arg1) \
				_syslog_2(prio, LOG_TYPE_COMMENT, (VP_INT) format, \
														(VP_INT)(arg1))

#define syslog_2(prio, format, arg1, arg2) \
				_syslog_3(prio, LOG_TYPE_COMMENT, (VP_INT) format, \
										(VP_INT)(arg1), (VP_INT)(arg2))

#define syslog_3(prio, format, arg1, arg2, arg3) \
				_syslog_4(prio, LOG_TYPE_COMMENT, (VP_INT) format, \
						(VP_INT)(arg1), (VP_INT)(arg2), (VP_INT)(arg3))

#define syslog_4(prio, format, arg1, arg2, arg3, arg4) \
				_syslog_5(prio, LOG_TYPE_COMMENT, (VP_INT) format, \
						(VP_INT)(arg1), (VP_INT)(arg2), (VP_INT)(arg3), \
														(VP_INT)(arg4))

#define syslog_5(prio, format, arg1, arg2, arg3, arg4, arg5) \
				_syslog_6(prio, LOG_TYPE_COMMENT, (VP_INT) format, \
						(VP_INT)(arg1), (VP_INT)(arg2), (VP_INT)(arg3), \
										(VP_INT)(arg4), (VP_INT)(arg5))

/*
 *  ʥμԡˤϤ뤿Υޥ
 */
#define _assert_fail(exp, file, line) \
				_syslog_3(LOG_EMERG, LOG_TYPE_ASSERT, (VP_INT)(file), \
										(VP_INT)(line), (VP_INT)(exp))

#endif /* _MACRO_ONLY */
#endif /* _T_SYSLOG_H_ */
