/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		٤Ƥδؿ򥳥ѥ뤹뤿
 */

#ifndef _ALLFUNC_H_
#define _ALLFUNC_H_

/* startup.c */
#define __sta_ker
#define __ext_ker

/* task.c */
#define __tskini
#define __tsksched
#define __tskrun
#define __tsknrun
#define __tskdmt
#define __tskact
#define __tskpri
#define __tskrot
#define __tsktex

/* wait.c */
#define __waimake
#define __waicmp
#define __waitmo
#define __waitmook
#define __wairel
#define __wobjwai
#define __wobjwaitmo
#define __iniwque

/* domain.c */
#define __domini

/* memory.c */
#define __memini
#define __prb_mem
#define __memprbw
#define __memprbr
#define __memprbs

/* time_event.c */
#define __tmeini
#define __tmeup
#define __tmedown
#define __tmeins
#define __tmedel
#define __isig_tim
#define __tmeltim

/* task_manage.c */
#define __act_tsk
#define __iact_tsk
#define __can_act
#define __ext_tsk
#define __ter_tsk
#define __chg_pri
#define __get_pri

/* task_refer.c */
#define __ref_tsk

/* task_sync.c */
#define __slp_tsk
#define __tslp_tsk
#define __wup_tsk
#define __iwup_tsk
#define __can_wup
#define __rel_wai
#define __irel_wai
#define __sus_tsk
#define __rsm_tsk
#define __frsm_tsk
#define __dly_tsk

/* task_except.c */
#define __ras_tex
#define __iras_tex
#define __dis_tex
#define __ena_tex
#define __sns_tex
#define __ref_tex

/* semaphore.c */
#define __semini
#define __sig_sem
#define __isig_sem
#define __wai_sem
#define __pol_sem
#define __twai_sem
#define __ini_sem
#define __ref_sem

/* eventflag.c */
#define __flgini
#define __flgcnd
#define __set_flg
#define __iset_flg
#define __clr_flg
#define __wai_flg
#define __pol_flg
#define __twai_flg
#define __ini_flg
#define __ref_flg

/* dataqueue.c */
#define __dtqini
#define __dtqenq
#define __dtqfenq
#define __dtqdeq
#define __dtqsnd
#define __dtqrcv
#define __snd_dtq
#define __psnd_dtq
#define __ipsnd_dtq
#define __tsnd_dtq
#define __fsnd_dtq
#define __ifsnd_dtq
#define __rcv_dtq
#define __prcv_dtq
#define __trcv_dtq
#define __ini_dtq
#define __ref_dtq

/* mailbox.c */
#define __mbxini
#define __snd_mbx
#define __rcv_mbx
#define __prcv_mbx
#define __trcv_mbx
#define __ini_mbx
#define __ref_mbx

/* mutex.c */
#define __mtxhook
#define __mtxini
#define __mtxchk
#define __mtxcalc
#define __mtxchg
#define __mtxrel
#define __mtxdeq
#define __loc_mtx
#define __ploc_mtx
#define __tloc_mtx
#define __unl_mtx
#define __ini_mtx
#define __ref_mtx

/* mempfix.c */
#define __mpfini
#define __mpfget
#define __get_mpf
#define __pget_mpf
#define __tget_mpf
#define __rel_mpf
#define __ini_mpf
#define __ref_mpf

/* time_manage.c */
#define __set_tim
#define __get_tim
#define __get_utm

/* cyclic.c */
#define __cycini
#define __sta_cyc
#define __stp_cyc
#define __ref_cyc
#define __cyccal

/* alarm.c */
#define __almini
#define __sta_alm
#define __ista_alm
#define __stp_alm
#define __istp_alm
#define __ref_alm
#define __almcal

/* overrun.c */
#define __ovrini
#define __ovrsta
#define __ovrstp
#define __sta_ovr
#define __stp_ovr
#define __ref_ovr
#define __ovrcal

/* sys_manage.c */
#define __rot_rdq
#define __irot_rdq
#define __get_did
#define __get_tid
#define __iget_tid
#define __loc_cpu
#define __iloc_cpu
#define __unl_cpu
#define __iunl_cpu
#define __dis_dsp
#define __ena_dsp
#define __sns_ctx
#define __sns_loc
#define __sns_dsp
#define __sns_dpn
#define __sns_ker

/* svc_manage.c */
#define __svcent

/* interrupt.c */
#define __intini
#define __dis_int
#define __ena_int
#define __chg_ipm
#define __get_ipm

/* exception.c */
#define __excini
#define __xsns_dpn
#define __xsns_xpn

/* syslog */
#define __logini
#define __wri_log
#define __rea_log
#define __msk_log
#define __logter

#endif /* _ALLFUNC_H_ */
