/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ǡ塼ǽ
 */

#include "hrp_kernel.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "dataqueue.h"

/*
 *  ǡ塼ο
 */
#define tnum_dtq	((UINT)(tmax_dtqid - TMIN_DTQID + 1))

/*
 *  ǡ塼IDǡ塼֥åФΥޥ
 */
#define INDEX_DTQ(dtqid)	((UINT)((dtqid) - TMIN_DTQID))
#define get_dtqcb(dtqid)	(&(dtqcb_table[INDEX_DTQ(dtqid)]))

/*
 *  ǡ塼ǽν
 */
#ifdef __dtqini

void
initialize_dataqueue(void)
{
	UINT	i;
	DTQCB	*p_dtqcb;

	for (p_dtqcb = dtqcb_table, i = 0; i < tnum_dtq; p_dtqcb++, i++) {
		queue_initialize(&(p_dtqcb->swait_queue));
		p_dtqcb->p_dtqinib = &(dtqinib_table[i]);
		queue_initialize(&(p_dtqcb->rwait_queue));
		p_dtqcb->count = 0u;
		p_dtqcb->head = 0u;
		p_dtqcb->tail = 0u;
	}
}

#endif /* __dtqini */

/*
 *  ǡ塼ΰ˥ǡǼ
 */
#ifdef __dtqenq

BOOL
enqueue_data(DTQCB *p_dtqcb, VP_INT data)
{
	if (p_dtqcb->count < p_dtqcb->p_dtqinib->dtqcnt) {
		*((VP_INT *)(p_dtqcb->p_dtqinib->dtq) + p_dtqcb->tail) = data;
		p_dtqcb->count++;
		p_dtqcb->tail++;
		if (p_dtqcb->tail >= p_dtqcb->p_dtqinib->dtqcnt) {
			p_dtqcb->tail = 0u;
		}
		return(TRUE);
	}
	return(FALSE);
}

#endif /* __dtqenq */

/*
 *  ǡ塼ΰ˥ǡǼ
 */
#ifdef __dtqfenq

void
force_enqueue_data(DTQCB *p_dtqcb, VP_INT data)
{
	*((VP_INT *)(p_dtqcb->p_dtqinib->dtq) + p_dtqcb->tail) = data;
	p_dtqcb->tail++;
	if (p_dtqcb->tail >= p_dtqcb->p_dtqinib->dtqcnt) {
		p_dtqcb->tail = 0u;
	}
	if (p_dtqcb->count < p_dtqcb->p_dtqinib->dtqcnt) {
		p_dtqcb->count++;
	}
	else {
		p_dtqcb->head = p_dtqcb->tail;
	}
}

#endif /* __dtqfenq */

/*
 *  ǡ塼ΰ褫ǡФ
 */
#ifdef __dtqdeq

BOOL
dequeue_data(DTQCB *p_dtqcb, VP_INT *p_data)
{
	if (p_dtqcb->count > 0u) {
		*p_data = *((VP_INT *)(p_dtqcb->p_dtqinib->dtq) + p_dtqcb->head);
		p_dtqcb->count--;
		p_dtqcb->head++;
		if (p_dtqcb->head >= p_dtqcb->p_dtqinib->dtqcnt) {
			p_dtqcb->head = 0u;
		}
		return(TRUE);
	}
	return(FALSE);
}

#endif /* __dtqdeq */

/*
 *  Ԥ塼ƬؤΥǡ
 */
#ifdef __dtqsnd

TCB *
send_data_rwait(DTQCB *p_dtqcb, VP_INT data)
{
	TCB		*p_tcb;

	if (!queue_empty(&(p_dtqcb->rwait_queue))) {
		p_tcb = (TCB *) queue_delete_next(&(p_dtqcb->rwait_queue));
		((WINFO_DTQ *)(p_tcb->p_winfo))->data = data;
		return(p_tcb);
	}
	return(NULL);
}

#endif /* __dtqsnd */

/*
 *  Ԥ塼ƬΥǡ
 */
#ifdef __dtqrcv

TCB *
receive_data_swait(DTQCB *p_dtqcb, VP_INT *p_data)
{
	TCB		*p_tcb;

	if (!queue_empty(&(p_dtqcb->swait_queue))) {
		p_tcb = (TCB *) queue_delete_next(&(p_dtqcb->swait_queue));
		*p_data = ((WINFO_DTQ *)(p_tcb->p_winfo))->data;
		return(p_tcb);
	}
	return(NULL);
}

#endif /* __dtqrcv */

/*
 *  ǡ塼ؤ
 */
#ifdef __snd_dtq

SYSCALL ER
snd_dtq(ID dtqid, VP_INT data)
{
	DTQCB	*p_dtqcb;
	WINFO_DTQ winfo_dtq;
	TCB		*p_tcb;
	ER		ercd;

	LOG_SND_DTQ_ENTER(dtqid, data);
	CHECK_DISPATCH();
	CHECK_DTQID(dtqid);
	p_dtqcb = get_dtqcb(dtqid);
	CHECK_ACPTN(p_dtqcb->p_dtqinib->acvct.acptn1);

	t_lock_cpu();
	if ((p_tcb = send_data_rwait(p_dtqcb, data)) != NULL) {
		if (wait_complete(p_tcb)) {
			dispatch();
		}
		ercd = E_OK;
	}
	else if (enqueue_data(p_dtqcb, data)) {
		ercd = E_OK;
	}
	else if (p_runtsk->waifbd) {
		ercd = E_RLWAI;
	}
	else {
		winfo_dtq.data = data;
		p_runtsk->tstat = (TS_WAITING | TS_WAIT_SDTQ);
		wobj_make_wait((WOBJCB *) p_dtqcb, (WINFO_WOBJ *) &winfo_dtq);
		dispatch();
		ercd = winfo_dtq.winfo.wercd;
	}
	t_unlock_cpu();

  error_exit:
	LOG_SND_DTQ_LEAVE(ercd);
	return(ercd);
}

#endif /* __snd_dtq */

/*
 *  ǡ塼ؤʥݡ󥰡
 */
#ifdef __psnd_dtq

SYSCALL ER
psnd_dtq(ID dtqid, VP_INT data)
{
	DTQCB	*p_dtqcb;
	TCB		*p_tcb;
	ER		ercd;

	LOG_PSND_DTQ_ENTER(dtqid, data);
	CHECK_TSKCTX_UNL();
	CHECK_DTQID(dtqid);
	p_dtqcb = get_dtqcb(dtqid);
	CHECK_ACPTN(p_dtqcb->p_dtqinib->acvct.acptn1);

	t_lock_cpu();
	if ((p_tcb = send_data_rwait(p_dtqcb, data)) != NULL) {
		if (wait_complete(p_tcb)) {
			dispatch();
		}
		ercd = E_OK;
	}
	else if (enqueue_data(p_dtqcb, data)) {
		ercd = E_OK;
	}
	else {
		ercd = E_TMOUT;
	}
	t_unlock_cpu();

  error_exit:
	LOG_PSND_DTQ_LEAVE(ercd);
	return(ercd);
}

#endif /* __psnd_dtq */

/*
 *  ǡ塼ؤʥݡ󥰡󥿥ƥѡ
 */
#ifdef __ipsnd_dtq

SYSCALL ER
ipsnd_dtq(ID dtqid, VP_INT data)
{
	DTQCB	*p_dtqcb;
	TCB		*p_tcb;
	ER		ercd;

	LOG_IPSND_DTQ_ENTER(dtqid, data);
	CHECK_INTCTX_UNL();
	CHECK_DTQID(dtqid);
	p_dtqcb = get_dtqcb(dtqid);

	i_lock_cpu();
	if ((p_tcb = send_data_rwait(p_dtqcb, data)) != NULL) {
		if (wait_complete(p_tcb)) {
			reqflg = TRUE;
		}
		ercd = E_OK;
	}
	else if (enqueue_data(p_dtqcb, data)) {
		ercd = E_OK;
	}
	else {
		ercd = E_TMOUT;
	}
	i_unlock_cpu();

  error_exit:
	LOG_IPSND_DTQ_LEAVE(ercd);
	return(ercd);
}

#endif /* __ipsnd_dtq */

/*
 *  ǡ塼ؤʥॢȤ
 */
#ifdef __tsnd_dtq

SYSCALL ER
tsnd_dtq(ID dtqid, VP_INT data, TMO tmout)
{
	DTQCB	*p_dtqcb;
	WINFO_DTQ winfo_dtq;
	TMEVTB	tmevtb;
	TCB		*p_tcb;
	ER		ercd;

	LOG_TSND_DTQ_ENTER(dtqid, data, tmout);
	CHECK_DISPATCH();
	CHECK_DTQID(dtqid);
	CHECK_TMOUT(tmout);
	p_dtqcb = get_dtqcb(dtqid);
	CHECK_ACPTN(p_dtqcb->p_dtqinib->acvct.acptn1);

	t_lock_cpu();
	if ((p_tcb = send_data_rwait(p_dtqcb, data)) != NULL) {
		if (wait_complete(p_tcb)) {
			dispatch();
		}
		ercd = E_OK;
	}
	else if (enqueue_data(p_dtqcb, data)) {
		ercd = E_OK;
	}
	else if (tmout == TMO_POL) {
		ercd = E_TMOUT;
	}
	else if (p_runtsk->waifbd) {
		ercd = E_RLWAI;
	}
	else {
		winfo_dtq.data = data;
		p_runtsk->tstat = (TS_WAITING | TS_WAIT_SDTQ);
		wobj_make_wait_tmout((WOBJCB *) p_dtqcb, (WINFO_WOBJ *) &winfo_dtq,
														&tmevtb, tmout);
		dispatch();
		ercd = winfo_dtq.winfo.wercd;
	}
	t_unlock_cpu();

  error_exit:
	LOG_TSND_DTQ_LEAVE(ercd);
	return(ercd);
}

#endif /* __tsnd_dtq */

/*
 *  ǡ塼ؤζ
 */
#ifdef __fsnd_dtq

SYSCALL ER
fsnd_dtq(ID dtqid, VP_INT data)
{
	DTQCB	*p_dtqcb;	
	TCB		*p_tcb;
	ER		ercd;

	LOG_FSND_DTQ_ENTER(dtqid, data);
	CHECK_TSKCTX_UNL();
	CHECK_DTQID(dtqid);
	p_dtqcb = get_dtqcb(dtqid);
	CHECK_ACPTN(p_dtqcb->p_dtqinib->acvct.acptn1);
	CHECK_ILUSE(p_dtqcb->p_dtqinib->dtqcnt > 0u);

	t_lock_cpu();
	if ((p_tcb = send_data_rwait(p_dtqcb, data)) != NULL) {
		if (wait_complete(p_tcb)) {
			dispatch();
		}
	}
	else {
		force_enqueue_data(p_dtqcb, data);
	}
	ercd = E_OK;
	t_unlock_cpu();

  error_exit:
	LOG_FSND_DTQ_LEAVE(ercd);
	return(ercd);
}

#endif /* __fsnd_dtq */

/*
 *  ǡ塼ؤζ󥿥ƥѡ
 */
#ifdef __ifsnd_dtq

SYSCALL ER
ifsnd_dtq(ID dtqid, VP_INT data)
{
	DTQCB	*p_dtqcb;
	TCB		*p_tcb;
	ER		ercd;

	LOG_IFSND_DTQ_ENTER(dtqid, data);
	CHECK_INTCTX_UNL();
	CHECK_DTQID(dtqid);
	p_dtqcb = get_dtqcb(dtqid);
	CHECK_ILUSE(p_dtqcb->p_dtqinib->dtqcnt > 0u);

	i_lock_cpu();
	if ((p_tcb = send_data_rwait(p_dtqcb, data)) != NULL) {
		if (wait_complete(p_tcb)) {
			reqflg = TRUE;
		}
	}
	else {
		force_enqueue_data(p_dtqcb, data);
	}
	ercd = E_OK;
	i_unlock_cpu();

  error_exit:
	LOG_IFSND_DTQ_LEAVE(ercd);
	return(ercd);
}

#endif /* __ifsnd_dtq */

/*
 *  ǡ塼μ
 */
#ifdef __rcv_dtq

SYSCALL ER
rcv_dtq(ID dtqid, VP_INT *p_data)
{
	DTQCB	*p_dtqcb;
	WINFO_DTQ winfo_dtq;
	TCB		*p_tcb;
	VP_INT	data;
	ER		ercd;

	LOG_RCV_DTQ_ENTER(dtqid, p_data);
	CHECK_DISPATCH();
	CHECK_DTQID(dtqid);
	p_dtqcb = get_dtqcb(dtqid);
	CHECK_ACPTN(p_dtqcb->p_dtqinib->acvct.acptn2);
	CHECK_MACV_WRITE(p_data, VP_INT);

	t_lock_cpu();
	if (dequeue_data(p_dtqcb, p_data)) {
		if ((p_tcb = receive_data_swait(p_dtqcb, &data)) != NULL) {
			enqueue_data(p_dtqcb, data);
			if (wait_complete(p_tcb)) {
				dispatch();
			}
		}
		ercd = E_OK;
	}
	else if ((p_tcb = receive_data_swait(p_dtqcb, p_data)) != NULL) {
		if (wait_complete(p_tcb)) {
			dispatch();
		}
		ercd = E_OK;
	}
	else if (p_runtsk->waifbd) {
		ercd = E_RLWAI;
	}
	else {
		p_runtsk->tstat = (TS_WAITING | TS_WAIT_RDTQ);
		make_wait((WINFO *) &winfo_dtq);
		queue_insert_prev(&(p_dtqcb->rwait_queue), &(p_runtsk->task_queue));
		winfo_dtq.p_dtqcb = p_dtqcb;
		LOG_TSKSTAT(p_runtsk);
		dispatch();
		ercd = winfo_dtq.winfo.wercd;
		if (ercd == E_OK) {
			*p_data = winfo_dtq.data;
		}
	}
	t_unlock_cpu();

  error_exit:
	LOG_RCV_DTQ_LEAVE(ercd, *p_data);
	return(ercd);
}

#endif /* __rcv_dtq */

/*
 *  ǡ塼μʥݡ󥰡
 */
#ifdef __prcv_dtq

SYSCALL ER
prcv_dtq(ID dtqid, VP_INT *p_data)
{
	DTQCB	*p_dtqcb;
	TCB		*p_tcb;
	VP_INT	data;
	ER		ercd;

	LOG_PRCV_DTQ_ENTER(dtqid, p_data);
	CHECK_TSKCTX_UNL();
	CHECK_DTQID(dtqid);
	p_dtqcb = get_dtqcb(dtqid);
	CHECK_ACPTN(p_dtqcb->p_dtqinib->acvct.acptn2);
	CHECK_MACV_WRITE(p_data, VP_INT);

	t_lock_cpu();
	if (dequeue_data(p_dtqcb, p_data)) {
		if ((p_tcb = receive_data_swait(p_dtqcb, &data)) != NULL) {
			enqueue_data(p_dtqcb, data);
			if (wait_complete(p_tcb)) {
				dispatch();
			}
		}
		ercd = E_OK;
	}
	else if ((p_tcb = receive_data_swait(p_dtqcb, p_data)) != NULL) {
		if (wait_complete(p_tcb)) {
			dispatch();
		}
		ercd = E_OK;
	}
	else {
		ercd = E_TMOUT;
	}
	t_unlock_cpu();

  error_exit:
	LOG_PRCV_DTQ_LEAVE(ercd, *p_data);
	return(ercd);
}

#endif /* __prcv_dtq */

/*
 *  ǡ塼μʥॢȤ
 */
#ifdef __trcv_dtq

SYSCALL ER
trcv_dtq(ID dtqid, VP_INT *p_data, TMO tmout)
{
	DTQCB	*p_dtqcb;
	WINFO_DTQ winfo_dtq;
	TMEVTB	tmevtb;
	TCB		*p_tcb;
	VP_INT	data;
	ER		ercd;

	LOG_TRCV_DTQ_ENTER(dtqid, p_data, tmout);
	CHECK_DISPATCH();
	CHECK_DTQID(dtqid);
	CHECK_TMOUT(tmout);
	p_dtqcb = get_dtqcb(dtqid);
	CHECK_ACPTN(p_dtqcb->p_dtqinib->acvct.acptn2);
	CHECK_MACV_WRITE(p_data, VP_INT);

	t_lock_cpu();
	if (dequeue_data(p_dtqcb, p_data)) {
		if ((p_tcb = receive_data_swait(p_dtqcb, &data)) != NULL) {
			enqueue_data(p_dtqcb, data);
			if (wait_complete(p_tcb)) {
				dispatch();
			}
		}
		ercd = E_OK;
	}
	else if ((p_tcb = receive_data_swait(p_dtqcb, p_data)) != NULL) {
		if (wait_complete(p_tcb)) {
			dispatch();
		}
		ercd = E_OK;
	}
	else if (tmout == TMO_POL) {
		ercd = E_TMOUT;
	}
	else if (p_runtsk->waifbd) {
		ercd = E_RLWAI;
	}
	else {
		p_runtsk->tstat = (TS_WAITING | TS_WAIT_RDTQ);
		make_wait_tmout((WINFO *) &winfo_dtq, &tmevtb, tmout);
		queue_insert_prev(&(p_dtqcb->rwait_queue), &(p_runtsk->task_queue));
		winfo_dtq.p_dtqcb = p_dtqcb;
		LOG_TSKSTAT(p_runtsk);
		dispatch();
		ercd = winfo_dtq.winfo.wercd;
		if (ercd == E_OK) {
			*p_data = winfo_dtq.data;
		}
	}
	t_unlock_cpu();

  error_exit:
	LOG_TRCV_DTQ_LEAVE(ercd, *p_data);
	return(ercd);
}

#endif /* __trcv_dtq */

/*
 *  ǡ塼ν
 */
#ifdef __ini_dtq

SYSCALL ER
ini_dtq(ID dtqid)
{
	DTQCB	*p_dtqcb;
	ER		ercd;
    
	LOG_INI_DTQ_ENTER(dtqid);
	CHECK_TSKCTX_UNL();
	CHECK_DTQID(dtqid);
	p_dtqcb = get_dtqcb(dtqid);
	CHECK_ACPTN(p_dtqcb->p_dtqinib->acvct.acptn3);

	t_lock_cpu();
	init_wait_queue(&(p_dtqcb->swait_queue));
	init_wait_queue(&(p_dtqcb->rwait_queue));
	p_dtqcb->count = 0u;
	p_dtqcb->head = 0u;
	p_dtqcb->tail = 0u;
	if (p_runtsk != p_schedtsk && dspflg) {
		dispatch();
	}
	ercd = E_OK;
	t_unlock_cpu();

  error_exit:
	LOG_INI_DTQ_LEAVE(ercd);
	return(ercd);
}

#endif /* __ini_dtq */

/*
 *  ǡ塼ξֻ
 */
#ifdef __ref_dtq

SYSCALL ER
ref_dtq(ID dtqid, T_RDTQ *pk_rdtq)
{
	DTQCB	*p_dtqcb;
	ER		ercd;
    
	LOG_REF_DTQ_ENTER(dtqid, pk_rdtq);
	CHECK_TSKCTX_UNL();
	CHECK_DTQID(dtqid);
	p_dtqcb = get_dtqcb(dtqid);
	CHECK_ACPTN(p_dtqcb->p_dtqinib->acvct.acptn4);
	CHECK_MACV_WRITE(pk_rdtq, T_RDTQ);

	t_lock_cpu();
	pk_rdtq->stskid = wait_tskid(&(p_dtqcb->swait_queue));
	pk_rdtq->rtskid = wait_tskid(&(p_dtqcb->rwait_queue));
	pk_rdtq->sdtqcnt = p_dtqcb->count;
	ercd = E_OK;
	t_unlock_cpu();

  error_exit:
	LOG_REF_DTQ_LEAVE(ercd, pk_rdtq);
	return(ercd);
}

#endif /* __ref_dtq */
