/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ǡ塼ǽ
 */

#ifndef _DATAQUEUE_H_
#define _DATAQUEUE_H_

#include "queue.h"

/*
 *  ǡ塼֥å
 *
 *  ι¤ΤϡƱ֥̿Ȥν֥åζʬ
 *  WOBJINIBˤĥʥ֥ȻظηѾˤΤǡ
 *  ǽΥեɤ̤ˤʤäƤ롥
 */
typedef struct dataqueue_initialization_block {
	ATR		dtqatr;			/* ǡ塼° */
	UINT	dtqcnt;			/* ǡ塼ΰ */
	VP		dtq;			/* ǡ塼ΰƬ */
	ACVCT	acvct;			/* ĥ٥ */
} DTQINIB;

/*
 *  ǡ塼֥å
 *
 *  ι¤ΤϡƱ֥̿Ȥδ֥åζʬWOBJCB
 *  ĥʥ֥ȻظηѾˤΤǡǽ2Ĥ
 *  եɤ̤ˤʤäƤ롥
 */
typedef struct dataqueue_control_block {
	QUEUE	swait_queue;		/* ǡ塼Ԥ塼 */
	const DTQINIB *p_dtqinib;	/* ֥åؤΥݥ */
	QUEUE	rwait_queue;		/* ǡ塼Ԥ塼 */
	UINT	count;				/* ǡ塼Υǡο */
	UINT	head;				/* ǽΥǡγǼ */
	UINT	tail;				/* ǸΥǡγǼμ */
} DTQCB;

/*
 *  ǡ塼Ԥ֥å
 *
 *  ι¤ΤϡƱ֥̿ȤԤ֥åζʬ
 *  WINFO_WOBJˤĥʥ֥ȻظηѾˤΤǡ
 *  ǽ2ĤΥեɤ̤ˤʤäƤ롥
 *  ǡ塼ؤԤȥǡ塼μԤǡƱԤ
 *  ֥åȤ
 */
typedef struct dataqueue_waiting_information {
	WINFO	winfo;			/* ɸԤ֥å */
	DTQCB	*p_dtqcb;		/* ԤäƤǡ塼δ֥å */
	VP_INT	data;			/* ǡ  */
} WINFO_DTQ;

/*
 *  ǡ塼IDκ͡kernel_cfg.c
 */
extern const ID	tmax_dtqid;

/*
 *  ǡ塼֥åΥꥢkernel_cfg.c
 */
extern const DTQINIB	dtqinib_table[];

/*
 *  ǡ塼֥åΥꥢkernel_cfg.c
 */
extern DTQCB	dtqcb_table[];

/*
 *  ǡ塼֥åǡ塼IDФΥޥ
 */
#define	DTQID(p_dtqcb)	((ID)(((p_dtqcb) - dtqcb_table) + TMIN_DTQID))

/*
 *  ǡ塼ǽν
 */
extern void	initialize_dataqueue(void);

/*
 *  ǡ塼ΰ˥ǡǼ
 */
extern BOOL	enqueue_data(DTQCB *p_dtqcb, VP_INT data);

/*
 *  ǡ塼ΰ˥ǡǼ
 */
extern void	force_enqueue_data(DTQCB *p_dtqcb, VP_INT data);

/*
 *  ǡ塼ΰ褫ǡФ
 */
extern BOOL	dequeue_data(DTQCB *p_dtqcb, VP_INT *p_data);

/*
 *  Ԥ塼ƬؤΥǡ
 */
extern TCB	*send_data_rwait(DTQCB *p_dtqcb, VP_INT data);

/*
 *  Ԥ塼ƬΥǡ
 */
extern TCB	*receive_data_swait(DTQCB *p_dtqcb, VP_INT *p_data);

#endif /* _DATAQUEUE_H_ */
