/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		CPU㳰ǽ
 */

#include "hrp_kernel.h"
#include "task.h"
#include "exception.h"

/* 
 *  CPU㳰ϥɥǽν
 */
#ifdef __excini
#ifndef OMIT_INITIALIZE_EXCEPTION

void
initialize_exception(void)
{
	UINT			i;
	const EXCINIB	*p_excinib;

	for (p_excinib = excinib_table, i = 0; i < tnum_excno; p_excinib++, i++) {
		x_define_exc(p_excinib->excno, p_excinib->exchdr);
	}
}

#endif /* OMIT_INITIALIZE_EXCEPTION */
#endif /* __excini */

/*
 *  CPU㳰ȯƥȤλ
 */

/*
 *  CPU㳰ȯΥǥѥåα֤λ
 *
 *  CPU㳰ϥɥdisdspѲ뤳ȤϤʤᡤCPU㳰ȯ
 *  disdsp¸ƤɬפϤʤ
 */
#ifdef __xsns_dpn

SYSCALL BOOL
xsns_dpn(VP p_excinf)
{
	BOOL	state;

	LOG_XSNS_DPN_ENTER(p_excinf);
	state = (sense_context() && exc_sense_intmask(p_excinf)
								&& !disdsp) ? FALSE : TRUE;
	LOG_XSNS_DPN_LEAVE(state);
	return(state);
}

#endif /* __xsns_dpn */

/*
 *  CPU㳰ȯΥ㳰α֤λ
 *
 *  CPU㳰ϥɥp_runtskp_runtsk->enatexѲ뤳ȤϤʤ
 *  ᡤCPU㳰ȯp_runtsk->enatex¸ƤɬפϤ
 *  
 */
#ifdef __xsns_xpn

SYSCALL BOOL
xsns_xpn(VP p_excinf)
{
	BOOL	state;

	LOG_XSNS_XPN_ENTER(p_excinf);
	state = (sense_context() && exc_sense_unlock(p_excinf)
				&& p_runtsk != NULL && p_runtsk->enatex) ? FALSE : TRUE;
	LOG_XSNS_XPN_LEAVE(state);
	return(state);
}

#endif /* __xsns_xpn */
