/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		TOPPERS/HRPͥɸ।󥯥롼ɥե
 *
 *  Υ󥯥롼ɥեϡͥץΥե
 *  ɬ󥯥롼ɤ٤ɸ।󥯥롼ɥեǤ롥
 *
 *  ֥Υե䥷ƥॳե졼ե
 *  뤫餳Υե򥤥󥯥롼ɤϡ_MACRO_ONLY
 *  ȤǡޥʳεҤȤǤ롥
 */

#ifndef _HRP_KERNEL_H_
#define _HRP_KERNEL_H_

/*
 *  ͥ̾Υ͡
 */
#include "hrp_rename.h"

/*
 *  ץꥱȶ̤Υ󥯥롼ɥե
 */
#include <kernel.h>

/*
 *  åȰ¸
 */
#include <t_config.h>

/*
 *  ٤Ƥδؿ򥳥ѥ뤹뤿
 */
#ifdef ALLFUNC
#include "allfunc.h"
#endif /* ALLFUNC */

/*
 *  ӥåȥեɤǤ̵
 *
 *  8ӥåȰʲΥӥåȥեɤǡ̵ͤݻ
 *  Ѥ٤ǡANSI CǤϡӥåȥեɤΥǡˤ
 *  intʤᡤǥեȤunsigned intȤƤ뤬
 *  åȤӥġ¸ǡunsigned charޤunsigned short
 *  Ψɤ礬롥
 */
#ifndef BIT_FIELD_UINT
#define BIT_FIELD_UINT		unsigned int
#endif /* BIT_FIELD_UINT */

/*
 *  ӥåȥեɤǤΥ֡뷿
 *
 *  1ӥåΥӥåȥեɤǡ֡ͤݻѤ
 *  ǡBIT_FIELD_UINTƱƤ뤬֡ͤݻ
 *  뤳Ȥ뤿̤̾ΤȤƤ롥
 */
#define BIT_FIELD_BOOL		BIT_FIELD_UINT

/*
 *  ֥IDκǾͤ
 */
#define	TMIN_DOMID		1		/* ݸɥᥤIDκǾ */
#define TMIN_TSKID		1		/* IDκǾ */
#define TMIN_SEMID		1		/* ޥեIDκǾ */
#define TMIN_FLGID		1		/* ե饰IDκǾ */
#define TMIN_DTQID		1		/* ǡ塼IDκǾ */
#define TMIN_MBXID		1		/* ᡼ܥåIDκǾ */
#define TMIN_MTXID		1		/* ߥ塼ƥåIDκǾ */
#define TMIN_MPFID		1		/* ĹסIDκǾ */
#define TMIN_CYCID		1		/* ϥɥIDκǾ */
#define TMIN_ALMID		1		/* 顼ϥɥIDκǾ */

/*
 *  ͥ٤ʳ
 */
#define TNUM_TPRI		(TMAX_TPRI - TMIN_TPRI + 1)
#define TNUM_MPRI		(TMAX_MPRI - TMIN_MPRI + 1)
#define TNUM_INTPRI		(TMAX_INTPRI - TMIN_INTPRI + 1)

/*
 *  ӥ
 *
 *  ӥδؿǤ뤳Ȥ뤿ˡӥ
 *  ؿƬSYSCALLȵҤ롥
 */
#define SYSCALL

/*
 *  إåեʤ⥸塼δؿѿ
 */
#ifndef _MACRO_ONLY

/*
 *  ƥ⥸塼νkernel_cfg.c
 */
extern void	initialize_object(void);

/*
 *  롼μ¹ԡkernel_cfg.c
 */
extern void	call_inirtn(void);

/*
 *  λ롼μ¹ԡkernel_cfg.c
 */
extern void	call_terrtn(void);

/*
 *  ͥư֥ե饰startup.c
 */
extern BOOL	kerflg;

/*
 *  ͥεưstartup.c
 */
extern void	sta_ker(void);

/*
 *  ͥνλstartup.c
 */
extern void	exit_kernel(void);

/*
 *  ƥФ륢ĥ٥kernel_cfg.c
 */
extern const ACVCT	systim_acvct;

/*
 *  ƥ֤Ф륢ĥ٥kernel_cfg.c
 */
extern const ACVCT	sysstat_acvct;

/*
 *  󥿥ƥѤΥåΰkernel_cfg.c
 */
extern const VP		istk;		/* åΰƬ */
extern const SIZE	istksz;		/* åΰΥʴݤ᤿͡ */

/*
 *  ưåɽbanner.c
 */
extern void	print_banner(void);

#endif /* _MACRO_ONLY */
#endif /* _HRP_KERNEL_H_ */
