/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ߴǽ
 */

#include "hrp_kernel.h"
#include "check.h"
#include "task.h"
#include "interrupt.h"

/* 
 *  ߴǽν
 */
#ifdef __intini
#ifndef OMIT_INITIALIZE_INTERRUPT

void
initialize_interrupt(void)
{
	UINT			i;
	const INHINIB	*p_inhinib;
	const INTINIB	*p_intinib;

	for (p_inhinib = inhinib_table, i = 0; i < tnum_inhno; p_inhinib++, i++) {
		x_define_inh(p_inhinib->inhno, p_inhinib->inthdr);
	}
	for (p_intinib = intinib_table, i = 0; i < tnum_intno; p_intinib++, i++) {
		x_config_int(p_intinib->intno, p_intinib->intatr, p_intinib->intpri);
	}
}

#endif /* OMIT_INITIALIZE_INTERRUPT */
#endif /* __intini */

/*
 *  ߤζػ
 */
#ifdef __dis_int

SYSCALL ER
dis_int(INTNO intno)
{
	ER		ercd;

	LOG_DIS_INT_ENTER(intno);
	CHECK_TSKCTX_UNL();
	CHECK_INTNO(intno);
	CHECK_ACPTN(sysstat_acvct.acptn2);

	t_lock_cpu();
	if (t_disable_int(intno)) {
		ercd = E_OK;
	}
	else {
		ercd = E_NOSPT;
	}
	t_unlock_cpu();

  error_exit:
	LOG_DIS_INT_LEAVE(ercd);
	return(ercd);
}

#endif /* __dis_int */

/*
 *  ߤε
 */
#ifdef __ena_int

SYSCALL ER
ena_int(INTNO intno)
{
	ER		ercd;

	LOG_ENA_INT_ENTER(intno);
	CHECK_TSKCTX_UNL();
	CHECK_INTNO(intno);
	CHECK_ACPTN(sysstat_acvct.acptn2);

	t_lock_cpu();
	if (t_enable_int(intno)) {
		ercd = E_OK;
	}
	else {
		ercd = E_NOSPT;
	}
	t_unlock_cpu();

  error_exit:
	LOG_ENA_INT_LEAVE(ercd);
	return(ercd);
}

#endif /* __ena_int */

/*
 *  ͥ٥ޥѹ
 */
#ifdef __chg_ipm

SYSCALL ER
chg_ipm(PRI intpri)
{
	ER		ercd;

	LOG_CHG_IPM_ENTER(intpri);
	CHECK_TSKCTX_UNL();
	CHECK_INTPRI(intpri);
	CHECK_ACPTN(sysstat_acvct.acptn2);

	t_lock_cpu();
	t_set_ipm(intpri);
	if (intpri != TIPM_ENAALL) {
		dspflg = FALSE;
	}
	else if (!disdsp) {
		dspflg = TRUE;
		if (p_runtsk != p_schedtsk) {
			dispatch();
		}
	}
	ercd = E_OK;
	t_unlock_cpu();

  error_exit:
	LOG_CHG_IPM_LEAVE(ercd);
	return(ercd);
}

#endif /* __chg_ipm */

/*
 *  ͥ٥ޥλ
 */
#ifdef __get_ipm

SYSCALL ER
get_ipm(PRI *p_intpri)
{
	ER		ercd;

	LOG_GET_IPM_ENTER(p_intpri);
	CHECK_TSKCTX_UNL();
	CHECK_ACPTN(sysstat_acvct.acptn2);
	CHECK_MACV_WRITE(p_intpri, PRI);

	t_lock_cpu();
	*p_intpri = t_get_ipm();
	ercd = E_OK;
	t_unlock_cpu();

  error_exit:
	LOG_GET_IPM_LEAVE(ercd, *p_intpri);
	return(ercd);
}

#endif /* __get_ipm */
