/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		kernel_cfg.cѥ󥯥롼ɥե
 */

#ifndef _KERNEL_CFG_H_
#define _KERNEL_CFG_H_

/*
 *  ͥɸ।󥯥롼ɥե
 */
#include "hrp_kernel.h"

/*
 *  ͥγƥ󥯥롼ɥե
 */
#include "task.h"
#include "memory.h"
#include "semaphore.h"
#include "eventflag.h"
#include "dataqueue.h"
#include "mailbox.h"
#include "mutex.h"
#include "mempfix.h"
#include "cyclic.h"
#include "alarm.h"
#include "overrun.h"
#include "svc_manage.h"
#include "interrupt.h"
#include "exception.h"
#include "time_event.h"

/*
 *  ͥΥꥢ뤿Υޥ
 *
 *  ʲϡVPΥPAGE_SIZE__STK_UNITΥ__MPF_UNIT
 *  2ζҾǤ뤳ȤꤷƤ롥
 */
#define __TROUND_SZ(sz, unit)		(((sz) + (unit) - 1) & ~((unit) - 1))
#define __TCOUNT_SZ(sz, unit)		(((sz) + (unit) - 1) / (unit))

#define __TROUND_VP(sz)				__TROUND_SZ(sz, sizeof(VP))
#define __TCOUNT_VP(sz)				__TCOUNT_SZ(sz, sizeof(VP))

#define	__TROUND_PAGE(sz)			__TROUND_SZ(sz, PAGE_SIZE)
#define	__TCOUNT_PAGE(sz)			__TCOUNT_SZ(sz, PAGE_SIZE)

#if !defined(__ghs__)
#define __TROUND_STK_UNIT(sz)		__TROUND_SZ(sz, sizeof(__STK_UNIT))
#else /* defined(__ghs__) */
#define __TROUND_STK_UNIT(sz)		__TROUND_SZ(sz, __SIZEOF_STK_UNIT)
#endif /* !defined(__ghs__) */
#define __TCOUNT_STK_UNIT(sz)		__TCOUNT_SZ(sz, sizeof(__STK_UNIT))

#define __TROUND_MPF_UNIT(sz)		__TROUND_SZ(sz, sizeof(__MPF_UNIT))
#define __TCOUNT_MPF_UNIT(sz)		__TCOUNT_SZ(sz, sizeof(__MPF_UNIT))

/*
 *  ͡षܥ򸵤᤹Υ󥯥롼ɥե
 */
#include "hrp_unrename.h"
#include <sys_unrename.h>
#include <cpu_unrename.h>

#endif /* _KERNEL_CFG_H_ */
