/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001,2002 by Information-technology Promotion Agency, JAPAN
 *  Copyright (C) 2001,2002 by TRON Association, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		᡼ܥåǽ
 */

#include "hrp_kernel.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "mailbox.h"

/*
 *  ᡼ܥåο
 */
#define tnum_mbx	((UINT)(tmax_mbxid - TMIN_MBXID + 1))

/*
 *  ᡼ܥåID᡼ܥå֥åФΥޥ
 */
#define INDEX_MBX(mbxid)	((UINT)((mbxid) - TMIN_MBXID))
#define get_mbxcb(mbxid)	(&(mbxcb_table[INDEX_MBX(mbxid)]))

/* 
 *  ᡼ܥåΥåν
 */
Inline void
init_mbxnode(MBXCB *p_mbxcb)
{
	UINT	j;
	MBXNODE	*p_mbxnode;

	p_mbxnode = p_mbxcb->p_mbxinib->p_mbxnode;
	p_mbxcb->p_free = p_mbxnode;
	for (j = 0; j < p_mbxcb->p_mbxinib->mbxcnt - 1; p_mbxnode++, j++) {
		p_mbxnode->p_next = p_mbxnode + 1;
	}
	p_mbxnode->p_next = NULL;
}

/* 
 *  ᡼ܥåǽν
 */
#ifdef __mbxini

void
initialize_mailbox(void)
{
	UINT	i;
	MBXCB	*p_mbxcb;

	for (p_mbxcb = mbxcb_table, i = 0; i < tnum_mbx; p_mbxcb++, i++) {
		queue_initialize(&(p_mbxcb->wait_queue));
		p_mbxcb->p_mbxinib = &(mbxinib_table[i]);
		p_mbxcb->p_head = NULL;
		init_mbxnode(p_mbxcb);
	}
}

#endif /* __mbxini */

/*
 *  åͥ٤μФ
 */
#define	MSGPRI(pk_msg)	(((T_MSG_PRI *) pk_msg)->msgpri)

/*
 *  ͥٽå塼ؤ
 */
Inline void
enqueue_msg_pri(MBXNODE **pp_prev_next, MBXNODE *p_mbxnode, PRI msgpri)
{
	MBXNODE	*p_next;

	while ((p_next = *pp_prev_next) != NULL) {
		if (p_next->msgpri > msgpri) {
			break;
		}
		pp_prev_next = &(p_next->p_next);
	}
	p_mbxnode->p_next = p_next;
	p_mbxnode->msgpri = msgpri;
	*pp_prev_next = p_mbxnode;
}

/*
 *  ᡼ܥåؤ
 */
#ifdef __snd_mbx

SYSCALL ER
snd_mbx(ID mbxid, T_MSG *pk_msg)
{
	MBXCB	*p_mbxcb;
	MBXNODE	*p_mbxnode;
	TCB		*p_tcb;
	ER		ercd;
    
	LOG_SND_MBX_ENTER(mbxid, pk_msg);
	CHECK_TSKCTX_UNL();
	CHECK_MBXID(mbxid);
	p_mbxcb = get_mbxcb(mbxid);
	CHECK_ACPTN(p_mbxcb->p_mbxinib->acvct.acptn1);
	if ((p_mbxcb->p_mbxinib->mbxatr & TA_MPRI) == 0u) {
		CHECK_MACV_READ((T_MSG *) pk_msg, T_MSG);
	}
	else {
		CHECK_MACV_READ((T_MSG_PRI *) pk_msg, T_MSG_PRI);
		CHECK_PAR(TMIN_MPRI <= MSGPRI(pk_msg)
						&& MSGPRI(pk_msg) <= p_mbxcb->p_mbxinib->maxmpri);
	}

	t_lock_cpu();
	if (!queue_empty(&(p_mbxcb->wait_queue))) {
		p_tcb = (TCB *) queue_delete_next(&(p_mbxcb->wait_queue));
		((WINFO_MBX *)(p_tcb->p_winfo))->pk_msg = pk_msg;
		if (wait_complete(p_tcb)) {
			dispatch();
		}
		ercd = E_OK;
	}
	else if (p_mbxcb->p_free == NULL) {
		ercd = E_QOVR;
	}
	else {
		p_mbxnode = p_mbxcb->p_free;
		p_mbxcb->p_free = p_mbxnode->p_next;
		if ((p_mbxcb->p_mbxinib->mbxatr & TA_MPRI) == 0u) {
			p_mbxnode->p_next = NULL;
			if (p_mbxcb->p_head != NULL) {
				p_mbxcb->p_last->p_next = p_mbxnode;
			}
			else {
				p_mbxcb->p_head = p_mbxnode;
			}
			p_mbxcb->p_last = p_mbxnode;
		}
		else {
			enqueue_msg_pri(&(p_mbxcb->p_head), p_mbxnode, MSGPRI(pk_msg));
		}
		p_mbxnode->pk_msg = pk_msg;
		ercd = E_OK;
	}
	t_unlock_cpu();

  error_exit:
	LOG_SND_MBX_LEAVE(ercd);
	return(ercd);
}

#endif /* __snd_mbx */

/*
 *  ᡼ܥåμ
 */
#ifdef __rcv_mbx

SYSCALL ER
rcv_mbx(ID mbxid, T_MSG **ppk_msg)
{
	MBXCB	*p_mbxcb;
	MBXNODE	*p_mbxnode;
	WINFO_MBX winfo_mbx;
	ER		ercd;
    
	LOG_RCV_MBX_ENTER(mbxid, ppk_msg);
	CHECK_DISPATCH();
	CHECK_MBXID(mbxid);
	p_mbxcb = get_mbxcb(mbxid);
	CHECK_ACPTN(p_mbxcb->p_mbxinib->acvct.acptn2);
	CHECK_MACV_WRITE(ppk_msg, T_MSG *);
    
	t_lock_cpu();
	if (p_mbxcb->p_head != NULL) {
		p_mbxnode = p_mbxcb->p_head;
		p_mbxcb->p_head = p_mbxnode->p_next;
		p_mbxnode->p_next = p_mbxcb->p_free;
		p_mbxcb->p_free = p_mbxnode;
		*ppk_msg = p_mbxnode->pk_msg;
		ercd = E_OK;
	}
	else if (p_runtsk->waifbd) {
		ercd = E_RLWAI;
	}
	else {
		p_runtsk->tstat = (TS_WAITING | TS_WAIT_MBX);
		wobj_make_wait((WOBJCB *) p_mbxcb, (WINFO_WOBJ *) &winfo_mbx);
		dispatch();
		ercd = winfo_mbx.winfo.wercd;
		if (ercd == E_OK) {
			*ppk_msg = winfo_mbx.pk_msg;
		}
	}
	t_unlock_cpu();

  error_exit:
	LOG_RCV_MBX_LEAVE(ercd, *ppk_msg);
	return(ercd);
}

#endif /* __rcv_mbx */

/*
 *  ᡼ܥåμʥݡ󥰡
 */
#ifdef __prcv_mbx

SYSCALL ER
prcv_mbx(ID mbxid, T_MSG **ppk_msg)
{
	MBXCB	*p_mbxcb;
	MBXNODE	*p_mbxnode;
	ER		ercd;
    
	LOG_PRCV_MBX_ENTER(mbxid, ppk_msg);
	CHECK_TSKCTX_UNL();
	CHECK_MBXID(mbxid);
	p_mbxcb = get_mbxcb(mbxid);
	CHECK_ACPTN(p_mbxcb->p_mbxinib->acvct.acptn2);
	CHECK_MACV_WRITE(ppk_msg, T_MSG *);
    
	t_lock_cpu();
	if (p_mbxcb->p_head != NULL) {
		p_mbxnode = p_mbxcb->p_head;
		p_mbxcb->p_head = p_mbxnode->p_next;
		p_mbxnode->p_next = p_mbxcb->p_free;
		p_mbxcb->p_free = p_mbxnode;
		*ppk_msg = p_mbxnode->pk_msg;
		ercd = E_OK;
	}
	else {
		ercd = E_TMOUT;
	}
	t_unlock_cpu();

  error_exit:
	LOG_PRCV_MBX_LEAVE(ercd, *ppk_msg);
	return(ercd);
}

#endif /* __prcv_mbx */

/*
 *  ᡼ܥåμʥॢȤ
 */
#ifdef __trcv_mbx

SYSCALL ER
trcv_mbx(ID mbxid, T_MSG **ppk_msg, TMO tmout)
{
	MBXCB	*p_mbxcb;
	MBXNODE	*p_mbxnode;
	WINFO_MBX winfo_mbx;
	TMEVTB	tmevtb;
	ER		ercd;
    
	LOG_TRCV_MBX_ENTER(mbxid, ppk_msg, tmout);
	CHECK_DISPATCH();
	CHECK_MBXID(mbxid);
	CHECK_TMOUT(tmout);
	p_mbxcb = get_mbxcb(mbxid);
	CHECK_ACPTN(p_mbxcb->p_mbxinib->acvct.acptn2);
	CHECK_MACV_WRITE(ppk_msg, T_MSG *);
    
	t_lock_cpu();
	if (p_mbxcb->p_head != NULL) {
		p_mbxnode = p_mbxcb->p_head;
		p_mbxcb->p_head = p_mbxnode->p_next;
		p_mbxnode->p_next = p_mbxcb->p_free;
		p_mbxcb->p_free = p_mbxnode;
		*ppk_msg = p_mbxnode->pk_msg;
		ercd = E_OK;
	}
	else if (tmout == TMO_POL) {
		ercd = E_TMOUT;
	}
	else if (p_runtsk->waifbd) {
		ercd = E_RLWAI;
	}
	else {
		p_runtsk->tstat = (TS_WAITING | TS_WAIT_MBX);
		wobj_make_wait_tmout((WOBJCB *) p_mbxcb, (WINFO_WOBJ *) &winfo_mbx,
														&tmevtb, tmout);
		dispatch();
		ercd = winfo_mbx.winfo.wercd;
		if (ercd == E_OK) {
			*ppk_msg = winfo_mbx.pk_msg;
		}
	}
	t_unlock_cpu();

  error_exit:
	LOG_TRCV_MBX_LEAVE(ercd, *ppk_msg);
	return(ercd);
}

#endif /* __trcv_mbx */

/*
 *  ᡼ܥåν
 */
#ifdef __ini_mbx

SYSCALL ER
ini_mbx(ID mbxid)
{
	MBXCB	*p_mbxcb;
	ER		ercd;
    
	LOG_INI_MBX_ENTER(mbxid);
	CHECK_TSKCTX_UNL();
	CHECK_MBXID(mbxid);
	p_mbxcb = get_mbxcb(mbxid);
	CHECK_ACPTN(p_mbxcb->p_mbxinib->acvct.acptn3);

	t_lock_cpu();
	init_wait_queue(&(p_mbxcb->wait_queue));
	p_mbxcb->p_head = NULL;
	init_mbxnode(p_mbxcb);
	if (p_runtsk != p_schedtsk && dspflg) {
		dispatch();
	}
	ercd = E_OK;
	t_unlock_cpu();

  error_exit:
	LOG_INI_MBX_LEAVE(ercd);
	return(ercd);
}

#endif /* __ini_mbx */

/*
 *  ᡼ܥåξֻ
 */
#ifdef __ref_mbx

SYSCALL ER
ref_mbx(ID mbxid, T_RMBX *pk_rmbx)
{
	MBXCB	*p_mbxcb;
	ER		ercd;
    
	LOG_REF_MBX_ENTER(mbxid, pk_rmbx);
	CHECK_TSKCTX_UNL();
	CHECK_MBXID(mbxid);
	p_mbxcb = get_mbxcb(mbxid);
	CHECK_ACPTN(p_mbxcb->p_mbxinib->acvct.acptn4);
	CHECK_MACV_WRITE(pk_rmbx, T_RMBX);

	t_lock_cpu();
	pk_rmbx->wtskid = wait_tskid(&(p_mbxcb->wait_queue));
	if (p_mbxcb->p_head == NULL) {
		pk_rmbx->pk_msg = NULL;
	}
	else {
		pk_rmbx->pk_msg = p_mbxcb->p_head->pk_msg;
	}
	ercd = E_OK;
	t_unlock_cpu();

  error_exit:
	LOG_REF_MBX_LEAVE(ercd, pk_rmbx);
	return(ercd);
}

#endif /* __ref_mbx */
