/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001,2002 by Information-technology Promotion Agency, JAPAN
 *  Copyright (C) 2001,2002 by TRON Association, JAPAN
 *  Copyright (C) 2005 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		᡼ܥåǽ
 */

#ifndef _MAILBOX_H_
#define _MAILBOX_H_

#include "queue.h"

/*
 *  ᡼ܥåΥå
 */
typedef struct mailbox_message_information	MBXNODE;

struct mailbox_message_information {
	MBXNODE	*p_next;		/* Υå */
	PRI		msgpri;			/* åͥ */
	T_MSG	*pk_msg;		/* åΥɥ쥹 */
};

/*
 *  ᡼ܥå֥å
 *
 *  ι¤ΤϡƱ֥̿Ȥν֥åζʬ
 *  WOBJINIBˤĥʥ֥ȻظηѾˤΤǡ
 *  ǽΥեɤ̤ˤʤäƤ롥
 */
typedef struct mailbox_initialization_block {
	ATR		mbxatr;			/* ᡼ܥå° */
	UINT	mbxcnt;			/* ᡼ܥå */
	PRI		maxmpri;		/* åͥ٤κ */
	MBXNODE	*p_mbxnode;		/* åΥꥢؤΥݥ */
	ACVCT	acvct;			/* ĥ٥ */
} MBXINIB;

/*
 *  ᡼ܥå֥å
 *
 *  ι¤ΤϡƱ֥̿Ȥδ֥åζʬWOBJCB
 *  ĥʥ֥ȻظηѾˤΤǡǽ2Ĥ
 *  եɤ̤ˤʤäƤ롥
 *
 *  å塼åͥٽξˤϡp_lastϻȤʤ
 *  ޤå塼ξp_headNULLξˤˤ⡤p_last
 *  ̵Ǥ롥
 */
typedef struct mailbox_control_block {
	QUEUE	wait_queue;			/* ᡼ܥåԤ塼 */
	const MBXINIB *p_mbxinib;	/* ֥åؤΥݥ */
	MBXNODE	*p_head;			/* ƬΥå */
	MBXNODE	*p_last;			/* Υå */
	MBXNODE *p_free;			/* åΥե꡼ꥹ */
} MBXCB;

/*
 *  ᡼ܥåԤ֥å
 *
 *  ι¤ΤϡƱ֥̿ȤԤ֥åζʬ
 *  WINFO_WOBJˤĥʥ֥ȻظηѾˤΤǡ
 *  ǽ2ĤΥեɤ̤ˤʤäƤ롥
 */
typedef struct mailbox_waiting_information {
	WINFO	winfo;			/* ɸԤ֥å */
	MBXCB	*p_mbxcb;		/* ԤäƤ᡼ܥåδ֥å */
	T_MSG	*pk_msg;		/* å */
} WINFO_MBX;

/*
 *  ᡼ܥåIDκ͡kernel_cfg.c
 */
extern const ID	tmax_mbxid;

/*
 *  ᡼ܥå֥åΥꥢkernel_cfg.c
 */
extern const MBXINIB	mbxinib_table[];

/*
 *  ᡼ܥå֥åΥꥢkernel_cfg.c
 */
extern MBXCB	mbxcb_table[];

/*
 *  ᡼ܥå֥å᡼ܥåIDФΥޥ
 */
#define	MBXID(p_mbxcb)	((ID)(((p_mbxcb) - mbxcb_table) + TMIN_MBXID))

/*
 *  ᡼ܥåǽν
 */
extern void	initialize_mailbox(void);

#endif /* _MAILBOX_H_ */
