/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001,2002 by Information-technology Promotion Agency, JAPAN
 *  Copyright (C) 2001,2002 by TRON Association, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ꥪ֥ȴ⥸塼
 */

#include "hrp_kernel.h"
#include "check.h"
#include "task.h"
#include "memory.h"

/*
 *  ꥪ֥Ƚ֥åθ
 */
Inline INT
search_meminib(VP addr)
{
	INT		left, right, i;

	left = 0;
	right = tnum_meminib - 1;
	while (left < right) {
		i = (left + right + 1) / 2;
#if !defined(__ghs__)
		if (addr < memtop_table[i]) {
			right = i - 1;
		}
#else /* defined(__ghs__) */
		/* GHS compiler compares pointers as SIGNED. so cast the pointer to UW */
		if ((UW)addr < (UW)memtop_table[i]) {
			right = i - 1;
		}
#endif
		else {
			left = i;
		}
	}
	return(left);
}

/*
 *  ꥪ֥ȴ⥸塼ν
 */
#ifdef __memini

void
initialize_memory(void)
{
#ifdef GENERATE_MEMINIB
#ifndef OMIT_GENERATE_MEMINIB
	const MEMINFO	*p_meminfo;
	VP				nexttop;
	INT				meminib;
	INT				i, j;

	/*
	 *  ꥪ֥Ƚ֥å
	 *
	 *  ΰ褬1Ĥζΰˤʤ褦롥
	 */
	tnum_meminib = 1;
	memtop_table[0] = (void *) 0;
	meminib_table[0].mematr = TA_UNUSED;
	meminib_table[0].acptn4 = 0u;
	meminib_table[0].acptn1 = 0u;
	meminib_table[0].acptn2 = 0u;

	for (p_meminfo = meminfo_table, i = 0; i < tnum_meminfo;
												p_meminfo++, i++) {
		/*
		 *  ƥꥪ֥ȽФơꥪ֥
		 *  ֥å롥ޤꥪ֥Ƚ
		 *  󤬼ΰޤꥪ֥Ȥõ줬
		 *  ΰǤʤΤϡꥪ֥Ƚ󤬼
		 *  ΰ˽Ťʤ꤬Ǥ롥
		 */
		meminib = search_meminib(p_meminfo->top);
		assert(meminib_table[meminib].mematr == TA_UNUSED);

		if (meminib + 1 < tnum_meminib) {
			nexttop = memtop_table[meminib + 1];
#if !defined(__ghs__)
			assert(p_meminfo->limit <= nexttop);
#else /* defined(__ghs__) */
			/* GHS compiler compares pointers as SIGNED. so cast the pointer to UW */
			assert((UW)p_meminfo->limit <= (UW)nexttop);
#endif
		}
		else {
			nexttop = (void *) 0;
		}

		if (p_meminfo->top == memtop_table[meminib]) {
			if (p_meminfo->limit != nexttop) {
				for (j = tnum_meminib - 1; j >= meminib; j--) {
					memtop_table[j + 1] = memtop_table[j];
					meminib_table[j + 1] = meminib_table[j];
				}
				tnum_meminib += 1;
				memtop_table[meminib + 1] = p_meminfo->limit;
			}
		}
		else {
			if (p_meminfo->limit != nexttop) {
				for (j = tnum_meminib - 1; j >= meminib; j--) {
					memtop_table[j + 2] = memtop_table[j];
					meminib_table[j + 2] = meminib_table[j];
				}
				tnum_meminib += 2;
				memtop_table[meminib + 2] = p_meminfo->limit;
			}
			else {
				for (j = tnum_meminib - 1; j >= meminib; j--) {
					memtop_table[j + 1] = memtop_table[j];
					meminib_table[j + 1] = meminib_table[j];
				}
				tnum_meminib += 1;
			}
			meminib += 1;
			memtop_table[meminib] = p_meminfo->top;
		}
		meminib_table[meminib].mematr = p_meminfo->mematr;
		meminib_table[meminib].acptn4 = p_meminfo->acptn4;
		meminib_table[meminib].acptn1 = p_meminfo->acptn1;
		meminib_table[meminib].acptn2 = p_meminfo->acptn2;
	}
#endif /* OMIT_GENERATE_MEMINIB */
#endif /* GENERATE_MEMINIB */
}

#endif /* __memini */

/*
 *  ꥢΥå
 *
 *  ΥӥǤϡŪʥǡ¤Ȥʤᡤƥ
 *  륻ɬפʤ
 */
#ifdef __prb_mem

SYSCALL ER
prb_mem(VP base, SIZE size, ID domid, ID tskid, MODE pmmode)
{
	ACPTN	domptn;
	INT		meminib;
	ATR		mematr;
	SIZE	memsize;
	ER		ercd;

	LOG_PRB_MEM_ENTER(base, size, domid, tskid, pmmode);
	CHECK_TSKCTX_UNL();
	CHECK_DOMID_SELF(domid);
	CHECK_TSKID_SELF(tskid);
	CHECK_PAR((pmmode & ~(TPM_READ | TPM_WRITE)) == 0u);
	CHECK_PAR(pmmode != 0u);

	if (domid == TDOM_SELF) {
		domptn = p_runtsk->p_dominib->domptn;
	}
	else if (domid == TDOM_KERNEL) {
		domptn = TACPTN_KERNEL;
	}
	else {
		domptn = TACP(domid);
	}

	meminib = search_meminib(base);
	mematr = meminib_table[meminib].mematr;
	if (meminib + 1 < tnum_meminib) {
		memsize = ((char *) memtop_table[meminib + 1]) - ((char *) base);
	}
	else {
		memsize = ((char *) 0) - ((char *) base);
	}

	if (mematr == TA_UNUSED) {
		ercd = E_NOEXS;
	}
	else if (size > memsize) {
		ercd = E_OBJ;
	}
	else if ((rundom & meminib_table[meminib].acptn4) == 0u) {
		ercd = E_OACV;
	}
	else if ((mematr & TA_USTACK) == 0u) {
		/*
		 *  ̾Υꥪ֥ȡʥΥ桼åΰʳ
		 *  ξ
		 *
		 *  ꥪ֥°TA_ROξˤϡacptn10uˤʤä
		 *  Τǡꥪ֥°TA_ROϥåƤʤ
		 */
		if ((pmmode & TPM_WRITE) != 0u
					&& (domptn & meminib_table[meminib].acptn1) == 0u) {
			ercd = E_MACV;
		}
		else if ((pmmode & TPM_READ) != 0u
					&& (domptn & meminib_table[meminib].acptn2) == 0u) {
			ercd = E_MACV;
		}
		else {
			ercd = E_OK;
		}
	}
	else {
		/*
		 *  Υ桼åΰξ
		 *
		 *  桼åΰ褬꡼ɥ꡼ˤʤäƤ뤳ȤϤ
		 *  ʤᡤꥪ֥°TA_ROϥåƤʤ
		 */
		if (*((TCB **) &(meminib_table[meminib].acptn1))
												!= get_tcb_self(tskid)) {
			ercd = E_MACV;
		}
		else {
			ercd = E_OK;
		}
	}

  error_exit:
	LOG_PRB_MEM_LEAVE(ercd);
	return(ercd);
}

#endif /* __prb_mem */

/*
 *  ؤν߸Υå
 */
#ifdef __memprbw
#ifndef CPU_PROBE_MEM_WRITE

BOOL
probe_mem_write(VP base, SIZE size)
{
	INT		meminib;
	ATR		mematr;
	SIZE	memsize;

	meminib = search_meminib(base);
	mematr = meminib_table[meminib].mematr;
	if (meminib + 1 < tnum_meminib) {
		memsize = ((char *) memtop_table[meminib + 1]) - ((char *) base);
	}
	else {
		memsize = ((char *) 0) - ((char *) base);
	}

	if (mematr == TA_UNUSED) {
		return(FALSE);
	}
	else if (size > memsize) {
		return(FALSE);
	}
	else if ((mematr & TA_USTACK) == 0u) {
		/*
		 *  ꥪ֥°TA_ROξˤϡacptn10uˤʤä
		 *  Τǡꥪ֥°TA_ROϥåƤʤ
		 */
		if ((rundom & meminib_table[meminib].acptn1) == 0u) {
			return(FALSE);
		}
	}
	else {
		if (*((TCB **) &(meminib_table[meminib].acptn1)) != p_runtsk) {
			return(FALSE);
		}
	}
	return(TRUE);
}

#endif /* CPU_PROBE_MEM_WRITE */
#endif /* __memprbw */

/*
 *  ꤫ɽФΥå
 */
#ifdef __memprbr
#ifndef CPU_PROBE_MEM_READ

BOOL
probe_mem_read(VP base, SIZE size)
{
	INT		meminib;
	ATR		mematr;
	SIZE	memsize;

	meminib = search_meminib(base);
	mematr = meminib_table[meminib].mematr;
	if (meminib + 1 < tnum_meminib) {
		memsize = ((char *) memtop_table[meminib + 1]) - ((char *) base);
	}
	else {
		memsize = ((char *) 0) - ((char *) base);
	}

	if (mematr == TA_UNUSED) {
		return(FALSE);
	}
	else if (size > memsize) {
		return(FALSE);
	}
	else if ((mematr & TA_USTACK) == 0u) {
		if ((rundom & meminib_table[meminib].acptn2) == 0u) {
			return(FALSE);
		}
	}
	else {
		if (*((TCB **) &(meminib_table[meminib].acptn1)) != p_runtsk) {
			return(FALSE);
		}
	}
	return(TRUE);
}

#endif /* CPU_PROBE_MEM_READ */
#endif /* __memprbr */

/*
 *  åΰ˴ޤޤƤ뤫Υå
 */
#ifdef __memprbs
#ifndef CPU_PROBE_STACK

BOOL
probe_stack(VP base, SIZE size)
{
	SIZE	stksz;

	stksz = ((SIZE)(p_runtsk->p_tinib->stkpsz)) * PAGE_SIZE;
#if !defined(__ghs__) 
	if (p_runtsk->p_tinib->stk <= base && size <= stksz
			&& (SIZE)(((char *) base) - ((char *)(p_runtsk->p_tinib->stk)))
														<= stksz - size) {
		return(TRUE);
	}		
#else /* defined(__ghs__) */
	/* GHS compiler compares pointers as SIGNED. so cast the pointer to UW */
	if ((UW)p_runtsk->p_tinib->stk <= (UW)base && size <= stksz
			&& (SIZE)(((char *) base) - ((char *)(p_runtsk->p_tinib->stk)))
														<= stksz - size) {
		return(TRUE);
	}		
#endif /* !defined(__ghs__) */
	return(FALSE);
}

#endif /* CPU_PROBE_STACK */
#endif /* __memprbs */
