/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001,2002 by Information-technology Promotion Agency, JAPAN
 *  Copyright (C) 2001,2002 by TRON Association, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		Ĺס뵡ǽ
 */

#include "hrp_kernel.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "mempfix.h"

/*
 *  Ĺסο
 */
#define tnum_mpf	((UINT)(tmax_mpfid - TMIN_MPFID + 1))

/*
 *  ĹסIDĹס֥åФ
 *  Υޥ
 */
#define INDEX_MPF(mpfid)	((UINT)((mpfid) - TMIN_MPFID))
#define get_mpfcb(mpfid)	(&(mpfcb_table[INDEX_MPF(mpfid)]))

/*
 *  üʥǥåͤ
 */
#define INDEX_NULL		(~0u)		/* ֥åꥹȤκǸ */
#define INDEX_ALLOC		(~1u)		/* ƤƤ֥å */

/* 
 *  Ĺ֥åν
 */
Inline void
init_mpfnode(MPFCB *p_mpfcb)
{
	UINT	j;
	MPFNODE	*p_mpfnode;

	p_mpfnode = p_mpfcb->p_mpfinib->p_mpfnode;
	p_mpfcb->freelist = 0u;
	for (j = 0; j < p_mpfcb->p_mpfinib->blkcnt - 1; p_mpfnode++, j++) {
		p_mpfnode->next = j + 1;
	}
	p_mpfnode->next = INDEX_NULL;
}

/* 
 *  Ĺס뵡ǽν
 */
#ifdef __mpfini

void
initialize_mempfix(void)
{
	UINT	i;
	MPFCB	*p_mpfcb;

	for (p_mpfcb = mpfcb_table, i = 0; i < tnum_mpf; p_mpfcb++, i++) {
		queue_initialize(&(p_mpfcb->wait_queue));
		p_mpfcb->p_mpfinib = &(mpfinib_table[i]);
		init_mpfnode(p_mpfcb);
		p_mpfcb->flistcnt = p_mpfcb->p_mpfinib->blkcnt;
	}
}

#endif /* __mpfini */

/*
 *  Ĺס뤫֥å
 */
#ifdef __mpfget

BOOL
get_mpf_block(MPFCB *p_mpfcb, VP *p_blk)
{
	UINT	blkidx;
	MPFNODE	*p_mpfnode;

	blkidx = p_mpfcb->freelist;
	if (blkidx != INDEX_NULL) {
		p_mpfnode = p_mpfcb->p_mpfinib->p_mpfnode + blkidx;
		p_mpfcb->freelist = p_mpfnode->next;
		p_mpfnode->next = INDEX_ALLOC;
		p_mpfcb->flistcnt--;
		*p_blk = (VP)((char *)(p_mpfcb->p_mpfinib->mpf)
								+ blkidx * p_mpfcb->p_mpfinib->blksz);
		return(TRUE);
	}
	return(FALSE);
}

#endif /* __mpfget */

/*
 *  Ĺ֥åγ
 */
#ifdef __get_mpf

SYSCALL ER
get_mpf(ID mpfid, VP *p_blk)
{
	MPFCB	*p_mpfcb;
	WINFO_MPF winfo_mpf;
	ER		ercd;

	LOG_GET_MPF_ENTER(mpfid, p_blk);
	CHECK_DISPATCH();
	CHECK_MPFID(mpfid);
	p_mpfcb = get_mpfcb(mpfid);
	CHECK_ACPTN(p_mpfcb->p_mpfinib->acvct.acptn1);
	CHECK_MACV_WRITE(p_blk, VP);

	t_lock_cpu();
	if (get_mpf_block(p_mpfcb, p_blk)) {
		ercd = E_OK;
	}
	else if (p_runtsk->waifbd) {
		ercd = E_RLWAI;
	}
	else {
		p_runtsk->tstat = (TS_WAITING | TS_WAIT_MPF);
		wobj_make_wait((WOBJCB *) p_mpfcb, (WINFO_WOBJ *) &winfo_mpf);
		dispatch();
		ercd = winfo_mpf.winfo.wercd;
		if (ercd == E_OK) {
			*p_blk = winfo_mpf.blk;
		}
	}
	t_unlock_cpu();

  error_exit:
	LOG_GET_MPF_LEAVE(ercd, *p_blk);
	return(ercd);
}

#endif /* __get_mpf */

/*
 *  Ĺ֥åγʥݡ󥰡
 */
#ifdef __pget_mpf

SYSCALL ER
pget_mpf(ID mpfid, VP *p_blk)
{
	MPFCB	*p_mpfcb;
	ER		ercd;

	LOG_PGET_MPF_ENTER(mpfid, p_blk);
	CHECK_TSKCTX_UNL();
	CHECK_MPFID(mpfid);
	p_mpfcb = get_mpfcb(mpfid);
	CHECK_ACPTN(p_mpfcb->p_mpfinib->acvct.acptn1);
	CHECK_MACV_WRITE(p_blk, VP);

	t_lock_cpu();
	if (get_mpf_block(p_mpfcb, p_blk)) {
		ercd = E_OK;
	}
	else {
		ercd = E_TMOUT;
	}
	t_unlock_cpu();

  error_exit:
	LOG_PGET_MPF_LEAVE(ercd, *p_blk);
	return(ercd);
}

#endif /* __pget_mpf */

/*
 *  Ĺ֥åγʥॢȤ
 */
#ifdef __tget_mpf

SYSCALL ER
tget_mpf(ID mpfid, VP *p_blk, TMO tmout)
{
	MPFCB	*p_mpfcb;
	WINFO_MPF winfo_mpf;
	TMEVTB	tmevtb;
	ER		ercd;

	LOG_TGET_MPF_ENTER(mpfid, p_blk, tmout);
	CHECK_DISPATCH();
	CHECK_MPFID(mpfid);
	CHECK_TMOUT(tmout);
	p_mpfcb = get_mpfcb(mpfid);
	CHECK_ACPTN(p_mpfcb->p_mpfinib->acvct.acptn1);
	CHECK_MACV_WRITE(p_blk, VP);

	t_lock_cpu();
	if (get_mpf_block(p_mpfcb, p_blk)) {
		ercd = E_OK;
	}
	else if (tmout == TMO_POL) {
		ercd = E_TMOUT;
	}
	else if (p_runtsk->waifbd) {
		ercd = E_RLWAI;
	}
	else {
		p_runtsk->tstat = (TS_WAITING | TS_WAIT_MPF);
		wobj_make_wait_tmout((WOBJCB *) p_mpfcb, (WINFO_WOBJ *) &winfo_mpf,
														&tmevtb, tmout);
		dispatch();
		ercd = winfo_mpf.winfo.wercd;
		if (ercd == E_OK) {
			*p_blk = winfo_mpf.blk;
		}
	}
	t_unlock_cpu();

  error_exit:
	LOG_TGET_MPF_LEAVE(ercd, *p_blk);
	return(ercd);
}

#endif /* __tget_mpf */

/*
 *  Ĺ֥åֵ
 */
#ifdef __rel_mpf

SYSCALL ER
rel_mpf(ID mpfid, VP blk)
{
	MPFCB	*p_mpfcb;
	SIZE	blkoffset;
	UINT	blkidx;
	TCB		*p_tcb;
	ER		ercd;
    
	LOG_REL_MPF_ENTER(mpfid, blk);
	CHECK_TSKCTX_UNL();
	CHECK_MPFID(mpfid);
	p_mpfcb = get_mpfcb(mpfid);
	CHECK_ACPTN(p_mpfcb->p_mpfinib->acvct.acptn2);

	CHECK_PAR(p_mpfcb->p_mpfinib->mpf <= blk);
	blkoffset = ((char *) blk) - (char *)(p_mpfcb->p_mpfinib->mpf);
	CHECK_PAR(blkoffset % p_mpfcb->p_mpfinib->blksz == 0u);
	blkidx = blkoffset / p_mpfcb->p_mpfinib->blksz;
	CHECK_PAR(blkidx < p_mpfcb->p_mpfinib->blkcnt);
	CHECK_PAR((p_mpfcb->p_mpfinib->p_mpfnode + blkidx)->next == INDEX_ALLOC);

	t_lock_cpu();
	if (!queue_empty(&(p_mpfcb->wait_queue))) {
		p_tcb = (TCB *) queue_delete_next(&(p_mpfcb->wait_queue));
		((WINFO_MPF *)(p_tcb->p_winfo))->blk = blk;
		if (wait_complete(p_tcb)) {
			dispatch();
		}
		ercd = E_OK;
	}
	else {
		(p_mpfcb->p_mpfinib->p_mpfnode + blkidx)->next = p_mpfcb->freelist;
		p_mpfcb->freelist = blkidx;
		p_mpfcb->flistcnt++;
		ercd = E_OK;
	}
	t_unlock_cpu();

  error_exit:
	LOG_REL_MPF_LEAVE(ercd);
	return(ercd);
}

#endif /* __rel_mpf */

/*
 *  Ĺסν
 */
#ifdef __ini_mpf

SYSCALL ER
ini_mpf(ID mpfid)
{
	MPFCB	*p_mpfcb;
	ER		ercd;
    
	LOG_INI_MPF_ENTER(mpfid);
	CHECK_TSKCTX_UNL();
	CHECK_MPFID(mpfid);
	p_mpfcb = get_mpfcb(mpfid);
	CHECK_ACPTN(p_mpfcb->p_mpfinib->acvct.acptn3);

	t_lock_cpu();
	init_wait_queue(&(p_mpfcb->wait_queue));
	init_mpfnode(p_mpfcb);
	p_mpfcb->flistcnt = p_mpfcb->p_mpfinib->blkcnt;
	if (p_runtsk != p_schedtsk && dspflg) {
		dispatch();
	}
	ercd = E_OK;
	t_unlock_cpu();

  error_exit:
	LOG_INI_MPF_LEAVE(ercd);
	return(ercd);
}

#endif /* __ini_mpf */

/*
 *  Ĺסξֻ
 */
#ifdef __ref_mpf

SYSCALL ER
ref_mpf(ID mpfid, T_RMPF *pk_rmpf)
{
	MPFCB	*p_mpfcb;
	ER		ercd;
    
	LOG_REF_MPF_ENTER(mpfid, pk_rmpf);
	CHECK_TSKCTX_UNL();
	CHECK_MPFID(mpfid);
	p_mpfcb = get_mpfcb(mpfid);
	CHECK_ACPTN(p_mpfcb->p_mpfinib->acvct.acptn4);
	CHECK_MACV_WRITE(pk_rmpf, T_RMPF);

	t_lock_cpu();
	pk_rmpf->wtskid = wait_tskid(&(p_mpfcb->wait_queue));
	pk_rmpf->fblkcnt = p_mpfcb->flistcnt;
	ercd = E_OK;
	t_unlock_cpu();

  error_exit:
	LOG_REF_MPF_LEAVE(ercd, pk_rmpf);
	return(ercd);
}

#endif /* __ref_mpf */
