/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001,2002 by Information-technology Promotion Agency, JAPAN
 *  Copyright (C) 2001,2002 by TRON Association, JAPAN
 *  Copyright (C) 2005 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		Ĺס뵡ǽ
 */

#ifndef _MEMPFIX_H_
#define _MEMPFIX_H_

#include "queue.h"

/*
 *  Ĺ֥å
 */
typedef struct fixed_memoryblock_informantion {
	UINT	next;			/* Υ֥åΥǥå */
} MPFNODE;

/*
 *  Ĺס֥å
 *
 *  ι¤ΤϡƱ֥̿Ȥν֥åζʬ
 *  WOBJINIBˤĥʥ֥ȻظηѾˤΤǡ
 *  ǽΥեɤ̤ˤʤäƤ롥
 */
typedef struct fixed_memorypool_initialization_block {
	ATR		mpfatr;			/* Ĺס° */
	UINT	blkcnt;			/* ֥å */
	UINT	blksz;			/* ֥åΥʴݤ᤿͡ */
	VP		mpf;			/* ĹסΰƬ */
	MPFNODE	*p_mpfnode;		/* Ĺ֥åƬ */
	ACVCT	acvct;			/* ĥ٥ */
} MPFINIB;

/*
 *  Ĺס֥å
 *
 *  ι¤ΤϡƱ֥̿Ȥδ֥åζʬWOBJCB
 *  ĥʥ֥ȻظηѾˤΤǡǽ2Ĥ
 *  եɤ̤ˤʤäƤ롥
 */
typedef struct fixed_memorypool_control_block {
	QUEUE	wait_queue;			/* ĹסԤ塼 */
	const MPFINIB *p_mpfinib;	/* ֥åؤΥݥ */
	UINT	freelist;			/* ֥åΥꥹȡʥǥå͡ */
	UINT	flistcnt;			/* ֥å */
} MPFCB;

/*
 *  ĹסԤ֥å
 *
 *  ι¤ΤϡƱ֥̿ȤԤ֥åζʬ
 *  WINFO_WOBJˤĥʥ֥ȻظηѾˤΤǡ
 *  ǽ2ĤΥեɤ̤ˤʤäƤ롥
 */
typedef struct fixed_memorypool_waiting_information {
	WINFO	winfo;			/* ɸԤ֥å */
	MPFCB	*p_mpfcb;		/* ԤäƤĹסδ֥å */
	VP		blk;			/* ֥å */
} WINFO_MPF;

/*
 *  ĹסIDκ͡kernel_cfg.c
 */
extern const ID	tmax_mpfid;

/*
 *  Ĺס֥åΥꥢkernel_cfg.c
 */
extern const MPFINIB	mpfinib_table[];

/*
 *  Ĺס֥åΥꥢkernel_cfg.c
 */
extern MPFCB	mpfcb_table[];

/*
 *  Ĺס֥åĹסIDФ
 *  Υޥ
 */
#define	MPFID(p_mpfcb)	((ID)(((p_mpfcb) - mpfcb_table) + TMIN_MPFID))

/*
 *  Ĺס뵡ǽν
 */
extern void	initialize_mempfix(void);

/*
 *  Ĺס뤫֥å
 */
extern BOOL	get_mpf_block(MPFCB *p_mpfcb, VP *p_blk);

#endif /* _MEMPFIX_H_ */
