/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ߥ塼ƥåǽ
 */

#include "hrp_kernel.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "mutex.h"

/*
 *  ߥ塼ƥåο
 */
#define tnum_mtx	((UINT)(tmax_mtxid - TMIN_MTXID + 1))

/*
 *  ߥ塼ƥåIDߥ塼ƥå֥åФΥޥ
 */
#define INDEX_MTX(mtxid)	((UINT)((mtxid) - TMIN_MTXID))
#define get_mtxcb(mtxid)	(&(mtxcb_table[INDEX_MTX(mtxid)]))

/*
 *  ߥ塼ƥå֥åmutex_queueؤΥݥ󥿤顤ߥ塼ƥ
 *  ֥åؤΥݥ󥿤ФΥޥ
 */
#define MTXCB_QUEUE(p_queue) \
			((MTXCB *)(((char *) p_queue) - offsetof(MTXCB, mutex_queue)))

/*
 *  ߥ塼ƥåΥץȥФޥ
 */
#define MTXPROTO_MASK		0x03u
#define MTXPROTO(p_mtxcb)	((p_mtxcb)->p_mtxinib->mtxatr & MTXPROTO_MASK)

/*
 *  եå롼ƽФѤѿ
 */
#ifdef __mtxhook

BOOL	(*mtxhook_check_ceilpri)(TCB *p_tcb, UINT bpriority);
UINT	(*mtxhook_calc_priority)(TCB *p_tcb);
TCB		*(*mtxhook_change_priority)(TCB *p_tcb, UINT oldpri, UINT *p_newpri);
void	(*mtxhook_release_all)(TCB *p_tcb);
BOOL	(*mtxhook_dequeue_wobj)(TCB *p_tcb);

#endif /* __mtxhook */

/* 
 *  ߥ塼ƥåǽν
 */
#ifdef __mtxini

void
initialize_mutex(void)
{
	UINT	i;
	MTXCB	*p_mtxcb;

	mtxhook_check_ceilpri = mutex_check_ceilpri;
	mtxhook_calc_priority = mutex_calc_priority;
	mtxhook_change_priority = mutex_change_priority;
	mtxhook_release_all = mutex_release_all;
	mtxhook_dequeue_wobj = mutex_dequeue_wobj;

	for (p_mtxcb = mtxcb_table, i = 0; i < tnum_mtx; p_mtxcb++, i++) {
		queue_initialize(&(p_mtxcb->wait_queue));
		p_mtxcb->p_mtxinib = &(mtxinib_table[i]);
		p_mtxcb->p_loctsk = NULL;
	}
}

#endif /* __mtxini */

/* 
 *  ٰͥȿΥå
 */
#ifdef __mtxchk

BOOL
mutex_check_ceilpri(TCB *p_tcb, UINT bpriority)
{
	QUEUE	*p_queue;
	MTXCB	*p_mtxcb;

	/*
	 *  åƤTA_CEILING°Υߥ塼ƥåǡ
	 *  ͥ٤bpriority㤤ΤСFLASE֤
	 */
	p_queue = p_tcb->mutex_queue.p_next;
	while (p_queue != &(p_tcb->mutex_queue)) {
		p_mtxcb = MTXCB_QUEUE(p_queue);
		if (MTXPROTO(p_mtxcb) == TA_CEILING) {
			if (bpriority < p_mtxcb->p_mtxinib->ceilpri) {
				return(FALSE);
			}
		}
		p_queue = p_queue->p_next;
	}

	/*
	 *  TA_CEILING°Υߥ塼ƥåԤäƤˡ
	 *  ͥ٤bpriority㤯СFALSE֤
	 */
	if (TSTAT_WAIT_MTX(p_tcb->tstat)) {
		p_mtxcb = ((WINFO_MTX *)(p_tcb->p_winfo))->p_mtxcb;
		if (MTXPROTO(p_mtxcb) == TA_CEILING) {
			if (bpriority < p_mtxcb->p_mtxinib->ceilpri) {
				return(FALSE);
			}
		}
	}

	/*
	 *  ξˤƤϤޤʤTRUE֤
	 */
	return(TRUE);
}

#endif /* __mtxchk */

/* 
 *  θͥ٤η׻
 */
#ifdef __mtxcalc

UINT
mutex_calc_priority(TCB *p_tcb)
{
	UINT	priority;
	QUEUE	*p_queue;
	MTXCB	*p_mtxcb;
	TCB		*p_headtsk;

	priority = p_tcb->bpriority;
	p_queue = p_tcb->mutex_queue.p_next;
	while (p_queue != &(p_tcb->mutex_queue)) {
		p_mtxcb = MTXCB_QUEUE(p_queue);
		switch (MTXPROTO(p_mtxcb)) {
		case TA_INHERIT:
			if (!queue_empty(&(p_mtxcb->wait_queue))) {
				p_headtsk = (TCB *)(p_mtxcb->wait_queue.p_next);
				if (p_headtsk->priority < priority) {
					priority = p_headtsk->priority;
				}
			}
			break;
		case TA_CEILING:
			if (p_mtxcb->p_mtxinib->ceilpri < priority) {
				priority = p_mtxcb->p_mtxinib->ceilpri;
			}
			break;
		default:
			break;
		}
		p_queue = p_queue->p_next;
	}
	return(priority);
}

#endif /* __mtxcalc */

/*
 *  ͥ٤夬ʤޤ˾θͥѹ
 *
 *  δؿǥͥ٤Ѳǥѥåɬפʾˤϡ
 *  TRUE֤
 */
Inline BOOL
mutex_raise_priority(TCB *p_tcb, UINT newpri)
{
	if (newpri < p_tcb->priority) {
		return(change_priority(p_tcb, newpri));
	}
	return(FALSE);
}

/*
 *  ͥ٤ʤޤϸ˾θͥѹ
 *
 *  δؿǥͥ٤Ѳǥѥåɬפʾˤϡ
 *  TRUE֤
 */
Inline BOOL
mutex_drop_priority(TCB *p_tcb, UINT oldpri)
{
	UINT	newpri;

	if (oldpri == p_tcb->priority) {
		newpri = mutex_calc_priority(p_tcb);
		if (newpri != p_tcb->priority) {
			return(change_priority(p_tcb, newpri));
		}
	}
	return(FALSE);
}

/*
 *  ߥ塼ƥååν
 *
 *  δؿǥͥ٤Ѳǥѥåɬפʾˤϡ
 *  TRUE֤
 */
Inline BOOL
mutex_acquire(TCB *p_loctsk, MTXCB *p_mtxcb)
{
	p_mtxcb->p_loctsk = p_loctsk;
	queue_insert_prev(&(p_loctsk->mutex_queue), &(p_mtxcb->mutex_queue));

	if (MTXPROTO(p_mtxcb) == TA_CEILING) {
		/*
		 *  TA_CEILING°Υߥ塼ƥåå
		 */
		return(mutex_raise_priority(p_loctsk, p_mtxcb->p_mtxinib->ceilpri));
	}
	return(FALSE);
}

/* 
 *  ߥ塼ƥåԤ֤Υθͥ٤ѹ
 */
#ifdef __mtxchg

TCB *
mutex_change_priority(TCB *p_tcb, UINT oldpri, UINT *p_newpri)
{
	MTXCB	*p_mtxcb;
	ATR		mtxproto;

	p_mtxcb = ((WINFO_MTX *)(p_tcb->p_winfo))->p_mtxcb;
	mtxproto = MTXPROTO(p_mtxcb);
	if (mtxproto != TA_TFIFO) {
		queue_delete(&(p_tcb->task_queue));
		queue_insert_tpri(&(p_mtxcb->wait_queue), p_tcb);
		if (mtxproto == TA_INHERIT) {
			/*
			 *  TA_INHERIT°Υߥ塼ƥåΥåԤäƤ륿
			 *  θͥ٤ѹ줿
			 */
			p_tcb = p_mtxcb->p_loctsk;
			if (*p_newpri < oldpri) {
				/*
				 *  ͥ٤夬ä
				 */
				if (*p_newpri < p_tcb->priority) {
					return(p_tcb);
				}
			}
			else if (*p_newpri > oldpri) {
				/*
				 *  ͥ٤ä
				 */
				if (oldpri == p_tcb->priority) {
					*p_newpri = mutex_calc_priority(p_tcb);
					if (*p_newpri != p_tcb->priority) {
						return(p_tcb);
					}
				}
			}
		}
	}
	return(NULL);
}

#endif /* __mtxchg */

/*
 *  åƤ뤹٤ƤΥߥ塼ƥåΥå
 */
#ifdef __mtxrel

void
mutex_release_all(TCB *p_tcb)
{
	MTXCB	*p_mtxcb;
	TCB		*p_loctsk;

	while (!queue_empty(&(p_tcb->mutex_queue))) {
		p_mtxcb = MTXCB_QUEUE(p_tcb->mutex_queue.p_next);
		queue_delete(&(p_mtxcb->mutex_queue));
		if (queue_empty(&(p_mtxcb->wait_queue))) {
			p_mtxcb->p_loctsk = NULL;
		}
		else {
			p_loctsk = (TCB *) queue_delete_next(&(p_mtxcb->wait_queue));
			(void) wait_complete(p_loctsk);
			(void) mutex_acquire(p_loctsk, p_mtxcb);
		}
	}
}

#endif /* __mtxrel */

/*
 *  ߥ塼ƥåԤ֤ΥԤν
 */
#ifdef __mtxdeq

BOOL
mutex_dequeue_wobj(TCB *p_tcb)
{
	MTXCB	*p_mtxcb;

	p_mtxcb = ((WINFO_MTX *)(p_tcb->p_winfo))->p_mtxcb;
	if (MTXPROTO(p_mtxcb) == TA_INHERIT) {
		assert(p_mtxcb->p_loctsk != NULL);
		return(mutex_drop_priority(p_mtxcb->p_loctsk, p_tcb->priority));
	}
	return(FALSE);
}

#endif /* __mtxdeq */

/* 
 *  ߥ塼ƥåԤ塼ؤ
 */
Inline void
mutex_queue_insert(MTXCB *p_mtxcb)
{
	if (MTXPROTO(p_mtxcb) != TA_TFIFO) {
		queue_insert_tpri(&(p_mtxcb->wait_queue), p_runtsk);
	}
	else {
		queue_insert_prev(&(p_mtxcb->wait_queue), &(p_runtsk->task_queue));
	}
}

/*
 *  ߥ塼ƥåΥå
 */
#ifdef __loc_mtx

SYSCALL ER
loc_mtx(ID mtxid)
{
	MTXCB	*p_mtxcb;
	ATR		mtxproto;
	WINFO_MTX winfo_mtx;
	ER		ercd;

	LOG_LOC_MTX_ENTER(mtxid);
	CHECK_DISPATCH();
	CHECK_MTXID(mtxid);
	p_mtxcb = get_mtxcb(mtxid);
	mtxproto = MTXPROTO(p_mtxcb);
	CHECK_ACPTN(p_mtxcb->p_mtxinib->acvct.acptn1);

	t_lock_cpu();
	if (mtxproto == TA_CEILING
				&& p_runtsk->bpriority < p_mtxcb->p_mtxinib->ceilpri) {
		ercd = E_ILUSE;
	}
	else if (p_mtxcb->p_loctsk == NULL) {
		(void) mutex_acquire(p_runtsk, p_mtxcb);
		/*
		 *  TA_CEILING°Υߥ塼ƥåå硤p_runtsk
		 *  ͥ٤夬ǽ뤬ǥѥåɬפˤʤ뤳
		 *  Ϥʤ
		 */
		assert(!(p_runtsk != p_schedtsk && dspflg));
		ercd = E_OK;
	}
	else if (p_mtxcb->p_loctsk == p_runtsk) {
		ercd = E_ILUSE;
	}
	else if (p_runtsk->waifbd) {
		ercd = E_RLWAI;
	}
	else {
		p_runtsk->tstat = (TS_WAITING | TS_WAIT_MTX);
		make_wait((WINFO *) &winfo_mtx);
		mutex_queue_insert(p_mtxcb);
		winfo_mtx.p_mtxcb = p_mtxcb;
		if (mtxproto == TA_INHERIT) {
			/*
			 *  TA_INHERIT°Υߥ塼ƥåΥåԤϤ᤿
			 */
			(void) mutex_raise_priority(p_mtxcb->p_loctsk, p_runtsk->priority);
		}
		LOG_TSKSTAT(p_runtsk);
		dispatch();
		ercd = winfo_mtx.winfo.wercd;
	}
	t_unlock_cpu();

  error_exit:
	LOG_LOC_MTX_LEAVE(ercd);
	return(ercd);
}

#endif /* __loc_mtx */

/*
 *  ߥ塼ƥåΥåʥݡ󥰡
 */
#ifdef __ploc_mtx

SYSCALL ER
ploc_mtx(ID mtxid)
{
	MTXCB	*p_mtxcb;
	ATR		mtxproto;
	ER		ercd;

	LOG_PLOC_MTX_ENTER(mtxid);
	CHECK_TSKCTX_UNL();
	CHECK_MTXID(mtxid);
	p_mtxcb = get_mtxcb(mtxid);
	mtxproto = MTXPROTO(p_mtxcb);
	CHECK_ACPTN(p_mtxcb->p_mtxinib->acvct.acptn1);

	t_lock_cpu();
	if (mtxproto == TA_CEILING
				&& p_runtsk->bpriority < p_mtxcb->p_mtxinib->ceilpri) {
		ercd = E_ILUSE;
	}
	else if (p_mtxcb->p_loctsk == NULL) {
		(void) mutex_acquire(p_runtsk, p_mtxcb);
		/*
		 *  TA_CEILING°Υߥ塼ƥåå硤p_runtsk
		 *  ͥ٤夬ǽ뤬ǥѥåɬפˤʤ뤳
		 *  Ϥʤ
		 */
		assert(!(p_runtsk != p_schedtsk && dspflg));
		ercd = E_OK;
	}
	else if (p_mtxcb->p_loctsk == p_runtsk) {
		ercd = E_ILUSE;
	}
	else {
		ercd = E_TMOUT;
	}
	t_unlock_cpu();

  error_exit:
	LOG_PLOC_MTX_LEAVE(ercd);
	return(ercd);
}

#endif /* __ploc_mtx */

/*
 *  ߥ塼ƥåΥåʥॢȤ
 */
#ifdef __tloc_mtx

SYSCALL ER
tloc_mtx(ID mtxid, TMO tmout)
{
	MTXCB	*p_mtxcb;
	ATR		mtxproto;
	WINFO_MTX winfo_mtx;
	TMEVTB	tmevtb;
	ER		ercd;

	LOG_TLOC_MTX_ENTER(mtxid, tmout);
	CHECK_DISPATCH();
	CHECK_MTXID(mtxid);
	CHECK_TMOUT(tmout);
	p_mtxcb = get_mtxcb(mtxid);
	mtxproto = MTXPROTO(p_mtxcb);
	CHECK_ACPTN(p_mtxcb->p_mtxinib->acvct.acptn1);

	t_lock_cpu();
	if (mtxproto == TA_CEILING
				&& p_runtsk->bpriority < p_mtxcb->p_mtxinib->ceilpri) {
		ercd = E_ILUSE;
	}
	else if (p_mtxcb->p_loctsk == NULL) {
		(void) mutex_acquire(p_runtsk, p_mtxcb);
		/*
		 *  TA_CEILING°Υߥ塼ƥåå硤p_runtsk
		 *  ͥ٤夬ǽ뤬ǥѥåɬפˤʤ뤳
		 *  Ϥʤ
		 */
		assert(!(p_runtsk != p_schedtsk && dspflg));
		ercd = E_OK;
	}
	else if (p_mtxcb->p_loctsk == p_runtsk) {
		ercd = E_ILUSE;
	}
	else if (tmout == TMO_POL) {
		ercd = E_TMOUT;
	}
	else if (p_runtsk->waifbd) {
		ercd = E_RLWAI;
	}
	else {
		p_runtsk->tstat = (TS_WAITING | TS_WAIT_MTX);
		make_wait_tmout((WINFO *) &winfo_mtx, &tmevtb, tmout);
		mutex_queue_insert(p_mtxcb);
		winfo_mtx.p_mtxcb = p_mtxcb;
		if (mtxproto == TA_INHERIT) {
			/*
			 *  TA_INHERIT°Υߥ塼ƥåΥåԤϤ᤿
			 */
			(void) mutex_raise_priority(p_mtxcb->p_loctsk, p_runtsk->priority);
		}
		LOG_TSKSTAT(p_runtsk);
		dispatch();
		ercd = winfo_mtx.winfo.wercd;
	}
	t_unlock_cpu();

  error_exit:
	LOG_TLOC_MTX_LEAVE(ercd);
	return(ercd);
}

#endif /* __tloc_mtx */

/*
 *  ߥ塼ƥåΥå
 */
#ifdef __unl_mtx

SYSCALL ER
unl_mtx(ID mtxid)
{
	MTXCB	*p_mtxcb;
	ATR		mtxproto;
	TCB		*p_loctsk;
	ER		ercd;
    
	LOG_UNL_MTX_ENTER(mtxid);
	CHECK_TSKCTX_UNL();
	CHECK_MTXID(mtxid);
	p_mtxcb = get_mtxcb(mtxid);
	mtxproto = MTXPROTO(p_mtxcb);

	t_lock_cpu();
	if (p_mtxcb->p_loctsk != p_runtsk) {
		ercd = E_ILUSE;
	}
	else {
		queue_delete(&(p_mtxcb->mutex_queue));
		if (mtxproto == TA_CEILING) {
			/*
			 *  TA_CEILING°Υߥ塼ƥåå
			 */
			(void) mutex_drop_priority(p_runtsk, p_mtxcb->p_mtxinib->ceilpri);
		}

		if (queue_empty(&(p_mtxcb->wait_queue))) {
			p_mtxcb->p_loctsk = NULL;
		}
		else {
			/*
			 *  ߥ塼ƥåԤ塼Ƭp_loctskˤˡߥ
			 *  ƥåå롥
			 */
			p_loctsk = (TCB *) queue_delete_next(&(p_mtxcb->wait_queue));
			if (mtxproto == TA_INHERIT) { 
				/*
				 *  TA_INHERIT°Υߥ塼ƥåå
				 *
				 *  Ԥ塼Ƭͥ٤ѾƤǽ
				 *  뤿ᡤͥ٤ѹԤ
				 */
				(void) mutex_drop_priority(p_runtsk, p_loctsk->priority);
			}
			(void) wait_complete(p_loctsk);
			(void) mutex_acquire(p_loctsk, p_mtxcb);
		}
		if (p_runtsk != p_schedtsk && dspflg) {
			dispatch();
		}
		ercd = E_OK;
	}
	t_unlock_cpu();

  error_exit:
	LOG_UNL_MTX_LEAVE(ercd);
	return(ercd);
}

#endif /* __unl_mtx */

/*
 *  ߥ塼ƥåν
 */
#ifdef __ini_mtx

SYSCALL ER
ini_mtx(ID mtxid)
{
	MTXCB	*p_mtxcb;
	TCB		*p_loctsk;
	PRI		newpri;
	ER		ercd;
    
	LOG_INI_MTX_ENTER(mtxid);
	CHECK_TSKCTX_UNL();
	CHECK_MTXID(mtxid);
	p_mtxcb = get_mtxcb(mtxid);
	CHECK_ACPTN(p_mtxcb->p_mtxinib->acvct.acptn3);

	t_lock_cpu();
	init_wait_queue(&(p_mtxcb->wait_queue));
	p_loctsk = p_mtxcb->p_loctsk;
	if (p_loctsk != NULL) {
		queue_delete(&(p_mtxcb->mutex_queue));
		p_mtxcb->p_loctsk = NULL;
		switch (MTXPROTO(p_mtxcb)) {
		case TA_INHERIT:
			/*
			 *  TA_INHERIT°Υߥ塼ƥåå
			 *
			 *  mutex_drop_priorityȤäƺŬ;ϤϤ뤬ߥ
			 *  ƥåԤäƤƬΥͥ٤äƤ
			 *  ΤݤǤ롥ini_mtxΥХإåɤ礭Τϵ
			 *  ȹͤŬƤʤ
			 */
			newpri = mutex_calc_priority(p_loctsk);
			if (newpri != p_loctsk->priority) {
				(void) change_priority(p_loctsk, newpri);
			}
			break;
		case TA_CEILING:
			/*
			 *  TA_CEILING°Υߥ塼ƥåå
			 */
			(void) mutex_drop_priority(p_loctsk, p_mtxcb->p_mtxinib->ceilpri);
			break;
		default:
			break;
		}
	}
	if (p_runtsk != p_schedtsk && dspflg) {
		dispatch();
	}
	ercd = E_OK;
	t_unlock_cpu();

  error_exit:
	LOG_INI_MTX_LEAVE(ercd);
	return(ercd);
}

#endif /* __ini_mtx */

/*
 *  ߥ塼ƥåξֻ
 */
#ifdef __ref_mtx

SYSCALL ER
ref_mtx(ID mtxid, T_RMTX *pk_rmtx)
{
	MTXCB	*p_mtxcb;
	ER		ercd;
    
	LOG_REF_MTX_ENTER(mtxid, pk_rmtx);
	CHECK_TSKCTX_UNL();
	CHECK_MTXID(mtxid);
	p_mtxcb = get_mtxcb(mtxid);
	CHECK_ACPTN(p_mtxcb->p_mtxinib->acvct.acptn4);
	CHECK_MACV_WRITE(pk_rmtx, T_RMTX);

	t_lock_cpu();
	pk_rmtx->htskid = (p_mtxcb->p_loctsk != NULL) ? TSKID(p_mtxcb->p_loctsk)
													: TSK_NONE;
	pk_rmtx->wtskid = wait_tskid(&(p_mtxcb->wait_queue));
	ercd = E_OK;
	t_unlock_cpu();

  error_exit:
	LOG_REF_MTX_LEAVE(ercd, pk_rmtx);
	return(ercd);
}

#endif /* __ref_mtx */
