/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2005 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ߥ塼ƥåǽ
 */

#ifndef _MUTEX_H_
#define _MUTEX_H_

#include "queue.h"

/*
 *  ߥ塼ƥå֥å
 *
 *  ι¤ΤϡƱ֥̿Ȥν֥åζʬ
 *  WOBJINIBˤĥʥ֥ȻظηѾˤΤǡ
 *  ǽΥեɤ̤ˤʤäƤ롥
 */
typedef struct mutex_initialization_block {
	ATR		mtxatr;			/* ߥ塼ƥå° */
	PRI		ceilpri;		/* ߥ塼ƥåξͥ١ɽ*/
	ACVCT	acvct;			/* ĥ٥ */
} MTXINIB;

/*
 *  ߥ塼ƥå֥å
 *
 *  ι¤ΤϡƱ֥̿Ȥδ֥åζʬWOBJCB
 *  ĥʥ֥ȻظηѾˤΤǡǽ2Ĥ
 *  եɤ̤ˤʤäƤ롥
 */
typedef struct mutex_control_block {
	QUEUE	wait_queue;			/* ߥ塼ƥåԤ塼 */
	const MTXINIB *p_mtxinib;	/* ֥åؤΥݥ */
	TCB		*p_loctsk;			/* ߥ塼ƥååƤ륿 */
	QUEUE	mutex_queue;		/* åƤߥ塼ƥåΥ塼 */
} MTXCB;

/*
 *  ߥ塼ƥåԤ֥å
 *
 *  ι¤ΤϡƱ֥̿ȤԤ֥åζʬ
 *  WINFO_WOBJˤĥʥ֥ȻظηѾˤΤǡ
 *  ٤ƤΥեɤ̤ˤʤäƤ롥
 */
typedef struct mutex_waiting_information {
	WINFO	winfo;			/* ɸԤ֥å */
	MTXCB	*p_mtxcb;		/* ԤäƤߥ塼ƥåδ֥å */
} WINFO_MTX;

/*
 *  ߥ塼ƥåIDκ͡kernel_cfg.c
 */
extern const ID	tmax_mtxid;

/*
 *  ߥ塼ƥå֥åΥꥢkernel_cfg.c
 */
extern const MTXINIB	mtxinib_table[];

/*
 *  ߥ塼ƥå֥åΥꥢkernel_cfg.c
 */
extern MTXCB	mtxcb_table[];

/*
 *  ߥ塼ƥå֥åߥ塼ƥåIDФΥޥ
 */
#define	MTXID(p_mtxcb)	((ID)(((p_mtxcb) - mtxcb_table) + TMIN_MTXID))

/*
 *  ߥ塼ƥåǽν
 */
extern void	initialize_mutex(void);

/*
 *  ٰͥȿΥå
 *
 *  chg_priǾٰͥȿΥåԤѤؿǤꡤ
 *  p_tcbǻꤵ륿åƤTA_CEILING°Υߥ塼ƥ
 *  ȡԤäƤTA_CEILING°Υߥ塼ƥåǡ
 *  ͥ٤bpriority㤤ΤFLASE򡤤Ǥʤ
 *  TRUE֤
 */
extern BOOL	(*mtxhook_check_ceilpri)(TCB *p_tcb, UINT bpriority);
extern BOOL	mutex_check_ceilpri(TCB *p_tcb, UINT bpriority);

/*
 *  θͥ٤η׻
 *
 *  ͥ浬§˽p_tcbǻꤵ륿θͥ١ʤ߷
 *  ٤͡ˤ׻롥
 */
extern UINT	(*mtxhook_calc_priority)(TCB *p_tcb);
extern UINT	mutex_calc_priority(TCB *p_tcb);

/*
 *  ߥ塼ƥåԤ֤Υθͥ٤ѹ
 *
 *  ߥ塼ƥåԤ֤Υθͥ٤ѹ줿ݤ˸ƤӽФ
 *  ؿǤꡤߥ塼ƥåԤ塼Ǥΰ֤ɬפͥ
 *  ԤŪͥٷѾɬפʾˤϡͥ٤
 *  ٤TCBؤΥݥ󥿤֤*p_newpri˷Ѿ٤ͥ
 *  롥ŪͥٷѾɬפǤʤˤϡNULL֤
 */
extern TCB	*(*mtxhook_change_priority)(TCB *p_tcb, UINT oldpri,
															UINT *p_newpri);
extern TCB	*mutex_change_priority(TCB *p_tcb, UINT oldpri, UINT *p_newpri);

/*
 *  åƤ뤹٤ƤΥߥ塼ƥåΥå
 *
 *  p_tcbǻꤵ륿ˡ줬åƤ뤹٤ƤΥߥ塼ƥ
 *  å롥åߥ塼ƥåˡåԤ
 *  ֤ΥˤϡΥ˥ߥ塼ƥåå
 *  롥
 *
 *  δؿϡνλ˻ȤΤǤ뤿ᡤp_tcbǻꤵ
 *  륿ͥ٤ѹϹԤʤδؿǥ
 *  ͥ٤Ѳ¹Ԥ٤Ѥ뤳Ȥ롥Τᡤ
 *  ؿäˡǥѥåɬפȽ̤ơɬפʾˤϥǥ
 *  ѥåԤʤФʤʤ
 */
extern void	(*mtxhook_release_all)(TCB *p_tcb);
extern void	mutex_release_all(TCB *p_tcb);

/*
 *  ߥ塼ƥåԤ֤ΥԤν
 *
 *  p_tcbǻꤵ륿ߥ塼ƥåԤ֤ݤ˸
 *  ӽФؿǤꡤɬפʾˤϡΥߥ塼ƥååƤ
 *  륿ͥ٤ѹ롥
 *
 *  δؿǥͥ٤Ѳǥѥåɬפʾˤϡ
 *  TRUE֤
 */
extern BOOL	(*mtxhook_dequeue_wobj)(TCB *p_tcb);
extern BOOL	mutex_dequeue_wobj(TCB *p_tcb);

#endif /* _MUTEX_H_ */
