/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		Хϥɥ鵡ǽ
 */

#include "hrp_kernel.h"
#include "check.h"
#include "task.h"
#include "overrun.h"

#ifdef SUPPORT_OVR
#include <hw_ovrtimer.h>
#endif /* SUPPORT_OVR */

/*
 *  ޤХϥɥη
 */
typedef void	(*OVRHDR)(ID tskid, VP_INT exinf);

#ifdef __ovrini
#ifdef SUPPORT_OVR

/*
 *  Х󥿥ޤư椫򼨤ե饰
 */
BOOL	ovrtimer_flag;

/*
 *  Хϥɥ鵡ǽν
 */
void
initialize_overrun(void)
{
	hw_ovrtimer_initialize();
	ovrtimer_flag = FALSE;
}

#endif /* SUPPORT_OVR */
#endif /* __ovrini */

/*
 *  Хϥɥѥޤư
 */
#ifdef __ovrsta
#ifdef SUPPORT_OVR

void
ovrtimer_start(void)
{
	if (p_runtsk->leftotm > 0u) {
		hw_ovrtimer_start(p_runtsk->leftotm);
		ovrtimer_flag = TRUE;
	}
}

#endif /* SUPPORT_OVR */
#endif /* __ovrsta */

/*
 *  Хϥɥѥޤ
 */
#ifdef __ovrstp
#ifdef SUPPORT_OVR

void
ovrtimer_stop(void)
{
	if (p_runtsk->leftotm > 0u) {
		p_runtsk->leftotm = hw_ovrtimer_stop();
		ovrtimer_flag = FALSE;
	}
}

#endif /* SUPPORT_OVR */
#endif /* __ovrstp */

/*
 *  Хϥɥư
 */
#ifdef __sta_ovr
#ifdef SUPPORT_OVR

SYSCALL ER
sta_ovr(ID tskid, OVRTIM ovrtim)
{
	TCB		*p_tcb;
	ER		ercd;

	LOG_STA_OVR_ENTER(tskid, ovrtim);
	CHECK_TSKCTX_UNL();
	CHECK_OBJ(ovrinib.ovrhdr != NULL);
	CHECK_TSKID_SELF(tskid);
	CHECK_PAR(0u < ovrtim && ovrtim <= TMAX_OVRTIM);
	p_tcb = get_tcb_self(tskid);
	CHECK_ACPTN(p_tcb->p_tinib->acvct.acptn2);

	t_lock_cpu();
	if (p_tcb == p_runtsk) {
		if (p_tcb->leftotm > 0u) {
			(void) hw_ovrtimer_stop();
		}
		hw_ovrtimer_start(ovrtim);
		ovrtimer_flag = TRUE;
	}
	p_tcb->leftotm = ovrtim;
	ercd = E_OK;
	t_unlock_cpu();

  error_exit:
	LOG_STA_OVR_LEAVE(ercd);
	return(ercd);
}

#else /* SUPPORT_OVR */

SYSCALL ER
sta_ovr(ID tskid, OVRTIM ovrtim)
{
	LOG_STA_OVR_ENTER(tskid, ovrtim);
	LOG_STA_OVR_LEAVE(E_NOSPT);
	return(E_NOSPT);
}

#endif /* SUPPORT_OVR */
#endif /* __sta_ovr */

/*
 *  Хϥɥư
 */
#ifdef __stp_ovr
#ifdef SUPPORT_OVR

SYSCALL ER
stp_ovr(ID tskid)
{
	TCB		*p_tcb;
	ER		ercd;

	LOG_STP_OVR_ENTER(tskid);
	CHECK_TSKCTX_UNL();
	CHECK_OBJ(ovrinib.ovrhdr != NULL);
	CHECK_TSKID_SELF(tskid);
	p_tcb = get_tcb_self(tskid);
	CHECK_ACPTN(p_tcb->p_tinib->acvct.acptn2);

	t_lock_cpu();
	if (p_tcb == p_runtsk) {
		(void) hw_ovrtimer_stop();
		ovrtimer_flag = FALSE;
	}
	p_tcb->leftotm = 0u;
	ercd = E_OK;
	t_unlock_cpu();

  error_exit:
	LOG_STP_OVR_LEAVE(ercd);
	return(ercd);
}

#else /* SUPPORT_OVR */

SYSCALL ER
stp_ovr(ID tskid)
{
	LOG_STP_OVR_ENTER(tskid);
	LOG_STP_OVR_LEAVE(E_NOSPT);
	return(E_NOSPT);
}

#endif /* SUPPORT_OVR */
#endif /* __stp_ovr */

/*
 *  Хϥɥξֻ
 */
#ifdef __ref_ovr
#ifdef SUPPORT_OVR

SYSCALL ER
ref_ovr(ID tskid, T_ROVR *pk_rovr)
{
	TCB		*p_tcb;
	ER		ercd;
    
	LOG_REF_OVR_ENTER(tskid, pk_rovr);
	CHECK_TSKCTX_UNL();
	CHECK_OBJ(ovrinib.ovrhdr != NULL);
	CHECK_TSKID_SELF(tskid);
	p_tcb = get_tcb_self(tskid);
	CHECK_ACPTN(p_tcb->p_tinib->acvct.acptn4);
	CHECK_MACV_WRITE(pk_rovr, T_ROVR);

	t_lock_cpu();
	if (p_tcb->leftotm > 0u) {
		pk_rovr->ovrstat = TOVR_STA;
		if (p_tcb == p_runtsk) {
			pk_rovr->leftotm = hw_ovrtimer_get_current();
		}
		else {
			pk_rovr->leftotm = p_tcb->leftotm;
		}
	}
	else {
		pk_rovr->ovrstat = TOVR_STP;
	}
	ercd = E_OK;
	t_unlock_cpu();

  error_exit:
	LOG_REF_OVR_LEAVE(ercd, pk_rovr);
	return(ercd);
}

#else /* SUPPORT_OVR */

SYSCALL ER
ref_ovr(ID tskid, T_ROVR *pk_rovr)
{
	LOG_REF_OVR_ENTER(tskid, pk_rovr);
	LOG_REF_OVR_LEAVE(E_NOSPT, pk_rovr);
	return(E_NOSPT);
}

#endif /* SUPPORT_OVR */
#endif /* __ref_ovr */

/*
 *  Хϥɥ鵯ư롼
 */
#ifdef __ovrcal
#ifdef SUPPORT_OVR

void
call_ovrhdr(void)
{
	assert(ovrinib.ovrhdr != NULL);
	p_runtsk->leftotm = 0u;
	(*((OVRHDR)(ovrinib.ovrhdr)))(TSKID(p_runtsk), p_runtsk->p_tinib->exinf);
	if (i_sense_lock()) {
		i_unlock_cpu();
	}
}

#endif /* SUPPORT_OVR */
#endif /* __ovrcal */
