/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		塼饤֥
 *
 *  Υ塼饤֥Ǥϡ塼إåޤ󥰹¤Υ֥
 *  󥯥塼򰷤Ūˤϡ塼إåμȥϥ塼
 *  ƬΥȥꡤȥϥ塼ΥȥȤ롥ޤ
 *  塼ƬΥȥȥȡ塼Υȥμ
 *  ȥϡ塼إåȤ롥Υ塼ϡȥꡤȥ
 *  ⼫ʬȤؤ塼إåǤ魯
 */

#ifndef	_QUEUE_H_
#define	_QUEUE_H_

/*
 *  塼Υǡ¤
 */
typedef struct queue {
	struct queue *p_next;		/* ȥؤΥݥ */
	struct queue *p_prev;		/* ȥؤΥݥ */
} QUEUE;

/*
 *  塼ν
 *
 *  p_queueˤϥ塼إåꤹ롥
 */
Inline void
queue_initialize(QUEUE *p_queue)
{
	p_queue->p_prev = p_queue->p_next = p_queue;
}

/*
 *  塼ȥؤ
 *
 *  p_queuep_entry롥p_queue˥塼إåꤷ
 *  ˤϡ塼p_entry뤳Ȥˤʤ롥
 */
Inline void
queue_insert_prev(QUEUE *p_queue, QUEUE *p_entry)
{
	p_entry->p_prev = p_queue->p_prev;
	p_entry->p_next = p_queue;
	p_queue->p_prev->p_next = p_entry;
	p_queue->p_prev = p_entry;
}

/*
 *  ȥκ
 *
 *  p_entry򥭥塼롥
 */
Inline void
queue_delete(QUEUE *p_entry)
{
	p_entry->p_prev->p_next = p_entry->p_next;
	p_entry->p_next->p_prev = p_entry->p_prev;
}

/*
 *  塼μȥμФ
 *
 *  p_queueμȥ򥭥塼ȥ֤
 *  p_queue˥塼إåꤷˤϡ塼ƬΥȥ
 *  ФȤˤʤ롥p_queue˶Υ塼ꤷƸƤӽФƤϤʤ
 *  ʤ
 */
Inline QUEUE *
queue_delete_next(QUEUE *p_queue)
{
	QUEUE	*p_entry;

	assert(p_queue->p_next != p_queue);
	p_entry = p_queue->p_next;
	p_queue->p_next = p_entry->p_next;
	p_entry->p_next->p_prev = p_queue;
	return(p_entry);
}

/*
 *  塼ɤΥå
 *
 *  p_queueˤϥ塼إåꤹ롥
 */
Inline BOOL
queue_empty(QUEUE *p_queue)
{
	if (p_queue->p_next == p_queue) {
		assert(p_queue->p_prev == p_queue);
		return(TRUE);
	}
	return(FALSE);
}

#endif /* _QUEUE_H_ */
