/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ޥեǽ
 */

#ifndef _SEMAPHORE_H_
#define _SEMAPHORE_H_

#include "queue.h"

/*
 *  ޥե֥å
 *
 *  ι¤ΤϡƱ֥̿Ȥν֥åζʬ
 *  WOBJINIBˤĥʥ֥ȻظηѾˤΤǡ
 *  ǽΥեɤ̤ˤʤäƤ롥
 */
typedef struct semaphore_initialization_block {
	ATR		sematr;			/* ޥե° */
	UINT	isemcnt;		/* ޥեλ񸻿ν */
	UINT	maxsem;			/* ޥեκ񸻿 */
	ACVCT	acvct;			/* ĥ٥ */
} SEMINIB;

/*
 *  ޥե֥å
 *
 *  ι¤ΤϡƱ֥̿Ȥδ֥åζʬWOBJCB
 *  ĥʥ֥ȻظηѾˤΤǡǽ2Ĥ
 *  եɤ̤ˤʤäƤ롥
 */
typedef struct semaphore_control_block {
	QUEUE	wait_queue;			/* ޥեԤ塼 */
	const SEMINIB *p_seminib;	/* ֥åؤΥݥ */
	UINT	semcnt;				/* ޥեߥ */
} SEMCB;

/*
 *  ޥեԤ֥å
 *
 *  ι¤ΤϡƱ֥̿ȤԤ֥åζʬ
 *  WINFO_WOBJˤĥʥ֥ȻظηѾˤΤǡ
 *  ٤ƤΥեɤ̤ˤʤäƤ롥
 */
typedef struct semaphore_waiting_information {
	WINFO	winfo;			/* ɸԤ֥å */
	SEMCB	*p_semcb;		/* ԤäƤ륻ޥեδ֥å */
} WINFO_SEM;

/*
 *  ޥեIDκ͡kernel_cfg.c
 */
extern const ID	tmax_semid;

/*
 *  ޥե֥åΥꥢkernel_cfg.c
 */
extern const SEMINIB	seminib_table[];

/*
 *  ޥե֥åΥꥢkernel_cfg.c
 */
extern SEMCB	semcb_table[];

/*
 *  ޥե֥å饻ޥեIDФΥޥ
 */
#define	SEMID(p_semcb)	((ID)(((p_semcb) - semcb_table) + TMIN_SEMID))

/*
 *  ޥեǽν
 */
extern void	initialize_semaphore(void);

#endif /* _SEMAPHORE_H_ */
