/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ͥνȽλ
 */

#include "hrp_kernel.h"
#include "check.h"
#include "memory.h"
#include "time_event.h"
#include "syslog.h"

#ifdef __sta_ker

/*
 *  ͥư֥ե饰
 *
 *  ȥåץ롼ǡFALSEʡ0ˤ˽뤳ȤԤ
 *  롥
 */
BOOL	kerflg = FALSE;

/*
 *  ͥεư
 */
void
sta_ker(void)
{
	/*
	 *  åȰ¸ν
	 */
	cpu_initialize();
	sys_initialize();
	tool_initialize();

	/*
	 *  ƥǽν
	 */
	initialize_syslog();

	/*
	 *  ưåɽ
	 */
	print_banner();

	/*
	 *  ƥ⥸塼ν
	 *
	 *  ।٥ȴ⥸塼¾Υ⥸塼˽
	 *  ɬפ롥
	 */
	initialize_memory();
	initialize_tmevt();
	initialize_object();

	/*
	 *  롼μ¹
	 */ 
	call_inirtn();

	/*
	 *  ͥưγ
	 */
	kerflg = TRUE;
	LOG_KER_ENTER();
	start_dispatch();
	assert(0);
}

#endif /* __sta_ker */

/*
 *  ͥνλ
 */
#ifdef __ext_ker

SYSCALL ER
ext_ker(void)
{
	ER		ercd;
	SIL_PRE_LOC;

	LOG_EXT_KER_ENTER();
	if (!sense_context()) {
		CHECK_ACPTN(sysstat_acvct.acptn3);
	}

	/*
	 *  ߥå֤˰ܹ
	 */
	SIL_LOC_INT();

	/*
	 *  ͥưνλ
	 */
	LOG_KER_LEAVE();
	kerflg = FALSE;

	/*
	 *  ͥνλθƽФ
	 *
	 *  󥿥ƥȤڤ괹ơexit_kernelƤӽФ
	 */
	call_exit_kernel();
	assert(0);

  error_exit:
	LOG_EXT_KER_LEAVE(ercd);
	return(ercd);
}

/*
 *  ͥνλ
 */
void
exit_kernel(void)
{
	/*
	 *  λ롼μ¹
	 */
	call_terrtn();

	/*
	 *  atexitνȥǥȥ饯μ¹
	 */
	call_atexit();

	/*
	 *  ƥǽνλ
	 */
	terminate_syslog();

	/*
	 *  åȰ¸νλ
	 */
	cpu_terminate();
	sys_exit();
	assert(0);
}

#endif /* __ext_ker */
