/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001,2002 by Information-technology Promotion Agency, JAPAN
 *  Copyright (C) 2001,2002 by TRON Association, JAPAN
 *  Copyright (C) 2005 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ӥǽ
 */

#include "hrp_kernel.h"
#include "domain.h"
#include "task.h"
#include "svc_manage.h"

/* 
 *  ĥӥؤʬ롼
 */
#ifdef __svcent

ER_UINT
cal_svc(FN fncd, 
				VP_INT par1, VP_INT par2, VP_INT par3,
				VP_INT par4, VP_INT par5)
{
	return extsvc_entry(par1, par2, par3, par4, par5, fncd);
}

ER_UINT
extsvc_entry(VP_INT par1, VP_INT par2, VP_INT par3,
					VP_INT par4, VP_INT par5, FN fncd)
{
	EXTSVC	svcrtn;
	ACPTN	saved_rundom;
	ER_UINT	ercd;

	if (fncd > tmax_fncd) {
		return(E_RSFN);
	}
	svcrtn = extsvc_table[fncd - 1];
	if (svcrtn == NULL) {
		return(E_RSFN);
	}

	if (sense_context()) {
		ercd = (*svcrtn)(par1, par2, par3, par4, par5);
	}
	else {
		saved_rundom = rundom;
		rundom = TACPTN_KERNEL;
		ercd = (*svcrtn)(par1, par2, par3, par4, par5);
		rundom = saved_rundom;
	}
	return(ercd);
}

#endif /* __svcent */
