/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ƥǽ
 */

#undef OMIT_SYSLOG
#include "hrp_kernel.h"
#include "time_event.h"
#include <log_output.h>
#include "syslog.h"

#ifdef __logini

/*
 *  ХåեȤ˥뤿Υݥ
 */
SYSLOG	syslog_buffer[TCNT_SYSLOG_BUFFER];	/* Хåե */
UINT	syslog_count;						/* ХåեΥο */
UINT	syslog_head;						/* ƬΥγǼ */
UINT	syslog_tail;						/* ΥγǼ */
UINT	syslog_lost;						/* 줿ο */

/*
 *  Ϥ٤ν١ʥӥåȥޥåס
 */
UINT	syslog_logmask;			/* Хåե˵Ͽ٤ */
UINT	syslog_lowmask;			/* ٥Ϥ٤ */

/*
 *  ƥǽν
 */
void
initialize_syslog(void)
{
	syslog_count = 0u;
	syslog_head = syslog_tail = 0u;
	syslog_lost = 0u;

	syslog_logmask = 0u;
	syslog_lowmask = LOG_UPTO(LOG_NOTICE);
}     

#endif /* __logini */

/* 
 *  ν
 *
 *  CPUå֤¹ԥƥȤˤ餺ưǤ褦˼Ƥ롥
 */
#ifdef __wri_log

SYSCALL ER
wri_log(UINT prio, SYSLOG *p_syslog)
{
	SIL_PRE_LOC;

	/*
	 *  ߥå֤˰ܹ
	 */
	SIL_LOC_INT();

	/*
	 *  
	 */
	p_syslog->logtim = systim_offset + current_time;

	/*
	 *  Хåե˵Ͽ
	 */
	if ((syslog_logmask & LOG_MASK(prio)) != 0u) {
		syslog_buffer[syslog_tail] = *p_syslog;
		syslog_tail++;
		if (syslog_tail >= TCNT_SYSLOG_BUFFER) {
			syslog_tail = 0u;
		}
		if (syslog_count < TCNT_SYSLOG_BUFFER) {
			syslog_count++;
		}
		else {
			syslog_head = syslog_tail;
			syslog_lost++;
		}
	}

	/*
	 *  ٥
	 */
	if ((syslog_lowmask & LOG_MASK(prio)) != 0u) {
		syslog_print(p_syslog, sys_putc);
	}

	SIL_UNL_INT();
	return(E_OK);
}

#endif /* __wri_log */

/*
 *  ХåեɽФ
 *
 *  CPUå֤¹ԥƥȤˤ餺ưǤ褦˼Ƥ롥
 */
#ifdef __rea_log

SYSCALL ER_UINT
rea_log(SYSLOG *p_syslog)
{
	ER_UINT	ercd;
	SIL_PRE_LOC;

	/*
	 *  ߥå֤˰ܹ
	 */
	SIL_LOC_INT();

	/*
	 *  ХåեμФ
	 */
	if (syslog_count > 0u) {
		*p_syslog = syslog_buffer[syslog_head];
		syslog_count--;
		syslog_head++;
		if (syslog_head >= TCNT_SYSLOG_BUFFER) {
			syslog_head = 0u;
		}
		ercd = (ER_UINT) syslog_lost;
		syslog_lost = 0u;
	}
	else {
		ercd = E_OBJ;
	}

	SIL_UNL_INT();
	return(ercd);
}

#endif /* __rea_log */

/* 
 *  Ϥ٤ν٤
 */
#ifdef __msk_log

SYSCALL ER
msk_log(UINT logmask, UINT lowmask)
{
	syslog_logmask = logmask;
	syslog_lowmask = lowmask;
	return(E_OK);
}

#endif /* __msk_log */

/* 
 *  ƥǽνλ
 *
 *  Хåե˵Ͽ줿٥ϵǽѤƽϤ
 *  롥
 */
#ifdef __logter

void
terminate_syslog(void)
{
	syslog_printf("-- buffered messages --", NULL, sys_putc);
	if (syslog_lost > 0u) {
		syslog_lostmsg(syslog_lost, sys_putc);
		syslog_lost = 0u;
	}
	while (syslog_count > 0u) {
		syslog_print(&syslog_buffer[syslog_head], sys_putc);
		syslog_count--;
		syslog_head++;
		if (syslog_head >= TCNT_SYSLOG_BUFFER) {
			syslog_head = 0u;
		}
	}
}

#endif /* __logter */
