/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001,2002 by Information-technology Promotion Agency, JAPAN
 *  Copyright (C) 2001,2002 by TRON Association, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		⥸塼
 */

#include "hrp_kernel.h"
#include "task.h"
#include "wait.h"
#include "mutex.h"

#ifdef __tskini

/*
 *  ¹Ծ֤Υ
 */
TCB		*p_runtsk;

/*
 *  ¹Ծ֤ΥݸɥᥤΥӥåȥѥ
 */
ACPTN	rundom;

/*
 *  ǹ̤ͥΥ
 */
TCB		*p_schedtsk;

/*
 *  ǥѥå㳰롼ư׵ե饰
 */
BOOL	reqflg;

/*
 *  ǥѥåػ߾
 */
BOOL	disdsp;

/*
 *  ǥѥåǽ
 */
BOOL	dspflg;

/*
 *  ǥ塼
 */
QUEUE	ready_queue[TNUM_TPRI];

/*
 *  ǥ塼ΤΥӥåȥޥå
 *
 *  ӥåȥޥåץؿͥ٤16ʳǤ뤳ȤꤷƤ뤿ᡤ
 *  UHȤƤ롥
 */
UH		ready_primap;

/*
 *  ⥸塼ν
 */
void
initialize_task(void)
{
	UINT	i, j;
	TCB		*p_tcb;
	ID		domid;

	p_runtsk = p_schedtsk = NULL;
	reqflg = FALSE;
	disdsp = FALSE;
	dspflg = TRUE;

	for (i = 0; i < TNUM_TPRI; i++) {
		queue_initialize(&(ready_queue[i]));
	}
	ready_primap = 0u;

	for (i = 0; i < tnum_tsk; i++) {
		j = INDEX_TSK(torder_table[i]);
		p_tcb = &(tcb_table[j]);
		p_tcb->p_tinib = &(tinib_table[j]);
		domid = OBJ_DOMID(p_tcb->p_tinib->tskatr);
		p_tcb->p_dominib = (domid == TDOM_KERNEL) ? &dominib_kernel
									: &(dominib_table[INDEX_DOM(domid)]);
		p_tcb->actque = FALSE;
		make_dormant(p_tcb);
		queue_initialize(&(p_tcb->mutex_queue));
		if ((p_tcb->p_tinib->tskatr & TA_ACT) != 0u) {
			make_active(p_tcb);
		}
	}
}

#endif /* __tskini */

/*
 *  ӥåȥޥåץؿ
 *
 *  bitmap1ΥӥåȤ⡤ǤⲼ̡ʱˤΤΤ򥵡Υӥ
 *  ֹ֤ӥåֹϡǲ̥ӥåȤ0Ȥ롥bitmap0
 *  ƤϤʤʤδؿǤϡͥ٤16ʳǤ뤳Ȥꤷ
 *  bitmapUHȤƤ롥
 *
 *  ӥåȥ̿ĥץåǤϡӥåȥ̿Ȥ褦
 *  ľΨɤΤ褦ʾˤϡcpu_insn.hǥ
 *  åȥ̿Ȥäbitmap_searchCPU_BITMAP_SEARCH
 *  Ф褤ޤӥåȥ̿Υդʤɤ
 *  ͳͥ٤ȥӥåȤȤбѹˤϡPRIMAP_BITޥ
 *  Ф褤
 *
 *  ޤɸ饤֥ffsʤ顤Τ褦ɸ饤
 *  ȤäΨɤǽ⤢롥
 *		#define	bitmap_search(bitmap) (ffs(bitmap) - 1)
 */
#ifndef PRIMAP_BIT
#define	PRIMAP_BIT(pri)		(1u << (pri))
#endif /* PRIMAP_BIT */

#ifndef CPU_BITMAP_SEARCH

Inline UINT
bitmap_search(UH bitmap)
{
	static const unsigned char search_table[] = { 0, 1, 0, 2, 0, 1, 0,
												3, 0, 1, 0, 2, 0, 1, 0 };
	UINT	n = 0;

	assert(bitmap != 0u);
	if ((bitmap & 0x00ffu) == 0u) {
		bitmap >>= 8;
		n += 8;
	}
	if ((bitmap & 0x0fu) == 0u) {
		bitmap >>= 4;
		n += 4;
	}
	return(n + search_table[(bitmap & 0x0fu) - 1]);
}

#endif /* CPU_BITMAP_SEARCH */

/*
 *  ǹ̥ͥΥ
 */
#ifdef __tsksched

TCB *
search_schedtsk(void)
{
	UINT	schedpri;

	schedpri = bitmap_search(ready_primap);
	return((TCB *)(ready_queue[schedpri].p_next));
}

#endif /* __tsksched */

/*
 *  ¹ԤǤ֤ؤΰܹ
 *
 *  ǹ̤ͥΥ򹹿Τϡ¹ԤǤ륿ʤä
 *  ȡp_tcbͥ٤ǹ̤ͥΥͥ٤⤤Ǥ
 *  롥
 */
#ifdef __tskrun

BOOL
make_runnable(TCB *p_tcb)
{
	UINT	pri = p_tcb->priority;

	p_tcb->tstat = TS_RUNNABLE;
	LOG_TSKSTAT(p_tcb);
	queue_insert_prev(&(ready_queue[pri]), &(p_tcb->task_queue));
	ready_primap |= PRIMAP_BIT(pri);

	if (p_schedtsk == (TCB *) NULL || pri < p_schedtsk->priority) {
		p_schedtsk = p_tcb;
		return(dspflg);
	}
	return(FALSE);
}

#endif /* __tskrun */

/*
 *  ¹ԤǤ֤¾ξ֤ؤΰܹ
 *
 *  ǹ̤ͥΥ򹹿Τϡp_tcbǹ̤ͥΥ
 *  äǤ롥p_tcbƱͥ٤Υ¾ˤϡp_tcb
 *  μΥǹ̤ͥˤʤ롥Ǥʤϡǥ塼
 *  ɬפ롥
 */
#ifdef __tsknrun

BOOL
make_non_runnable(TCB *p_tcb)
{
	UINT	pri = p_tcb->priority;
	QUEUE	*p_queue = &(ready_queue[pri]);

	queue_delete(&(p_tcb->task_queue));
	if (queue_empty(p_queue)) {
		ready_primap &= ~PRIMAP_BIT(pri);
		if (p_schedtsk == p_tcb) {
			p_schedtsk = (ready_primap == 0u) ? (TCB * ) NULL
												: search_schedtsk();
			return(dspflg);
		}
	}
	else {
		if (p_schedtsk == p_tcb) {
			p_schedtsk = (TCB *)(p_queue->p_next);
			return(dspflg);
		}
	}
	return(FALSE);
}

#endif /* __tsknrun */

/*
 *  ٻ߾֤ؤΰܹ
 */
#ifdef __tskdmt

void
make_dormant(TCB *p_tcb)
{
	p_tcb->tstat = TS_DORMANT;
	p_tcb->svclevel = 0u;
	p_tcb->bpriority = p_tcb->priority = p_tcb->p_tinib->ipriority;
	p_tcb->wupque = FALSE;
	p_tcb->enatex = FALSE;
	p_tcb->waifbd = FALSE;
	p_tcb->texptn = 0u;
	p_tcb->leftotm = 0u;
	LOG_TSKSTAT(p_tcb);
}

#endif /* __tskdmt */

/*
 *  ٻ߾֤¹ԤǤ֤ؤΰܹ
 */
#ifdef __tskact

BOOL
make_active(TCB *p_tcb)
{
	activate_context(p_tcb);
	return(make_runnable(p_tcb));
}

#endif /* __tskact */

/*
 *  θͥ٤ѹ
 *
 *  ¹ԤǤ֤ξˤϡǥ塼Ǥΰ֤ѹ
 *  롥֥ȤԤ塼Ԥ֤ˤʤäƤˤϡ
 *  塼Ǥΰ֤ѹ롥ޤߥ塼ƥåԤ
 *  ֤ξˤϡŪͥٷѾԤ
 *
 *  ǹ̤ͥΥ򹹿Τϡ(1) p_tcbǹ̤ͥΥ
 *  Ǥäơͥ٤򲼤硤(2) p_tcbǹ̤ͥΥ
 *  ǤϤʤѹͥ٤ǹ̤ͥΥͥ٤⤤
 *  Ǥ롥(1)ξˤϡǥ塼򥵡ɬפ롥
 */
#ifdef __tskpri

BOOL
change_priority(TCB *p_tcb, UINT newpri)
{
	UINT	oldpri;

  transitive_inheritance:
	oldpri = p_tcb->priority;
	p_tcb->priority = newpri;

	if (TSTAT_RUNNABLE(p_tcb->tstat)) {
		/*
		 *  ¹ԤǤ֤ξ
		 */
		queue_delete(&(p_tcb->task_queue));
		if (queue_empty(&(ready_queue[oldpri]))) {
			ready_primap &= ~PRIMAP_BIT(oldpri);
		}
		queue_insert_prev(&(ready_queue[newpri]), &(p_tcb->task_queue));
		ready_primap |= PRIMAP_BIT(newpri);

		if (p_schedtsk == p_tcb) {
			if (newpri >= oldpri) {
				p_schedtsk = search_schedtsk();
				return(p_schedtsk != p_tcb && dspflg);
			}
		}
		else {
			if (newpri < p_schedtsk->priority) {
				p_schedtsk = p_tcb;
				return(dspflg);
			}
		}
	}
	else {
		if (TSTAT_WAIT_MTX(p_tcb->tstat)) {
			/*
			 *  ߥ塼ƥåԤ֤ξ
			 *
			 *  ƵƽФȤФ줤˽񤱤뤬åξ
			 *  ¤ޤʤʤ뤿ᡤκƵŸǵ
			 *  Ƥ롥
			 */
			p_tcb = (*mtxhook_change_priority)(p_tcb, oldpri, &newpri);
			if (p_tcb != NULL) {
				goto transitive_inheritance;
			}
		}
		else if (TSTAT_WAIT_WOBJCB(p_tcb->tstat)) {
			/*
			 *  ¾Υ֥Ԥ֤ǡƱ̿
			 *  Ȥδ֥åζʬWOBJCBˤԤ塼
			 *  ˤĤʤƤ
			 */
			wobj_change_priority(((WINFO_WOBJ *)(p_tcb->p_winfo))->p_wobjcb,
																	p_tcb);
		}
	}
	return(FALSE);
}

#endif /* __tskpri */

/*
 *  ǥ塼βž
 *
 *  ǹ̤ͥΥ򹹿Τϡǹ̤ͥΥ
 *  塼˰ưǤ롥
 */
#ifdef __tskrot

BOOL
rotate_ready_queue(UINT pri)
{
	QUEUE	*p_queue = &(ready_queue[pri]);
	QUEUE	*p_entry;

	if (!queue_empty(p_queue) && p_queue->p_next->p_next != p_queue) {
		p_entry = queue_delete_next(p_queue);
		queue_insert_prev(p_queue, p_entry);
		if (p_schedtsk == (TCB *) p_entry) {
			p_schedtsk = (TCB *)(p_queue->p_next);
			return(dspflg);
		}
	}
	return(FALSE);
}

#endif /* __tskrot */

/*
 *  ޤ㳰롼η
 */
typedef void	(*TEXRTN)(TEXPTN texptn, VP_INT exinf);

/*
 *  ƥॿΥ㳰롼θƽФ
 *
 *  HRPͥǤϡ㳰롼CPUå֤˰ܹԤ
 *  ξ֤ᤵ˥꥿󤷤硤ͥ뤬ξ֤᤹
 */
#ifdef __tsktex
#ifndef OMIT_CALL_TEXRTN

void
call_texrtn_smode(void)
{
	TEXPTN	texptn;

	do {
		texptn = p_runtsk->texptn;
		p_runtsk->enatex = FALSE;
		p_runtsk->texptn = 0u;

		t_unlock_cpu();
		LOG_TEX_ENTER(texptn);
		(*((TEXRTN)(p_runtsk->p_tinib->texrtn)))(texptn,
												p_runtsk->p_tinib->exinf);
		LOG_TEX_LEAVE(texptn);
		if (!t_sense_lock()) {
			t_lock_cpu();
		}
	} while (p_runtsk->texptn != 0u);
	p_runtsk->enatex = TRUE;
}

#endif /* OMIT_CALL_TEXRTN */

/*
 *  ƥॿΥ㳰롼εư
 */
#ifndef OMIT_CALLTEX

void
calltex_smode(void)
{
	if (p_runtsk->enatex && p_runtsk->texptn != 0u) {
		call_texrtn_smode();
	}
}

#endif /* OMIT_CALLTEX */
#endif /* __tsktex */
