/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		।٥ȴ⥸塼
 */

#include "hrp_kernel.h"
#include "check.h"
#include "time_event.h"

/*
 *  ।٥ȥҡޥ
 */
#define	PARENT(index)		((index) >> 1)		/* ƥΡɤ */
#define	LCHILD(index)		((index) << 1)		/* λҥΡɤ */
#define	TMEVT_NODE(index)	(tmevt_heap[(index) - 1])

/*
 *  ٥ȯӥޥ
 *
 *  ٥ȯϡcurrent_timeͤӤ롥ʤ
 *  current_timeǾ͡ʺǤᤤˡcurrent_time-1͡ʺǤ
 *  󤤻ˤȤߤʤӤ롥
 */
#define	EVTTIM_LT(t1, t2) (((t1) - current_time) < ((t2) - current_time))
#define	EVTTIM_LE(t1, t2) (((t1) - current_time) <= ((t2) - current_time))

#ifdef __tmeini

/*
 *  ƥΥեå
 */
SYSTIM	systim_offset;

/*
 *  ߤΥƥñ: ߥá
 *
 *  ̩ˤϡΥƥåΥƥ
 */
EVTTIM	current_time;

/*
 *  ΥƥåΥƥñ: 1ߥá
 */
EVTTIM	next_time;

/*
 *  ƥѻѿñ: 1/TIM_DENOߥá
 */
#if TIC_DENO != 1u
UINT	next_subtime;
#endif /* TIC_DENO != 1u */

/*
 *  ।٥ȥҡפκǸλΰΥǥå
 */
UINT	last_index;

/*
 *  ޥ⥸塼ν
 */
void
initialize_tmevt(void)
{
	systim_offset = 0u;
	current_time = 0u;
	next_time = current_time + TIC_NUME / TIC_DENO;
#if TIC_DENO != 1u
	next_subtime = TIC_NUME % TIC_DENO;
#endif /* TIC_DENO != 1u */
	last_index = 0u;
}

#endif /* __tmeini */

/*
 *  ।٥Ȥ֤õ
 *
 *  timeȯ륿।٥ȤΡɤ뤿ˡ
 *  ҡפξ˸äƶΡɤư롥ưζΡɤΰ֤
 *  indexϤȡưζΡɤΰ֡ʤʤ֡ˤ֤
 */
#ifdef __tmeup

UINT
tmevt_up(UINT index, EVTTIM time)
{
	UINT	parent;

	while (index > 1) {
		/*
		 *  ƥΡɤΥ٥ȯᤤʤޤƱ
		 *  ʤСindex ֤ʤΤǥ롼פȴ롥
		 */
		parent = PARENT(index);
		if (EVTTIM_LE(TMEVT_NODE(parent).time, time)) {
			break;
		}

		/*
		 *  ƥΡɤ index ΰ֤˰ư롥
		 */
		TMEVT_NODE(index) = TMEVT_NODE(parent);
		TMEVT_NODE(index).p_tmevtb->index = index;

		/*
		 *  index ƥΡɤΰ֤˹
		 */
		index = parent;
	}
	return(index);
}

#endif /* __tmeup */

/*
 *  ।٥Ȥ֤򲼸õ
 *
 *  timeȯ륿।٥ȤΡɤ뤿ˡ
 *  ҡפβ˸äƶΡɤư롥ưζΡɤΰ֤ 
 *  indexϤȡưζΡɤΰ֡ʤʤ֡ˤ֤
 */
#ifdef __tmedown

UINT
tmevt_down(UINT index, EVTTIM time)
{
	UINT	child;

	while ((child = LCHILD(index)) <= last_index) {
		/*
		 *  λҥΡɤΥ٥ȯӤᤤ
		 *  ҥΡɤΰ֤ child ꤹ롥ʲλҥΡ
		 *  ϡФ줿λҥΡɤΤȡ
		 */
		if (child + 1 <= last_index
						&& EVTTIM_LT(TMEVT_NODE(child + 1).time,
										TMEVT_NODE(child).time)) {
			child = child + 1;
		}

		/*
		 *  ҥΡɤΥ٥ȯ٤ʤޤƱ
		 *  ʤСindex ֤ʤΤǥ롼פȴ롥
		 */
		if (EVTTIM_LE(time, TMEVT_NODE(child).time)) {
			break;
		}

		/*
		 *  ҥΡɤ index ΰ֤˰ư롥
		 */
		TMEVT_NODE(index) = TMEVT_NODE(child);
		TMEVT_NODE(index).p_tmevtb->index = index;

		/*
		 *  index ҥΡɤΰ֤˹
		 */
		index = child;
	}
	return(index);
}

#endif /* __tmedown */

/*
 *  ।٥ȥҡפؤϿ
 *
 *  p_tmevtbǻꤷ।٥ȥ֥åtimeǻꤷ֤
 *  ˥٥Ȥȯ褦ˡ।٥ȥҡפϿ롥
 */
#ifdef __tmeins

void
tmevtb_insert(TMEVTB *p_tmevtb, EVTTIM time)
{
	UINT	index;

	/*
	 *  last_index 򥤥󥯥Ȥ֤õ
	 */
	index = tmevt_up(++last_index, time);

	/*
	 *  ।٥Ȥ index ΰ֤롥
	 */ 
	TMEVT_NODE(index).time = time;
	TMEVT_NODE(index).p_tmevtb = p_tmevtb;
	p_tmevtb->index = index;
}

#endif /* __tmeins */

/*
 *  ।٥ȥҡפκ
 */
#ifdef __tmedel

void
tmevtb_delete(TMEVTB *p_tmevtb)
{
	UINT	index = p_tmevtb->index;
	UINT	parent;
	EVTTIM	event_time = TMEVT_NODE(last_index).time;

	/*
	 *  ˤ꥿।٥ȥҡפˤʤϲ⤷ʤ
	 */
	if (--last_index == 0) {
		return;
	}

	/*
	 *  Ρɤΰ֤˺ǸΥΡɡlast_index+1ΰ֤ΥΡɡ
	 *  Ŭڤʰ֤ذư롥ºݤˤϡǸΥΡ
	 *  ºݤΤǤϤʤΡɤΰ֤Ρɤˤ
	 *  ΤǡǸΥΡɤ٤֤ظƶΡɤư
	 *  롥
	 *  ǸΥΡɤΥ٥ȯ郎ΡɤοƥΡɤΥ
	 *  ٥ȯξˤϡ˸ä֤õ
	 *  Ǥʤˤϡ˸äõ
	 */
	if (index > 1 && EVTTIM_LT(event_time,
								TMEVT_NODE(parent = PARENT(index)).time)) {
		/*
		 *  ƥΡɤindexΰ֤˰ư롥
		 */
		TMEVT_NODE(index) = TMEVT_NODE(parent);
		TMEVT_NODE(index).p_tmevtb->index = index;

		/*
		 *  ΡɤοƥΡɤ˸ä֤õ
		 */
		index = tmevt_up(parent, event_time);
	}
	else {
		/*
		 *  Ρɤ鲼˸ä֤õ
		 */
		index = tmevt_down(index, event_time);
	}

	/*
	 *  ǸΥΡɤindexΰ֤롥
	 */ 
	TMEVT_NODE(index) = TMEVT_NODE(last_index + 1);
	TMEVT_NODE(index).p_tmevtb->index = index;
}

#endif /* __tmedel */

/*
 *  ।٥ȥҡפƬΥΡɤκ
 */
Inline void
tmevtb_delete_top(void)
{
	UINT	index;
	EVTTIM	event_time = TMEVT_NODE(last_index).time;

	/*
	 *  ˤ꥿।٥ȥҡפˤʤϲ⤷ʤ
	 */
	if (--last_index == 0) {
		return;
	}

	/*
	 *  롼ȥΡɤ˺ǸΥΡɡlast_index + 1 ΰ֤ΥΡɡˤ
	 *  Ŭڤʰ֤ذư롥ºݤˤϡǸΥΡɤ
	 *  ºݤΤǤϤʤ롼ȥΡɤΡɤˤʤΤǡ
	 *  ΥΡɤ٤֤ظƶΡɤư롥
	 */
	index = tmevt_down(1, event_time);

	/*
	 *  ǸΥΡɤindexΰ֤롥
	 */ 
	TMEVT_NODE(index) = TMEVT_NODE(last_index + 1);
	TMEVT_NODE(index).p_tmevtb->index = index;
}

/*
 *  ƥåζ
 */
#ifdef __isig_tim

SYSCALL ER
isig_tim(void)
{
	TMEVTB	*p_tmevtb;
	ER		ercd;

	LOG_ISIG_TIM_ENTER();
	CHECK_INTCTX_UNL();
	i_lock_cpu();

	/*
	 *  next_timeꥤ٥ȯᤤʤޤƱ˥।٥
	 *  Ȥ򡤥।٥ȥҡפХåؿƤӽ
	 *  
	 */
	while (last_index > 0 && EVTTIM_LE(TMEVT_NODE(1).time, next_time)) {
		p_tmevtb = TMEVT_NODE(1).p_tmevtb;
		tmevtb_delete_top();
		(*(p_tmevtb->callback))(p_tmevtb->arg);

		/*
		 *  ͥ٤ι⤤ߤդ롥
		 */
		i_unlock_cpu();
		i_lock_cpu();
	}

	/*
	 *  current_time򹹿롥
	 */
	current_time = next_time;

	/*
	 *  next_timenext_subtime򹹿롥
	 *
	 *  TIC_NUME < TIC_DENOλϡȤ鷺˻ιǤ뤬
	 *  ɤɤߤ䤹ˤ뤿#if¿Ѥ򤱤Ƥ롥
	 */
#if TIC_DENO == 1u
	next_time = current_time + TIC_NUME;
#else /* TIC_DENO == 1u */
	next_subtime += TIC_NUME % TIC_DENO;
	next_time = current_time + TIC_NUME / TIC_DENO;
	if (next_subtime >= TIC_DENO) {
		next_subtime -= TIC_DENO;
		next_time += 1u;
	}
#endif /* TIC_DENO == 1u */

	ercd = E_OK;
	i_unlock_cpu();

  error_exit:
	LOG_ISIG_TIM_LEAVE(ercd);
	return(ercd);
}

#endif /* __isig_tim */

/*
 *  ।٥ȤޤǤλĤ֤η׻
 */
#ifdef __tmeltim

RELTIM
tmevtb_lefttim(TMEVTB *p_tmevtb)
{
	EVTTIM	time;

	time = TMEVT_NODE(p_tmevtb->index).time;
	if (EVTTIM_LE(time, next_time)) {
		/*
		 *  Υƥåǽˤ0֤
		 */
		return(0u);
	}
	else {
		return((RELTIM)(time - base_time));
	}
}

#endif /* __tmeltim */
