/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		।٥ȴ⥸塼
 */

#ifndef _TIME_EVENT_H_
#define _TIME_EVENT_H_

/*
 *  ٥ȯΥǡ
 *
 *  EVTTIMϡRELTIMȤƻǤϰϤ⹭ϰϤɽǤɬ
 *  롥ɥץեǤϡRELTIM16ӥåȰʾǤʤ
 *  ФʤʤᡤEVTTIM17ӥåȰʾǤ뤳ȤɬפǤ롥Τ
 *  ᡤ16ӥåȤˤʤ礬UINTǤϤʤUWƤ롥
 */
typedef UW		EVTTIM;

/*
 *  л֡RELTIMˤ˻Ǥ
 */
#define TMAX_RELTIM	((((EVTTIM) 1u) << (sizeof(EVTTIM) * CHAR_BIT - 1)) - 1u)

/* 
 *  ।٥ȥ֥åΥǡ
 */
typedef void	(*CBACK)(VP);	/* Хåؿη */

typedef struct time_event_block {
	UINT	index;			/* ।٥ȥҡǤΰ */
	CBACK	callback;		/* Хåؿ */
	VP		arg;			/* ХåؿϤ */
} TMEVTB;

/*
 *  ।٥ȥҡΥΡɤΥǡ
 */
typedef struct time_event_node {
	EVTTIM	time;			/* ٥ȯ */
	TMEVTB	*p_tmevtb;		/* б륿।٥ȥ֥å */
} TMEVTN;

/*
 *  ।٥ȥҡסkernel_cfg.c
 */
extern TMEVTN	tmevt_heap[];

/*
 *  ƥΥեå
 */
extern SYSTIM	systim_offset;

/*
 *  ߤΥƥñ: ߥá
 *
 *  ƥ൯ư0˽졤ʹߡisig_timƤФ٤ñĴ
 *  ä롥set_timˤäѹʤ
 */
extern EVTTIM	current_time;

/*
 *  ΥƥåΥƥñ: 1ߥá
 */
extern EVTTIM	next_time;

/*
 *  ƥѻѿñ: 1/TIM_DENOߥá
 *
 *  ΥƥåΥƥβ̷򼨤ʾ̷next_timeˡ
 *  TIC_DENO1λϡ̷Ͼ0Ǥ뤿ᡤѿɬפʤ
 */
#if TIC_DENO != 1u
extern UINT	next_subtime;
#endif /* TIC_DENO != 1u */

/*
 *  л֤Υ١ñ: 1ߥá
 *
 *  ΥƥåΥƥڤ夲TIC_DENO1λ
 *  ϡnext_time˰פ롥
 */
#if TIC_DENO == 1u
#define	base_time	(next_time)
#else /* TIC_DENO == 1u */
#define	base_time	(next_time + (next_subtime > 0u ? 1u : 0u))
#endif /* TIC_DENO == 1u */

/*
 *  ।٥ȥҡפκǸλΰΥǥå
 *
 *  ।٥ȥҡפϿƤ륿।٥Ȥο˰פ롥
 */
extern UINT	last_index;

/*
 *  ।٥ȴ⥸塼ν
 */
extern void	initialize_tmevt(void);

/*
 *  ।٥Ȥ֤õ
 */
extern UINT	tmevt_up(UINT index, EVTTIM time);
extern UINT	tmevt_down(UINT index, EVTTIM time);

/*
 *  ।٥ȥҡפؤϿȺ
 */
extern void	tmevtb_insert(TMEVTB *p_tmevtb, EVTTIM time);
extern void	tmevtb_delete(TMEVTB *p_tmevtb);

/*
 *  ।٥ȥ֥åϿлֻ
 *
 *  timeǻꤷл֤вᤷˡargȤcallback
 *  ӽФ褦ˡp_tmevtbǻꤷ।٥ȥ֥åϿ
 *  롥
 *  
 */
Inline void
tmevtb_enqueue(TMEVTB *p_tmevtb, RELTIM time, CBACK callback, VP arg)
{
	assert(time <= TMAX_RELTIM);

	p_tmevtb->callback = callback;
	p_tmevtb->arg = arg;
	tmevtb_insert(p_tmevtb, base_time + time);
}

/*
 *  ।٥ȥ֥åϿʥ٥ȯ
 *
 *  timeǻꤷ٥ȯˡargȤcallbackƤӽ
 *  褦ˡp_tmevtbǻꤷ।٥ȥ֥åϿ롥
 */
Inline void
tmevtb_enqueue_evttim(TMEVTB *p_tmevtb, EVTTIM time, CBACK callback, VP arg)
{
	p_tmevtb->callback = callback;
	p_tmevtb->arg = arg;
	tmevtb_insert(p_tmevtb, time);
}

/*
 *  ।٥ȥ֥åϿ
 */
Inline void
tmevtb_dequeue(TMEVTB *p_tmevtb)
{
	tmevtb_delete(p_tmevtb);
}

/*
 *  ।٥ȤޤǤλĤ֤η׻
 */
extern RELTIM	tmevtb_lefttim(TMEVTB *p_tmevtb);

#endif /* _TIME_EVENT_H_ */
