/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ƥΥեޥåȽ
 */

#include <kernel.h>

/*
 *  ݥ󥿤ǼǤΥǥեȤ
 */
#ifndef _intptr_
#define _intptr_	long
#endif /* _intptr_ */

/*
 *  ͤʸѴ
 */
#define CONVERT_BUFLEN	((sizeof(_intptr_) * CHAR_BIT + 2) / 3)
										/* _intptr_οͤκʸ */
static void
convert(unsigned _intptr_ val, UINT radix, const char *radchar,
				UINT width, BOOL minus, BOOL padzero, void (*putc)(char))
{
	char	buf[CONVERT_BUFLEN];
	UINT	i, j;

	i = 0u;
	do {
		buf[i++] = radchar[val % radix];
		val /= radix;
	} while (i < CONVERT_BUFLEN && val != 0);

	if (minus && width > 0) {
		width -= 1;
	}
	if (minus && padzero) {
		(*putc)('-');
	}
	for (j = i; j < width; j++) {
		(*putc)((char)(padzero ? '0' : ' '));
	}
	if (minus && !padzero) {
		(*putc)('-');
	}
	while (i > 0u) {
		(*putc)(buf[--i]);
	}
}

/*
 *  ʸ
 */
static const char raddec[] = "0123456789";
static const char radhex[] = "0123456789abcdef";
static const char radHEX[] = "0123456789ABCDEF";

void
syslog_printf(const char *format, VP_INT *p_args, void (*putc)(char))
{
	char		c;
	UINT		width;
	BOOL		padzero;
	_intptr_	val;
	const char	*str;

	while ((c = *format++) != '\0') {
		if (c != '%') {
			(*putc)(c);
			continue;
		}

		width = 0u;
		padzero = FALSE;
		if ((c = *format++) == '0') {
			padzero = TRUE;
			c = *format++;
		}
		while ('0' <= c && c <= '9') {
			width = width * 10u + c - '0';
			c = *format++;
		}
		if (c == 'l') {
			c = *format++;
		}
		switch (c) {
		case 'd':
			val = (_intptr_)(*p_args++);
			if (val >= 0) {
				convert((unsigned _intptr_) val, 10u, raddec,
								width, FALSE, padzero, putc);
			}
			else {
				convert((unsigned _intptr_)(-val), 10u, raddec,
								width, TRUE, padzero, putc);
			}
			break;
		case 'u':
			val = (_intptr_)(*p_args++);
			convert((unsigned _intptr_) val, 10u, raddec,
								width, FALSE, padzero, putc);
			break;
		case 'x':
		case 'p':
			val = (_intptr_)(*p_args++);
			convert((unsigned _intptr_) val, 16u, radhex,
								width, FALSE, padzero, putc);
			break;
		case 'X':
			val = (_intptr_)(*p_args++);
			convert((unsigned _intptr_) val, 16u, radHEX,
								width, FALSE, padzero, putc);
			break;
		case 'c':
			(*putc)((char)(_intptr_)(*p_args++));
			break;
		case 's':
			str = (const char *)(*p_args++);
			while ((c = *str++) != '\0') {
				(*putc)(c);
			}
			break;
		case '%':
			(*putc)('%');
			break;
		case '\0':
			format--;
			break;
		default:
			break;
		}
	}
	(*putc)('\n');
}

/*
 *  ν
 */
void
syslog_print(SYSLOG *p_syslog, void (*putc)(char))
{
	switch (p_syslog->logtype) {
	case LOG_TYPE_COMMENT:
		syslog_printf((const char *)(p_syslog->loginfo[0]),
								&(p_syslog->loginfo[1]), putc);
		break;
	case LOG_TYPE_ASSERT:
		syslog_printf("%s:%u: Assertion `%s' failed.",
								&(p_syslog->loginfo[0]), putc);
		break;
	}
}

/*
 *  Ӽåν
 */
void
syslog_lostmsg(UINT lost, void (*putc)(char))
{
	VP_INT	lostinfo[1];

	lostinfo[0] = (VP_INT) lost;
	syslog_printf("%d messages are lost.", lostinfo, putc);
}
