/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2000-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2005-     by Monami Software Limited Partnership, JAPAN
 *  Copyright (C) 2005-2006 by Japan Aerospace Exploration Agency.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		default CPU exception handlerMIPS32ѡ
 */

#include "hrp_kernel.h"

void default_exc_handler( VP p_excinf ) {
	EXCSTACK *sp = p_excinf;

    syslog_0(LOG_EMERG, "-- default_exc_handler --");

#if ABI_POINTER == 4
	syslog_1(LOG_EMERG, "PC(EPC;CP0_r14) = 0x%08x", sp->CP0_EPC);
#else /* ABI_POINTER == 8 */
	syslog_1(LOG_EMERG, "PC(EPC;CP0_r14) = 0x%016x", sp->CP0_EPC);
#endif
    syslog_2(LOG_EMERG, "SR(Status;CP0_r12) = 0x%08x CR(Cause;CP0_r13) = 0x%08x",
    			sp->CP0_Status, sp->CP0_Cause);
#if ABI_POINTER == 4
	syslog_1(LOG_EMERG, "at(r1 ) = 0x%08x", sp->at);
	syslog_2(LOG_EMERG, "v0(r2 ) = 0x%08x v1(r3 ) = 0x%08x", sp->v0, sp->v1);
	syslog_2(LOG_EMERG, "a0(r4 ) = 0x%08x a1(r5 ) = 0x%08x", sp->a0, sp->a1);
	syslog_2(LOG_EMERG, "a2(r6 ) = 0x%08x a3(r7 ) = 0x%08x", sp->a2, sp->a3);
	syslog_2(LOG_EMERG, "a4(r8 ) = 0x%08x a5(r9 ) = 0x%08x", sp->a4, sp->a5);
	syslog_2(LOG_EMERG, "a6(r10) = 0x%08x a7(r11) = 0x%08x", sp->a6, sp->a7);
	syslog_2(LOG_EMERG, "t4(r12) = 0x%08x t5(r13) = 0x%08x", sp->t4, sp->t5);
	syslog_2(LOG_EMERG, "t6(r14) = 0x%08x t7(r15) = 0x%08x", sp->t6, sp->t7);
	syslog_2(LOG_EMERG, "t8(r24) = 0x%08x t9(r25) = 0x%08x", sp->t8, sp->t9);
	syslog_2(LOG_EMERG, "gp(r28) = 0x%08x ra(r31) = 0x%08x", sp->gp, sp->ra);
	syslog_2(LOG_EMERG, "HI = 0x%08x LO = 0x%08x", sp->hi, sp->lo);
#else /* ABI_POINTER == 8 */
	syslog_1(LOG_EMERG, "at(r1 ) = 0x%016x", sp->at);
	syslog_2(LOG_EMERG, "v0(r2 ) = 0x%016x v1(r3 ) = 0x%016x", sp->v0, sp->v1);
	syslog_2(LOG_EMERG, "a0(r4 ) = 0x%016x a1(r5 ) = 0x%016x", sp->a0, sp->a1);
	syslog_2(LOG_EMERG, "a2(r6 ) = 0x%016x a3(r7 ) = 0x%016x", sp->a2, sp->a3);
	syslog_2(LOG_EMERG, "a4(r8 ) = 0x%016x a5(r9 ) = 0x%016x", sp->a4, sp->a5);
	syslog_2(LOG_EMERG, "a6(r10) = 0x%016x a7(r11) = 0x%016x", sp->a6, sp->a7);
	syslog_2(LOG_EMERG, "t4(r12) = 0x%016x t5(r13) = 0x%016x", sp->t4, sp->t5);
	syslog_2(LOG_EMERG, "t6(r14) = 0x%016x t7(r15) = 0x%016x", sp->t6, sp->t7);
	syslog_2(LOG_EMERG, "t8(r24) = 0x%016x t9(r25) = 0x%016x", sp->t8, sp->t9);
	syslog_2(LOG_EMERG, "gp(r28) = 0x%016x ra(r31) = 0x%016x", sp->gp, sp->ra);
	syslog_2(LOG_EMERG, "HI = 0x%016x LO = 0x%016x", sp->hi, sp->lo);
#endif
	while (1) { /* infinite loop */
		;
	}
}
