/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2000-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2005-     by Monami Software Limited Partnership, JAPAN
 *  Copyright (C) 2005-2006 by Japan Aerospace Exploration Agency.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *	ꥢI/OǥХSIO˥ɥ饤
 */

#ifndef _HW_SERIAL_H_
#define _HW_SERIAL_H_

#include <mips_uart.h>		/* siopcb, mips_uart_openflag */

/*
 *  SIOγߥϥɥΥ٥ֹ
 */
#define INHNO_SIO1		INTNO_SIO0
#define INHNO_SIO2		INTNO_SIO1

/*
 *  SIOɥ饤Фν롼
 */
#define	sio_initialize		mips_uart_initialize

/*
 *  ͥ뵯ưѤν (sys_putc)
 */
#define sio_init		mips_uart_init

#ifndef _MACRO_ONLY

/*
 *  ꥢI/OݡȤΥץ
 */
Inline SIOPCB *
sio_opn_por(ID siopid, VP_INT exinf)
{
	SIOPCB	*siopcb;
	BOOL	openflag;


	/*
	 *  ץ󤷤ݡȤ뤫 openflag ɤǤ
	 */
	openflag = mips_uart_openflag();

	/*
	 *  ǥХ¸Υץ
	 */
	siopcb = mips_uart_opn_por(siopid, exinf);

	/*
	 *  ꥢI/Oߤγߥ٥ꤷޥ롥
	 */
	if (!openflag) {
		switch(siopid) {
		case 1 :	/* ݡȣ; ꥢ룰 */
							/* ߥ٥ */
			break;
		case 2 :	/* ݡȣ; ꥢ룱 */
							/* ߥ٥ */
			break;
		}
	}

	return(siopcb);
}

/*
 *  ꥢI/OݡȤΥ
 */
Inline void
sio_cls_por(SIOPCB *siopcb)
{
	BOOL	openflag;


	/*
	 *  ץ󤷤ݡȤ뤫 openflag ɤǤ
	 */
	openflag = mips_uart_openflag();
	
	/*
	 *  ǥХ¸Υ
	 */
	mips_uart_cls_por(siopcb);

	/*
	 *  ꥢI/Oߤޥ롥(ݡȣξ)
	 */
	if (!openflag) {
	}
}

#endif /* _MACRO_ONLY */

/*
 *  SIOγߥϥɥ
 */
#define	sio1_handler		mips_uart_uart0_isr
#if TNUM_SIOP >= 2
#define sio2_handler		mips_uart_uart1_isr
#endif /* TNUM_SIOP */

/*
 *  ꥢI/OݡȤؤʸ
 */
#define	sio_snd_chr		mips_uart_snd_chr

/*
 *  ꥢI/OݡȤؤʸʥݡ󥰡
 */
#define	sio_snd_chr_pol		mips_uart_putchar_pol

/*
 *  ꥢI/OݡȤʸ
 */
#define	sio_rcv_chr		mips_uart_rcv_chr

/*
 *  ꥢI/OݡȤΥХåε
 */
#define	sio_ena_cbr		mips_uart_ena_cbr

/*
 *  ꥢI/OݡȤΥХåζػ
 */
#define	sio_dis_cbr		mips_uart_dis_cbr

/*
 *  ꥢI/OݡȤǽХå
 */
#define	sio_ierdy_snd		mips_uart_ierdy_snd

/*
 *  ꥢI/OݡȤμΥХå
 */
#define	sio_ierdy_rcv		mips_uart_ierdy_rcv

#endif /* _HW_SERIAL_H_ */
