/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2000-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2005-     by Monami Software Limited Partnership, JAPAN
 *  Copyright (C) 2005-2006 by Japan Aerospace Exploration Agency.
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

#include <mips_uart.h>

/*
 *	mips_uart(TI) ʰSIOɥ饤
 */

typedef struct sio_port_reg_addr {
	VP	rbr;
	VP	thr;
	VP	dll;
	VP	ier;
	VP	dlm;
	VP	iir;
	VP	fcr;
	VP	lcr;
	VP	mcr;
	VP	lsr;
	VP	msr;
	VP	scr;
} SIOPREG;

/*
 *  ꥢI/OݡȽ֥å
 */
typedef struct sio_port_initialization_block {
	SIOPREG	reg;

	UB	lcr_def;	/* LCR b0-b6;
				(ӥåȿȥåץӥåȡѥƥ) */
	UB	scr_def;	/* SCR͡ʥץꥹ顨*/
	UB	baud_hi_def;	/* DLM͡ʥܡ졼Ⱦ̤͡ */
	UB	baud_lo_def;	/* DLL͡ʥܡ졼Ȳ̤͡ */
} SIOPINIB;

/*
 *  ꥢI/Oݡȴ֥å
 */
struct sio_port_control_block {
	const SIOPINIB	*siopinib;	/* ꥢI/OݡȽ֥å */
	VP_INT		exinf;		/* ĥ */
	BOOL		openflag;	/* ץѤߥե饰 */
	BOOL		getready;	/* ʸ */
	BOOL		putready;	/* ʸǤ */
};

/*
 *  ꥢI/OݡȽ֥å
 *    ID = 1 ݡ1ID = 2 ݡ2бƤ롥
 */
const SIOPINIB siopinib_table[TNUM_SIOP] = {
	{
	  { (VP)(UART_CH01 + RBR),
	    (VP)(UART_CH01 + THR),
	    (VP)(UART_CH01 + DLL),
	    (VP)(UART_CH01 + IER),
	    (VP)(UART_CH01 + DLM),
	    (VP)(UART_CH01 + IIR),
	    (VP)(UART_CH01 + FCR),
	    (VP)(UART_CH01 + LCR),
	    (VP)(UART_CH01 + MCR),
	    (VP)(UART_CH01 + LSR),
	    (VP)(UART_CH01 + MSR),
	    (VP)(UART_CH01 + SCR)},
	  (UB)	WORD_LENGTH_8 | STOP_BITS_1 | PARITY_NON,
	  (UB)	PRE_DIVISOR,
	  (UB)	HI8(DIVISOR),
	  (UB)	LO8(DIVISOR) },
#if TNUM_SIOP >= 2
	{
	  { (VP)(UART_CH02 + RBR),
	    (VP)(UART_CH02 + THR),
	    (VP)(UART_CH02 + DLL),
	    (VP)(UART_CH02 + IER),
	    (VP)(UART_CH02 + DLM),
	    (VP)(UART_CH02 + IIR),
	    (VP)(UART_CH02 + FCR),
	    (VP)(UART_CH02 + LCR),
	    (VP)(UART_CH02 + MCR),
	    (VP)(UART_CH02 + LSR),
	    (VP)(UART_CH02 + MSR),
	    (VP)(UART_CH02 + SCR)},
	  (UB)	WORD_LENGTH_8 | STOP_BITS_1 | PARITY_NON,
	  (UB)	PRE_DIVISOR,
	  (UB)	HI8(DIVISOR),
	  (UB)	LO8(DIVISOR) },
#endif /* TNUM_SIOP >= 2 */
};

/*
 *  ꥢI/OݡȽ֥åμФ
 */
#define INDEX_SIOPINIB(siopid)	((UINT)((siopid) - 1))
#define get_siopinib(siopid)	(&(siopinib_table[INDEX_SIOPINIB(siopid)]))


/*
 *  ꥢI/Oݡȴ֥åΥꥢ
 */
SIOPCB	siopcb_table[TNUM_SIOP];

/*
 *  ꥢI/OݡID֥åФΥޥ
 */
#define INDEX_SIOP(siopid)	((UINT)((siopid) - 1))
#define get_siopcb(siopid)	(&(siopcb_table[INDEX_SIOP(siopid)]))

/*
 *  SIOѥ쥸ؿ
 */
Inline void
mips_uart_orb( VP addr, UB val )
{
	val |= sil_reb_mem( addr );
	sil_wrb_mem( addr, val );
}

Inline void
mips_uart_andb( VP addr, UB val )
{
	val &= sil_reb_mem( addr );
	sil_wrb_mem( addr, val );
}


/*
 *  ֤ɽФIIRɽФ
 */
static void
mips_uart_get_stat(SIOPCB *siopcb)
{
	UB	iir;

	iir = sil_reb_mem( siopcb->siopinib->reg.iir);
	iir &= INT_MASK;

	switch( iir ) {
		case INT_TRANS_EMPTY :
			siopcb->putready = TRUE;
			break;
		case INT_RECEIVE_DATA :
		case INT_CHAR_TIME_OUT :
			siopcb->getready = TRUE;
			break;
		default :
			siopcb->putready = TRUE;
			sil_reb_mem( siopcb->siopinib->reg.lsr );
			break;
	}

}

/*
 *  ʸǤ뤫
 */
Inline BOOL
mips_uart_getready(SIOPCB *siopcb)
{
	return(siopcb->getready);
}

/*
 *  ʸǤ뤫
 */
Inline BOOL
mips_uart_putready(SIOPCB *siopcb)
{
	return(siopcb->putready);
}

/*
 *  ʸμФ
 */
Inline char
mips_uart_getchar(SIOPCB *siopcb)
{
	char c;

	siopcb->getready = FALSE;
	c = (char) sil_reb_mem( siopcb->siopinib->reg.rbr );
	return c;

	/* 1byte ñ̤ǤʸμФԤä뤿ᡢmips_uart_opn_por
	   Хåե䤷ȤƤǽθϸʤ
	   ǽθˤϡХåեΤΥ֥åžԤʤɤνɬס*/
}

/*
 *  ʸν
 */
Inline void
mips_uart_putchar(SIOPCB *siopcb, char c)
{
	siopcb->putready = FALSE;
	sil_wrb_mem( siopcb->siopinib->reg.thr, c );
}

/*
 *  SIOɥ饤Фν롼
 */
void
mips_uart_initialize()
{
	SIOPCB	*siopcb;
	UINT	i;

	/*
	 *  ꥢI/Oݡȴ֥åν
	 */
	for (siopcb = siopcb_table, i = 0; i < TNUM_SIOP; siopcb++, i++) {
		siopcb->siopinib = &(siopinib_table[i]);
		siopcb->openflag = FALSE;
	}
}

/*
 *  SIO쥸롼
 */
void
mips_uart_init_siopinib( const SIOPINIB  *siopinib )
{
	/*
	 * SIO쥸ν
	 */
	/*  */
	sil_wrb_mem( siopinib->reg.ier, DIS_INT );

	sil_wrb_mem( siopinib->reg.fcr, TRANS_FIFO_RESET | RECEIVE_FIFO_RESET );

	/* ܡ졼Ȥ */
	sil_wrb_mem( siopinib->reg.lcr, siopinib->lcr_def | DIVISOR_LATCH_ACC );

	sil_wrb_mem( siopinib->reg.scr, siopinib->scr_def );

	sil_wrb_mem( siopinib->reg.dll, siopinib->baud_lo_def );
	sil_wrb_mem( siopinib->reg.dlm, siopinib->baud_hi_def );

	/* ⡼ɤ */
	sil_wrb_mem( siopinib->reg.lcr, siopinib->lcr_def );
}

/*
 *  ͥ뵯ưΥСʡѤν
 */
void
mips_uart_init(void)
{
	int i;
	for (i = 1; i <= TNUM_SIOP; i++) {
		mips_uart_init_siopinib( get_siopinib(i) );
	}
}

/*
 *  ץ󤷤ƤݡȤ뤫
 */
BOOL
mips_uart_openflag(void)
{
#if TNUM_SIOP < 2
	return(siopcb_table[0].openflag);
#elif TNUM_SIOP == 2
	return(siopcb_table[0].openflag || siopcb_table[1].openflag);
#else
#error "This target doesn't support more than 3 for TNUM_SIOP."
#endif
}

/*
 *  ꥢI/OݡȤΥץ
 */
SIOPCB *
mips_uart_opn_por(ID siopid, VP_INT exinf)
{
	SIOPCB		*siopcb;
	const SIOPINIB	*siopinib;

	siopcb = get_siopcb(siopid);
	siopinib = siopcb->siopinib;

	/*
	 *  ꥢ륳ȥν
	 */
	mips_uart_init_siopinib( siopinib );

	/*
	 *  ߥ٥ꡢ׵᥯ꥢϡ
	 *  sio_opn_por(hw_serial.h)ǹԤ
	 */

	siopcb->exinf = exinf;
	siopcb->getready = siopcb->putready = FALSE;
	siopcb->openflag = TRUE;

	sil_wrb_mem( siopinib->reg.mcr, ENABLE_EXT_INT | DTR | RTS);
	sil_reb_mem( siopinib->reg.msr );

	sil_wrb_mem( siopinib->reg.ier, RECEIVE_DATA_AVAILABLE | RECEIVE_LINE_STATUS);


	return(siopcb);
}

/*
 *  ꥢI/OݡȤΥ
 */
void
mips_uart_cls_por(SIOPCB *siopcb)
{
	sil_wrb_mem( siopcb->siopinib->reg.ier, DIS_INT );

	siopcb->openflag = FALSE;
}

/*
 *  ꥢI/OݡȤؤʸ
 */
BOOL
mips_uart_snd_chr(SIOPCB *siopcb, char c)
{
	BOOL b;
	b = mips_uart_putready(siopcb);
	if (b) {
		mips_uart_putchar(siopcb, c);
		return TRUE;
	}
	return FALSE;
}

/*
 *  ꥢI/OݡȤʸ
 */
INT
mips_uart_rcv_chr(SIOPCB *siopcb)
{
	BOOL b;

	b = mips_uart_getready(siopcb);
	if (b) {
		return (INT)(UB) mips_uart_getchar(siopcb);
	}

	return -1;
}

/*
 *  ꥢI/OݡȤΥХåε
 */
void
mips_uart_ena_cbr(SIOPCB *siopcb, UINT cbrtn)
{
	UB	ier_bit = 0;

	switch (cbrtn) {
	case SIO_ERDY_SND:
		ier_bit = TRANS_REG_EMPTY;
		break;
	case SIO_ERDY_RCV:
	  ier_bit = (RECEIVE_DATA_AVAILABLE | RECEIVE_LINE_STATUS);
		break;
	}

	mips_uart_orb( siopcb->siopinib->reg.ier, ier_bit );
}

/*
 *  ꥢI/OݡȤΥХåζػ
 */
void
mips_uart_dis_cbr(SIOPCB *siopcb, UINT cbrtn)
{
	UB	ier_bit = 0;

	switch (cbrtn) {
	case SIO_ERDY_SND:
		ier_bit = TRANS_REG_EMPTY;
		break;
	case SIO_ERDY_RCV:
	  ier_bit = (RECEIVE_DATA_AVAILABLE | RECEIVE_LINE_STATUS);
		break;
	}

	mips_uart_andb( siopcb->siopinib->reg.ier, ~ier_bit );
}

/*
 *  ꥢI/OݡȤФ߽
 */
static void
mips_uart_isr_siop(SIOPCB *siopcb)
{
	mips_uart_get_stat(siopcb);

	if ( mips_uart_getready(siopcb) ) {
		/*
		 *  ΥХå롼ƤӽФ
		 */
		mips_uart_ierdy_rcv(siopcb->exinf);
	} else if ( mips_uart_putready(siopcb) ) {
		/*
		 *  ǽХå롼ƤӽФ
		 */
		mips_uart_ierdy_snd(siopcb->exinf);
	}
}

/*
 *  SIOγߥӥ롼
 */
void
mips_uart_uart0_isr()
{
	if (siopcb_table[0].openflag) {
		mips_uart_isr_siop(&(siopcb_table[0]));
	}
}

#if TNUM_SIOP >= 2
void
mips_uart_uart1_isr()
{
	if (siopcb_table[1].openflag) {
		mips_uart_isr_siop(&(siopcb_table[1]));
	}
}
#endif /* TNUM_SIOP >= 2 */

/*
 *  ꥢI/OݡȤؤΥݡ󥰤Ǥν
 */
void
mips_uart_putchar_pol( char val ) {

	const SIOPINIB  *siopinib = get_siopinib( LOGTASK_PORTID );

	/* ץƥˤʤޤԤġ */
	while( (sil_reb_mem( siopinib->reg.lsr ) & (THRE) ) == 0 ) {
		/* wait */
	}

	sil_wrb_mem( siopinib->reg.thr, val );
}
