/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2005 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/*
 *		ߥ塼ƥåǽ
 */

#include "hrp_kernel.h"
#include "queue.h"
#include "task.h"
#include "mutex.h"

/*
 *  ߥ塼ƥåIDߥ塼ƥå֥åФΥޥ
 *  mutex.c
 */
#define INDEX_MTX(mtxid)	((UINT)((mtxid) - TMIN_MTXID))
#define get_mtxcb(mtxid)	(&(mtxcb_table[INDEX_MTX(mtxid)]))

/*
 *  ߥ塼ƥå֥åmutex_queueؤΥݥ󥿤顤ߥ塼ƥ
 *  ֥åؤΥݥ󥿤ФΥޥmutex.c
 */
#define MTXCB_QUEUE(p_queue) \
			((MTXCB *)(((char *) p_queue) + offsetof(MTXCB, mutex_queue)))

/*
 *  ߥ塼ƥåΥץȥФޥmutex.c
 */
#define MTXPROTO_MASK		0x03u
#define MTXPROTO(p_mtxcb)	((p_mtxcb)->p_mtxinib->mtxatr & MTXPROTO_MASK)

/*
 *  륨顼μȥ֥顼
 *
 *  E_MTX_QUEUE1 : Ρ֥åƤߥ塼ƥåΥ塼פˡ
 *                 ֥󥯤礬롥
 *  E_MTX_QUEUE2 : Ρ֥åƤߥ塼ƥåΥ塼פˡ
 *                 ߥ塼ƥå֥åʳĤʤäƤ롥
 *  E_MTX_MSTAT : Ρ֥åƤߥ塼ƥåΥ塼פˤ
 *                ʤäƤߥ塼ƥåФơåƤ
 *                ߥ塼ƥåΥȤϰۤʤ롥
 *  E_MTX_PRIO : θͥ٤ʤ
 *  E_MTX_WINFO : ߥ塼ƥåԤ֤ΥԤ֥å
 *                ߥ塼ƥå֥åؤƤʤ
 *  E_MTX_WQTSK : ߥ塼ƥåԤ֤ΥԤäƤߥ塼ƥ
 *                Ԥ塼ˡΥĤʤäƤʤ
 *  E_MTX_INIB : ߥ塼ƥå֥åбߥ塼ƥå
 *               ֥åؤƤʤ
 *  E_MTX_WAITQ1 : ߥ塼ƥåԤ塼ˡ֥󥯤礬
 *                 롥
 *  E_MTX_WAITQ2 : ߥ塼ƥåԤ塼ˡ֥åʳ
 *                 ĤʤäƤ롥
 *  E_MTX_WAITQ3 : TA_TFIFOʳ°Υߥ塼ƥåԤ塼
 *                 ͥˤʤäƤʤ
 *  E_MTX_TSTAT : ߥ塼ƥåԤ塼ˤĤʤäƤ륿
 *                ߥ塼ƥåԤ֤ˤʤäƤʤ
 *  E_MTX_CEIL1 : TA_CEILING°Υߥ塼ƥåԤ塼ˤĤʤ
 *                Ƥ륿Υ١ͥ٤ߥ塼ƥåͥ
 *                ¤⤤
 *  E_MTX_CEIL2 : TA_CEILING°Υߥ塼ƥååƤ륿
 *                Υ١ͥ٤ߥ塼ƥåͥپ¤
 *                
 *  E_MTX_LOCK : ߥ塼ƥååƤʤΤˡԤ塼ˤ
 *               ʤäƤ륿롥
 *  E_MTX_LOCTSK : ߥ塼ƥååƤ륿
 *                 åؤƤʤ
 *  E_MTX_MQMTX : ߥ塼ƥååƤ륿Ρ֥åƤ
 *                ߥ塼ƥåΥ塼פˡΥߥ塼ƥå
 *                ʤäƤʤ
 */
#define E_MTX_QUEUE1		(-1)
#define E_MTX_QUEUE2		(-2)
#define E_MTX_MSTAT			(-3)
#define E_MTX_PRIO			(-4)
#define E_MTX_WINFO			(-5)
#define E_MTX_WQTSK			(-6)
#define E_MTX_INIB			(-7)
#define E_MTX_WAITQ1		(-8)
#define E_MTX_WAITQ2		(-9)
#define E_MTX_WAITQ3		(-10)
#define E_MTX_TSTAT			(-11)
#define E_MTX_CEIL1			(-12)
#define E_MTX_CEIL2			(-13)
#define E_MTX_LOCK			(-14)
#define E_MTX_LOCTSK		(-15)
#define E_MTX_MQMTX			(-16)

/*
 *  ֥åΥɥ쥹Υå
 */
#define VALID_TCB(p_tcb) \
		((((char *) p_tcb) - ((char *) tcb_table)) % sizeof(TCB) == 0 \
			&& TMIN_TSKID <= TSKID(p_tcb) && TSKID(p_tcb) <= tmax_tskid)

#define VALID_MTXCB(p_mtxcb) \
		((((char *) p_mtxcb) - ((char *) mtxcb_table)) % sizeof(MTXCB) == 0 \
			&& TMIN_MTXID <= MTXID(p_mtxcb) && MTXID(p_mtxcb) <= tmax_mtxid)
				
/*
 *  塼ΥåΤδؿ
 *
 *  p_queuep_entryޤޤƤ뤫Ĵ٤롥ޤޤƤTRUEޤ
 *  ƤʤˤFALSE֤֥󥯤ξˤ⡤
 *  FALSE֤
 */
static BOOL
in_queue(QUEUE *p_queue, QUEUE *p_entry)
{
	QUEUE	*p_current, *p_next;

	p_current = p_queue->p_next;
	if (p_current->p_prev != p_queue) {
		return(FALSE);					/* ֥󥯤 */
	}
	while (p_current != p_queue) {
		if (p_current == p_entry) {
			return(TRUE);				/* p_entryޤޤƤ */
		}

		/*
		 *  塼μǤ˿ʤ
		 */
		p_next = p_current->p_next;
		if (p_next->p_prev != p_current) {
			return(FALSE);				 /* ֥󥯤 */
		}
		p_current = p_next;
	}
	return(FALSE);
}

/*
 *  롼
 */
ER
bit_mutex(void)
{
	ID		tskid, mtxid;
	TCB		*p_tcb, *p_headtsk;
	MTXCB	*p_mtxcb;
	UINT	priority;
	QUEUE	*p_queue, *p_next;

	/*
	 *  θ
	 */
	for (tskid = TMIN_TSKID; tskid <= tmax_tskid; tskid++) {
		p_tcb = get_tcb(tskid);
		priority = p_tcb->bpriority;

		/*
		 *  åƤߥ塼ƥåΥ塼θ
		 */
		p_queue = p_tcb->mutex_queue.p_next;
		if (p_queue->p_prev != &(p_tcb->mutex_queue)) {
			return(ERCD(E_SYS, E_MTX_QUEUE1));		/* ֥󥯤 */
		}
		while (p_queue != &(p_tcb->mutex_queue)) {
			p_mtxcb = MTXCB_QUEUE(p_queue);
			if (!VALID_MTXCB(p_mtxcb)) {
				return(ERCD(E_SYS, E_MTX_QUEUE2));
			}

			/*
			 *  ߥ塼ƥååƤ륿Υå
			 */
			if (p_mtxcb->p_loctsk != p_tcb) {
				return(ERCD(E_SYS, E_MTX_MSTAT));
			}

			/*
			 *  ͥ٤η׻
			 */
			switch (MTXPROTO(p_mtxcb)) {
			case TA_INHERIT:
				if (!queue_empty(&(p_mtxcb->wait_queue))) {
					p_headtsk = (TCB *)(p_mtxcb->wait_queue.p_next);
					if (p_headtsk->priority < priority) {
						priority = p_headtsk->priority;
					}
				}
				break;
			case TA_CEILING:
				if (p_mtxcb->p_mtxinib->ceilpri < priority) {
					priority = p_mtxcb->p_mtxinib->ceilpri;
				}
				break;
			default:
				break;
			}

			/*
			 *  塼μǤ˿ʤ
			 */
			p_next = p_queue->p_next;
			if (p_next->p_prev != p_queue) {
				return(ERCD(E_SYS, E_MTX_QUEUE1));	/* ֥󥯤 */
			}
			p_queue = p_next;
		}

		/*
		 *  ͥ٤θ
		 */
		if (p_tcb->priority != p_tcb->priority) {
			return(ERCD(E_SYS, E_MTX_PRIO));
		}

		/*
		 *  ԤäƤߥ塼ƥå˴ؤ븡
		 */
		if (TSTAT_WAIT_MTX(p_tcb->tstat)) {
			p_mtxcb = ((WINFO_MTX *)(p_tcb->p_winfo))->p_mtxcb;
			if (!VALID_MTXCB(p_mtxcb)) {
				return(ERCD(E_SYS, E_MTX_WINFO));
			}
			if (!in_queue(&(p_mtxcb->wait_queue), &(p_tcb->task_queue))) {
				return(ERCD(E_SYS, E_MTX_WQTSK));
			}
		}
	}

	/*
	 *  ߥ塼ƥåθ
	 */
	for (mtxid = TMIN_MTXID; mtxid <= tmax_mtxid; mtxid++) {
		p_mtxcb = get_mtxcb(mtxid);
		if (p_mtxcb->p_mtxinib != &(mtxinib_table[INDEX_MTX(mtxid)])) {
			return(ERCD(E_SYS, E_MTX_INIB));
		}

		/*
		 *  ߥ塼ƥåԤ塼θ
		 */
		p_queue = p_mtxcb->wait_queue.p_next;
		if (p_queue->p_prev != &(p_tcb->mutex_queue)) {
			return(ERCD(E_SYS, E_MTX_WAITQ1));		/* ֥󥯤 */
		}
		priority = TMIN_TPRI;
		while (p_queue != &(p_mtxcb->mutex_queue)) {
			p_tcb = (TCB *) p_queue;
			if (!VALID_TCB(p_tcb)) {
				return(ERCD(E_SYS, E_MTX_WAITQ2));
			}

			/*
			 *  塼ͥٽˤʤäƤ뤫θ
			 */
			if (MTXPROTO(p_mtxcb) != TA_TFIFO) {
				if (p_tcb->priority < priority) {
					return(ERCD(E_SYS, E_MTX_WAITQ3));
				}
			}
			priority = p_tcb->priority;

			/*
			 *  ֤θ
			 *
			 *  ߥ塼ƥåԤ֤Υθϡθ
             *  ǹԤäƤ뤿ᡤǤϹԤʤ
			 */
			if (!TSTAT_WAIT_MTX(p_tcb->tstat)) {
				return(ERCD(E_SYS, E_MTX_TSTAT));
			}

			/*
			 *  ͥپ¤θ
			 */
			if (MTXPROTO(p_mtxcb) == TA_CEILING) {
				if (p_tcb->bpriority < p_mtxcb->p_mtxinib->ceilpri) {
					return(ERCD(E_SYS, E_MTX_CEIL1));
				}
			}

			/*
			 *  塼μǤ˿ʤ
			 */
			p_next = p_queue->p_next;
			if (p_next->p_prev != p_queue) {
				return(ERCD(E_SYS, E_MTX_WAITQ1));	/* ֥󥯤 */
			}
			p_queue = p_next;
		}

		/*
		 *  ߥ塼ƥååƤ륿θ
		 */
		p_tcb = p_mtxcb->p_loctsk;
		if (p_tcb == NULL) {
			/*
			 *  ߥ塼ƥååƤʤ
			 */
			if (!queue_empty(&(p_mtxcb->wait_queue))) {
				return(ERCD(E_SYS, E_MTX_LOCK));
			}
		}
		else {
			/*
			 *  ߥ塼ƥååƤ
			 *
			 *  ߥ塼ƥååƤ륿θϡ
             *  θǹԤäƤ뤿ᡤǤϹԤʤ
			 */
			if (!VALID_TCB(p_tcb)) {
				return(ERCD(E_SYS, E_MTX_LOCTSK));
			}
			if (!in_queue(&(p_tcb->mutex_queue), &(p_mtxcb->mutex_queue))) {
				return(ERCD(E_SYS, E_MTX_MQMTX));
			}

			/*
			 *  ͥپ¤θ
			 */
			if (MTXPROTO(p_mtxcb) == TA_CEILING) {
				if (p_tcb->bpriority < p_mtxcb->p_mtxinib->ceilpri) {
					return(ERCD(E_SYS, E_MTX_CEIL2));
				}
			}
		}
	}
	return(E_OK);
}
