/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2005 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/* 
 *		ƥȥץѥ饤֥
 */

#include <t_services.h>
#include "test_lib.h"

/*
 *  顼åʸ֤ؿ
 */
extern const char	*itron_strerror(ER ercd);

/*
 *	åݥ
 */
static UINT		check_count = 0u;
static BIT_FUNC	check_bit_func = NULL;

void
set_bit_func(BIT_FUNC bit_func)
{
	check_bit_func = bit_func;
}

void
check_point(UINT count)
{
	BOOL	eflag = FALSE;
	ER		ercd;

	sns_ctx() ? iloc_cpu() : loc_cpu();

	/*
	 *  󥹥å
	 */
	if (++check_count == count) {
		syslog_1(LOG_NOTICE, "Check point %d passed.", count);
	}
	else {
		syslog_1(LOG_ERROR, "Unexpected check point %d.", count);
		eflag = TRUE;
	}

	/*
	 *  ֤ͥθ
	 */
	if (check_bit_func != NULL) {
		ercd = (*check_bit_func)();
		if (ercd != E_OK) {
			syslog_2(LOG_ERROR, "Internal inconsistency detected (%s, %d).",
								itron_strerror(ercd), SERCD(ercd));
			eflag = TRUE;
		}
	}

	sns_ctx() ? iunl_cpu() : unl_cpu();

	if (eflag) {
		/*
		 *  ƥȥץμ¹ԤǤ롥
		 */
		ext_ker();
	}
}

/*
 *	å
 */
void
_check_assert(const char *expr, const char *file, int line)
{
	syslog_3(LOG_ERROR, "Assertion `%s' failed at %s:%u.",
						expr, file, line);
	ext_ker();
}

/*
 *	顼ɥå
 */
void
_check_ercd(ER ercd, const char *file, int line)
{
	syslog_3(LOG_ERROR, "Unexpected error %s detected at %s:%u.",
						itron_strerror(ercd), file, line);
	ext_ker();
}
