/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id$
 */

/* 
 *		ߥ塼ƥåǽΥƥȥץࣱ
 */

#include <t_services.h>
#include "kernel_id.h"
#include "test_lib.h"
#include "test_mutex1.h"

/*
 *  ƥȥ
 */
void task1(VP_INT exinf)
{
	ER		ercd;
	T_RMTX	pk_rmtx;
	PRI		tskpri;

	check_point(1);
	ercd = ref_mtx(MUTEX1, &pk_rmtx);
	check_ercd(ercd, E_OK);
	check_assert(pk_rmtx.htskid == TSK_NONE);
	check_assert(pk_rmtx.wtskid == TSK_NONE);

	check_point(2);
	ercd = loc_mtx(MUTEX1);
	check_ercd(ercd, E_OK);

	check_point(3);
	ercd = ref_mtx(MUTEX1, &pk_rmtx);
	check_ercd(ercd, E_OK);
	check_assert(pk_rmtx.htskid == TASK1);
	check_assert(pk_rmtx.wtskid == TSK_NONE);

	check_point(4);
	ercd = loc_mtx(MUTEX1);
	check_ercd(ercd, E_ILUSE);

	check_point(5);
	ercd = act_tsk(TASK2);
	check_ercd(ercd, E_OK);

	check_point(8);
	ercd = get_pri(TASK1, &tskpri);
	check_ercd(ercd, E_OK);
	check_assert(tskpri == MID_PRIORITY);

	check_point(9);
	ercd = act_tsk(TASK3);
	check_ercd(ercd, E_OK);

	check_point(14);
	ercd = ref_mtx(MUTEX1, &pk_rmtx);
	check_ercd(ercd, E_OK);
	check_assert(pk_rmtx.htskid == TASK1);
	check_assert(pk_rmtx.wtskid == TASK3);

	check_point(15);
	ercd = unl_mtx(MUTEX1);
	check_ercd(ercd, E_OK);

	check_point(22);
	ercd = rsm_tsk(TASK2);
	check_ercd(ercd, E_OK);

	check_point(25);
	ercd = loc_mtx(MUTEX1);
	check_ercd(ercd, E_OK);

	check_point(26);
	ercd = act_tsk(TASK5);
	check_ercd(ercd, E_OK);

	check_point(28);
	ercd = dis_dsp();
	check_ercd(ercd, E_OK);

	check_point(29);
	ercd = unl_mtx(MUTEX1);
	check_ercd(ercd, E_OK);

	check_point(30);
	ercd = ena_dsp();
	check_ercd(ercd, E_OK);

	check_point(32);
	ercd = ref_mtx(MUTEX1, &pk_rmtx);
	check_ercd(ercd, E_OK);
	check_assert(pk_rmtx.htskid == TSK_NONE);
	check_assert(pk_rmtx.wtskid == TSK_NONE);

	check_point(33);
	ext_ker();
}

/*
 *  ƥȥ
 */
void task2(VP_INT exinf)
{
	ER		ercd;

	check_point(6);
	ercd = unl_mtx(MUTEX1);
	check_ercd(ercd, E_ILUSE);

	check_point(7);
	ercd = loc_mtx(MUTEX1);
	check_ercd(ercd, E_OK);

	check_point(23);
	ercd = unl_mtx(MUTEX1);
	check_ercd(ercd, E_OK);

	check_point(24);
	ext_tsk();
}

/*
 *  ƥȥ
 */
void task3(VP_INT exinf)
{
	PRI		tskpri;
	ER		ercd;

	check_point(10);
	ercd = act_tsk(TASK4);
	check_ercd(ercd, E_OK);

	check_point(11);
	ercd = loc_mtx(MUTEX1);
	check_ercd(ercd, E_OK);

	check_point(16);
	ercd = get_pri(TASK1, &tskpri);
	check_ercd(ercd, E_OK);
	check_assert(tskpri == LOW_PRIORITY);

	check_point(17);
	ercd = unl_mtx(MUTEX1);
	check_ercd(ercd, E_OK);

	check_point(18);
	ext_tsk();
}

/*
 *  ƥȥ
 */
void task4(VP_INT exinf)
{
	ER		ercd;
	PRI		tskpri;

	check_point(12);
	ercd = get_pri(TASK1, &tskpri);
	check_ercd(ercd, E_OK);
	check_assert(tskpri == HIGH_PRIORITY);

	check_point(13);
	ercd = loc_mtx(MUTEX1);
	check_ercd(ercd, E_OK);

	check_point(19);
	ercd = sus_tsk(TASK2);
	check_ercd(ercd, E_OK);

	check_point(20);
	ercd = unl_mtx(MUTEX1);
	check_ercd(ercd, E_OK);

	check_point(21);
	ext_tsk();
}

/*
 *  ƥȥ
 */
void task5(VP_INT exinf)
{
	ER		ercd;

	check_point(27);
	ercd = loc_mtx(MUTEX1);
	check_ercd(ercd, E_OK);

	check_point(31);
	ext_tsk();
}
