/*
 *  IIMP Kernel
 *      An Implementation of ITRON with Memory Protection
 * 
 *  Copyright (C) 2001,2002 by Information-technology Promotion Agency, JAPAN
 *  Copyright (C) 2001,2002 by TRON Association, JAPAN
 * 
 *  based on TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭ԤϡFree Software Foundation ˤäƸɽƤ 
 *  GNU General Public License  Version 2 ˵ҤƤ狼
 *  (1)(4)ξ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥѲǽʥХʥꥳɡʥ֥륪
 *      ȥե饤֥ʤɡˤηѤˤϡ
 *      ȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭ɽ
 *      Ѿ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥԲǽʥХʥꥳɤηޤϵ
 *      ߹ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 */



#include <jsp_services.h>
#include "kernel_id.h"
#include "sample.h"


Inline ER
probe_memory(VP base, SIZE size, ID domid, ID tskid, MODE pmmode)
{
#if !defined(__ghs__)
	CAL_SVC_5(ER, TFN_PROBE_MEMORY, VP, base, SIZE, size, ID, domid, ID, tskid, MODE, pmmode);
#else /* defined(__ghs__) */
	return (ER)CAL_SVC_5(TFN_PROBE_MEMORY, base, size, domid, tskid, pmmode);
#endif /* defined(__ghs__) */
}

/* with cpu command */
void	privileged_instructions()
{
	t_pline("privileged instructions");

	/* Please Insert privileged instructions	BY ELMIC	*/
	ena_tex();
	TOKKEN_TST();     /* privileged instruction for SH3 */
	dis_tex();

}

/* ref. a task-event-value */
INT	ref_tsk( ID tskid )
{
	return stac[tskid].reftsk;
}

/* get a result code of the service-call */
INT	get_tsk_result( ID tskid )
{
	return stac[tskid].er;
}

/* set task-event-value of INT d */
void	ref_tsk_event( ID tskid, INT d )
{
	stac[tskid].reftsk = d;
}

/* init. task-event-value */
void	ref_tsk_init()
{
	stac[TASK1].reftsk = -1;
	stac[TASK2].reftsk = -1;
	stac[TASK3].reftsk = -1;
	stac[TASK4].reftsk = -1;
	stac[TASK99].reftsk = -1;
}

/* output a message */
void	t_pline	(char *msg)
{
	syslog(LOG_NOTICE,msg);
	dly_tsk(100);
}

/* conv. str. to num.(sub) */
void rint2sz(char *str, int num, int *off)
{
    int k;

    if ((k = num / 10) != 0) rint2sz(str, k, off);
    *(str + *off) = num % 10 + '0';
    (*off)++;
}

/* conv. str. to num.(main) */
void int2sz(char *str, int num)
{
    int i;

    i = 0;
    if (num < 0) {
        num = -num;
        *str = '-';
        i++;
    }
    rint2sz(str, num, &i);
    *(str + i) = '\0';
}

/* normal putput */
void	t_success( B *no, B *comment, ID t_id, ER ec)
{
	chg_buf	(no, comment, ec, stac[t_id].msg_buf);
	t_pline(stac[t_id].msg_buf);
}

/* error output */
BOOL	t_error( B *no, ID t_id, ER src, INT cmp, ER dst)
{
	switch( cmp )
	{
		case	C_EQ:		/* src == dst */
			if( src == dst )
				return TRUE;
			break;
		case	C_NE:		/* src != dst */
			if( src != dst )
				return TRUE;
			break;
		case	C_LT:		/* src < dst */
			if( src < dst )
				return TRUE;
			break;
		case	C_LE:		/* src <= dst */
			if( src <= dst )
				return TRUE;
			break;
		case	C_GT:		/* src > dst */
			if( src > dst )
				return TRUE;
			break;
		case	C_GE:		/* src >= dst */
			if( src >= dst )
				return TRUE;
			break;
	}

	chg_buf	(no, "", src, stac[t_id].msg_buf);
	t_pline(stac[t_id].msg_buf);
	t_pline("not passed");
	while(1);
	return FALSE;
}


/* buf<-buf+str */
char	*str_plus( B *buf, B *s1 )
{

	while( *s1 != '\0' ){
		*buf++ = *s1++;
	}

	*buf = '\0';
	return buf;
}

/************* make a message with error string  **************/

void		chg_buf	(char *no, char *comment, int code,  char *buf)
{
B	*err_code;
B	tmp[16];
B	*p;

	switch(code)
	{
		case	0:
			err_code = "E_OK      : ";
			break;
		case	-5:
			err_code = "E_SYS     : ";
			break ;
		case	-9:
			err_code = "E_NOTSPT  : ";
			break ;
		case	-10:
			err_code = "E_RSFN    : ";
			break ;
		case	-11:
			err_code = "E_RSATR   : ";
			break ;
		case	-17:
			err_code = "E_PAR     : ";
			break ;
		case	-18:
			err_code = "E_ID      : ";
			break ;
		case	-25:
			err_code = "E_CTX     : ";
			break ;
		case	-26:
			err_code = "E_MACV    : ";
			break ;
		case	-27:
			err_code = "E_OACV    : ";
			break ;
		case	-28:
			err_code = "E_ILUSE   : ";
			break ;
		case	-33:
			err_code = "E_NOMEM   : ";
			break ;
		case	-34:
			err_code = "E_NOID    : ";
			break ;
		case	-41:
			err_code = "E_OBJ     : ";
			break ;
		case	-42:
			err_code = "E_NOEXS   : ";
			break ;
		case	-43:
			err_code = "E_QOVR    : ";
			break ;
		case	-49:
			err_code = "E_RLWAI   : ";
			break ;
		case	-50:
			err_code = "E_TMOUT   : ";
			break ;
		case	-51:
			err_code = "E_DLT     : ";
			break ;
		case	-52:
			err_code = "E_CLS     : ";
			break ;
		case	-57:
			err_code = "E_WBLK    : ";
			break ;
		case	-58:
			err_code = "E_BOVR    : ";
			break ;
		case	T_OK:
			err_code = "passed    : ";
			break ;
		case	T_SUCCESS:
			err_code = "successful: ";
			break ;
		case	T_END:
			err_code = "the end.  : ";
			break ;
		case	T_LINE:
			err_code = " -----------";
			break;
		default:
			int2sz(tmp, code);
			p = str_plus(buf, no);
			p = str_plus(p, " | ");
			p = str_plus(p,"(E_UINT)  : ");
			p = str_plus(p, comment);
			p = str_plus(p, " (");
			p = str_plus( p, tmp);
			str_plus(p, ")");
			return ;
	}

	p = str_plus(buf, no);
	p = str_plus(p, " | ");
	p = str_plus(p, err_code);
	str_plus(p, comment);

}

/* execut a service call */
void	exec_svc(VP_INT code)
{
ID	t_id;
ACT_MENU	*act_menu;

	get_tid( &t_id );
	act_menu = (ACT_MENU *)code;

	ref_tsk_event( t_id, act_menu->menu );

	switch( act_menu->menu )
	{
		case	F_NOTHING:
			break;

		case	F_ACT_TSK:
			ref_tsk_event( act_menu->id, 0 );
			act_menu->er = act_tsk(act_menu->id);
			break;

		case	F_CAN_ACT:
			act_menu->er = can_act(act_menu->id);
			break;

		case	F_SLP_TSK:
			act_menu->er = slp_tsk();
			break;

		case	F_WUP_TSK:
			act_menu->er = wup_tsk(act_menu->id);
			break;

		case	F_CAN_WUP:
			act_menu->er = can_wup(act_menu->id);
			break;

		case	F_REL_WAI:
			act_menu->er = rel_wai(act_menu->id);
			break;

		case	F_GET_PRI:
			act_menu->er = get_pri(act_menu->id, &act_menu->pri);
			break;

		case	F_CHG_PRI:
			act_menu->er = chg_pri(act_menu->id, act_menu->pri);
			break;

		case	F_SUS_TSK:
			act_menu->er = sus_tsk(act_menu->id);
			break;

		case	F_RSM_TSK:
			act_menu->er = rsm_tsk(act_menu->id);
			break;

		case	F_FRSM_TSK:
			act_menu->er = frsm_tsk(act_menu->id);
			break;

		case	F_TER_TSK:
			act_menu->er = ter_tsk(act_menu->id);
			break;

		case	F_WAI_SEM:
			act_menu->er = wai_sem(act_menu->id);
			break;

		case	F_POL_SEM:
			act_menu->er = pol_sem(act_menu->id);
			break;

		case	F_TWAI_SEM:
			act_menu->er = twai_sem(act_menu->id, act_menu->tmout);
			break;

		case	F_SIG_SEM:
			act_menu->er = sig_sem(act_menu->id);
			break;

		case	F_SET_FLG:
			act_menu->er = set_flg(act_menu->id, act_menu->ptn);
			break;

		case	F_CLR_FLG:
				act_menu->er = set_flg(act_menu->id, act_menu->ptn);
			break;

		case	F_WAI_FLG:
			act_menu->er = wai_flg(act_menu->id, act_menu->ptn, TWF_ORW, &(act_menu->pptn));
			break;

		case	F_POL_FLG:
			act_menu->er = pol_flg(act_menu->id, act_menu->ptn, TWF_ORW, &(act_menu->pptn));
			break;

		case	F_TWAI_FLG:
			act_menu->er = twai_flg(act_menu->id, act_menu->ptn, TWF_ORW, &(act_menu->pptn), act_menu->tmout);
			break;

		case	F_SND_DTQ:
			act_menu->er = snd_dtq(act_menu->id, act_menu->data);
			break;

		case	F_PSND_DTQ:
			act_menu->er = psnd_dtq(act_menu->id, act_menu->data);
			break;

		case	F_TSND_DTQ:
			act_menu->er = tsnd_dtq(act_menu->id, act_menu->data, act_menu->tmout);
			break;

		case	F_FSND_DTQ:
			act_menu->er = fsnd_dtq(act_menu->id, act_menu->data);
			break;

		case	F_RCV_DTQ:
			act_menu->er = rcv_dtq(act_menu->id, &(act_menu->pdata));
			break;

		case	F_PRCV_DTQ:
			act_menu->er = prcv_dtq(act_menu->id, &(act_menu->pdata));
			break;

		case	F_TRCV_DTQ:
			act_menu->er = trcv_dtq(act_menu->id, &(act_menu->pdata), act_menu->tmout);
			break;

		case	F_SND_MBX:
			act_menu->er = snd_mbx(act_menu->id, act_menu->msg);
			break;

		case	F_RCV_MBX:
			act_menu->er = rcv_mbx(act_menu->id, &(act_menu->pmsg));
			break;

		case	F_PRCV_MBX:
			act_menu->er = prcv_mbx(act_menu->id, &(act_menu->pmsg));
			break;

		case	F_TRCV_MBX:
			act_menu->er = trcv_mbx(act_menu->id, &(act_menu->pmsg), act_menu->tmout);
			break;

		case	F_GET_MPF:
			act_menu->er = get_mpf(act_menu->id, &(act_menu->blk));
			break;

		case	F_PGET_MPF:
			act_menu->er = pget_mpf(act_menu->id, &(act_menu->blk));
			break;

		case	F_TGET_MPF:
			act_menu->er = tget_mpf(act_menu->id, &(act_menu->blk), act_menu->tmout);
			break;

		case	F_REL_MPF:
			act_menu->er = rel_mpf(act_menu->id, act_menu->blk);
			break;

		case	F_XXX_TEX:

			ena_tex();
			act_menu->er = ras_tex(act_menu->id, 1);
			dly_tsk(10);
			dis_tex();
			break;

#if 0
		case	F_SND_MBP:
			act_menu->er = snd_mbp(act_menu->id, act_menu->blk, act_menu->pri);
			break;

		case	F_RCV_MBP:
			act_menu->er = rcv_mbp(act_menu->id, &(act_menu->blk));
			break;

		case	F_PRCV_MBP:
			act_menu->er = prcv_mbp(act_menu->id, &(act_menu->blk));
			break;

		case	F_TRCV_MBP:
			act_menu->er = trcv_mbp(act_menu->id, &(act_menu->blk), act_menu->tmout);
			break;

		case	F_GET_MPP:
			act_menu->er = get_mpp(act_menu->id, act_menu->size, &(act_menu->blk));
			break;

		case	F_PGET_MPP:
			act_menu->er = pget_mpp(act_menu->id, act_menu->size, &(act_menu->blk));
			break;

		case	F_TGET_MPP:
			act_menu->er = tget_mpp(act_menu->id, act_menu->size, &(act_menu->blk), act_menu->tmout);
			break;

		case	F_REL_MPP:
			act_menu->er = rel_mpp(act_menu->id, act_menu->blk);
			break;
#else /* patch */
#endif

		case	F_VPRB_MEM:
			act_menu->er = probe_memory(act_menu->blk, act_menu->size, TDOM_SELF, TSK_SELF, act_menu->mode);
										/*	02/02/18	Mod		*/
			break;

		case	F_GET_DID:
			act_menu->er = get_did(&(act_menu->id));
			break;

		case	F_CPU_COMMAND:
			privileged_instructions();
			break;

		default:
			break;
	}

	ref_tsk_event( t_id, -1 );
}


void	test_1_1_1()
{

ER	err_code;

	t_success( " 1. 1. 1", "test cyclic handler", TASK1, T_LINE);

	cyc_count_shared = 0;

	err_code = sta_cyc( CYC9 );
	if( t_error(" 1", TASK1, err_code, C_EQ, E_OK ) )
	{
		while( cyc_count_shared != 1);
		while( cyc_count_shared != 2);
		while( cyc_count_shared != 3);
		while( cyc_count_shared != 4);
		while( cyc_count_shared != 5);
		err_code = stp_cyc( CYC9 );
		t_error(" 2", TASK1, err_code, C_EQ, E_OK );
	}

	t_pline("");

}

void	test_1_1_2()
{
	
	ER	err_code;

	
	t_success( " 1. 1. 2", "call the CPU exception handler", TASK1, T_LINE);

	ref_tsk_event( TASK2, 0 );				/*	Add	02/02/18-2	*/
	stac[TASK2].menu = -1;
	err_code = act_tsk(TASK2);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );

	dly_tsk(1000);

	t_pline("");

}


void	test_1_1_3()
{

SYSTIM	gt1;
SYSTIM	gt2;
ER	err_code;
INT	i;

	t_success( " 1. 1. 3", "test system clock handler", TASK1, T_LINE);

	err_code = get_tim(&gt1);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_OK ))
		t_success( " 1. 1. 3", "Time before dly_tsk(2000) X 5.", TASK1, gt1);

	for( i=0; i<5; i++)
	{
		err_code = dly_tsk(2000);
		t_error(" 2", TASK1, err_code, C_EQ, E_OK );
	}

	err_code = get_tim(&gt2);
	if( t_error(" 3", TASK1, err_code, C_EQ, E_OK ))
		t_success( " 1. 1. 3", "Time after dly_tsk(2000) X 5.", TASK1, gt2);

	t_pline("");

}


void	test_2_1_1()
{
ER err_code;

	t_success( " 2. 1. 1", "CPU Mode in a task of user domain", TASK1, T_LINE);

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_CPU_COMMAND;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_pline("");
}

void	test_2_1_2()
{

ER err_code;

	t_success( " 2. 1. 2", "CPU Mode in a task of kernel domain", TASK1, T_LINE);

	ref_tsk_event( TASK99, 0 );
	stac[TASK99].menu = F_CPU_COMMAND;
	err_code = act_tsk(TASK99);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_pline("");

}

void	test_2_1_3()
{

ER	err_code;

	test_2_1_3_flg = 1;

	t_success( " 2. 1. 3", "CPU Mode in the task exception routine of user domain", TASK1, T_LINE);

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_XXX_TEX;
	stac[TASK3].id = TASK3;
	err_code = act_tsk(TASK3);
	
	while(test_2_1_3_flg){
		dly_tsk(10);
	}
	
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	t_pline("");

}

void	test_2_1_4()
{
ER	err_code;

	t_success( " 2. 1. 4", "CPU Mode in the task exception routine of kernel domain", TASK1, T_LINE);

	ref_tsk_event( TASK99, 0 );
	stac[TASK99].menu = F_XXX_TEX;
	stac[TASK99].id = TASK99;
	err_code = act_tsk(TASK99);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK99), C_EQ, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	t_pline("");

}

void	test_2_1_5()
{

ER	err_code;

	t_success( " 2. 1. 5", "CPU Mode in the cyclic handler of user domain", TASK1, T_LINE);

	err_code = sta_cyc( CYC1 );
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );

	err_code = dly_tsk(3000);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = stp_cyc( CYC1 );
	t_error(" 3", TASK1, err_code, C_EQ, E_OK );

	t_pline("");
}

void	test_2_1_6()
{

	t_success( " 2. 1. 6", "CPU Mode in the interrupt handler", TASK1, T_LINE);
	t_pline("?");
	t_pline("");
}


void	test_2_1_7()
{

INT	tmp;

	t_success( " 2. 1. 7", "CPU Mode in the CPU exception handler", TASK1, T_LINE);

	pi_flag = TRUE;

	tmp = 1;

/*#########################################

	err_code = 1/(tmp-1);

*/

	pi_flag = FALSE;

	t_pline("");

}


void	test_2_2_1()
{

ER	err_code;

	t_success( " 2. 2. 1", "auto-variable address of the task exception routine", TASK1, T_LINE);

	err_code = ena_tex();
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );

	syslog(LOG_NOTICE, "task's auto-variable address = 0x%08x).", (VW)&err_code );

	err_code = ras_tex(TASK1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = dis_tex();
	t_error(" 3", TASK1, err_code, C_EQ, E_OK );

	t_pline("");
}


void	test_2_3_1()
{
ER	err_code;
ID	dom;

	t_success( " 2. 3. 1", "service-call get_did", TASK1, T_LINE);
	t_pline("");

	err_code = get_did( &dom );
	if( t_error(" 1", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 2. 3. 1", "get_did( &dom ) in TASK1.", TASK1, err_code);

	t_success( " 2. 3. 1", "TASK1's domain.", TASK1, dom );

	t_pline("");

}

void	test_2_3_2()
{
ER	err_code;

	t_success( " 2. 3. 2", "service-call get_did in other domain", TASK1, T_LINE);
	t_pline("");

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_GET_DID;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 2. 3. 2", "get_did( &dom ) in TASK3.", TASK1, get_tsk_result(TASK3));

	t_error(" 2", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_success( " 2. 3. 2", "TASK3's domain.", TASK1, stac[TASK3].id );


	t_pline("");

}




void	test_3_2_1()
{


ER	err_code;

	t_success( " 3. 2. 1", "local memory check for other domain", TASK1, T_LINE);
	t_pline("");

	err_code = probe_memory((VP)&dom1_mem, sizeof(INT), TDOM_SELF, TSK_SELF, TPM_READ);
						/*	02/02/18	Mod	*/
	if( t_error(" 1", TASK1, err_code, C_LE, E_OK ) )
		t_success( " 3. 2. 1", "vprb_mem(&dom1_mem, sizeof(INT), TDOM_SELF, TSK_SELF, TPM_READ) in TASK1.", TASK1, err_code);

	err_code = probe_memory((VP)&dom1_mem, sizeof(INT), TDOM_SELF, TSK_SELF, TPM_WRITE);
						/*	02/02/18	Mod	*/
	if( t_error(" 2", TASK1, err_code, C_LE, E_OK ) )
		t_success( " 3. 2. 1", "vprb_mem(&dom1_mem, sizeof(INT), TDOM_SELF, TSK_SELF, TPM_WRITE) in TASK1.", TASK1, err_code);

	err_code = probe_memory((VP)&dom1_mem, sizeof(INT), TDOM_SELF, TSK_SELF, TPM_READ|TPM_WRITE);
						/*	02/02/18	Mod	*/
	if( t_error(" 3", TASK1, err_code, C_LE, E_OK ) )
		t_success( " 3. 2. 1", "vprb_mem(&dom1_mem, sizeof(INT), TDOM_SELF, TSK_SELF, TPM_READ|TPM_WRITE) in TASK1.", TASK1, err_code);

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_VPRB_MEM;
	stac[TASK3].blk = (VP)&dom1_mem;
	stac[TASK3].size = sizeof(INT);
	stac[TASK3].mode = TPM_READ;
	err_code = act_tsk(TASK3);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 5", TASK1, get_tsk_result(TASK3), C_LE, E_OK ) )
		t_success( " 3. 2. 1", "vprb_mem(&dom1_mem, sizeof(INT), TDOM_SELF, TSK_SELF, TPM_READ) in TASK3.", TASK1, get_tsk_result(TASK3));
	t_error(" 6", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_VPRB_MEM;
	stac[TASK3].blk = (VP)&dom1_mem;
	stac[TASK3].size = sizeof(INT);
	stac[TASK3].mode = TPM_WRITE;
	err_code = act_tsk(TASK3);
	t_error(" 7", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 8", TASK1, get_tsk_result(TASK3), C_LE, E_OK ) )
		t_success( " 3. 2. 1", "vprb_mem(&dom1_mem, sizeof(INT), TDOM_SELF, TSK_SELF, TPM_WRITE) in TASK3.", TASK1, get_tsk_result(TASK3));
	t_error(" 9", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_VPRB_MEM;
	stac[TASK3].blk = (VP)&dom1_mem;
	stac[TASK3].size = sizeof(INT);
	stac[TASK3].mode = TPM_READ|TPM_WRITE;
	err_code = act_tsk(TASK3);
	t_error(" 10", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 11", TASK1, get_tsk_result(TASK3), C_LE, E_OK ) )
		t_success( " 3. 2. 1", "vprb_mem(&dom1_mem, sizeof(INT), TDOM_SELF, TSK_SELF, TPM_READ|TPM_WRITE) in TASK3.", TASK1, get_tsk_result(TASK3));
	t_error(" 12", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	t_pline("");


}

void	test_3_2_2()
{

ER	err_code;

	t_success( " 3. 2. 2", "local memory check for same domain", TASK1, T_LINE);
	t_pline("");

	err_code = probe_memory((VP)&dom1_mem, sizeof(INT), TDOM_SELF, TSK_SELF, TPM_READ);
				/*	02/02/18	Mod	*/
	if( t_error(" 1", TASK1, err_code, C_LE, E_OK ) )
		t_success( " 3. 2. 2", "vprb_mem(&dom1_mem, sizeof(INT), TDOM_SELF, TSK_SELF, TPM_READ) in TASK1.", TASK1, err_code);

	err_code = probe_memory((VP)&dom1_mem, sizeof(INT), TDOM_SELF, TSK_SELF, TPM_WRITE);
				/*	02/02/18	Mod	*/
	if( t_error(" 2", TASK1, err_code, C_LE, E_OK ) )
		t_success( " 3. 2. 2", "vprb_mem(&dom1_mem, sizeof(INT), TDOM_SELF, TSK_SELF, TPM_WRITE) in TASK1.", TASK1, err_code);

	err_code = probe_memory((VP)&dom1_mem, sizeof(INT), TDOM_SELF, TSK_SELF, TPM_READ|TPM_WRITE);
				/*	02/02/18	Mod	*/
	if( t_error(" 3", TASK1, err_code, C_LE, E_OK ) )
		t_success( " 3. 2. 2", "vprb_mem(&dom1_mem, sizeof(INT), TDOM_SELF, TSK_SELF, TPM_READ|TPM_WRITE) in TASK1.", TASK1, err_code);

	ref_tsk_event( TASK2, 0 );
	stac[TASK2].menu = F_VPRB_MEM;
	stac[TASK2].blk = (VP)&dom1_mem;
	stac[TASK2].size = sizeof(INT);
	stac[TASK2].mode = TPM_READ;
	err_code = act_tsk(TASK2);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 5", TASK1, get_tsk_result(TASK2), C_LE, E_OK ) )
		t_success( " 3. 2. 2", "vprb_mem(&dom1_mem, sizeof(INT), TDOM_SELF, TSK_SELF, TPM_READ) in TASK2.", TASK1, get_tsk_result(TASK2));
	t_error(" 6", TASK1, ref_tsk(TASK2), C_EQ, -1 );

	ref_tsk_event( TASK2, 0 );
	stac[TASK2].menu = F_VPRB_MEM;
	stac[TASK2].blk = (VP)&dom1_mem;
	stac[TASK2].size = sizeof(INT);
	stac[TASK2].mode = TPM_WRITE;
	err_code = act_tsk(TASK2);
	t_error(" 7", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 8", TASK1, get_tsk_result(TASK2), C_LE, E_OK ) )
		t_success( " 3. 2. 2", "vprb_mem(&dom1_mem, sizeof(INT), TDOM_SELF, TSK_SELF, TPM_WRITE) in TASK2.", TASK1, get_tsk_result(TASK2));
	t_error(" 9", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	ref_tsk_event( TASK2, 0 );
	stac[TASK2].menu = F_VPRB_MEM;
	stac[TASK2].blk = (VP)&dom1_mem;
	stac[TASK2].size = sizeof(INT);
	stac[TASK2].mode = TPM_READ|TPM_WRITE;
	err_code = act_tsk(TASK2);
	t_error(" 10", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 11", TASK1, get_tsk_result(TASK2), C_LE, E_OK ) )
		t_success( " 3. 2. 2", "vprb_mem(&dom1_mem, sizeof(INT), TDOM_SELF, TSK_SELF, TPM_READ|TPM_WRITE) in TASK2.", TASK1, get_tsk_result(TASK2));
	t_error(" 12", TASK1, ref_tsk(TASK2), C_EQ, -1 );

	t_pline("");

}

void	test_3_3_1()
{

	t_success( " 3. 3. 1", "CPU Mode in the memory access exception handler", TASK1, T_LINE);
	t_pline("");

/*		Del	02/02/18-2
	pi_flag = TRUE;

	*(B *)DOM3_ADDR_RW = (B)0xaa; 

	pi_flag = FALSE;
*/

}

void	test_3_4_1()
{				/*	Add	02/02/18-2	*/

	ER	err_code;

	t_success( " 3. 4. 1", "read access to invalid memory", TASK1, T_LINE);
	t_pline("");

	ref_tsk_event( TASK2, 0 );
	stac[TASK2].menu = -2;
	err_code = act_tsk(TASK2);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );

	dly_tsk(1000);

	t_pline("");

}


void	test_3_4_2()
{				/*	Add	02/02/18-2	*/

	ER	err_code;

	t_success( " 3. 4. 2", "write access to invalid memory", TASK1, T_LINE);
	t_pline("");

	ref_tsk_event( TASK2, 0 );
	stac[TASK2].menu = -3;
	err_code = act_tsk(TASK2);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );

	dly_tsk(1000);

	t_pline("");

}


void	test_4_2_1()
{
ER	err_code;

	t_success( " 4. 2. 1", "service-call of task-control to no-accessable domain", TASK1, T_LINE);
	t_pline("");

	/* 1. act_tsk(NG)*/
	ref_tsk_event( TASK4, 0 );
	stac[TASK4].menu = F_NOTHING;

	err_code = act_tsk(TASK4);

	if( t_error(" 1", TASK1, err_code, C_EQ, E_OACV ) )
	{
		ref_tsk_event( TASK4, -1 );
		t_error(" 2", TASK1, ref_tsk(TASK4), C_EQ, -1 );
		t_success( " 4. 2. 1", "act_tsk(TASK4) in TASK1.", TASK1, err_code);
	}
	t_pline("");

	/* 2. can_act(NG)*/

	err_code = can_act(TASK4);

	if( t_error(" 1", TASK1, err_code, C_EQ, E_OACV ) )
		t_success( " 4. 2. 1", "can_act(TASK4) in TASK1.", TASK1, err_code);
	t_pline("");

	/* 3. wup_tsk(NG)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_ACT_TSK;
	stac[TASK3].id = TASK4;
	stac[TASK4].menu = F_SLP_TSK;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_error(" 4", TASK1, ref_tsk(TASK4), C_EQ, F_SLP_TSK );


	err_code = wup_tsk(TASK4);

	if( t_error(" 5", TASK1, err_code, C_EQ, E_OACV ) )
	{
		t_success( " 4. 2. 1", "wup_tsk(TASK4) in TASK1.", TASK1, err_code);

		ref_tsk_event( TASK3, 0 );
		stac[TASK3].menu = F_WUP_TSK;
		stac[TASK3].id = TASK4;
		err_code = act_tsk(TASK3);
		t_error(" 6", TASK1, err_code, C_EQ, E_OK );
		t_error(" 7", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
		t_error(" 8", TASK1, ref_tsk(TASK4), C_EQ, -1 );
		t_error(" 9", TASK1, get_tsk_result(TASK4), C_EQ, E_OK );
	}
	t_pline("");

	/* 4  can_wup(NG)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_ACT_TSK;
	stac[TASK3].id = TASK4;
	stac[TASK4].menu= F_SLP_TSK;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_error(" 4", TASK1, ref_tsk(TASK4), C_EQ, F_SLP_TSK );

	err_code = can_wup(TASK4);

	if( t_error(" 5", TASK1, err_code, C_EQ, E_OACV ) )
	{
		t_success( " 4. 2. 1", "can_wup(TASK4) in TASK1.", TASK1, err_code);

		ref_tsk_event( TASK3, 0 );
		stac[TASK3].menu = F_WUP_TSK;
		stac[TASK3].id = TASK4;
		err_code = act_tsk(TASK3);
		t_error(" 6", TASK1, err_code, C_EQ, E_OK );
		t_error(" 7", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
		t_error(" 8", TASK1, ref_tsk(TASK4), C_EQ, -1 );
		t_error(" 9", TASK1, get_tsk_result(TASK4), C_EQ, E_OK );
	}
	t_pline("");

	/* 5  get_pri(NG)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_ACT_TSK;
	stac[TASK3].id = TASK4;
	stac[TASK4].menu = F_SLP_TSK;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_error(" 4", TASK1, ref_tsk(TASK4), C_EQ, F_SLP_TSK );

	err_code = get_pri(TASK4, &(stac[TASK1].pri));

	if( t_error(" 5", TASK1, err_code, C_EQ, E_OACV ) )
	{
		t_success( " 4. 2. 1", "get_pri(TASK4,&pri) in TASK1.", TASK1, err_code);

		ref_tsk_event( TASK3, 0 );
		stac[TASK3].menu = F_WUP_TSK;
		stac[TASK3].id = TASK4;
		err_code = act_tsk(TASK3);
		t_error(" 6", TASK1, err_code, C_EQ, E_OK );
		t_error(" 7", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
		t_error(" 8", TASK1, ref_tsk(TASK4), C_EQ, -1 );
		t_error(" 9", TASK1, get_tsk_result(TASK4), C_EQ, E_OK );
	}
	t_pline("");

	/* 6  chg_pri(NG)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_ACT_TSK;
	stac[TASK3].id = TASK4;
	stac[TASK4].menu = F_SLP_TSK;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_error(" 4", TASK1, ref_tsk(TASK4), C_EQ, F_SLP_TSK );

	stac[TASK1].pri = HIGH_PRIORITY; 

	err_code = chg_pri(TASK4, stac[TASK1].pri);

	if( t_error(" 5", TASK1, err_code, C_EQ, E_OACV ) )
	{
		t_success( " 4. 2. 1", "chg_pri(TASK4,HIGH_PRIORITY) in TASK1.", TASK1, err_code);

		ref_tsk_event( TASK3, 0 );
		stac[TASK3].menu = F_WUP_TSK;
		stac[TASK3].id = TASK4;
		err_code = act_tsk(TASK3);
		t_error(" 6", TASK1, err_code, C_EQ, E_OK );
		t_error(" 7", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
		t_error(" 8", TASK1, ref_tsk(TASK4), C_EQ, -1 );
		t_error(" 9", TASK1, get_tsk_result(TASK4), C_EQ, E_OK );
	}
	t_pline("");

	/* 7  rel_wai(NG)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_ACT_TSK;
	stac[TASK3].id = TASK4;
	stac[TASK4].menu = F_SLP_TSK;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_error(" 4", TASK1, ref_tsk(TASK4), C_EQ, F_SLP_TSK );

	err_code = rel_wai(TASK4);

	if( t_error(" 5", TASK1, err_code, C_EQ, E_OACV) )
	{
		t_success( " 4. 2. 1", "rel_wai(TASK4) in TASK1.", TASK1, err_code);

		ref_tsk_event( TASK3, 0 );
		stac[TASK3].menu = F_WUP_TSK;
		stac[TASK3].id = TASK4;
		err_code = act_tsk(TASK3);
		t_error(" 6", TASK1, err_code, C_EQ, E_OK );
		t_error(" 7", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
		t_error(" 8", TASK1, ref_tsk(TASK4), C_EQ, -1 );
		t_error(" 9", TASK1, get_tsk_result(TASK4), C_EQ, E_OK );
	}
	t_pline("");

	/* 8. sus_tsk(NG)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_ACT_TSK;
	stac[TASK3].id = TASK4;
	stac[TASK4].menu = F_SLP_TSK;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_error(" 4", TASK1, ref_tsk(TASK4), C_EQ, F_SLP_TSK );

	err_code = sus_tsk(TASK4);		/* 02/01/31 TASK3->TASK4 */

	if( t_error(" 5", TASK1, err_code, C_EQ, E_OACV) )
	{
		t_success( " 4. 2. 1", "sus_tsk(TASK4) in TASK1.", TASK1, err_code);

		ref_tsk_event( TASK3, 0 );
		stac[TASK3].menu = F_WUP_TSK;
		stac[TASK3].id = TASK4;
		err_code = act_tsk(TASK3);
		t_error(" 6", TASK1, err_code, C_EQ, E_OK );
		t_error(" 7", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
		t_error(" 8", TASK1, ref_tsk(TASK4), C_EQ, -1 );
		t_error(" 9", TASK1, get_tsk_result(TASK4), C_EQ, E_OK );
	}
	t_pline("");

	/* 9. rsm_tsk(NG)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_ACT_TSK;
	stac[TASK3].id = TASK4;
	stac[TASK4].menu = F_SUS_TSK;
	stac[TASK4].id = TASK4;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_error(" 4", TASK1, ref_tsk(TASK4), C_EQ, F_SUS_TSK );

	err_code = rsm_tsk(TASK4);

	if( t_error(" 5", TASK1, err_code, C_EQ, E_OACV) )
	{
		t_success( " 4. 2. 1", "rsm_tsk(TASK4) in TASK1.", TASK1, err_code);

		ref_tsk_event( TASK3, 0 );
		stac[TASK3].menu = F_RSM_TSK;
		stac[TASK3].id = TASK4;
		err_code = act_tsk(TASK3);
		t_error(" 6", TASK1, err_code, C_EQ, E_OK );
		t_error(" 7", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
		t_error(" 8", TASK1, ref_tsk(TASK3), C_EQ, -1 );
		t_error(" 9", TASK1, ref_tsk(TASK3), C_EQ, -1 );
		t_error("10", TASK1, get_tsk_result(TASK4), C_EQ, E_OK );
	}
	t_pline("");

	/* 10. frsm_tsk(NG)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_ACT_TSK;
	stac[TASK3].id = TASK4;
	stac[TASK4].menu = F_SUS_TSK;
	stac[TASK4].id = TASK4;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_error(" 4", TASK1, ref_tsk(TASK4), C_EQ, F_SUS_TSK );

	err_code = frsm_tsk(TASK4);

	if( t_error(" 5", TASK1, err_code, C_EQ, E_OACV) )
	{

		t_success( " 4. 2. 1", "frsm_tsk(TASK4) in TASK1.", TASK1, err_code);

		ref_tsk_event( TASK3, 0 );
		stac[TASK3].menu = F_FRSM_TSK;
		stac[TASK3].id = TASK4;
		err_code = act_tsk(TASK3);
		t_error(" 6", TASK1, err_code, C_EQ, E_OK );
		t_error(" 7", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
		t_error(" 8", TASK1, ref_tsk(TASK3), C_EQ, -1 );
		t_error(" 9", TASK1, ref_tsk(TASK4), C_EQ, -1 );
		t_error("10", TASK1, get_tsk_result(TASK4), C_EQ, E_OK );
	}
	t_pline("");

	/* 11. ter_tsk(NG)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_ACT_TSK;
	stac[TASK3].id = TASK4;
	stac[TASK4].menu = F_SUS_TSK;
	stac[TASK4].id = TASK4;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_error(" 4", TASK1, ref_tsk(TASK4), C_EQ, F_SUS_TSK );

	err_code = ter_tsk(TASK4);

	if( t_error(" 5", TASK1, err_code, C_EQ, E_OACV) )
	{
		t_success( " 4. 2. 1", "ter_tsk(TASK4) in TASK1.", TASK1, err_code);

		ref_tsk_event( TASK3, 0 );
		stac[TASK3].menu = F_FRSM_TSK;
		stac[TASK3].id = TASK4;
		err_code = act_tsk(TASK3);
		t_error(" 6", TASK1, err_code, C_EQ, E_OK );
		t_error(" 7", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
		t_error(" 8", TASK1, ref_tsk(TASK3), C_EQ, -1 );
		t_error(" 9", TASK1, ref_tsk(TASK4), C_EQ, -1 );
		t_error("10", TASK1, get_tsk_result(TASK4), C_EQ, E_OK );
	}

	t_pline("");

}


void	test_4_2_2()
{
ER	err_code;

	t_success( " 4. 2. 2", "service-call of task-control to accessable domain", TASK1, T_LINE);
	t_pline("");

	/* 1. act_tsk(OK)*/
	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_NOTHING;
	err_code = act_tsk(TASK3);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 2. 2", "act_tsk(TASK3) in TASK1.", TASK1, err_code);
	t_error(" 2", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_pline("");

	/* 2. can_act(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_CAN_ACT;
	stac[TASK3].id = TASK4;
	err_code = act_tsk(TASK3);

	t_error(" 1", TASK1, err_code, C_EQ, E_OK );

	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_GE, 0 ) )
		t_success( " 4. 2. 2", "can_act(TASK4) in TASK3.", TASK1, get_tsk_result(TASK3));
	t_error(" 3", TASK1, ref_tsk(TASK4), C_EQ, -1 );
	t_error(" 4", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_pline("");

	/* 3. wup_tsk(OK)*/
	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SLP_TSK;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, ref_tsk(TASK3), C_EQ, F_SLP_TSK );

	err_code = wup_tsk(TASK3);
	if( t_error(" 3", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 2. 2", "wup_tsk(TASK3) in TASK1.", TASK1, err_code);
	t_error(" 4", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_error(" 5", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_pline("");


	/* 4. can_wup(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SLP_TSK;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, ref_tsk(TASK3), C_EQ, F_SLP_TSK );

	err_code = can_wup(TASK3);
	if( t_error(" 3", TASK1, err_code, C_GE, 0 ) )
		t_success( " 4. 2. 2", "can_wup(TASK3) in TASK1.", TASK1, err_code);

	err_code = wup_tsk(TASK3);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );
	t_error(" 5", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_error(" 6", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_pline("");

	/* 5  get_pri(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SLP_TSK;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, ref_tsk(TASK3), C_EQ, F_SLP_TSK );

	err_code = get_pri(TASK3, &(stac[TASK1].pri));
	if( t_error(" 3", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 2. 2", "get_pri(TASK3, &pri) in TASK1.", TASK1, err_code);
	t_error(" 4", TASK1, stac[TASK1].pri, C_EQ, MID_PRIORITY );

	err_code = wup_tsk(TASK3);
	t_error(" 5", TASK1, err_code, C_EQ, E_OK );
	t_error(" 6", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_error(" 7", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );

	t_pline("");


	/* 6  chg_pri(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SLP_TSK;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, ref_tsk(TASK3), C_EQ, F_SLP_TSK );

	stac[TASK1].pri = MID_PRIORITY; 
	err_code = chg_pri(TASK3, stac[TASK1].pri);
	if( t_error(" 3", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 2. 2", "chg_pri(TASK3, MID_PRIORITY) in TASK1.", TASK1, err_code);

	err_code = wup_tsk(TASK3);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );
	t_error(" 5", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_pline("");

	/* 7. rel_wai(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SLP_TSK;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, ref_tsk(TASK3), C_EQ, F_SLP_TSK );

	err_code = rel_wai(TASK3);
	if( t_error(" 3", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 2. 2", "rel_wai(TASK3) in TASK1.", TASK1, err_code);

	t_error(" 4", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_error(" 5", TASK1, get_tsk_result(TASK3), C_EQ, E_RLWAI );
	t_pline("");

	/* 8. sus_tsk(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SLP_TSK;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, ref_tsk(TASK3), C_EQ, F_SLP_TSK );

	err_code = sus_tsk(TASK3);
	if( t_error(" 3", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 2. 2", "sus_tsk(TASK3) in TASK1.", TASK1, err_code);

	err_code = rsm_tsk(TASK3);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );
	t_error(" 5", TASK1, ref_tsk(TASK3), C_EQ, F_SLP_TSK );

	err_code = wup_tsk(TASK3);
	t_error(" 6", TASK1, err_code, C_EQ, E_OK );
	t_error(" 7", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_error(" 8", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_pline("");


	/* 9. rsm_tsk(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SUS_TSK;
	stac[TASK3].id = TASK3;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, ref_tsk(TASK3), C_EQ, F_SUS_TSK );

	err_code = rsm_tsk(TASK3);
	if( t_error(" 3", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 2. 2", "rsm_tsk(TASK3) in TASK1.", TASK1, err_code);

	t_error(" 4", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_error(" 5", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_pline("");

	/* 10. frsm_tsk(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SUS_TSK;
	stac[TASK3].id = TASK3;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, ref_tsk(TASK3), C_EQ, F_SUS_TSK );

	err_code = frsm_tsk(TASK3);
	if( t_error(" 3", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 2. 2", "frsm_tsk(TASK3) in TASK1.", TASK1, err_code);

	t_error(" 4", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_error(" 5", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_pline("");


	/* 11. ter_tsk(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SUS_TSK;
	stac[TASK3].id = TASK3;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, ref_tsk(TASK3), C_EQ, F_SUS_TSK );

	err_code = ter_tsk(TASK3);
	if( t_error(" 3", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 2. 2", "ter_tsk(TASK3) in TASK1.", TASK1, err_code);

	ref_tsk_event( TASK3, -1 );
	t_pline("");

}

void	test_4_3_1()
{
ER	err_code;

	t_success( " 4. 3. 1", "service-call of semaphore to no-accessable domain", TASK1, T_LINE);
	t_pline("");

	/* 1. wai_sem(NG)*/

	err_code = wai_sem(SEM4);

	if( t_error(" 1", TASK1, err_code, C_EQ, E_OACV ) )
		t_success( " 4. 3. 1", "wai_sem(SEM4) in TASK1.", TASK1, err_code);

	t_pline("");

	/* 2. pol_sem(NG)*/

	err_code = pol_sem(SEM4);

	if( t_error(" 1", TASK1, err_code, C_EQ, E_OACV ) )
		t_success( " 4. 3. 1", "pol_sem(SEM4) in TASK1.", TASK1, err_code);

	t_pline("");

	/* 3. twai_sem(NG)*/

	err_code = twai_sem(SEM4, 10000);

	if( t_error(" 1", TASK1, err_code, C_EQ, E_OACV ) )
		t_success( " 4. 3. 1", "twai_sem(SEM4, 10000) in TASK1.", TASK1, err_code);

	t_pline("");

	/* 4. sig_sem(NG)*/

	err_code = sig_sem(SEM4);

	if( t_error(" 1", TASK1, err_code, C_EQ, E_OACV ) )
		t_success( " 4. 3. 1", "sig_sem(SEM4) in TASK1.", TASK1, err_code);

	t_pline("");

}

void	test_4_3_2()
{
ER	err_code;

	t_success( " 4. 3. 2", "service-call of semaphore to accessable domain", TASK1, T_LINE);
	t_pline("");

	/* 1. wai_sem(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_WAI_SEM;
	stac[TASK3].id = SEM4;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 3. 2", "wai_sem(SEM4) in TASK3.", TASK1, get_tsk_result(TASK3));

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_pline("");

	/* 2. pol_sem(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_POL_SEM;
	stac[TASK3].id = SEM4;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 3. 2", "pol_sem(SEM4) in TASK3.", TASK1, get_tsk_result(TASK3));

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_pline("");

	/* 3. twai_sem(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_TWAI_SEM;
	stac[TASK3].id = SEM4;
	stac[TASK3].tmout = 10000;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 3. 2", "twai_sem(SEM4, 10000) in TASK3.", TASK1, get_tsk_result(TASK3));

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_pline("");

	/* 4. sig_sem(OK)*/
	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SIG_SEM;
	stac[TASK3].id = SEM4;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );

	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 3. 2", "sig_sem(SEM4) in TASK3.", TASK1, get_tsk_result(TASK3));

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SIG_SEM;
	stac[TASK3].id = SEM4;
	err_code = act_tsk(TASK3);
	t_error(" 5", TASK1, err_code, C_EQ, E_OK );
	t_error(" 6", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 7", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SIG_SEM;
	stac[TASK3].id = SEM4;
	err_code = act_tsk(TASK3);
	t_error(" 8", TASK1, err_code, C_EQ, E_OK );
	t_error(" 9", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error("10", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	t_pline("");
}


void	test_4_3_3()
{
ER	err_code;

	t_success( " 4. 3. 3", "service-call of semaphore to shared domain", TASK1, T_LINE);
	t_pline("");

	/* 1. wai_sem(OK)*/
	err_code = wai_sem(SEM9);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 3. 3", "wai_sem(SEM9) in TASK1.", TASK1, err_code);

	t_pline("");

	/* 2. pol_sem(OK)*/
	err_code = pol_sem(SEM9);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 3. 3", "pol_sem(SEM9) in TASK1.", TASK1, err_code);

	t_pline("");

	/* 3. twai_sem(OK)*/
	err_code = twai_sem(SEM9, 10000);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 3. 3", "twai_sem(SEM9, 10000) in TASK1.", TASK1, err_code);

	t_pline("");

	/* 4. sig_sem(OK)*/
	err_code = sig_sem(SEM9);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 3. 3", "sig_sem(SEM9) in TASK1.", TASK1, err_code);

	err_code = sig_sem(SEM9);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = sig_sem(SEM9);
	t_error(" 3", TASK1, err_code, C_EQ, E_OK );

	t_pline("");


	/* 5. wai_sem(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_WAI_SEM;
	stac[TASK3].id = SEM9;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 3. 3", "wai_sem(SEM9) in TASK3.", TASK1, get_tsk_result(TASK3));

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_pline("");

	/* 6. pol_sem(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_POL_SEM;
	stac[TASK3].id = SEM9;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 3. 3", "pol_sem(SEM9) in TASK3.", TASK1, get_tsk_result(TASK3));

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_pline("");

	/* 7. twai_sem(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_TWAI_SEM;
	stac[TASK3].id = SEM9;
	stac[TASK3].tmout = 10000;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 3. 3", "twai_sem(SEM9, 10000) in TASK3.", TASK1, get_tsk_result(TASK3));

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_pline("");

	/* 8. sig_sem(OK)*/
	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SIG_SEM;
	stac[TASK3].id = SEM9;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 3. 3", "sig_sem(SEM9) in TASK3.", TASK1, get_tsk_result(TASK3));
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SIG_SEM;
	stac[TASK3].id = SEM9;
	err_code = act_tsk(TASK3);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );
	t_error(" 5", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 6", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SIG_SEM;
	stac[TASK3].id = SEM9;
	err_code = act_tsk(TASK3);
	t_error(" 7", TASK1, err_code, C_EQ, E_OK );
	t_error(" 8", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 9", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	t_pline("");

}

void	test_4_4_1()
{
ER	err_code;
FLGPTN	sptn = 0x0001;
FLGPTN	cptn = 0x0000;
FLGPTN	pptn;

	t_success( " 4. 4. 1", "service-call of event-flag to no-accessable domain", TASK1, T_LINE);
	t_pline("");

	/* 1. set_flg(NG)*/

	err_code = set_flg(FLG4, sptn);

	if( t_error(" 1", TASK1, err_code, C_EQ, E_OACV ) )
		t_success( " 4. 4. 1", "set_flg(FLG4, 0x0001) in TASK1.", TASK1, err_code);
	t_pline("");


	/* 2. clr_flg(NG)*/

	err_code = clr_flg(FLG4, cptn);

	if( t_error(" 1", TASK1, err_code, C_EQ, E_OACV ) )
		t_success( " 4. 4. 1", "clr_flg(FLG4, 0x0000) in TASK1.", TASK1, err_code);
	t_pline("");


	/* 3. wai_flg(NG)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SET_FLG;
	stac[TASK3].id = FLG4;
	stac[TASK3].ptn = sptn;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	err_code = wai_flg(FLG4, sptn, TWF_ORW, &pptn);

	if( t_error(" 4", TASK1, err_code, C_EQ, E_OACV ) )
	{
		t_success( " 4. 4. 1", "wai_flg(FLG4, 0x0001, TWF_ORW, &pptn) in TASK1.", TASK1, err_code);

		ref_tsk_event( TASK3, 0 );
		stac[TASK3].menu = F_CLR_FLG;
		stac[TASK3].id = FLG4;
		stac[TASK3].ptn = cptn;
		err_code = act_tsk(TASK3);
		t_error(" 5", TASK1, err_code, C_EQ, E_OK );
		t_error(" 6", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
		t_error(" 7", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	}
	t_pline("");

	/* 4. pol_flg(NG)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SET_FLG;
	stac[TASK3].id = FLG4;
	stac[TASK3].ptn = sptn;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	err_code = pol_flg(FLG4, sptn, TWF_ORW, &pptn);

	if( t_error(" 4", TASK1, err_code, C_EQ, E_OACV ) )
	{
		t_success( " 4. 4. 1", "pol_flg(FLG4, 0x0001, TWF_ORW, &pptn) in TASK1.", TASK1, err_code);

		ref_tsk_event( TASK3, 0 );
		stac[TASK3].menu = F_CLR_FLG;
		stac[TASK3].id = FLG4;
		stac[TASK3].ptn = cptn;
		err_code = act_tsk(TASK3);
		t_error(" 5", TASK1, err_code, C_EQ, E_OK );
		t_error(" 6", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
		t_error(" 7", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	}
	t_pline("");

	/* 5. twai_flg(NG)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SET_FLG;
	stac[TASK3].id = FLG4;
	stac[TASK3].ptn = sptn;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	err_code = twai_flg(FLG4, sptn, TWF_ORW, &pptn, 10000);

	if( t_error(" 4", TASK1, err_code, C_EQ, E_OACV ) )
	{
		t_success( " 4. 4. 1", "twai_flg(FLG4, 0x0001, TWF_ORW, &pptn, 10000) in TASK1.", TASK1, err_code);

		ref_tsk_event( TASK3, 0 );
		stac[TASK3].menu = F_CLR_FLG;
		stac[TASK3].id = FLG4;
		stac[TASK3].ptn = cptn;
		err_code = act_tsk(TASK3);
		t_error(" 5", TASK1, err_code, C_EQ, E_OK );
		t_error(" 6", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
		t_error(" 7", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	}
	t_pline("");

}

void	test_4_4_2()
{
ER	err_code;
FLGPTN	sptn = 0x0001;
FLGPTN	cptn = 0x0000;

	t_success( " 4. 4. 2", "service-call of event-flag to accessable domain", TASK1, T_LINE);
	t_pline("");

	/* 1. set_flg(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SET_FLG;
	stac[TASK3].id = FLG4;
	stac[TASK3].ptn = sptn;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 4. 2", "set_flg(FLG4, 0x0001) in TASK3.", TASK1, get_tsk_result(TASK3));

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	t_pline("");

	/* 2. clr_flg(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_CLR_FLG;
	stac[TASK3].id = FLG4;
	stac[TASK3].ptn = cptn;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 4. 2", "clr_flg(FLG4, 0x0000) in TASK3.", TASK1, get_tsk_result(TASK3));

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	t_pline("");


	/* 3. wai_flg(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SET_FLG;
	stac[TASK3].id = FLG4;
	stac[TASK3].ptn = sptn;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_WAI_FLG;
	stac[TASK3].id = FLG4;
	stac[TASK3].ptn = sptn;
	err_code = act_tsk(TASK3);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 5", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 4. 2", "wai_flg(FLG4, 0x0001) in TASK3.", TASK1, get_tsk_result(TASK3));

	t_error(" 6", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_CLR_FLG;
	stac[TASK3].id = FLG4;
	stac[TASK3].ptn = cptn;
	err_code = act_tsk(TASK3);
	t_error(" 7", TASK1, err_code, C_EQ, E_OK );
	t_error(" 8", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 9", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	t_pline("");

	/* 4. pol_flg(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SET_FLG;
	stac[TASK3].id = FLG4;
	stac[TASK3].ptn = sptn;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_POL_FLG;
	stac[TASK3].id = FLG4;
	stac[TASK3].ptn = sptn;
	err_code = act_tsk(TASK3);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 5", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 4. 2", "pol_flg(FLG4, 0x0001) in TASK3.", TASK1, get_tsk_result(TASK3));
	t_error(" 6", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_CLR_FLG;
	stac[TASK3].id = FLG4;
	stac[TASK3].ptn = cptn;
	err_code = act_tsk(TASK3);
	t_error(" 7", TASK1, err_code, C_EQ, E_OK );
	t_error(" 8", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 9", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	t_pline("");

	/* 5. twai_flg(KO)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SET_FLG;
	stac[TASK3].id = FLG4;
	stac[TASK3].ptn = sptn;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_TWAI_FLG;
	stac[TASK3].id = FLG4;
	stac[TASK3].ptn = sptn;
	stac[TASK3].tmout = 10000;
	err_code = act_tsk(TASK3);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 5", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 4. 2", "twai_flg(FLG4, 0x0001, TWF_ORW, &pptn, 10000) in TASK3.", TASK1, get_tsk_result(TASK3));

	t_error(" 6", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_CLR_FLG;
	stac[TASK3].id = FLG4;
	stac[TASK3].ptn = cptn;
	err_code = act_tsk(TASK3);
	t_error(" 7", TASK1, err_code, C_EQ, E_OK );
	 t_error(" 8", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );

	t_error(" 9", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	t_pline("");

}


void	test_4_4_3()
{
ER	err_code;
FLGPTN	sptn = 0x0001;
FLGPTN	cptn = 0x0000;
FLGPTN	pptn;

	t_success( " 4. 4. 3", "service-call of event-flag to shared domain", TASK1, T_LINE);
	t_pline("");

	/* 1. set_flg(OK)*/

	err_code = set_flg(FLG9, sptn);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 4. 3", "set_flg(FLG9, 0x0001) in TASK1.", TASK1, err_code);

	t_pline("");


	/* 2. clr_flg(OK)*/

	err_code = clr_flg(FLG9, cptn);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 4. 3", "clr_flg(FLG9, 0x0000) in TASK1.", TASK1, err_code);

	t_pline("");


	/* 3. wai_flg(OK)*/

	err_code = set_flg(FLG9, sptn);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );

	err_code = wai_flg(FLG9, sptn, TWF_ORW, &pptn);
	if( t_error(" 2", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 4. 3", "wai_flg(FLG9, 0x0001, TWF_ORW, &pptn) in TASK1.", TASK1, err_code);

	err_code = clr_flg(FLG9, cptn);
	t_error(" 3", TASK1, err_code, C_EQ, E_OK );
	t_pline("");

	/* 4. pol_flg(OK)*/

	err_code = set_flg(FLG9, sptn);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );

	err_code = pol_flg(FLG9, sptn, TWF_ORW, &pptn);
	if( t_error(" 2", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 4. 3", "pol_flg(FLG9, 0x0001, TWF_ORW, &pptn) in TASK1.", TASK1, err_code);

	err_code = clr_flg(FLG9, cptn);
	t_error(" 3", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

	/* 5. twai_flg(OK)*/

	err_code = set_flg(FLG9, sptn);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );

	err_code = twai_flg(FLG9, sptn, TWF_ORW, &pptn, 10000);
	if( t_error(" 2", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 4. 3", "twai_flg(FLG9, 0x0001, TWF_ORW, &pptn, 10000) in TASK1.", TASK1, err_code);

	err_code = clr_flg(FLG9, cptn);
	t_error(" 3", TASK1, err_code, C_EQ, E_OK );

	t_pline("");




	/* 6. set_flg(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SET_FLG;
	stac[TASK3].id = FLG9;
	stac[TASK3].ptn = sptn;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 4. 3", "set_flg(FLG9, 0x0001) in TASK3.", TASK1, get_tsk_result(TASK3));

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	t_pline("");

	/* 7. clr_flg(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_CLR_FLG;
	stac[TASK3].id = FLG9;
	stac[TASK3].ptn = cptn;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 4. 3", "clr_flg(FLG9, 0x0000) in TASK3.", TASK1, get_tsk_result(TASK3));

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	t_pline("");


	/* 8. wai_flg(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SET_FLG;
	stac[TASK3].id = FLG9;
	stac[TASK3].ptn = sptn;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_WAI_FLG;
	stac[TASK3].id = FLG9;
	stac[TASK3].ptn = sptn;
	err_code = act_tsk(TASK3);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 5", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 4. 3", "wai_flg(FLG9, 0x0001, TWF_ORW, &pptn) in TASK3.", TASK1, get_tsk_result(TASK3));

	t_error(" 6", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_CLR_FLG;
	stac[TASK3].id = FLG9;
	stac[TASK3].ptn = cptn;
	err_code = act_tsk(TASK3);
	t_error(" 7", TASK1, err_code, C_EQ, E_OK );
	t_error(" 8", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 9", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	t_pline("");

	/* 9. pol_flg(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SET_FLG;
	stac[TASK3].id = FLG9;
	stac[TASK3].ptn = sptn;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_POL_FLG;
	stac[TASK3].id = FLG9;
	stac[TASK3].ptn = sptn;
	err_code = act_tsk(TASK3);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 5", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 4. 3", "pol_flg(FLG9, 0x0001, TWF_ORW, &pptn) in TASK3.", TASK1, get_tsk_result(TASK3));

	t_error(" 6", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_CLR_FLG;
	stac[TASK3].id = FLG9;
	stac[TASK3].ptn = cptn;
	err_code = act_tsk(TASK3);
	t_error(" 7", TASK1, err_code, C_EQ, E_OK );
	t_error(" 8", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 9", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	t_pline("");

	/* 10. twai_flg(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SET_FLG;
	stac[TASK3].id = FLG9;
	stac[TASK3].ptn = sptn;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_TWAI_FLG;
	stac[TASK3].id = FLG9;
	stac[TASK3].ptn = sptn;
	stac[TASK3].tmout = 10000;
	err_code = act_tsk(TASK3);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 5", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 4. 3", "twai_flg(FLG9, 0x0001, TWF_ORW, &pptn, 10000) in TASK3.", TASK1, get_tsk_result(TASK3));
	t_error(" 6", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_CLR_FLG;
	stac[TASK3].id = FLG9;
	stac[TASK3].ptn = cptn;
	err_code = act_tsk(TASK3);
	t_error(" 7", TASK1, err_code, C_EQ, E_OK );
	t_error(" 8", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 9", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	t_pline("");

}

void	test_4_5_1()
{

ER	err_code;

	INT	pdata;

#define	DTQ_DATA	9

	t_success( " 4. 5. 1", "service-call of data-queue to no-accessable domain", TASK1, T_LINE);
	t_pline("");

	/* 1. snd_dtq(NG)*/

	err_code = snd_dtq(DTQ4, (VP_INT)DTQ_DATA);

	if( t_error(" 1", TASK1, err_code, C_EQ, E_OACV ) )
		t_success( " 4. 5. 1", "snd_dtq(DTQ4, (VP_INT)DTQ_DATA) in TASK1.", TASK1, err_code);

	t_pline("");

	/* 2. psnd_dtq(NG)*/

	err_code = psnd_dtq(DTQ4, (VP_INT)DTQ_DATA);

	if( t_error(" 1", TASK1, err_code, C_EQ, E_OACV ) )
		t_success( " 4. 5. 1", "psnd_dtq(DTQ4, (VP_INT)DTQ_DATA) in TASK1.", TASK1, err_code);

	t_pline("");

	/* 3. tsnd_dtq(NG)*/

	err_code = tsnd_dtq(DTQ4, (VP_INT)DTQ_DATA, 10000);

	if( t_error(" 1", TASK1, err_code, C_EQ, E_OACV) )
		t_success( " 4. 5. 1", "tsnd_dtq(DTQ4, (VP_INT)DTQ_DATA) in TASK1.", TASK1, err_code);

	t_pline("");

	/* 4. fsnd_dtq(NG)*/

	err_code = fsnd_dtq(DTQ4, (VP_INT)DTQ_DATA);

	if( t_error(" 1", TASK1, err_code, C_EQ, E_OACV) )
		t_success( " 4. 5. 1", "fsnd_dtq(DTQ4, (VP_INT)DTQ_DATA) in TASK1.", TASK1, err_code);

	t_pline("");

	/* 5. rcv_dtq(NG)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SND_DTQ;
	stac[TASK3].id = DTQ4;
	stac[TASK3].data = (VP_INT)(DTQ_DATA+1);
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	err_code = rcv_dtq(DTQ4, (VP_INT *)&pdata);

	if( t_error(" 4", TASK1, err_code, C_EQ, E_OACV ) )
	{
		t_success( " 4. 5. 1", "rcv_dtq(DTQ4, (VP_INT *)&pdata) in TASK1.", TASK1, err_code);

		ref_tsk_event( TASK3, 0 );
		stac[TASK3].menu = F_RCV_DTQ;
		stac[TASK3].id = DTQ4;
		err_code = act_tsk(TASK3);
		t_error(" 5", TASK1, err_code, C_EQ, E_OK );
		t_error(" 6", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
		t_error(" 7", TASK1, ref_tsk(TASK3), C_EQ, -1 );
		t_error(" 8", TASK1, (INT)stac[TASK3].pdata, C_EQ, DTQ_DATA+1 );
	}
	t_pline("");


	/* 6. prcv_dtq(NG)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SND_DTQ;
	stac[TASK3].id = DTQ4;
	stac[TASK3].data = (VP_INT)(DTQ_DATA+2);
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	err_code = prcv_dtq(DTQ4, (VP_INT *)&pdata);

	if( t_error(" 4", TASK1, err_code, C_EQ, E_OACV ) )
	{
		t_success( " 4. 5. 1", "prcv_dtq(DTQ4, (VP_INT *)&pdata) in TASK1.", TASK1, err_code);

		ref_tsk_event( TASK3, 0 );
		stac[TASK3].menu = F_RCV_DTQ;
		stac[TASK3].id = DTQ4;
		err_code = act_tsk(TASK3);
		t_error(" 5", TASK1, err_code, C_EQ, E_OK );
		t_error(" 6", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
		t_error(" 7", TASK1, ref_tsk(TASK3), C_EQ, -1 );
		t_error(" 8", TASK1, (INT)stac[TASK3].pdata, C_EQ, DTQ_DATA+2 );
	}
	t_pline("");

	/* 7. trcv_dtq(NG)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SND_DTQ;
	stac[TASK3].id = DTQ4;
	stac[TASK3].data = (VP_INT)(DTQ_DATA+3);
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	err_code = trcv_dtq(DTQ4, (VP_INT *)&pdata, 10000);

	if( t_error(" 4", TASK1, err_code, C_EQ, E_OACV ))
	{
		t_success( " 4. 5. 1", "trcv_dtq(DTQ4, (VP_INT *)&pdata, 10000) in TASK1.", TASK1, err_code);

		ref_tsk_event( TASK3, 0 );
		stac[TASK3].menu = F_RCV_DTQ;
		stac[TASK3].id = DTQ4;
		err_code = act_tsk(TASK3);
		t_error(" 5", TASK1, err_code, C_EQ, E_OK );
		t_error(" 6", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
		t_error(" 7", TASK1, ref_tsk(TASK3), C_EQ, -1 );
		t_error(" 8", TASK1, (INT)stac[TASK3].pdata, C_EQ, DTQ_DATA+3 );
	}
	t_pline("");

}

void	test_4_5_2()
{

ER	err_code;
#define	DTQ_DATA	9

	t_success( " 4. 5. 2", "service-call of data-queue to accessable domain", TASK1, T_LINE);
	t_pline("");

	/* 1. snd_dtq(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SND_DTQ;
	stac[TASK3].id = DTQ4;
	stac[TASK3].data = (VP_INT)(DTQ_DATA);
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 5. 2", "snd_dtq(DTQ4, (VP_INT)DTQ_DATA) in TASK3.", TASK1, get_tsk_result(TASK3) );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	t_pline("");

	/* 2. psnd_dtq(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_PSND_DTQ;
	stac[TASK3].id = DTQ4;
	stac[TASK3].data = (VP_INT)(DTQ_DATA+1);
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 5. 2", "psnd_dtq(DTQ4, (VP_INT)DTQ_DATA+1) in TASK3.", TASK1, get_tsk_result(TASK3) );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	t_pline("");

	/* 3. tsnd_dtq(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_TSND_DTQ;
	stac[TASK3].id = DTQ4;
	stac[TASK3].data = (VP_INT)(DTQ_DATA+2);
	stac[TASK3].tmout = 10000;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 5. 2", "tsnd_dtq(DTQ4, (VP_INT)DTQ_DATA+2, 10000) in TASK3.", TASK1, get_tsk_result(TASK3) );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	t_pline("");

	/* 4. fsnd_dtq(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_FSND_DTQ;
	stac[TASK3].id = DTQ4;
	stac[TASK3].data = (VP_INT)(DTQ_DATA+3);
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 5. 2", "fsnd_dtq(DTQ4, (VP_INT)DTQ_DATA+3) in TASK3.", TASK1, get_tsk_result(TASK3) );

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	t_pline("");

	/* 5. rcv_dtq(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_RCV_DTQ;
	stac[TASK3].id = DTQ4;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 5. 2", "rcv_dtq(DTQ4, (VP_INT *)&pdata) in TASK3.", TASK1, get_tsk_result(TASK3));

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_error(" 4", TASK1, (INT)stac[TASK3].pdata, C_EQ, DTQ_DATA );

	t_pline("");


	/* 6. prcv_dtq(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_PRCV_DTQ;
	stac[TASK3].id = DTQ4;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 5. 2", "prcv_dtq(DTQ4, (VP_INT *)&pdata) in TASK3.", TASK1, get_tsk_result(TASK3));

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_error(" 4", TASK1, (INT)stac[TASK3].pdata, C_EQ, DTQ_DATA+1 );
	t_pline("");

	/* 7. trcv_dtq(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_TRCV_DTQ;
	stac[TASK3].id = DTQ4;
	stac[TASK3].tmout = 10000;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_error(" 4", TASK1, (INT)stac[TASK3].pdata, C_EQ, DTQ_DATA+2 );

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_TRCV_DTQ;
	stac[TASK3].id = DTQ4;
	stac[TASK3].tmout = TMO_FEVR;
	err_code = act_tsk(TASK3);
	t_error(" 5", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 6", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 5. 2", "trcv_dtq(DTQ4, (VP_INT *)&pdata, 10000) in TASK3.", TASK1, get_tsk_result(TASK3));

	t_error(" 7", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_error(" 8", TASK1, (INT)stac[TASK3].pdata, C_EQ, DTQ_DATA+3 );

	t_pline("");

}

void	test_4_5_3()
{
ER	err_code;
INT	pdata;
#define	DTQ_DATA	9

	t_success( " 4. 5. 3", "service-call of data-queue to shared domain", TASK1, T_LINE);
	t_pline("");

	/* 1. snd_dtq(OK)*/

	err_code = snd_dtq(DTQ9, (VP_INT)DTQ_DATA);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_OK ))
		t_success( " 4. 5. 3", "snd_dtq(DTQ9, (VP_INT)DTQ_DATA) in TASK1.", TASK1, err_code );

	t_pline("");

	/* 2. psnd_dtq(OK)*/

	err_code = psnd_dtq(DTQ9, (VP_INT)(DTQ_DATA+1));
	if( t_error(" 1", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 5. 3", "psnd_dtq(DTQ9, (VP_INT)(DTQ_DATA+1)) in TASK1.", TASK1, err_code );

	t_pline("");

	/* 3. tsnd_dtq(OK)*/

	err_code = tsnd_dtq(DTQ9, (VP_INT)(DTQ_DATA+2), 10000);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 5. 3", "tsnd_dtq(DTQ9, (VP_INT)(DTQ_DATA+2), 10000) in TASK1.", TASK1, err_code );

	t_pline("");

	/* 4. fsnd_dtq(OK)*/

	err_code = fsnd_dtq(DTQ9, (VP_INT)(DTQ_DATA+3));
	if( t_error(" 1", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 5. 3", "fsnd_dtq(DTQ9, (VP_INT)(DTQ_DATA+3)) in TASK1.", TASK1, err_code );

	t_pline("");

	/* 5. rcv_dtq(OK)*/

	err_code = rcv_dtq(DTQ9, (VP_INT *)&pdata);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 5. 3", "rcv_dtq(DTQ9, (VP_INT *)&pdata) in TASK1.", TASK1, err_code );

	t_error(" 2", TASK1, pdata, C_EQ, DTQ_DATA );
	t_pline("");

	/* 6. prcv_dtq(OK)*/

	err_code = prcv_dtq(DTQ9, (VP_INT *)&pdata);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 5. 3", "prcv_dtq(DTQ9, (VP_INT *)&pdata) in TASK1.", TASK1, err_code );

	t_error(" 2", TASK1, pdata, C_EQ, DTQ_DATA+1 );
	t_pline("");

	/* 7. trcv_dtq(OK)*/

	err_code = trcv_dtq(DTQ9, (VP_INT *)&pdata, 10000);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 5. 3", "trcv_dtq(DTQ9, (VP_INT *)&pdata, 10000) in TASK1.", TASK1, err_code );

	t_error(" 2", TASK1, pdata, C_EQ, DTQ_DATA+2 );

	err_code = trcv_dtq(DTQ9, (VP_INT *)&pdata, TMO_FEVR);
	t_error(" 3", TASK1, err_code, C_EQ, E_OK );
	t_error(" 4", TASK1, pdata, C_EQ, DTQ_DATA+3 );

	t_pline("");


	/* 8. snd_dtq(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SND_DTQ;
	stac[TASK3].id = DTQ9;
	stac[TASK3].data = (VP_INT)(DTQ_DATA);
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 5. 3", "snd_dtq(DTQ9, (VP_INT)DTQ_DATA) in TASK3.", TASK1, get_tsk_result(TASK3) );

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	t_pline("");

	/* 9. psnd_dtq(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_PSND_DTQ;
	stac[TASK3].id = DTQ9;
	stac[TASK3].data = (VP_INT)(DTQ_DATA+1);
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 5. 3", "psnd_dtq(DTQ9, (VP_INT)(DTQ_DATA+1)) in TASK3.", TASK1, get_tsk_result(TASK3) );

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	t_pline("");

	/* 10. tsnd_dtq(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_TSND_DTQ;
	stac[TASK3].id = DTQ9;
	stac[TASK3].data = (VP_INT)(DTQ_DATA+2);
	stac[TASK3].tmout = 10000;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 5. 3", "tsnd_dtq(DTQ9, (VP_INT)(DTQ_DATA+2), 10000) in TASK3.", TASK1, get_tsk_result(TASK3) );

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	t_pline("");

	/* 11. fsnd_dtq(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_FSND_DTQ;
	stac[TASK3].id = DTQ9;
	stac[TASK3].data = (VP_INT)(DTQ_DATA+3);
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 5. 3", "fsnd_dtq(DTQ9, (VP_INT)(DTQ_DATA+3)) in TASK3.", TASK1, get_tsk_result(TASK3) );

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	t_pline("");

	/* 12. rcv_dtq(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_RCV_DTQ;
	stac[TASK3].id = DTQ9;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 5. 3", "rcv_dtq(DTQ9, (VP_INT *)&pdata) in TASK3.", TASK1, get_tsk_result(TASK3) );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_error(" 4", TASK1, (INT)stac[TASK3].pdata, C_EQ, DTQ_DATA );

	t_pline("");


	/* 13. prcv_dtq(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_PRCV_DTQ;
	stac[TASK3].id = DTQ9;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 5. 3", "prcv_dtq(DTQ9, (VP_INT *)&pdata) in TASK3.", TASK1, get_tsk_result(TASK3) );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_error(" 4", TASK1, (INT)stac[TASK3].pdata, C_EQ, DTQ_DATA+1 );
	t_pline("");

	/* 14. trcv_dtq(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_TRCV_DTQ;
	stac[TASK3].id = DTQ9;
	stac[TASK3].tmout = 10000;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 5. 3", "trcv_dtq(DTQ9, (VP_INT *)&pdata, 10000) in TASK3.", TASK1, get_tsk_result(TASK3) );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_error(" 4", TASK1, (INT)stac[TASK3].pdata, C_EQ, DTQ_DATA+2 );

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_TRCV_DTQ;
	stac[TASK3].id = DTQ9;
	stac[TASK3].tmout = TMO_FEVR;
	err_code = act_tsk(TASK3);
	t_error(" 5", TASK1, err_code, C_EQ, E_OK );
	t_error(" 6", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 7", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_error(" 8", TASK1, (INT)stac[TASK3].pdata, C_EQ, DTQ_DATA+3 );

	t_pline("");

}


void	test_4_6_1()
{
ER	err_code;
INT	i;

MSG_DATA	*pmsg;

	/* init. messages for mbx */
	for( i=0; i<10; i++ )
		mdata[i].msg = i+1;

	t_success( " 4. 6. 1", "service-call of message-box to no-accessable domain", TASK1, T_LINE);
	t_pline("");

	/* 1. snd_mbx(NG)*/

	err_code = snd_mbx(MBX4, (T_MSG *)&mdata[9] );

	if( t_error(" 1", TASK1, err_code, C_EQ, E_OACV ) )
		t_success( " 4. 6. 1", "snd_mbx(MBX4, (T_MSG *)&mdata[9] ) in TASK1.", TASK1, err_code );

	t_pline("");

	/* 2. rcv_mbx(NG)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SND_MBX;
	stac[TASK3].id = MBX4;
	stac[TASK3].msg = (T_MSG *)&mdata[0];
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	err_code = rcv_mbx(MBX4, (T_MSG **)&pmsg );

	if( t_error(" 4", TASK1, err_code, C_EQ, E_OACV ) )
	{
		t_success( " 4. 6. 1", "rcv_mbx(MBX4, (T_MSG **)&pmsg ) in TASK1.", TASK1, err_code );

		ref_tsk_event( TASK3, 0 );
		stac[TASK3].menu = F_RCV_MBX;
		stac[TASK3].id = MBX4;
		err_code = act_tsk(TASK3);
		t_error(" 5", TASK1, err_code, C_EQ, E_OK );
		t_error(" 6", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
		t_error(" 7", TASK1, ref_tsk(TASK3), C_EQ, -1 );
		pmsg = (MSG_DATA *)(stac[TASK3].pmsg);
		t_error(" 8", TASK1, (INT)pmsg->msg, C_EQ, mdata[0].msg );
	}
	t_pline("");

	/* 3. prcv_mbx(NG)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SND_MBX;
	stac[TASK3].id = MBX4;
	stac[TASK3].msg = (T_MSG *)&mdata[1];
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	err_code = prcv_mbx(MBX4, (T_MSG **)&pmsg );

	if( t_error(" 4", TASK1, err_code, C_EQ, E_OACV ) )
	{

		t_success( " 4. 6. 1", "prcv_mbx(MBX4, (T_MSG **)&pmsg ) in TASK1.", TASK1, err_code );

		ref_tsk_event( TASK3, 0 );
		stac[TASK3].menu = F_RCV_MBX;
		stac[TASK3].id = MBX4;
		err_code = act_tsk(TASK3);
		t_error(" 5", TASK1, err_code, C_EQ, E_OK );
		t_error(" 6", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
		t_error(" 7", TASK1, ref_tsk(TASK3), C_EQ, -1 );
		pmsg = (MSG_DATA *)(stac[TASK3].pmsg);
		t_error(" 8", TASK1, (INT)pmsg->msg, C_EQ, mdata[1].msg );
	}

	t_pline("");

	/* 4. trcv_mbx(NG)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SND_MBX;
	stac[TASK3].id = MBX4;
	stac[TASK3].msg = (T_MSG *)&mdata[2];
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	err_code = trcv_mbx(MBX4, (T_MSG **)&pmsg, 10000 );

	if( t_error(" 4", TASK1, err_code, C_EQ, E_OACV ) )
	{

		t_success( " 4. 6. 1", "trcv_mbx(MBX4, (T_MSG **)&pmsg, 10000 ) in TASK1.", TASK1, err_code );

		ref_tsk_event( TASK3, 0 );
		stac[TASK3].menu = F_RCV_MBX;
		stac[TASK3].id = MBX4;
		err_code = act_tsk(TASK3);
		t_error(" 5", TASK1, err_code, C_EQ, E_OK );
		t_error(" 6", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
		t_error(" 7", TASK1, ref_tsk(TASK3), C_EQ, -1 );
		pmsg = (MSG_DATA *)(stac[TASK3].pmsg);
		t_error(" 8", TASK1, (INT)pmsg->msg, C_EQ, mdata[2].msg );
	}

	t_pline("");

}

void	test_4_6_2()
{
ER	err_code;
INT	i;

MSG_DATA	*pmsg;

	/* init. messages for mbx */
	for( i=0; i<10; i++ )
		mdata[i].msg = i+1;

	t_success( " 4. 6. 2", "service-call of message-box to accessable domain", TASK1, T_LINE);
	t_pline("");

	/* 1. snd_mbx(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SND_MBX;
	stac[TASK3].id = MBX4;
	stac[TASK3].msg = (T_MSG *)&mdata[0];
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 6. 2", "snd_mbx(MBX4, (T_MSG *)&mdata[0]) in TASK3.", TASK1, get_tsk_result(TASK3) );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SND_MBX;
	stac[TASK3].id = MBX4;
	stac[TASK3].msg = (T_MSG *)&mdata[1];
	err_code = act_tsk(TASK3);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );
	t_error(" 5", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 6", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SND_MBX;
	stac[TASK3].id = MBX4;
	stac[TASK3].msg = (T_MSG *)&mdata[2];
	err_code = act_tsk(TASK3);
	t_error(" 7", TASK1, err_code, C_EQ, E_OK );
	t_error(" 8", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 9", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	t_pline("");

	/* 2. rcv_mbx(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_RCV_MBX;
	stac[TASK3].id = MBX4;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 6. 2", "rcv_mbx(MBX4, (T_MSG **)&pmsg ) in TASK3.", TASK1, get_tsk_result(TASK3) );

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	pmsg = (MSG_DATA *)(stac[TASK3].pmsg);
	t_error(" 4", TASK1, (INT)pmsg->msg, C_EQ, mdata[0].msg );

	t_pline("");

	/* 3. prcv_mbx(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_PRCV_MBX;
	stac[TASK3].id = MBX4;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 6. 2", "prcv_mbx(MBX4, (T_MSG **)&pmsg ) in TASK3.", TASK1, get_tsk_result(TASK3) );

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	pmsg = (MSG_DATA *)(stac[TASK3].pmsg);
	t_error(" 4", TASK1, (INT)pmsg->msg, C_EQ, mdata[1].msg );

	t_pline("");

	/* 4. trcv_mbx(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_TRCV_MBX;
	stac[TASK3].id = MBX4;
	stac[TASK3].tmout = 10000;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 6. 2", "trcv_mbx(MBX4, (T_MSG **)&pmsg, 10000 ) in TASK3.", TASK1, get_tsk_result(TASK3) );

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	pmsg = (MSG_DATA *)(stac[TASK3].pmsg);
	t_error(" 4", TASK1, (INT)pmsg->msg, C_EQ, mdata[2].msg );

	t_pline("");
}

void	test_4_6_3()
{
ER	err_code;
INT	i;

MSG_DATA	*pmsg;

	/* init. messages for mbx */
	for( i=0; i<10; i++ )
		mdata[i].msg = i+1;

	t_success( " 4. 6. 3", "service-call of message-box to shared domain", TASK1, T_LINE);
	t_pline("");

	/* 1. snd_mbx(OK)*/

	err_code = snd_mbx(MBX9, (T_MSG *)&mdata[0] );
	if( t_error(" 1", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 6. 3", "snd_mbx(MBX9, (T_MSG *)&mdata[0]) in TASK1.", TASK1, err_code );

	err_code = snd_mbx(MBX9, (T_MSG *)&mdata[1] );
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = snd_mbx(MBX9, (T_MSG *)&mdata[2] );
	t_error(" 3", TASK1, err_code, C_EQ, E_OK );

	t_pline("");


	/* 2. rcv_mbx(OK)*/

	err_code = rcv_mbx(MBX9, (T_MSG **)&pmsg );
	if( t_error(" 1", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 6. 3", "rcv_mbx(MBX9, (T_MSG **)&pmsg) in TASK1.", TASK1, err_code );

	t_error(" 2", TASK1, (INT)pmsg->msg, C_EQ, mdata[0].msg );

	t_pline("");

	/* 3. prcv_mbx(OK)*/

	err_code = prcv_mbx(MBX9, (T_MSG **)&pmsg );
	if( t_error(" 1", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 6. 3", "prcv_mbx(MBX9, (T_MSG **)&pmsg) in TASK1.", TASK1, err_code );

	t_error(" 2", TASK1, (INT)pmsg->msg, C_EQ, mdata[1].msg );

	t_pline("");

	/* 4. trcv_mbx(OK)*/

	err_code = trcv_mbx(MBX9, (T_MSG **)&pmsg, 10000 );
	if( t_error(" 1", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 6. 3", "trcv_mbx(MBX9, (T_MSG **)&pmsg, 10000) in TASK1.", TASK1, err_code );

	t_error(" 2", TASK1, (INT)pmsg->msg, C_EQ, mdata[2].msg );

	t_pline("");


	/* 5. snd_mbx(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SND_MBX;
	stac[TASK3].id = MBX9;
	stac[TASK3].msg = (T_MSG *)&mdata[0];
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 6. 3", "snd_mbx(MBX9, (T_MSG *)&mdata[0]) in TASK3.", TASK1, get_tsk_result(TASK3) );

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SND_MBX;
	stac[TASK3].id = MBX9;
	stac[TASK3].msg = (T_MSG *)&mdata[1];
	err_code = act_tsk(TASK3);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );
	t_error(" 5", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 6", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SND_MBX;
	stac[TASK3].id = MBX9;
	stac[TASK3].msg = (T_MSG *)&mdata[2];
	err_code = act_tsk(TASK3);
	t_error(" 7", TASK1, err_code, C_EQ, E_OK );
	t_error(" 8", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 9", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	t_pline("");

	/* 6. rcv_mbx(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_RCV_MBX;
	stac[TASK3].id = MBX9;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 6. 3", "rcv_mbx(MBX9, (T_MSG **)&pmsg) in TASK3.", TASK1, get_tsk_result(TASK3) );

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	pmsg = (MSG_DATA *)(stac[TASK3].pmsg);
	t_error(" 4", TASK1, (INT)pmsg->msg, C_EQ, mdata[0].msg );

	t_pline("");

	/* 7. prcv_mbx(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_PRCV_MBX;
	stac[TASK3].id = MBX9;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 6. 3", "prcv_mbx(MBX9, (T_MSG **)&pmsg) in TASK3.", TASK1, get_tsk_result(TASK3) );

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	pmsg = (MSG_DATA *)(stac[TASK3].pmsg);
	t_error(" 4", TASK1, (INT)pmsg->msg, C_EQ, mdata[1].msg );

	t_pline("");

	/* 8. trcv_mbx(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_TRCV_MBX;
	stac[TASK3].id = MBX9;
	stac[TASK3].tmout = 10000;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 6. 3", "trcv_mbx(MBX9, (T_MSG **)&pmsg, 10000) in TASK3.", TASK1, get_tsk_result(TASK3) );

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	pmsg = (MSG_DATA *)(stac[TASK3].pmsg);
	t_error(" 4", TASK1, (INT)pmsg->msg, C_EQ, mdata[2].msg );

	t_pline("");

}

void	test_4_7_1()
{
ER	err_code;
VP	blk;

	t_success( " 4. 7. 1", "service-call of memory-pool to no-accessable domain", TASK1, T_LINE);
	t_pline("");

	/* 1. get_mpf(NG)*/

	err_code = get_mpf(MPF4, &blk );

	if( t_error(" 1", TASK1, err_code, C_EQ, E_OACV ) )
		t_success( " 4. 7. 1", "get_mpf(MPF4, &blk ) in TASK1.", TASK1, err_code );

	t_pline("");

	/* 2. pget_mpf(NG)*/

	err_code = pget_mpf(MPF4, &blk );

	if( t_error(" 1", TASK1, err_code, C_EQ, E_OACV ) )
		t_success( " 4. 7. 1", "pget_mpf(MPF4, &blk ) in TASK1.", TASK1, err_code );

	t_pline("");

	/* 3. tget_mpf(NG)*/

	err_code = tget_mpf(MPF4, &blk, 10000 );

	if( t_error(" 1", TASK1, err_code, C_EQ, E_OACV ) )
		t_success( " 4. 7. 1", "tget_mpf(MPF4, &blk, 10000) in TASK1.", TASK1, err_code );

	t_pline("");


	/* 4. rel_mpf(NG)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_GET_MPF;
	stac[TASK3].id = MPF4;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	blk = stac[TASK3].blk;

	err_code = rel_mpf(MPF4, blk );

	if(t_error(" 4", TASK1, err_code, C_EQ, E_OACV ))
	{
		t_success( " 4. 7. 1", "rel_mpf(MPF4, blk ) in TASK1.", TASK1, err_code );

		ref_tsk_event( TASK3, 0 );
		stac[TASK3].menu = F_REL_MPF;
		stac[TASK3].id = MPF4;
		stac[TASK3].blk = blk;
		err_code = act_tsk(TASK3);
		t_error(" 5", TASK1, err_code, C_EQ, E_OK );
		t_error(" 6", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
		t_error(" 7", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	}
	t_pline("");

}

void	test_4_7_2()
{
ER	err_code;
VP	blk1;
VP	blk2;
VP	blk3;

	t_success( " 4. 7. 2", "service-call of memory-pool to accessable domain", TASK1, T_LINE);
	t_pline("");

	/* 1. get_mpf(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_GET_MPF;
	stac[TASK3].id = MPF4;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 7. 2", "get_mpf(MPF4, &blk ) in TASK3.", TASK1, get_tsk_result(TASK3) );

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	blk1 = stac[TASK3].blk;

	t_pline("");

	/* 2. pget_mpf(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_PGET_MPF;
	stac[TASK3].id = MPF4;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );

	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 7. 2", "pget_mpf(MPF4, &blk ) in TASK3.", TASK1, get_tsk_result(TASK3) );

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	blk2 = stac[TASK3].blk;

	t_pline("");

	/* 3. tget_mpf(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_TGET_MPF;
	stac[TASK3].id = MPF4;
	stac[TASK3].tmout = 10000;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 7. 2", "tget_mpf(MPF4, &blk, 10000 ) in TASK3.", TASK1, get_tsk_result(TASK3) );

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	blk3 = stac[TASK3].blk;

	t_pline("");


	/* 4. rel_mpf(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_REL_MPF;
	stac[TASK3].id = MPF4;
	stac[TASK3].blk = blk1;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 7. 2", "rel_mpf(MPF4, blk1 ) in TASK3.", TASK1, get_tsk_result(TASK3) );

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_REL_MPF;
	stac[TASK3].id = MPF4;
	stac[TASK3].blk = blk2;
	err_code = act_tsk(TASK3);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );
	t_error(" 5", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 6", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_REL_MPF;
	stac[TASK3].id = MPF4;
	stac[TASK3].blk = blk3;
	err_code = act_tsk(TASK3);
	t_error(" 7", TASK1, err_code, C_EQ, E_OK );
	t_error(" 8", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 9", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	t_pline("");
}

void	test_4_7_3()
{
ER	err_code;
VP	blk1;
VP	blk2;
VP	blk3;

	t_success( " 4. 7. 3", "service-call of memory-pool to shared domain", TASK1, T_LINE);
	t_pline("");

	/* 1. get_mpf(OK)*/

	err_code = get_mpf(MPF9, &blk1 );

	if( t_error(" 1", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 7. 3", "get_mpf(MPF9, &blk1 ) in TASK1.", TASK1, err_code );

	t_pline("");

	/* 2. pget_mpf(NG)*/

	err_code = pget_mpf(MPF9, &blk2 );

	if( t_error(" 1", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 7. 3", "pget_mpf(MPF9, &blk2 ) in TASK1.", TASK1, err_code );

	t_pline("");

	/* 3. tget_mpf(OK)*/

	err_code = tget_mpf(MPF9, &blk3, 10000 );

	if( t_error(" 1", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 7. 3", "tget_mpf(MPF9, &blk3, 10000 ) in TASK1.", TASK1, err_code );

	t_pline("");


	/* 4. rel_mpf(OK)*/

	err_code = rel_mpf(MPF9, blk1 );
	if( t_error(" 1", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 4. 7. 3", "rel_mpf(MPF9, blk1 ) in TASK1.", TASK1, err_code );

	err_code = rel_mpf(MPF9, blk2 );
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = rel_mpf(MPF9, blk3 );
	t_error(" 3", TASK1, err_code, C_EQ, E_OK );

	t_pline("");


	/* 5. get_mpf(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_GET_MPF;
	stac[TASK3].id = MPF9;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 7. 3", "get_mpf(MPF9, &blk ) in TASK3.", TASK1, get_tsk_result(TASK3) );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	blk1 = stac[TASK3].blk;

	t_pline("");

	/* 6. pget_mpf(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_PGET_MPF;
	stac[TASK3].id = MPF9;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 7. 3", "pget_mpf(MPF9, &blk ) in TASK3.", TASK1, get_tsk_result(TASK3) );

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	blk2 = stac[TASK3].blk;

	t_pline("");

	/* 7. tget_mpf(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_TGET_MPF;
	stac[TASK3].id = MPF9;
	stac[TASK3].tmout = 10000;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 7. 3", "tget_mpf(MPF9, &blk, 10000 ) in TASK3.", TASK1, get_tsk_result(TASK3) );

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	blk3 = stac[TASK3].blk;

	t_pline("");


	/* 8. rel_mpf(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_REL_MPF;
	stac[TASK3].id = MPF9;
	stac[TASK3].blk = blk1;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 2", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 4. 7. 3", "rel_mpf(MPF9, blk1 ) in TASK3.", TASK1, get_tsk_result(TASK3) );

	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_REL_MPF;
	stac[TASK3].id = MPF9;
	stac[TASK3].blk = blk2;
	err_code = act_tsk(TASK3);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );
	t_error(" 5", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 6", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_REL_MPF;
	stac[TASK3].id = MPF9;
	stac[TASK3].blk = blk3;
	err_code = act_tsk(TASK3);
	t_error(" 7", TASK1, err_code, C_EQ, E_OK );
	t_error(" 8", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 9", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	t_pline("");

}


void	test_4_8_1()
{
ER	err_code;

	t_success( " 4. 8. 1", "service-call sta_cyc to no-accessable domain", TASK1, T_LINE);
	t_pline("");

	err_code = sta_cyc( CYC4 );

	if( t_error(" 1", TASK1, err_code, C_EQ, E_OACV ) )
		t_success( " 4. 8. 1", "sta_cyc(CYC4) in TASK1.", TASK1, err_code );

	t_pline("");
}


void	test_5_1_1()
{
ER	err_code;

	t_success( " 5. 1. 1", "parameter of no-accessable domain's memory (read)", TASK1, T_LINE);
	t_pline("");

	/* 1. set_tim(NG)*/

	err_code = set_tim((SYSTIM *)DOM3_ADDR_RW);

	if( t_error(" 1", TASK1, err_code, C_EQ, E_MACV ) )			/*	02/02/18	xbx		*/
		t_success( " 5. 1. 1", "set_tim((SYSTIM *)DOM3_ADDR_RW) in TASK1.", TASK1, err_code );

	err_code = set_tim((SYSTIM *)KNL_ADDR_RW);

	if( t_error(" 2", TASK1, err_code, C_EQ, E_MACV ) )			/*	02/02/18	xbx		*/
		t_success( " 5. 1. 1", "set_tim((SYSTIM *)KNL_ADDR_RW) in TASK1.", TASK1, err_code );
	t_pline("");

																/*	02/02/18	xbx		*/
	/* 2. snd_mbx(NG)*/

	err_code = snd_mbx(MBX9, (T_MSG *)DOM3_ADDR_RW );

	if( t_error(" 1", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 5. 1. 1", "snd_mbx(MBX9, (T_MSG *)DOM3_ADDR_RW ) in TASK1.", TASK1, err_code );

	err_code = snd_mbx(MBX9, (T_MSG *)KNL_ADDR_RW );

	if( t_error(" 2", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 5. 1. 1", "snd_mbx(MBX9, (T_MSG *)KNL_ADDR_RW ) in TASK1.", TASK1, err_code );

	t_pline("");

}


void	test_5_2_1()
{
ER	err_code;
INT	pdata;

	B	tmp[MEM_SIZE];

	t_success( " 5. 2. 1", "parameter of no-accessable domain's memory (write)", TASK1, T_LINE);
	t_pline("");

	/* 1. get_pri(NG)*/

	err_code = get_pri( TSK_SELF, (PRI *)DOM3_ADDR_RW );

	if( t_error(" 1", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 5. 2. 1", "get_pri( TSK_SELF, (PRI *)DOM3_ADDR_RW ) in TASK1.", TASK1, err_code );

	err_code = get_pri( TSK_SELF, (PRI *)KNL_ADDR_RW );

	if( t_error(" 2", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 5. 2. 1", "get_pri( TSK_SELF, (PRI *)KNL_ADDR_RW ) in TASK1.", TASK1, err_code );


	t_pline("");

	/* 2. wai_flg(NG)*/

	err_code = set_flg(FLG9, 0x0001);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );

	err_code = wai_flg( FLG9, 0xffff, TWF_ORW, (FLGPTN *)DOM3_ADDR_RW );

	if( t_error(" 2", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 5. 2. 1", "wai_flg( FLG9, 0xffff, TWF_ORW, (FLGPTN *)DOM3_ADDR_RW ) in TASK1.", TASK1, err_code );


	err_code = wai_flg( FLG9, 0xffff, TWF_ORW, (FLGPTN *)KNL_ADDR_RW );

	if( t_error(" 3", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 5. 2. 1", "wai_flg( FLG9, 0xffff, TWF_ORW, (FLGPTN *)KNL_ADDR_RW ) in TASK1.", TASK1, err_code );

	err_code = clr_flg(FLG9, 0x0000);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );

	t_pline("");


	/* 3. pol_flg(NG)*/
				/*	02/02/18	Add	*/

	err_code = set_flg(FLG9, 0x0001);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );

	err_code = pol_flg( FLG9, 0xffff, TWF_ORW, (FLGPTN *)DOM3_ADDR_RW );

	if( t_error(" 2", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 5. 2. 1", "pol_flg( FLG9, 0xffff, TWF_ORW, (FLGPTN *)DOM3_ADDR_RW ) in TASK1.", TASK1, err_code );


	err_code = pol_flg( FLG9, 0xffff, TWF_ORW, (FLGPTN *)KNL_ADDR_RW );

	if( t_error(" 3", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 5. 2. 1", "pol_flg( FLG9, 0xffff, TWF_ORW, (FLGPTN *)KNL_ADDR_RW ) in TASK1.", TASK1, err_code );

	err_code = clr_flg(FLG9, 0x0000);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );

	t_pline("");


	/* 4. twai_flg(NG)*/
				/*	02/02/18	Add	*/

	err_code = set_flg(FLG9, 0x0001);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );

	err_code = twai_flg( FLG9, 0xffff, TWF_ORW, (FLGPTN *)DOM3_ADDR_RW, TMO_FEVR );

	if( t_error(" 2", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 5. 2. 1", "twai_flg( FLG9, 0xffff, TWF_ORW, (FLGPTN *)DOM3_ADDR_RW, TMO_FEVR ) in TASK1.",
				 TASK1, err_code );


	err_code = twai_flg( FLG9, 0xffff, TWF_ORW, (FLGPTN *)KNL_ADDR_RW, TMO_FEVR );

	if( t_error(" 3", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 5. 2. 1", "twai_flg( FLG9, 0xffff, TWF_ORW, (FLGPTN *)KNL_ADDR_RW, TMO_FEVR ) in TASK1.",
				 TASK1, err_code );

	err_code = clr_flg(FLG9, 0x0000);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );

	t_pline("");


	/* 5. rcv_dtq(NG)*/
				/*	02/02/18	Add	*/

	err_code = snd_dtq(DTQ9, (VP_INT) 0);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );

	err_code = rcv_dtq(DTQ9, (VP_INT *)DOM3_ADDR_RW );
	if( t_error(" 2", TASK1, err_code, C_EQ, E_MACV ) )
	{
		t_success( " 5. 2. 1", "rcv_dtq(DTQ9, (VP_INT *)DOM3_ADDR_RW ) in TASK1.", TASK1, err_code );
	}
	else
	{
		err_code = snd_dtq(DTQ9, (VP_INT) 0);
		t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	}

	err_code = rcv_dtq(DTQ9, (VP_INT *)KNL_ADDR_RW );
	if( t_error(" 3", TASK1, err_code, C_EQ, E_MACV ) )
	{
		t_success( " 5. 2. 1", "rcv_dtq(DTQ9, (VP_INT *)KNL_ADDR_RW ) in TASK1.", TASK1, err_code );
	}
	else
	{
		err_code = snd_dtq(DTQ9, (VP_INT) 0);
		t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	}


	err_code = rcv_dtq(DTQ9, (VP_INT *) &pdata );
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );

	t_pline("");


	/* 6. prcv_dtq(NG)*/
				/*	02/02/18	Add	*/

	err_code = snd_dtq(DTQ9, (VP_INT) 0);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );

	err_code = prcv_dtq(DTQ9, (VP_INT *)DOM3_ADDR_RW );
	if( t_error(" 2", TASK1, err_code, C_EQ, E_MACV ) )
	{
		t_success( " 5. 2. 1", "prcv_dtq(DTQ9, (VP_INT *)DOM3_ADDR_RW ) in TASK1.", TASK1, err_code );
	}
	else
	{
		err_code = snd_dtq(DTQ9, (VP_INT) 0);
		t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	}

	err_code = prcv_dtq(DTQ9, (VP_INT *)KNL_ADDR_RW );
	if( t_error(" 3", TASK1, err_code, C_EQ, E_MACV ) )
	{
		t_success( " 5. 2. 1", "prcv_dtq(DTQ9, (VP_INT *)KNL_ADDR_RW ) in TASK1.", TASK1, err_code );
	}
	else
	{
		err_code = snd_dtq(DTQ9, (VP_INT) 0);
		t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	}

	err_code = rcv_dtq(DTQ9, (VP_INT *) &pdata );
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );

	t_pline("");


	/* 7. trcv_dtq(NG)*/
				/*	02/02/18	Add	*/

	err_code = snd_dtq(DTQ9, (VP_INT) 0);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );

	err_code = trcv_dtq(DTQ9, (VP_INT *)DOM3_ADDR_RW, TMO_FEVR );
	if( t_error(" 2", TASK1, err_code, C_EQ, E_MACV ) )
	{
		t_success( " 5. 2. 1", "trcv_dtq(DTQ9, (VP_INT *)DOM3_ADDR_RW, TMO_FEVR ) in TASK1.", TASK1, err_code );
	}
	else
	{
		err_code = snd_dtq(DTQ9, (VP_INT) 0);
		t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	}

	err_code = trcv_dtq(DTQ9, (VP_INT *)KNL_ADDR_RW, TMO_FEVR );
	if( t_error(" 3", TASK1, err_code, C_EQ, E_MACV ) )
	{
		t_success( " 5. 2. 1", "trcv_dtq(DTQ9, (VP_INT *)KNL_ADDR_RW, TMO_FEVR ) in TASK1.", TASK1, err_code );
	}
	else
	{
		err_code = snd_dtq(DTQ9, (VP_INT) 0);
		t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	}

	err_code = rcv_dtq(DTQ9, (VP_INT *) &pdata );
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

	/* 8. rcv_mbx(NG)*/

	err_code = snd_mbx(MBX9, (T_MSG *)&(mdata[0].h) );
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );

	err_code = rcv_mbx( MBX9, (T_MSG **)DOM3_ADDR_RW );

	if(t_error(" 2", TASK1, err_code, C_EQ, E_MACV ) )
	{
		t_success( " 5. 2. 1", "rcv_mbx( MBX9, (T_MSG **)DOM3_ADDR_RW ) in TASK1.", TASK1, err_code );

		err_code = rcv_mbx( MBX9, (T_MSG **)&tmp);
		t_error(" 3", TASK1, err_code, C_EQ, E_OK );
	}


	err_code = snd_mbx(MBX9, (T_MSG *)&(mdata[0].h) );
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );

	err_code = rcv_mbx( MBX9, (T_MSG **)KNL_ADDR_RW );

	if(t_error(" 5", TASK1, err_code, C_EQ, E_MACV ) )
	{
		t_success( " 5. 2. 1", "rcv_mbx( MBX9, (T_MSG **)KNL_ADDR_RW ) in TASK1.", TASK1, err_code );
		err_code = rcv_mbx( MBX9, (T_MSG **)&tmp);
		t_error(" 6", TASK1, err_code, C_EQ, E_OK );
	}

	t_pline("");

	/* 9. prcv_mbx(NG)*/

	err_code = snd_mbx(MBX9, (T_MSG *)&(mdata[0].h) );
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );

	err_code = prcv_mbx( MBX9, (T_MSG **)DOM3_ADDR_RW );

	if(t_error(" 2", TASK1, err_code, C_EQ, E_MACV ) )
	{
		t_success( " 5. 2. 1", "prcv_mbx( MBX9, (T_MSG **)DOM3_ADDR_RW ) in TASK1.", TASK1, err_code );
		err_code = rcv_mbx( MBX9, (T_MSG **)&tmp);
		t_error(" 3", TASK1, err_code, C_EQ, E_OK );
	}


	err_code = snd_mbx(MBX9, (T_MSG *)&(mdata[0].h) );
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );

	err_code = prcv_mbx( MBX9, (T_MSG **)KNL_ADDR_RW );

	if(t_error(" 5", TASK1, err_code, C_EQ, E_MACV ) )
	{
		t_success( " 5. 2. 1", "prcv_mbx( MBX9, (T_MSG **)KNL_ADDR_RW ) in TASK1.", TASK1, err_code );
		err_code = rcv_mbx( MBX9, (T_MSG **)&tmp);
		t_error(" 6", TASK1, err_code, C_EQ, E_OK );
	}

	t_pline("");

	/* 10. trcv_mbx(NG)*/

	err_code = snd_mbx(MBX9, (T_MSG *)&(mdata[0].h) );
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );

	err_code = trcv_mbx( MBX9, (T_MSG **)DOM3_ADDR_RW, 10000 );

	if(t_error(" 2", TASK1, err_code, C_EQ, E_MACV ) )
	{
		t_success( " 5. 2. 1", "trcv_mbx( MBX9, (T_MSG **)DOM3_ADDR_RW, 10000 ) in TASK1.", TASK1, err_code );
		err_code = rcv_mbx( MBX9, (T_MSG **)&tmp);
		t_error(" 3", TASK1, err_code, C_EQ, E_OK );
	}

	err_code = snd_mbx(MBX9, (T_MSG *)&(mdata[0].h) );
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );

	err_code = trcv_mbx( MBX9, (T_MSG **)KNL_ADDR_RW, 10000 );

	if(t_error(" 5", TASK1, err_code, C_EQ, E_MACV ) )
	{
		t_success( " 5. 2. 1", "trcv_mbx( MBX9, (T_MSG **)KNL_ADDR_RW, 10000 ) in TASK1.", TASK1, err_code );
		err_code = rcv_mbx( MBX9, (T_MSG **)&tmp);
		t_error(" 6", TASK1, err_code, C_EQ, E_OK );
	}

	t_pline("");

	/* 11. get_mpf(NG)*/

	err_code = get_mpf( MPF9, (VP *)DOM3_ADDR_RW );

	if( t_error(" 1", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 5. 2. 1", "get_mpf( MPF9, (VP *)DOM3_ADDR_RW ) in TASK1.", TASK1, err_code );


	err_code = get_mpf( MPF9, (VP *)KNL_ADDR_RW );

	if( t_error(" 2", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 5. 2. 1", "get_mpf( MPF9, (VP *)KNL_ADDR_RW ) in TASK1.", TASK1, err_code );

	t_pline("");

	/* 12. pget_mpf(NG)*/

	err_code = pget_mpf( MPF9, (VP *)DOM3_ADDR_RW );

	if( t_error(" 1", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 5. 2. 1", "pget_mpf( MPF9, (VP *)DOM3_ADDR_RW ) in TASK1.", TASK1, err_code );

	err_code = pget_mpf( MPF9, (VP *)KNL_ADDR_RW );

	if( t_error(" 2", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 5. 2. 1", "pget_mpf( MPF9, (VP *)KNL_ADDR_RW ) in TASK1.", TASK1, err_code );

	t_pline("");

	/* 13. tget_mpf(NG)*/

	err_code = tget_mpf( MPF9, (VP *)DOM3_ADDR_RW, 10000 );

	if( t_error(" 1", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 5. 2. 1", "tget_mpf( MPF9, (VP *)DOM3_ADDR_RW, 10000 ) in TASK1.", TASK1, err_code );

	err_code = tget_mpf( MPF9, (VP *)KNL_ADDR_RW, 10000 );

	if( t_error(" 2", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 5. 2. 1", "tget_mpf( MPF9, (VP *)KNL_ADDR_RW, 10000 ) in TASK1.", TASK1, err_code );

	t_pline("");

	/* 14. get_tim(NG)*/

	err_code = get_tim( (SYSTIM *)DOM3_ADDR_RW );

	if( t_error(" 1", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 5. 2. 1", "get_tim( (SYSTIM *)DOM3_ADDR_RW ) in TASK1.", TASK1, err_code );

	err_code = get_tim( (SYSTIM *)KNL_ADDR_RW );

	if( t_error(" 2", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 5. 2. 1", "get_tim( (SYSTIM *)KNL_ADDR_RW ) in TASK1.", TASK1, err_code );

	t_pline("");


	/* 15. get_tid(NG)*/

	err_code = get_tid( (ID *)DOM3_ADDR_RW );

	if( t_error(" 1", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 5. 2. 1", "get_tid( (ID *)DOM3_ADDR_RW ) in TASK1.", TASK1, err_code );

	err_code = get_tid( (ID *)KNL_ADDR_RW );

	if( t_error(" 2", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 5. 2. 1", "get_tid( (ID *)KNL_ADDR_RW ) in TASK1.", TASK1, err_code );

	t_pline("");


}

#if 0
void	test_6_1_1()
{
ER	err_code;
UINT	size = 16;
VP	blk;

	t_success( " 6. 1. 1", "check the right of ownership for a memory pool", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = probe_memory(blk, size, TDOM_SELF, TSK_SELF, TPM_READ);
				/*	02/02/18	Mod	*/
	if( t_error(" 2", TASK1, err_code, C_LE, E_OK ) )
		t_success( " 6. 1. 1", "vprb_mem(blk, size, TDOM_SELF, TSK_SELF, TPM_READ) in TASK1 before sending.", TASK1, err_code );

	err_code = probe_memory(blk, size, TDOM_SELF, TSK_SELF, TPM_WRITE);
				/*	02/02/18	Mod	*/
	if( t_error(" 3", TASK1, err_code, C_LE, E_OK ) )
		t_success( " 6. 1. 1", "vprb_mem(blk, size, TDOM_SELF, TSK_SELF, TPM_WRITE) in TASK1 before sending.", TASK1, err_code );

	err_code = probe_memory(blk, size, TDOM_SELF, TSK_SELF, TPM_READ|TPM_WRITE);
				/*	02/02/18	Mod	*/
	if( t_error(" 4", TASK1, err_code, C_LE, E_OK ) )
		t_success( " 6. 1. 1", "vprb_mem(blk, size, TDOM_SELF, TSK_SELF, TPM_READ|TPM_WRITE) in TASK1 before sending.", TASK1, err_code );


	err_code = snd_mbp(MBP1, blk, 1);
	t_error(" 5", TASK1, err_code, C_EQ, E_OK );

	err_code = probe_memory(blk, size, TDOM_SELF, TSK_SELF, TPM_READ);
				/*	02/02/18	Mod	*/
	if( t_error(" 6", TASK1, err_code, C_LE, E_OK ) )
		t_success( " 6. 1. 1", "vprb_mem(blk, size, TDOM_SELF, TSK_SELF, TPM_READ) in TASK1 after sending.", TASK1, err_code );

	err_code = probe_memory(blk, size, TDOM_SELF, TSK_SELF, TPM_WRITE);
				/*	02/02/18	Mod	*/
	if( t_error(" 7", TASK1, err_code, C_LE, E_OK ) )
		t_success( " 6. 1. 1", "vprb_mem(blk, size, TDOM_SELF, TSK_SELF, TPM_WRITE) in TASK1 after sending.", TASK1, err_code );

	err_code = probe_memory(blk, size, TDOM_SELF, TSK_SELF, TPM_READ|TPM_WRITE);
				/*	02/02/18	Mod	*/
	if( t_error(" 8", TASK1, err_code, C_LE, E_OK ) )
		t_success( " 6. 1. 1", "vprb_mem(blk, size, TDOM_SELF, TSK_SELF, TPM_READ|TPM_WRITE) in TASK1 after sending.",
						TASK1, err_code );

	err_code = rcv_mbp(MBP1, &blk);
	t_error(" 9", TASK1, err_code, C_GE, E_OK );

	err_code = rel_mpp(MPP1, blk);					/*	02/02/18	xbx		*/
	t_error("10", TASK1, err_code, C_EQ, E_OK );

	t_pline("");


}

void	test_6_3_1()
{
ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 6. 3. 1", "service-call snd_mbp with ID(-1)", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(-1, blk1, 1);
	if( t_error(" 2", TASK1, err_code, C_EQ, E_ID ) )
		t_success( " 6. 3. 1", "snd_mbp(-1, blk1, 1) in TASK1.", TASK1, err_code);

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 3", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}

void	test_6_3_2()
{
ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 6. 3. 2", "service-call snd_mbp with ID(100)", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(100, blk1, 1);
	if( t_error(" 2", TASK1, err_code, C_EQ, E_ID ) )
		t_success( " 6. 3. 2", "snd_mbp(100, blk1, 1) in TASK1.", TASK1, err_code);

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 3", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}

void	test_6_3_3()
{
ER	err_code;
B	dummy;

	t_success( " 6. 3. 3", "service-call snd_mbp with illegal memory block", TASK1, T_LINE);
	t_pline("");

	err_code = snd_mbp(MBP1, (VP)((UINT)&dummy & 0xFFFFF000), 1);		/*	Mod	02/02/20	*/
//	if( t_error(" 1", TASK1, err_code, C_EQ, E_ILUSE ) )
	if( t_error(" 1", TASK1, err_code, C_EQ, E_PAR ) )
					/*	02/02/18	Mod	*/
		t_success( " 6. 3. 3", "snd_mbp(MBP1, &dummy, 1) in TASK1. &dummy is a stack address.", TASK1, err_code);

	t_pline("");

}

void	test_6_3_4()
{
ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 6. 3. 4", "service-call snd_mbp with a sent memory block", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP1, blk1, 1);
	if( t_error(" 2", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 6. 3. 4", "snd_mbp(MBP1, blk1, 1) at 1st in TASK1.", TASK1, err_code);

	err_code = snd_mbp(MBP1, blk1, 1);
	if( t_error(" 3", TASK1, err_code, C_EQ, E_ILUSE ) )
				/*	02/02/18	Mod	*/
		t_success( " 6. 3. 4", "snd_mbp(MBP1, blk1, 1) to the 2nd in TASK1.", TASK1, err_code);

	err_code = rcv_mbp(MBP1, &blk1);
	t_error(" 4", TASK1, err_code, C_GE, E_OK );

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 5", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}


void	test_6_3_5()
{
ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 6. 3. 5", "check a sent memory block", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP1, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = probe_memory(blk1, size, TDOM_SELF, TSK_SELF, TPM_READ);
				/*	02/02/18	Mod	*/
	if( t_error(" 3", TASK1, err_code, C_LE, E_OK ) )
		t_success( " 6. 3. 5", "vprb_mem(blk1, size, TDOM_SELF, TSK_SELF, TPM_READ) in TASK1. blk1 was sent to MBP1.", 
				TASK1, err_code);

	err_code = probe_memory(blk1, size, TDOM_SELF, TSK_SELF, TPM_WRITE);
				/*	02/02/18	Mod	*/
	if( t_error(" 4", TASK1, err_code, C_LE, E_OK ) )
		t_success( " 6. 3. 5", "vprb_mem(blk1, size, TDOM_SELF, TSK_SELF, TPM_WRITE) in TASK1. blk1 was sent to MBP1.", 
				TASK1, err_code);

	err_code = probe_memory(blk1, size, TDOM_SELF, TSK_SELF, TPM_READ|TPM_WRITE);
				/*	02/02/18	Mod	*/
	if( t_error(" 5", TASK1, err_code, C_LE, E_OK ) )
		t_success( " 6. 3. 5", "vprb_mem(blk1, size, TDOM_SELF, TSK_SELF, TPM_READ|TPM_WRITE) in TASK1. blk1 was sent to MBP1.", TASK1, err_code);

	err_code = rcv_mbp(MBP1, &blk1);
	t_error(" 6", TASK1, err_code, C_GE, E_OK );

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 7", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}


void	test_6_5_1()
{
ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 6. 5. 1", "service-call rcv_mbp with ID(-1)", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP1, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = rcv_mbp(-1, &blk1);
	if( t_error(" 3", TASK1, err_code, C_EQ, E_ID ) )
		t_success( " 6. 5. 1", "rcv_mbp(-1, &blk1) in TASK1.", TASK1, err_code);

	err_code = rcv_mbp(MBP1, &blk1);
	t_error(" 4", TASK1, err_code, C_GE, E_OK );

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 5", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}


void	test_6_5_2()
{
ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 6. 5. 2", "service-call rcv_mbp with ID(100)", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP1, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = rcv_mbp(100, &blk1);
	if( t_error(" 3", TASK1, err_code, C_EQ, E_ID ) )
		t_success( " 6. 5. 2", "rcv_mbp(100, &blk1) in TASK1.", TASK1, err_code);

	err_code = rcv_mbp(MBP1, &blk1);
	t_error(" 4", TASK1, err_code, C_GE, E_OK );

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 5", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}


void	test_6_5_3()
{
ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 6. 5. 3", "service-call rcv_mbp with no-accessable domain's memory", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP1, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = rcv_mbp(MBP1, (VP)DOM3_ADDR_RW);
	if( t_error(" 3", TASK1, err_code, C_EQ, E_MACV ) )
				/*	02/02/18	Mod	*/
		t_success( " 6. 5. 3", "rcv_mbp(MBP1, (VP)DOM3_ADDR_RW) in TASK1.", TASK1, err_code);

	err_code = rcv_mbp(MBP1, &blk1);
	t_error(" 4", TASK1, err_code, C_GE, E_OK );

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 5", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}


void	test_6_5_4()
{
ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 6. 5. 4", "service-call rcv_mbp/vprb_mem with accessable domain's memory block", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP1, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = rcv_mbp(MBP1, &blk1);
	t_error(" 3", TASK1, err_code, C_GE, E_OK );

	err_code = probe_memory(blk1, size, TDOM_SELF, TSK_SELF, TPM_READ);
				/*	02/02/18	Mod	*/
	if( t_error(" 4", TASK1, err_code, C_LE, E_OK ) )
		t_success( " 6. 5. 4", "vprb_mem(blk1, size, TDOM_SELF, TSK_SELF, TPM_READ) in TASK1. blk1 is a block of MPP1.", TASK1, err_code);

	err_code = probe_memory(blk1, size, TDOM_SELF, TSK_SELF, TPM_WRITE);
				/*	02/02/18	Mod	*/
	if( t_error(" 5", TASK1, err_code, C_LE, E_OK ) )
		t_success( " 6. 5. 4", "vprb_mem(blk1, size, TDOM_SELF, TSK_SELF, TPM_WRITE) in TASK1. blk1 is a block of MPP1.", TASK1, err_code);

	err_code = probe_memory(blk1, size, TDOM_SELF, TSK_SELF, TPM_READ|TPM_WRITE);
				/*	02/02/18	Mod	*/
	if( t_error(" 6", TASK1, err_code, C_LE, E_OK ) )
		t_success( " 6. 5. 4", "vprb_mem(blk1, size, TDOM_SELF, TSK_SELF, TPM_READ|TPM_WRITE) in TASK1. blk1 is a block of MPP1.", TASK1, err_code);

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 7", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}


void	test_6_5_5()
{
ER	err_code;
UINT	size = 16;
VP	blk1;
INT	i;
B	dummy;
B	*p;

	t_success( " 6. 5. 5", "read memory for accessable domain's memory block", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP1, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = rcv_mbp(MBP1, &blk1);
	t_error(" 3", TASK1, err_code, C_GE, E_OK );

	p = (B *)blk1;
	for(i=0; i<size; i++)
		dummy = *(p+i);

	t_success( " 6. 5. 5", "dummy = *(p+0..15)", TASK1, T_SUCCESS);

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}

void	test_6_5_6()
{
ER	err_code;
UINT	size = 16;
VP	blk1;
INT	i;
B	*p;

	t_success( " 6. 5. 6", "write memory for accessable domain's memory block", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP1, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = rcv_mbp(MBP1, &blk1);
	t_error(" 3", TASK1, err_code, C_GE, E_OK );

	p = (B *)blk1;
	for(i=0; i<size; i++)
		*(p+i) = (B)0xaa;

	t_success( " 6. 5. 6", "*(p+0..15) = (B)0xaa", TASK1, T_SUCCESS);

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}


void	test_6_6_1()
{
ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 6. 6. 1", "service-call prcv_mbp with ID(-1)", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP1, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = prcv_mbp(-1, &blk1);
	if( t_error(" 3", TASK1, err_code, C_EQ, E_ID ) )
		t_success( " 6. 6. 1", "prcv_mbp(-1, &blk1) in TASK1.", TASK1, err_code);

	err_code = rcv_mbp(MBP1, &blk1);
	t_error(" 4", TASK1, err_code, C_GE, E_OK );

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 5", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}

void	test_6_6_2()
{
ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 6. 6. 2", "service-call prcv_mbp with ID(100)", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP1, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = prcv_mbp(100, &blk1);
	if( t_error(" 3", TASK1, err_code, C_GE, E_ID ) )
		t_success( " 6. 6. 2", "prcv_mbp(100, &blk1) in TASK1.", TASK1, err_code);

	err_code = rcv_mbp(MBP1, &blk1);
	t_error(" 4", TASK1, err_code, C_GE, E_OK );

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 5", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}


void	test_6_6_3()
{
ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 6. 6. 3", "service-call prcv_mbp with no-accessable domain's memory", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP1, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = prcv_mbp(MBP1, (VP)DOM3_ADDR_RW);
	if( t_error(" 3", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 6. 6. 3", "prcv_mbp(MBP1, (VP)DOM3_ADDR_RW) in TASK1.", TASK1, err_code);

	err_code = rcv_mbp(MBP1, &blk1);
	t_error(" 4", TASK1, err_code, C_GE, E_OK );

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 5", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}


void	test_6_6_4()
{
ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 6. 6. 4", "service-call prcv_mbp with no-accessable domain's memory", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP1, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = prcv_mbp(MBP1, (VP)KNL_ADDR_RW);
	if( t_error(" 3", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 6. 6. 4", "prcv_mbp(MBP1, (VP)KNL_ADDR_RW) in TASK1.", TASK1, err_code);

	err_code = rcv_mbp(MBP1, &blk1);
	t_error(" 4", TASK1, err_code, C_GE, E_OK );

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 5", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}

void	test_6_6_5()
{
ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 6. 6. 5", "service-call prcv_mbp with memory(ReadOnly)", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP1, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = prcv_mbp(MBP1, (VP)DOM1_ADDR_RO);
	if( t_error(" 3", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 6. 6. 5", "prcv_mbp(MBP1, (VP)DOM1_ADDR_RO) in TASK1.", TASK1, err_code);

	err_code = rcv_mbp(MBP1, &blk1);
	t_error(" 4", TASK1, err_code, C_GE, E_OK );

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 5", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}


void	test_6_6_6()
{
ER	err_code;
VP	blk1;

	t_success( " 6. 6. 6", "service-call prcv_mbp without message", TASK1, T_LINE);
	t_pline("");

	err_code = prcv_mbp(MBP1, (VP)&blk1);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_TMOUT ) )
		t_success( " 6. 6. 6", "prcv_mbp(MBP1, (VP)&blk1) in TASK1.", TASK1, err_code);

	t_pline("");

}

void	test_6_6_7()
{
ER	err_code;
UINT	size = 16;
VP	blk1;
INT	i;
B	dummy;
B	*p;

	t_success( " 6. 6. 7", "read memory for accessable domain's memory block", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP1, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = prcv_mbp(MBP1, &blk1);
	t_error(" 3", TASK1, err_code, C_GE, E_OK );

	p = (B *)blk1;
	for(i=0; i<size; i++)
		dummy = *(p+i);

	t_success( " 6. 6. 7", "dummy = *(p+0..15)", TASK1, T_SUCCESS);

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}


void	test_6_6_8()
{
ER	err_code;
UINT	size = 16;
VP	blk1;
INT	i;
B	*p;

	t_success( " 6. 6. 8", "write memory for accessable domain's memory block", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP1, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = prcv_mbp(MBP1, &blk1);
	t_error(" 3", TASK1, err_code, C_GE, E_OK );

	p = (B *)blk1;
	for(i=0; i<size; i++)
		*(p+i) = (B)0xaa;

	t_success( " 6. 6. 8", "*(p+0..15) = (B)0xaa", TASK1, T_SUCCESS);

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}


void	test_6_7_1()
{
ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 6. 7. 1", "service-call trcv_mbp with ID(-1)", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP1, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = trcv_mbp(-1, &blk1, 10000 );
	if( t_error(" 3", TASK1, err_code, C_EQ, E_ID ) )
		t_success( " 6. 7. 1", "trcv_mbp(-1, &blk1, 10000 ) in TASK1.", TASK1, err_code);

	err_code = rcv_mbp(MBP1, &blk1);
	t_error(" 4", TASK1, err_code, C_GE, E_OK );

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 5", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}

void	test_6_7_2()
{
ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 6. 7. 2", "service-call trcv_mbp with ID(100)", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP1, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = trcv_mbp(100, &blk1, 1000);
	if( t_error(" 3", TASK1, err_code, C_EQ, E_ID ) )
		t_success( " 6. 7. 2", "trcv_mbp(100, &blk1, 10000 ) in TASK1.", TASK1, err_code);

	err_code = rcv_mbp(MBP1, &blk1);
	t_error(" 4", TASK1, err_code, C_GE, E_OK );

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 5", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}

void	test_6_7_3()
{
ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 6. 7. 3", "service-call trcv_mbp with no-accessable domain's memory", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP1, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = trcv_mbp(MBP1, (VP)DOM3_ADDR_RW, 10000);
	if( t_error(" 3", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 6. 7. 3", "trcv_mbp(MBP1, (VP)DOM3_ADDR_RW, 10000) in TASK1.", TASK1, err_code);

	err_code = rcv_mbp(MBP1, &blk1);
	t_error(" 4", TASK1, err_code, C_GE, E_OK );

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 5", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}


void	test_6_7_4()
{
ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 6. 7. 4", "service-call trcv_mbp with no-accessable domain's memory", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP1, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = trcv_mbp(MBP1, (VP)KNL_ADDR_RW, 10000);
	if( t_error(" 3", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 6. 7. 4", "trcv_mbp(MBP1, (VP)KNL_ADDR_RW, 10000) in TASK1.", TASK1, err_code);

	err_code = rcv_mbp(MBP1, &blk1);
	t_error(" 4", TASK1, err_code, C_GE, E_OK );

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 5", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}


void	test_6_7_5()
{
ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 6. 7. 5", "service-call trcv_mbp with memory(ReadOnly)", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP1, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = trcv_mbp(MBP1, (VP)DOM1_ADDR_RO, 10000);
	if( t_error(" 3", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 6. 7. 5", "trcv_mbp(MBP1, (VP)DOM1_ADDR_RO, 10000) in TASK1.", TASK1, err_code);

	err_code = rcv_mbp(MBP1, &blk1);
	t_error(" 4", TASK1, err_code, C_GE, E_OK );

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 5", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}

void	test_6_7_6()
{
ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 6. 7. 6", "service-call trcv_mbp with -2ms", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP1, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = trcv_mbp(MBP1, &blk1, -2 );
	if( t_error(" 3", TASK1, err_code, C_EQ, E_PAR ) )
		t_success( " 6. 7. 6", "trcv_mbp(MBP1, &blk1, -2 ) in TASK1.", TASK1, err_code);

	err_code = rcv_mbp(MBP1, &blk1);
	t_error(" 4", TASK1, err_code, C_GE, E_OK );

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 5", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}


void	test_6_7_7()
{
ER	err_code;
VP	blk1;

	t_success( " 6. 7. 7", "service-call trcv_mbp without message", TASK1, T_LINE);
	t_pline("");

	err_code = trcv_mbp(MBP1, (VP)&blk1, 1000);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_TMOUT ) )
		t_success( " 6. 7. 7", "trcv_mbp(MBP1, (VP)&blk1, 1000) in TASK1.", TASK1, err_code);

	t_pline("");

}


void	test_6_7_8()
{
ER	err_code;
UINT	size = 16;
VP	blk1;
INT	i;
B	dummy;
B	*p;

	t_success( " 6. 7. 8", "read memory for accessable domain's memory block", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP1, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = trcv_mbp(MBP1, &blk1, 10000);
	t_error(" 3", TASK1, err_code, C_GE, E_OK );

	p = (B *)blk1;
	for(i=0; i<size; i++)
		dummy = *(p+i);

	t_success( " 6. 7. 8", "dummy = *(p+0..15)", TASK1, T_SUCCESS);

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );

	t_pline("");


}


void	test_6_7_9()
{
ER	err_code;
UINT	size = 16;
VP	blk1;
INT	i;
B	*p;

	t_success( " 6. 7. 9", "write memory for accessable domain's memory block", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP1, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = trcv_mbp(MBP1, &blk1, 10000);
	t_error(" 3", TASK1, err_code, C_GE, E_OK );

	p = (B *)blk1;
	for(i=0; i<size; i++)
		*(p+i) = (B)0xaa;

	t_success( " 6. 7. 9", "*(p+0..15) = (B)0xaa", TASK1, T_SUCCESS);

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}

void	test_6_7_10()
{
ER	err_code;
VP	blk1;

	t_success( " 6. 7.10 ", "service-call trcv_mbp with 0ms", TASK1, T_LINE);
	t_pline("");

	err_code = trcv_mbp(MBP1, (VP)&blk1, 0);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_TMOUT ) )
		t_success( " 6. 7.10" , "trcv_mbp(MBP1, (VP)&blk1, 0) in TASK1.", TASK1, err_code);

	t_pline("");

}

void	test_6_7_11()
{
ER	err_code;
VP	blk1;

	t_success( " 6. 7.11", "service-call trcv_mbp will wait 10s", TASK1, T_LINE);
	t_pline("");

	err_code = trcv_mbp(MBP1, (VP)&blk1, 10000);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_TMOUT ) )
		t_success( " 6. 7.11", "trcv_mbp(MBP1, (VP)&blk1, 10000) in TASK1.", TASK1, err_code);

	t_pline("");

}

void	test_6_8_1()
{
ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 6. 8. 1", "service-call snd_mbp/rcv_mbp/prcv_mbp/trcv_mbp to no-accessable domain", TASK1, T_LINE);
	t_pline("");

	/* 1. snd_mbp(NG)*/

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP4, blk1, 1);
	if( t_error(" 2", TASK1, err_code, C_EQ, E_OACV ) )
	{
		t_success( " 6. 8. 1", "snd_mbp(MBP4, blk1, 1) in TASK1. blk1 is a block of MPP1.", TASK1, err_code);

		err_code = rel_mpp(MPP1, blk1);
		t_error(" 3", TASK1, err_code, C_EQ, E_OK );
	}

	t_pline("");

	/* 2. rcv_mbp(NG)*/

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP1, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	stac[TASK3].menu = F_ACT_TSK;
	stac[TASK3].id = TASK4;
	stac[TASK4].menu = F_RCV_MBP;
	stac[TASK4].id = MBP1;
	err_code = act_tsk(TASK3);
	t_error(" 3", TASK1, err_code, C_EQ, E_OK );
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );

	if( t_error(" 5", TASK1, get_tsk_result(TASK4), C_EQ, E_OACV ) )
	{
		t_success( " 6. 8. 1", "rcv_mbp(MBP1, &blk1) in TASK4.", TASK1, get_tsk_result(TASK4));

		t_error(" 6", TASK1, ref_tsk(TASK4), C_EQ, -1 );
		t_error(" 7", TASK1, ref_tsk(TASK3), C_EQ, -1 );

		err_code = rcv_mbp(MBP1, &blk1);
		t_error(" 8", TASK1, err_code, C_GE, E_OK );

		err_code = rel_mpp(MPP1, blk1);
		t_error(" 9", TASK1, err_code, C_EQ, E_OK );
	}

	t_pline("");


	/* 3. prcv_mbp(NG)*/

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP1, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	stac[TASK3].menu = F_ACT_TSK;
	stac[TASK3].id = TASK4;
	stac[TASK4].menu = F_PRCV_MBP;
	stac[TASK4].id = MBP1;
	err_code = act_tsk(TASK3);
	t_error(" 3", TASK1, err_code, C_EQ, E_OK );
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );

	if( t_error(" 5", TASK1, get_tsk_result(TASK4), C_EQ, E_OACV ) )
	{

		t_success( " 6. 8. 1", "prcv_mbp(MBP1, &blk1) in TASK4.", TASK1, get_tsk_result(TASK4));

		t_error(" 6", TASK1, ref_tsk(TASK4), C_EQ, -1 );
		t_error(" 7", TASK1, ref_tsk(TASK3), C_EQ, -1 );

		err_code = rcv_mbp(MBP1, &blk1);
		t_error(" 8", TASK1, err_code, C_GE, E_OK );

		err_code = rel_mpp(MPP1, blk1);
		t_error(" 9", TASK1, err_code, C_EQ, E_OK );
	}

	t_pline("");


	/* 4. trcv_mbp(NG)*/
	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP1, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	stac[TASK3].menu = F_ACT_TSK;
	stac[TASK3].id = TASK4;
	stac[TASK4].menu = F_TRCV_MBP;
	stac[TASK4].id = MBP1;
	stac[TASK4].tmout = 10000;
	err_code = act_tsk(TASK3);
	t_error(" 3", TASK1, err_code, C_EQ, E_OK );
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );

	if( t_error(" 5", TASK1, get_tsk_result(TASK4), C_EQ, E_OACV ) )
	{

		t_success( " 6. 8. 1", "trcv_mbp(MBP1, &blk1, 10000) in TASK4.", TASK1, get_tsk_result(TASK4));

		t_error(" 6", TASK1, ref_tsk(TASK4), C_EQ, -1 );
		t_error(" 7", TASK1, ref_tsk(TASK3), C_EQ, -1 );

		err_code = rcv_mbp(MBP1, &blk1);
		t_error(" 8", TASK1, err_code, C_GE, E_OK );

		err_code = rel_mpp(MPP1, blk1);
		t_error(" 9", TASK1, err_code, C_EQ, E_OK );
	}

	t_pline("");

}



void	test_6_8_2()
{
ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 6. 8. 2", "service-call snd_mbp/rcv_mbp/prcv_mbp/trcv_mbp to accessable domain", TASK1, T_LINE);
	t_pline("");

	/* 1. snd_mbp(OK)*/

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP3, blk1, 1);
	if( t_error(" 2", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 6. 8. 2", "snd_mbp(MBP3, blk1, 1) in TASK1. blk1 is a block of MPP1.", TASK1, err_code);

	err_code = rcv_mbp(MBP3, &blk1);
	t_error(" 3", TASK1, err_code, C_GE, E_OK );

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

	/* 2. rcv_mbp(OK)*/

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP3, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = rcv_mbp(MBP3, &blk1);
	if( t_error(" 3", TASK1, err_code, C_GE, E_OK ) )
		t_success( " 6. 8. 2", "rcv_mbp(MBP3, &blk1) in TASK1.", TASK1, err_code);

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );


	t_pline("");


	/* 3. prcv_mbp(OK)*/

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP3, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = prcv_mbp(MBP3, &blk1);
	if (t_error(" 3", TASK1, err_code, C_GE, E_OK ) )
		t_success( " 6. 8. 2", "prcv_mbp(MBP3, &blk1) in TASK1.", TASK1, err_code);

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );

	t_pline("");


	/* 4. trcv_mbp(OK)*/

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP3, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	err_code = trcv_mbp(MBP3, &blk1, 10000);
	if( t_error(" 3", TASK1, err_code, C_GE, E_OK ) )
		t_success( " 6. 8. 2", "trcv_mbp(MBP3, &blk1, 10000) in TASK1.", TASK1, err_code);

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );


	t_pline("");

}


void	test_6_8_3()
{

ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 6. 8. 3", "service-call snd_mbp/rcv_mbp/prcv_mbp/trcv_mbp to shared domain", TASK1, T_LINE);
	t_pline("");

	/* 1. snd_mbp(OK)*/
	err_code = get_mpp(MPP9, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP9, blk1, 1);
	if( t_error(" 2", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 6. 8. 3", "snd_mbp(MBP9, blk1, 1) in TASK1. blk1 is a block of MPP9.", TASK1, err_code);

	err_code = rcv_mbp(MBP9, &blk1);			/*	Add	02/02/20	*/
	t_error(" 3", TASK1, err_code, C_GE, E_OK );		/*	Add	02/02/20	*/

	err_code = rel_mpp(MPP9, blk1);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

	/* 2. rcv_mbp(OK)*/

	err_code = get_mpp(MPP9, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP9, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	stac[TASK3].menu = F_ACT_TSK;
	stac[TASK3].id = TASK4;
	stac[TASK4].menu = F_RCV_MBP;
	stac[TASK4].id = MBP9;
	err_code = act_tsk(TASK3);
	t_error(" 3", TASK1, err_code, C_EQ, E_OK );
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );

	if( t_error(" 5", TASK1, get_tsk_result(TASK4), C_GE, E_OK ) )
		t_success( " 6. 8. 3", "rcv_mbp(MBP9, &blk1) in TASK4.", TASK1, get_tsk_result(TASK4));
	blk1 = stac[TASK4].blk;

	t_error(" 6", TASK1, ref_tsk(TASK4), C_EQ, -1 );
	t_error(" 7", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	stac[TASK3].menu = F_ACT_TSK;
	stac[TASK3].id = TASK4;
	stac[TASK4].menu = F_REL_MPP;
	stac[TASK4].id = MPP9;
	stac[TASK4].blk = blk1;
	err_code = act_tsk(TASK3);
	t_error(" 8", TASK1, err_code, C_EQ, E_OK );
	t_error(" 9", TASK1, err_code, C_EQ, E_OK );

	t_error("10", TASK1, get_tsk_result(TASK4), C_EQ, E_OK );

	t_pline("");


	/* 3. prcv_mbp(OK)*/

	err_code = get_mpp(MPP9, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP9, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	stac[TASK3].menu = F_ACT_TSK;
	stac[TASK3].id = TASK4;
	stac[TASK4].menu = F_PRCV_MBP;
	stac[TASK4].id = MBP9;
	err_code = act_tsk(TASK3);
	t_error(" 3", TASK1, err_code, C_EQ, E_OK );
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );

	if( t_error(" 5", TASK1, get_tsk_result(TASK4), C_GE, E_OK ) )
		t_success( " 6. 8. 3", "prcv_mbp(MBP9, &blk1) in TASK4.", TASK1, get_tsk_result(TASK4));
	blk1 = stac[TASK4].blk;

	t_error(" 6", TASK1, ref_tsk(TASK4), C_EQ, -1 );
	t_error(" 7", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	stac[TASK3].menu = F_ACT_TSK;
	stac[TASK3].id = TASK4;
	stac[TASK4].menu = F_REL_MPP;
	stac[TASK4].id = MPP9;
	stac[TASK4].blk = blk1;
	err_code = act_tsk(TASK3);
	t_error(" 8", TASK1, err_code, C_EQ, E_OK );
	t_error(" 9", TASK1, err_code, C_EQ, E_OK );

	t_error("10", TASK1, get_tsk_result(TASK4), C_EQ, E_OK );

	t_pline("");


	/* 4. trcv_mbp(OK)*/
	err_code = get_mpp(MPP9, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = snd_mbp(MBP9, blk1, 1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	stac[TASK3].menu = F_ACT_TSK;
	stac[TASK3].id = TASK4;
	stac[TASK4].menu = F_TRCV_MBP;
	stac[TASK4].id = MBP9;
	stac[TASK4].tmout = 10000;
	err_code = act_tsk(TASK3);
	t_error(" 3", TASK1, err_code, C_EQ, E_OK );
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );

	if( t_error(" 5", TASK1, get_tsk_result(TASK4), C_GE, E_OK ) )
		t_success( " 6. 8. 3", "trcv_mbp(MBP9, &blk1, 10000) in TASK4.", TASK1, get_tsk_result(TASK4));
	blk1 = stac[TASK4].blk;

	t_error(" 6", TASK1, ref_tsk(TASK4), C_EQ, -1 );
	t_error(" 7", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	stac[TASK3].menu = F_ACT_TSK;
	stac[TASK3].id = TASK4;
	stac[TASK4].menu = F_REL_MPP;
	stac[TASK4].id = MPP9;
	stac[TASK4].blk = blk1;
	err_code = act_tsk(TASK3);
	t_error(" 8", TASK1, err_code, C_EQ, E_OK );
	t_error(" 9", TASK1, err_code, C_EQ, E_OK );

	t_error("10", TASK1, get_tsk_result(TASK4), C_EQ, E_OK );

	t_pline("");

}


void	test_7_2_1()
{

ER	err_code;
UINT	size = 16;
VP	blk1;
B	*p;
INT	i;

	t_success( " 7. 2. 1", "write to accessable domain's memory", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	p = (B *)blk1;
	for(i=0; i<size; i++)
		*(p+i) = (B)0xaa;

	t_success( " 7. 2. 1", "*(p+0..15) = (B)0xaa", TASK1, T_SUCCESS);

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}


void	test_7_2_2()
{

ER	err_code;
UINT	size = 16;
VP	blk1;
B	dummy;
B	*p;
INT	i;

	t_success( " 7. 2. 2", "read from accessable domain's memory", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	p = (B *)blk1;
	for(i=0; i<size; i++)
		dummy = *(p+i);

	t_success( " 7. 2. 2", "dummy = *(p+0..15)", TASK1, T_SUCCESS);

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}


void	test_7_4_1()
{

ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 7. 4. 1", "service-call get_mpp with ID(-1)", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(-1, size, &blk1);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_ID ) )
		t_success( " 7. 4. 1", "get_mpp(-1, size, &blk1) in TASK1.", TASK1, err_code);

	t_pline("");

}

void	test_7_4_2()
{

ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 7. 4. 2", "service-call get_mpp with ID(100)", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(100, size, &blk1);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_ID ) )
		t_success( " 7. 4. 2", "get_mpp(100, size, &blk1) in TASK1.", TASK1, err_code);

	t_pline("");

}

void	test_7_4_3()
{

ER	err_code;
UINT	size = 16;

	t_success( " 7. 4. 3", "service-call get_mpp with no-accessable domain's memory", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, (VP)DOM3_ADDR_RW);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 7. 4. 3", "get_mpp(MPP1, size, (VP)DOM3_ADDR_RW) in TASK1.", TASK1, err_code);

	t_pline("");

}

void	test_7_4_4()
{

ER	err_code;
UINT	size = 16;

	t_success( " 7. 4. 4", "service-call get_mpp with no-accessable domain's memory", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, (VP)KNL_ADDR_RW);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 7. 4. 4", "get_mpp(MPP1, size, (VP)KNL_ADDR_RW) in TASK1.", TASK1, err_code);

	t_pline("");

}

void	test_7_4_5()
{

ER	err_code;
UINT	size = 16;

	t_success( " 7. 4. 5", "service-call get_mpp with memory(ReadOnly)", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, (VP)DOM1_ADDR_RO);
	if (t_error(" 1", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 7. 4. 5", "get_mpp(MPP1, size, (VP)DOM1_ADDR_RO) in TASK1.", TASK1, err_code);


	t_pline("");

}


void	test_7_4_6()
{

ER	err_code;
UINT	size = 100;

VP	blk1;
VP	blk2;
VP	blk3;	// NEWRAL

	t_success( " 7. 4. 6", "service-call get_mpp will wait", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = get_mpp(MPP1, size, &blk2);
	t_error(" 2", TASK1, err_code, C_GE, E_OK );

	err_code = get_mpp(MPP1, size, &blk3);			// NEWRAL
	t_error(" 3", TASK1, err_code, C_GE, E_OK );	// NEWRAL


	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_GET_MPP;
	stac[TASK3].id = MPP1;
	stac[TASK3].size = size;
	stac[TASK3].tmout = -1;
	err_code = act_tsk(TASK3);
	t_error(" 3", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 4", TASK1, ref_tsk(TASK3), C_EQ, F_GET_MPP ) )
		t_success( " 7. 4. 6", "TASK3 is waiting with get_mpp(MPF1, 100, &blk3 ).", TASK1, T_SUCCESS );

	err_code = rel_wai(TASK3);
	t_error(" 5", TASK1, err_code, C_EQ, E_OK );

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 6", TASK1, err_code, C_EQ, E_OK );

	err_code = rel_mpp(MPP1, blk2);
	t_error(" 7", TASK1, err_code, C_EQ, E_OK );

	err_code = rel_mpp(MPP1, blk3);					// NEWRAL
	t_error(" 8", TASK1, err_code, C_EQ, E_OK );	// NEWRAL



	t_error(" 8", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	t_error(" 9", TASK1, get_tsk_result(TASK3), C_EQ, E_RLWAI );

	t_pline("");

}


void	test_7_4_7()
{

ER	err_code;
UINT	size = 16;
VP	blk1;
B	*p;
INT	i;

	t_success( " 7. 4. 7", "write memory for accessable domain's memory block", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	p = (B *)blk1;
	for(i=0; i<size; i++)
		*(p+i) = (B)0xaa;

	t_success( " 7. 4. 7", "*(p+0..15) = (B)0xaa", TASK1, T_SUCCESS);

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}

void	test_7_4_8()
{

ER	err_code;
UINT	size = 16;
VP	blk1;
B	*p;
INT	i;

	t_success( " 7. 4. 8", "write and read memory for accessable domain's memory block", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	p = (B *)blk1;
	for(i=0; i<size; i++)
		*(p+i) = (B)0xaa;

	p = (B *)blk1;
	for(i=0; i<size; i++)
		if( *(p+i) != (B)0xaa )
		{
			t_pline("not passed");
			while(1);
		}

	t_success( " 7. 4. 8", "verify the memory.", TASK1, T_SUCCESS);

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}


void	test_7_5_1()
{

ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 7. 5. 1", "service-call pget_mpp with ID(-1)", TASK1, T_LINE);
	t_pline("");

	err_code = pget_mpp(-1, size, &blk1);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_ID ) )
		t_success( " 7. 5. 1", "pget_mpp(-1, size, &blk1) in TASK1.", TASK1, err_code);

	t_pline("");

}

void	test_7_5_2()
{

ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 7. 5. 2", "service-call pget_mpp with ID(100)", TASK1, T_LINE);
	t_pline("");

	err_code = pget_mpp(100, size, &blk1);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_ID ) )
		t_success( " 7. 5. 2", "pget_mpp(100, size, &blk1) in TASK1.", TASK1, err_code);

	t_pline("");

}

void	test_7_5_3()
{

ER	err_code;
UINT	size = 16;

	t_success( " 7. 5. 3", "service-call pget_mpp with no-accessable domain's memory", TASK1, T_LINE);
	t_pline("");

	err_code = pget_mpp(MPP1, size, (VP)DOM3_ADDR_RW);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 7. 5. 3", "pget_mpp(MPP1, size, (VP)DOM3_ADDR_RW) in TASK1.", TASK1, err_code);

	t_pline("");

}

void	test_7_5_4()
{

ER	err_code;
UINT	size = 16;

	t_success( " 7. 5. 4", "service-call pget_mpp with no-accessable domain's memory", TASK1, T_LINE);
	t_pline("");

	err_code = pget_mpp(MPP1, size, (VP)KNL_ADDR_RW);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 7. 5. 4", "pget_mpp(MPP1, size, (VP)KNL_ADDR_RW) in TASK1.", TASK1, err_code);

	t_pline("");

}

void	test_7_5_5()
{

ER	err_code;
UINT	size = 16;

	t_success( " 7. 5. 5", "service-call pget_mpp with memory(ReadOnly)", TASK1, T_LINE);
	t_pline("");

	err_code = pget_mpp(MPP1, size, (VP)DOM1_ADDR_RO);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 7. 5. 5", "pget_mpp(MPP1, size, (VP)DOM1_ADDR_RO) in TASK1.", TASK1, err_code);




	t_pline("");

}


void	test_7_5_6()
{

ER	err_code;
UINT	size = 100;
VP	blk1;
VP	blk2;
VP	blk3;
VP	blk4;

	t_success( " 7. 5. 6", "service-call pget_mpp will fail", TASK1, T_LINE);
	t_pline("");


	err_code = pget_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = pget_mpp(MPP1, size, &blk2);
	t_error(" 2", TASK1, err_code, C_GE, E_OK );

	err_code = pget_mpp(MPP1, size, &blk3);
	t_error(" 2", TASK1, err_code, C_GE, E_OK );

	err_code = pget_mpp(MPP1, size, &blk4);
	if( t_error(" 3", TASK1, err_code, C_GE, E_TMOUT ) )
		t_success( " 7. 5. 6", "pget_mpp(MPP1, size,  &blk3) in TASK1.", TASK1, err_code);

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );

	err_code = rel_mpp(MPP1, blk2);
	t_error(" 5", TASK1, err_code, C_EQ, E_OK );

	err_code = rel_mpp(MPP1, blk3);
	t_error(" 6", TASK1, err_code, C_EQ, E_OK );


	t_pline("");

}


void	test_7_5_7()
{

ER	err_code;
UINT	size = 16;
VP	blk1;
B	*p;
INT	i;

	t_success( " 7. 5. 7", "write and read memory for accessable domain's memory block", TASK1, T_LINE);
	t_pline("");

	err_code = pget_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	p = (B *)blk1;
	for(i=0; i<size; i++)
		*(p+i) = (B)0xaa;

	p = (B *)blk1;
	for(i=0; i<size; i++)
		if( *(p+i) != (B)0xaa )
		{
			t_pline("not passed");
			while(1);
		}

	t_success( " 7. 5. 7", "verify the memory.", TASK1, T_SUCCESS);

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}


void	test_7_6_1()
{

ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 7. 6. 1", "service-call tget_mpp with ID(-1)", TASK1, T_LINE);
	t_pline("");

	err_code = tget_mpp(-1, size, &blk1, 10000);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_ID ) )
				/*	02/02/18	Mod	*/
		t_success( " 7. 6. 1", "tget_mpp(-1, size, &blk1, 10000) in TASK1.", TASK1, err_code);

	t_pline("");

}

void	test_7_6_2()
{

ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 7. 6. 2", "service-call tget_mpp with ID(100)", TASK1, T_LINE);
	t_pline("");

	err_code = tget_mpp(100, size, &blk1, 10000);
	if( t_error(" 1", TASK1, err_code, C_GE, E_ID ) )
		t_success( " 7. 6. 2", "tget_mpp(100, size, &blk1, 10000) in TASK1.", TASK1, err_code);

	t_pline("");

}

void	test_7_6_3()
{

ER	err_code;
UINT	size = 16;

	t_success( " 7. 6. 3", "service-call tget_mpp with no-accessable domain's memory", TASK1, T_LINE);
	t_pline("");

	err_code = tget_mpp(MPP1, size, (VP)DOM3_ADDR_RW, 10000);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 7. 6. 3", "tget_mpp(MPP1, size, (VP)DOM3_ADDR_RW, 10000) in TASK1.", TASK1, err_code);

	t_pline("");

}

void	test_7_6_4()
{

ER	err_code;
UINT	size = 16;

	t_success( " 7. 6. 4", "service-call tget_mpp with no-accessable domain's memory", TASK1, T_LINE);
	t_pline("");

	err_code = tget_mpp(MPP1, size, (VP)KNL_ADDR_RW, 10000);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_MACV ))
		t_success( " 7. 6. 4", "tget_mpp(MPP1, size, (VP)KNL_ADDR_RW, 10000) in TASK1.", TASK1, err_code);

	t_pline("");

}


void	test_7_6_5()
{

ER	err_code;
UINT	size = 16;

	t_success( " 7. 6. 5", "service-call tget_mpp with memory(ReadOnly)", TASK1, T_LINE);
	t_pline("");

	err_code = tget_mpp(MPP1, size, (VP)DOM1_ADDR_RO, 10000);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_MACV ) )
		t_success( " 7. 6. 5", "tget_mpp(MPP1, size, (VP)DOM1_ADDR_RO, 10000) in TASK1.", TASK1, err_code);

	t_pline("");

}


void	test_7_6_6()
{

ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 7. 6. 6", "service-call tget_mpp with -2ms", TASK1, T_LINE);
	t_pline("");

	err_code = tget_mpp(MPP1, size, (VP)&blk1, -2);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_PAR ) )
		t_success( " 7. 6. 6", "tget_mpp(MPP1, size, (VP)&blk1, -2) in TASK1.", TASK1, err_code);

	t_pline("");

}


void	test_7_6_7()
{

ER	err_code;
UINT	size = 100;
VP	blk1;
VP	blk2;
VP	blk3;
VP	blk4;		//NEWRAL

	t_success( " 7. 6. 7", "service-call tget_mpp will fail", TASK1, T_LINE);
	t_pline("");


	err_code = tget_mpp(MPP1, size, &blk1, 10000);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = tget_mpp(MPP1, size, &blk2, 10000);
	t_error(" 2", TASK1, err_code, C_GE, E_OK );

	err_code = tget_mpp(MPP1, size, &blk4, 10000);	// NEWRAL
	t_error(" 3", TASK1, err_code, C_GE, E_OK );    // NEWRAL

	err_code = tget_mpp(MPP1, size, &blk3, 1000);
	if( t_error(" 4", TASK1, err_code, C_EQ, E_TMOUT ) )

		t_success( " 7. 6. 7", "tget_mpp(MPP1, size, (VP)&blk3, 1000) in TASK1.", TASK1, err_code);

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 5", TASK1, err_code, C_EQ, E_OK );

	err_code = rel_mpp(MPP1, blk2);
	t_error(" 6", TASK1, err_code, C_EQ, E_OK );

	err_code = rel_mpp(MPP1, blk4);					//NEWRAL
	t_error(" 7", TASK1, err_code, C_EQ, E_OK );    //NEWRAL


	t_pline("");

}


void	test_7_6_8()
{

ER	err_code;
UINT	size = 16;
VP	blk1;
B	*p;
INT	i;

	t_success( " 7. 6. 8", "write memory for accessable domain's memory block", TASK1, T_LINE);
	t_pline("");

	err_code = tget_mpp(MPP1, size, &blk1, 10000);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	p = (B *)blk1;
	for(i=0; i<size; i++)
		*(p+i) = (B)0xaa;

	t_success( " 7. 6. 8", "*(p+0..15) = (B)0xaa", TASK1, T_SUCCESS);

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}

void	test_7_6_9()
{

ER	err_code;
UINT	size = 16;
VP	blk1;
B	*p;
INT	i;

	t_success( " 7. 6. 9", "write and read memory for accessable domain's memory block", TASK1, T_LINE);
	t_pline("");

	err_code = tget_mpp(MPP1, size, &blk1, 10000);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	p = (B *)blk1;
	for(i=0; i<size; i++)
		*(p+i) = (B)0xaa;

	p = (B *)blk1;
	for(i=0; i<size; i++)
		if( *(p+i) != (B)0xaa )
		{
			t_pline("not passed");
			while(1);
		}

	t_success( " 7. 6. 9", "verify the memory.", TASK1, T_SUCCESS);

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}


void	test_7_6_10()
{
ER	err_code;
UINT	size = 16;
VP	blk1;
VP	blk2;

	t_success( " 7. 6.10", "service-call tget_mpp will fail with 0ms", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, 3*4096, &blk1);				/*	Add	02/02/20	*/
	t_error(" 1", TASK1, err_code, C_EQ, 12288 );			/*	Add	02/02/20	*/

	err_code = tget_mpp(MPP1, size, &blk2, 0);
	if( t_error(" 2", TASK1, err_code, C_EQ, E_TMOUT ) )
		t_success( " 7. 6.10", "tget_mpp(MPP1, size, &blk1, 0) in TASK1.", TASK1, err_code);

	err_code = rel_mpp(MPP1, blk1);					/*	Add	02/02/20	*/
	t_error(" 3", TASK1, err_code, C_EQ, E_OK );			/*	Add	02/02/20	*/


	t_pline("");

}

void	test_7_6_11()
{
UINT	size = 200;
ER	err_code;
VP	blk1;
VP	blk2;

	t_success( " 7. 6.11", "service-call tget_mpp will wait and fail", TASK1, T_LINE);
	t_pline("");

	err_code = tget_mpp(MPP1, 3*4096, &blk1, 10000);	/* Mod	02/02/20	*/
	t_error(" 1", TASK1, err_code, C_EQ, 12288 );

	err_code = tget_mpp(MPP1, size, &blk2, 10000);
	if( t_error(" 2", TASK1, err_code, C_EQ, E_TMOUT ) )
		t_success( " 7. 6.11", "tget_mpp(MPP1, size, &blk2, 10000) in TASK1.", TASK1, err_code);

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 3", TASK1, err_code, C_EQ, E_OK );


	t_pline("");

}


void	test_7_8_1()
{

ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 7. 8. 1", "service-call rel_mpp with ID(-1)", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = rel_mpp(-1, blk1);
	if( t_error(" 2", TASK1, err_code, C_EQ, E_ID ) )
		t_success( " 7. 8. 1", "rel_mpp(-1, blk1) in TASK1.", TASK1, err_code);

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 3", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}

void	test_7_8_2()
{

ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 7. 8. 2", "service-call rel_mpp with ID(100)", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = rel_mpp(100, blk1);
	if( t_error(" 2", TASK1, err_code, C_EQ, E_ID ) )
		t_success( " 7. 8. 2", "rel_mpp(100, blk1) in TASK1.", TASK1, err_code);

	err_code = rel_mpp(MPP1, blk1);
	t_error(" 3", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

}

void	test_7_8_3()
{

ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 7. 8. 3", "service-call rel_mpp with no-accessable domain's memory", TASK1, T_LINE);
	t_pline("");

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_ACT_TSK;
	stac[TASK3].id = TASK4;
	stac[TASK4].menu = F_GET_MPP;
	stac[TASK4].id = MPP4;
	stac[TASK4].size = size;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );
	t_error(" 3", TASK1, get_tsk_result(TASK4), C_GE, E_OK );
	t_error(" 4", TASK1, ref_tsk(TASK4), C_EQ, -1 );
	t_error(" 5", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	blk1 =  stac[TASK4].blk;

	err_code = rel_mpp(MPP1, blk1);
	if( t_error(" 6", TASK1, err_code, C_EQ, E_PAR ))
				/*	02/02/18	Mod	*/
	{
		t_success( " 7. 8. 3", "rel_mpp(MPP1, blk1) in TASK1. blk1 is a block of MPP4.", TASK1, err_code);

		ref_tsk_event( TASK3, 0 );
		stac[TASK3].menu = F_ACT_TSK;
		stac[TASK3].id = TASK4;
		stac[TASK4].menu = F_REL_MPP;
		stac[TASK4].id = MPP4;
		stac[TASK4].blk = blk1;
		err_code = act_tsk(TASK3);
		t_error(" 7", TASK1, err_code, C_EQ, E_OK );
		t_error(" 8", TASK1, err_code, C_EQ, E_OK );
		t_error(" 9", TASK1, get_tsk_result(TASK4), C_EQ, E_OK );
		t_error("10", TASK1, ref_tsk(TASK4), C_EQ, -1 );
		t_error("11", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	}
	t_pline("");

}

void	test_7_8_4()
{

ER	err_code;
B	dummy;

	t_success( " 7. 8. 4", "service-call rel_mpp with illegal memory block", TASK1, T_LINE);
	t_pline("");

	err_code = rel_mpp(MPP1, &dummy);
	t_error(" 1", TASK1, err_code, C_EQ, E_PAR );
		t_success( " 7. 8. 4", "rel_mpp(MPP1, &dummy) in TASK1. &dummy is a stack address.", TASK1, err_code);

	t_pline("");

}

void	test_7_8_5()
{

ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 7. 8. 5", "service-call rel_mpp with a released memory block", TASK1, T_LINE);
	t_pline("");

	err_code = get_mpp(MPP1, size, &blk1);
	t_error(" 1", TASK1, err_code, C_GE, E_OK );

	err_code = rel_mpp(MPP1, blk1);
	if( t_error(" 2", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 7. 8. 5", "rel_mpp(MBP1, blk1) at 1st in TASK1.", TASK1, err_code);

	err_code = rel_mpp(MPP1, blk1);
	if( t_error(" 3", TASK1, err_code, C_EQ, E_ILUSE ) )
				/*	02/02/18	Mod	*/
		t_success( " 7. 8. 5", "rel_mpp(MBP1, blk1) to the 2nd in TASK1.", TASK1, err_code);

	t_pline("");

}


void	test_7_9_1()
{
ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 7. 9. 1", "service-call get_mpp/pget_mpp/tget_mpp/rel_mpp to no-accessable domain", TASK1, T_LINE);
	t_pline("");


	/* 1. get_mpp(NG)*/

	err_code = get_mpp(MPP4, size, &blk1);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_OACV ) )
		t_success( " 7. 9. 1", "get_mpp(MPP4, size, &blk1) in TASK1.", TASK1, err_code );

	t_pline("");

	/* 2. pget_mpp(NG)*/

	err_code = pget_mpp(MPP4, size, &blk1);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_OACV ) )
		t_success( " 7. 9. 1", "pget_mpp(MPP4, size, &blk1) in TASK1.", TASK1, err_code );

	t_pline("");

	/* 3. tget_mpp(NG)*/

	err_code = tget_mpp(MPP4, size, &blk1, 10000);
	if( t_error(" 1", TASK1, err_code, C_EQ, E_OACV ) )
		t_success( " 7. 9. 1", "tget_mpp(MPP4, size, &blk1, 10000) in TASK1.", TASK1, err_code );

	t_pline("");

	/* 4. rel_mpp(NG)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_GET_MPP;
	stac[TASK3].id = MPP4;
	stac[TASK3].size = size;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_GE, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	blk1 =  stac[TASK3].blk;

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SND_MBP;
	stac[TASK3].id = MBP3;
	stac[TASK3].blk = blk1;
	stac[TASK3].pri = 1;
	err_code = act_tsk(TASK3);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );
	t_error(" 5", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 6", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	err_code = rcv_mbp(MBP3, &blk1);
	t_error(" 7", TASK1, err_code, C_GE, E_OK );

	err_code = rel_mpp(MPP4, blk1);
	if( t_error(" 8", TASK1, err_code, C_EQ, E_OACV ))
	{
		t_success( " 7. 9. 1", "rel_mpp(MPP4, blk1) in TASK1. blk1 is a block of MPP4.", TASK1, err_code );

		err_code = snd_mbp(MBP3, blk1, 1);
		t_error(" 9", TASK1, err_code, C_EQ, E_OK );

		ref_tsk_event( TASK3, 0 );
		stac[TASK3].menu = F_RCV_MBP;
		stac[TASK3].id = MBP3;
		err_code = act_tsk(TASK3);
		t_error("10", TASK1, err_code, C_EQ, E_OK );
		t_error("11", TASK1, get_tsk_result(TASK3), C_GE, E_OK );
		t_error("12", TASK1, ref_tsk(TASK3), C_EQ, -1 );
		blk1 =  stac[TASK3].blk;

		ref_tsk_event( TASK3, 0 );
		stac[TASK3].menu = F_REL_MPP;
		stac[TASK3].id = MPP4;
		stac[TASK3].blk = blk1;
		err_code = act_tsk(TASK3);
		t_error("13", TASK1, err_code, C_EQ, E_OK );
		t_error("14", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
		t_error("15", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	}
	t_pline("");

}


void	test_7_9_2()
{
ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 7. 9. 2", "service-call get_mpp/pget_mpp/tget_mpp/rel_mpp to accessable domain", TASK1, T_LINE);
	t_pline("");


	/* 1. get_mpp(OK)*/

	err_code = get_mpp(MPP3, size, &blk1);
	if( t_error(" 1", TASK1, err_code, C_GE, E_OK ) )
		t_success( " 7. 9. 2", "get_mpp(MPP3, size, &blk1) in TASK1.", TASK1, err_code );

	err_code = rel_mpp(MPP3, blk1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

	/* 2. pget_mpp(OK)*/

	err_code = pget_mpp(MPP3, size, &blk1);
	if( t_error(" 1", TASK1, err_code, C_GE, E_OK ) )
		t_success( " 7. 9. 2", "pget_mpp(MPP3, size, &blk1) in TASK1.", TASK1, err_code );

	err_code = rel_mpp(MPP3, blk1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

	/* 3. tget_mpp(OK)*/

	err_code = tget_mpp(MPP3, size, &blk1, 10000);
	if( t_error(" 1", TASK1, err_code, C_GE, E_OK ) )
		t_success( " 7. 9. 2", "tget_mpp(MPP3, size, &blk1, 10000) in TASK1.", TASK1, err_code );

	err_code = rel_mpp(MPP3, blk1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

	/* 4. rel_mpp(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_GET_MPP;
	stac[TASK3].id = MPP1;
	stac[TASK3].size = size;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_GE, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	blk1 =  stac[TASK3].blk;

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_REL_MPP;
	stac[TASK3].id = MPP1;
	stac[TASK3].blk = blk1;
	err_code = act_tsk(TASK3);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );
	if( t_error(" 5", TASK1, get_tsk_result(TASK3), C_EQ, E_OK ) )
		t_success( " 7. 9. 2", "rel_mpp(MPP1, blk1) in TASK3. blk1 is a block of MPP1.", TASK1, get_tsk_result(TASK3) );

	t_error(" 6", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	t_pline("");

}


void	test_7_9_3()
{
ER	err_code;
UINT	size = 16;
VP	blk1;

	t_success( " 7. 9. 3", "service-call get_mpp/pget_mpp/tget_mpp/rel_mpp to shared domain", TASK1, T_LINE);
	t_pline("");


	/* 1. get_mpp(OK)*/

	err_code = get_mpp(MPP9, size, &blk1);
	if( t_error(" 1", TASK1, err_code, C_GE, E_OK ) )
		t_success( " 7. 9. 3", "get_mpp(MPP9, size, &blk1) in TASK1.", TASK1, err_code );

	err_code = rel_mpp(MPP9, blk1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

	/* 2. pget_mpp(OK)*/

	err_code = pget_mpp(MPP9, size, &blk1);
	if( t_error(" 1", TASK1, err_code, C_GE, E_OK ) )
		t_success( " 7. 9. 3", "pget_mpp(MPP9, size, &blk1) in TASK1.", TASK1, err_code );

	err_code = rel_mpp(MPP9, blk1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

	/* 3. tget_mpp(OK)*/

	err_code = tget_mpp(MPP9, size, &blk1, 10000);
	if( t_error(" 1", TASK1, err_code, C_GE, E_OK ) )
		t_success( " 7. 9. 3", "tget_mpp(MPP9, size, &blk1, 10000) in TASK1.", TASK1, err_code );

	err_code = rel_mpp(MPP9, blk1);
	t_error(" 2", TASK1, err_code, C_EQ, E_OK );

	t_pline("");

	/* 4. rel_mpp(OK)*/

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_GET_MPP;
	stac[TASK3].id = MPP9;
	stac[TASK3].size = size;
	err_code = act_tsk(TASK3);
	t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	t_error(" 2", TASK1, get_tsk_result(TASK3), C_GE, E_OK );
	t_error(" 3", TASK1, ref_tsk(TASK3), C_EQ, -1 );
	blk1 =  stac[TASK3].blk;

	ref_tsk_event( TASK3, 0 );
	stac[TASK3].menu = F_SND_MBP;
	stac[TASK3].id = MBP3;
	stac[TASK3].blk = blk1;
	stac[TASK3].pri = 1;
	err_code = act_tsk(TASK3);
	t_error(" 4", TASK1, err_code, C_EQ, E_OK );
	t_error(" 5", TASK1, get_tsk_result(TASK3), C_EQ, E_OK );
	t_error(" 6", TASK1, ref_tsk(TASK3), C_EQ, -1 );

	err_code = rcv_mbp(MBP3, &blk1);
	t_error(" 7", TASK1, err_code, C_GE, E_OK );

	err_code = rel_mpp(MPP9, blk1);
	if( t_error(" 8", TASK1, err_code, C_EQ, E_OK ) )
		t_success( " 7. 9. 3", "rel_mpp(MPP9, blk1) in TASK1. blk1 is a block of MPP9.", TASK1, err_code );

	t_pline("");

}
#else /* patch */
#endif


void	test_8_1_1()
{
ER	err_code;
MSG_DATA	*rcv;
INT	i;
INT	j;
B	*p;


	t_success( " 8. 1. 1", "rcv_mbx after filling -1 in area of T_MSG", TASK1, T_LINE);
	t_pline("");

	for( i=0; i<10; i++ )
	{
		mdata[i].msg = i;
		err_code = snd_mbx(MBX9, (T_MSG *)&(mdata[i].h) );
		t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	}

	for( i=0; i<10; i++)
	{
		p = (B *)&(mdata[i].h);
		for( j=0; j<sizeof(T_MSG); j++ )
			*(p+j) = (B)0xff;	/* fill 0xff for the header */
	}

	for( i=0; i<10; i++ )
	{
		ref_tsk_event( TASK3, 0 );
		stac[TASK3].menu = F_RCV_MBX;
		stac[TASK3].id = MBX9;
		err_code = act_tsk(TASK3);
		t_error(" 2", TASK1, err_code, C_EQ, E_OK );
		t_error(" 3", TASK1, get_tsk_result(TASK3), C_GE, E_OK );
		t_error(" 4", TASK1, ref_tsk(TASK3), C_EQ, -1 );
		rcv = (MSG_DATA *)stac[TASK3].pmsg;
		t_error(" 5", TASK1, rcv->msg, C_EQ, i );
	}

	t_success( " 8. 1. 1", "", TASK1, T_SUCCESS);

	t_pline("");

}


void	test_8_2_1()
{
ER	err_code;
INT	size = 16;
VP	rcv[10];
VP	rcv1[10];
INT	i;
INT	j;
B	*p;

	t_success( " 8. 2. 1", "change data of memory block and get_mpf/rel_mpf", TASK1, T_LINE);
	t_pline("");

	for( i=0; i<10; i++ )
	{
		err_code = get_mpf(MPF9, (VP *)&rcv[i] );
		t_error(" 1", TASK1, err_code, C_EQ, E_OK );
	}

	for( i=0; i<10; i++ )
	{
		err_code = rel_mpf(MPF9, rcv[i] );
		t_error(" 2", TASK1, err_code, C_EQ, E_OK );
	}

	for( i=0; i<10; i++)
	{
		p = (B *)rcv[i];
		for( j=0; j<size; j++ )
			*(p+j) = (B)0xff;	/* fill 0xff */
	}

	for( i=0; i<10; i++ )
	{
		err_code = get_mpf(MPF9, (VP *)&rcv1[i] );
		t_error(" 3", TASK1, err_code, C_EQ, E_OK );
	}

	for( i=0; i<10; i++ )
	{
		err_code = rel_mpf(MPF9, rcv1[i] );
		t_error(" 4", TASK1, err_code, C_EQ, E_OK );
	}

	t_success( " 8. 2. 1", "", TASK1, T_SUCCESS);

	t_pline("");

}


/****************************************************************/
/*	Extended SVC prob_memory				*/
/*		02/02/18	Addition			*/
/****************************************************************/
ER
#if 0
SVC_probe_memory(VP base, UINT size, ID domid, ID tskid, MODE pmmode)
#else /* patch */
SVC_probe_memory(VP base, SIZE size, ID domid, ID tskid, MODE pmmode)
#endif
{

	return(vprb_mem(base, size, domid, tskid, pmmode));

}
